// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAnimationAspectWrapper_H
#define SBK_QAnimationAspectWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DAnimation/qanimationaspect.h>

namespace PySide { class DynamicQMetaObject; }

class QAnimationAspectWrapper : public Qt3DAnimation::QAnimationAspect
{
public:
    QAnimationAspectWrapper(const QAnimationAspectWrapper &) = delete;
    QAnimationAspectWrapper& operator=(const QAnimationAspectWrapper &) = delete;
    QAnimationAspectWrapper(QAnimationAspectWrapper &&) = delete;
    QAnimationAspectWrapper& operator=(QAnimationAspectWrapper &&) = delete;

    QAnimationAspectWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    ::QStringList dependencies() const override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QAnimationAspectWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_QAnimationAspectWrapper_H

