// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAnimationCallbackWrapper_H
#define SBK_QAnimationCallbackWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DAnimation/qanimationcallback.h>

class QAnimationCallbackWrapper : public Qt3DAnimation::QAnimationCallback
{
public:
    QAnimationCallbackWrapper(const QAnimationCallbackWrapper &) = delete;
    QAnimationCallbackWrapper& operator=(const QAnimationCallbackWrapper &) = delete;
    QAnimationCallbackWrapper(QAnimationCallbackWrapper &&) = delete;
    QAnimationCallbackWrapper& operator=(QAnimationCallbackWrapper &&) = delete;

    QAnimationCallbackWrapper();
    void valueChanged(const ::QVariant & value) override;
    ~QAnimationCallbackWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QAnimationCallbackWrapper_H

