// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QVertexBlendAnimationWrapper_H
#define SBK_QVertexBlendAnimationWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DAnimation/qvertexblendanimation.h>

namespace PySide { class DynamicQMetaObject; }

class QVertexBlendAnimationWrapper : public Qt3DAnimation::QVertexBlendAnimation
{
public:
    QVertexBlendAnimationWrapper(const QVertexBlendAnimationWrapper &) = delete;
    QVertexBlendAnimationWrapper& operator=(const QVertexBlendAnimationWrapper &) = delete;
    QVertexBlendAnimationWrapper(QVertexBlendAnimationWrapper &&) = delete;
    QVertexBlendAnimationWrapper& operator=(QVertexBlendAnimationWrapper &&) = delete;

    QVertexBlendAnimationWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QVertexBlendAnimationWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QVertexBlendAnimationWrapper_H

