// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qt3danimation_python.h"

// main header
#include "qt3danimation_wrapper.h"

// inner classes
#include "qt3danimation_qmorphtarget_wrapper.h"
#include "qt3danimation_qanimationcontroller_wrapper.h"
#include "qt3danimation_qanimationgroup_wrapper.h"
#include "qt3danimation_qanimationclipdata_wrapper.h"
#include "qt3danimation_qchannel_wrapper.h"
#include "qt3danimation_qchannelcomponent_wrapper.h"
#include "qt3danimation_qkeyframe_wrapper.h"
#include "qt3danimation_qanimationcallback_wrapper.h"
#include "qt3danimation_qanimationaspect_wrapper.h"
#include "qt3danimation_qabstractclipblendnode_wrapper.h"
#include "qt3danimation_qlerpclipblend_wrapper.h"
#include "qt3danimation_qclipblendvalue_wrapper.h"
#include "qt3danimation_qadditiveclipblend_wrapper.h"
#include "qt3danimation_qabstractclipanimator_wrapper.h"
#include "qt3danimation_qclipanimator_wrapper.h"
#include "qt3danimation_qblendedclipanimator_wrapper.h"
#include "qt3danimation_qclock_wrapper.h"
#include "qt3danimation_qchannelmapper_wrapper.h"
#include "qt3danimation_qabstractchannelmapping_wrapper.h"
#include "qt3danimation_qskeletonmapping_wrapper.h"
#include "qt3danimation_qchannelmapping_wrapper.h"
#include "qt3danimation_qcallbackmapping_wrapper.h"
#include "qt3danimation_qabstractanimationclip_wrapper.h"
#include "qt3danimation_qanimationcliploader_wrapper.h"
#include "qt3danimation_qanimationclip_wrapper.h"
#include "qt3danimation_qabstractanimation_wrapper.h"
#include "qt3danimation_qvertexblendanimation_wrapper.h"
#include "qt3danimation_qmorphinganimation_wrapper.h"
#include "qt3danimation_qkeyframeanimation_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {

static const char *Sbk_Qt3DAnimation_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_Qt3DAnimation_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_Qt3DAnimation_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_Qt3DAnimation_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_Qt3DAnimation_Type = nullptr;
static PyTypeObject *Sbk_Qt3DAnimation_TypeF(void)
{
    return _Sbk_Qt3DAnimation_Type;
}

static PyType_Slot Sbk_Qt3DAnimation_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_Qt3DAnimation_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_Qt3DAnimation_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_Qt3DAnimation_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_Qt3DAnimation_spec = {
    "2:PySide6.Qt3DAnimation.Qt3DAnimation",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_Qt3DAnimation_slots
};

} //extern "C"

// Type conversion functions.

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *Qt3DAnimationQt3DAnimation_SignatureStrings[] = {
    nullptr}; // Sentinel
#else
static constexpr size_t Qt3DAnimationQt3DAnimation_SignatureByteSize = 0;
static constexpr uint8_t Qt3DAnimationQt3DAnimation_SignatureBytes[1] = {
    0x00
};
#endif

PyTypeObject *init_Qt3DAnimationQt3DAnimation(PyObject *module)
{
    if (SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimationQt3DAnimation_IDX].type != nullptr)
        return SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimationQt3DAnimation_IDX].type;

    Shiboken::AutoDecRef Sbk_Qt3DAnimation_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_Qt3DAnimation_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "Qt3DAnimation",
        "Qt3DAnimation",
        &Sbk_Qt3DAnimation_spec,
        nullptr,
        Sbk_Qt3DAnimation_Type_bases.object(),
        0);
    auto *pyType = Sbk_Qt3DAnimation_TypeF(); // references _Sbk_Qt3DAnimation_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, Qt3DAnimationQt3DAnimation_SignatureStrings);
#else
    InitSignatureBytes(pyType, Qt3DAnimationQt3DAnimation_SignatureBytes, Qt3DAnimationQt3DAnimation_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_Qt3DAnimation_PropertyStrings);
    SbkPySide6_Qt3DAnimationTypeStructs[SBK_Qt3DAnimationQt3DAnimation_IDX].type = pyType;



    return pyType;
}
