// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QBackendNodeWrapper_H
#define SBK_QBackendNodeWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DCore/qbackendnode.h>

class QBackendNodeWrapper : public Qt3DCore::QBackendNode
{
public:
    QBackendNodeWrapper(const QBackendNodeWrapper &) = delete;
    QBackendNodeWrapper& operator=(const QBackendNodeWrapper &) = delete;
    QBackendNodeWrapper(QBackendNodeWrapper &&) = delete;
    QBackendNodeWrapper& operator=(QBackendNodeWrapper &&) = delete;

    QBackendNodeWrapper(::Qt3DCore::QBackendNode::Mode mode = Qt3DCore::QBackendNode::Mode::ReadOnly);
    void syncFromFrontEnd(const ::Qt3DCore::QNode * frontEnd, bool firstTime) override;
    ~QBackendNodeWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QBackendNodeWrapper_H

