// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QBackendNodeMapperWrapper_H
#define SBK_QBackendNodeMapperWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DCore/qbackendnode.h>

class QBackendNodeMapperWrapper : public Qt3DCore::QBackendNodeMapper
{
public:
    QBackendNodeMapperWrapper(const QBackendNodeMapperWrapper &) = delete;
    QBackendNodeMapperWrapper& operator=(const QBackendNodeMapperWrapper &) = delete;
    QBackendNodeMapperWrapper(QBackendNodeMapperWrapper &&) = delete;
    QBackendNodeMapperWrapper& operator=(QBackendNodeMapperWrapper &&) = delete;

    QBackendNodeMapperWrapper();
    ::Qt3DCore::QBackendNode * create(::Qt3DCore::QNodeId id) const override;
    void destroy(::Qt3DCore::QNodeId id) const override;
    ::Qt3DCore::QBackendNode * get(::Qt3DCore::QNodeId id) const override;
    ~QBackendNodeMapperWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QBackendNodeMapperWrapper_H

