// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QCuboidGeometryViewWrapper_H
#define SBK_QCuboidGeometryViewWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DExtras/qcuboidgeometryview.h>

namespace PySide { class DynamicQMetaObject; }

class QCuboidGeometryViewWrapper : public Qt3DExtras::QCuboidGeometryView
{
public:
    QCuboidGeometryViewWrapper(const QCuboidGeometryViewWrapper &) = delete;
    QCuboidGeometryViewWrapper& operator=(const QCuboidGeometryViewWrapper &) = delete;
    QCuboidGeometryViewWrapper(QCuboidGeometryViewWrapper &&) = delete;
    QCuboidGeometryViewWrapper& operator=(QCuboidGeometryViewWrapper &&) = delete;

    QCuboidGeometryViewWrapper(::Qt3DCore::QNode * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QCuboidGeometryViewWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QCuboidGeometryViewWrapper_H

