// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QKeyEventWrapper_H
#define SBK_QKeyEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DInput/qkeyevent.h>

namespace PySide { class DynamicQMetaObject; }

class QKeyEventWrapper : public Qt3DInput::QKeyEvent
{
public:
    QKeyEventWrapper(const QKeyEventWrapper &) = delete;
    QKeyEventWrapper& operator=(const QKeyEventWrapper &) = delete;
    QKeyEventWrapper(QKeyEventWrapper &&) = delete;
    QKeyEventWrapper& operator=(QKeyEventWrapper &&) = delete;

    QKeyEventWrapper(::QEvent::Type type, int key, ::QFlags<Qt::KeyboardModifier> modifiers, const ::QString & text = QString(), bool autorep = false, ushort count = 1);
    QKeyEventWrapper(const ::QKeyEvent & ke);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QKeyEventWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QKeyEventWrapper_H

