// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qt3dinput_python.h"

// main header
#include "qt3dinput_wrapper.h"

// inner classes
#include "qt3dinput_qmousehandler_wrapper.h"
#include "qt3dinput_qwheelevent_wrapper.h"
#include "qt3dinput_qmouseevent_wrapper.h"
#include "qt3dinput_qlogicaldevice_wrapper.h"
#include "qt3dinput_qkeyboardhandler_wrapper.h"
#include "qt3dinput_qkeyevent_wrapper.h"
#include "qt3dinput_qinputsettings_wrapper.h"
#include "qt3dinput_qinputaspect_wrapper.h"
#include "qt3dinput_qaxissetting_wrapper.h"
#include "qt3dinput_qaxisaccumulator_wrapper.h"
#include "qt3dinput_qaxis_wrapper.h"
#include "qt3dinput_qaction_wrapper.h"
#include "qt3dinput_qabstractaxisinput_wrapper.h"
#include "qt3dinput_qbuttonaxisinput_wrapper.h"
#include "qt3dinput_qanalogaxisinput_wrapper.h"
#include "qt3dinput_qabstractphysicaldevice_wrapper.h"
#include "qt3dinput_qmousedevice_wrapper.h"
#include "qt3dinput_qkeyboarddevice_wrapper.h"
#include "qt3dinput_qabstractactioninput_wrapper.h"
#include "qt3dinput_qinputsequence_wrapper.h"
#include "qt3dinput_qinputchord_wrapper.h"
#include "qt3dinput_qactioninput_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {

static const char *Sbk_Qt3DInput_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_Qt3DInput_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_Qt3DInput_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_Qt3DInput_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_Qt3DInput_Type = nullptr;
static PyTypeObject *Sbk_Qt3DInput_TypeF(void)
{
    return _Sbk_Qt3DInput_Type;
}

static PyType_Slot Sbk_Qt3DInput_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_Qt3DInput_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_Qt3DInput_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_Qt3DInput_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_Qt3DInput_spec = {
    "2:PySide6.Qt3DInput.Qt3DInput",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_Qt3DInput_slots
};

} //extern "C"

// Type conversion functions.

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *Qt3DInputQt3DInput_SignatureStrings[] = {
    nullptr}; // Sentinel
#else
static constexpr size_t Qt3DInputQt3DInput_SignatureByteSize = 0;
static constexpr uint8_t Qt3DInputQt3DInput_SignatureBytes[1] = {
    0x00
};
#endif

PyTypeObject *init_Qt3DInputQt3DInput(PyObject *module)
{
    if (SbkPySide6_Qt3DInputTypeStructs[SBK_Qt3DInputQt3DInput_IDX].type != nullptr)
        return SbkPySide6_Qt3DInputTypeStructs[SBK_Qt3DInputQt3DInput_IDX].type;

    Shiboken::AutoDecRef Sbk_Qt3DInput_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_Qt3DInput_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "Qt3DInput",
        "Qt3DInput",
        &Sbk_Qt3DInput_spec,
        nullptr,
        Sbk_Qt3DInput_Type_bases.object(),
        0);
    auto *pyType = Sbk_Qt3DInput_TypeF(); // references _Sbk_Qt3DInput_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, Qt3DInputQt3DInput_SignatureStrings);
#else
    InitSignatureBytes(pyType, Qt3DInputQt3DInput_SignatureBytes, Qt3DInputQt3DInput_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_Qt3DInput_PropertyStrings);
    SbkPySide6_Qt3DInputTypeStructs[SBK_Qt3DInputQt3DInput_IDX].type = pyType;



    return pyType;
}
