// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QCameraSelectorWrapper_H
#define SBK_QCameraSelectorWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DRender/qcameraselector.h>

namespace PySide { class DynamicQMetaObject; }

class QCameraSelectorWrapper : public Qt3DRender::QCameraSelector
{
public:
    QCameraSelectorWrapper(const QCameraSelectorWrapper &) = delete;
    QCameraSelectorWrapper& operator=(const QCameraSelectorWrapper &) = delete;
    QCameraSelectorWrapper(QCameraSelectorWrapper &&) = delete;
    QCameraSelectorWrapper& operator=(QCameraSelectorWrapper &&) = delete;

    QCameraSelectorWrapper(::Qt3DCore::QNode * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QCameraSelectorWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QCameraSelectorWrapper_H

