// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRenderCaptureReplyWrapper_H
#define SBK_QRenderCaptureReplyWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DRender/qrendercapture.h>

namespace PySide { class DynamicQMetaObject; }

class QRenderCaptureReplyWrapper : public Qt3DRender::QRenderCaptureReply
{
public:
    QRenderCaptureReplyWrapper(const QRenderCaptureReplyWrapper &) = delete;
    QRenderCaptureReplyWrapper& operator=(const QRenderCaptureReplyWrapper &) = delete;
    QRenderCaptureReplyWrapper(QRenderCaptureReplyWrapper &&) = delete;
    QRenderCaptureReplyWrapper& operator=(QRenderCaptureReplyWrapper &&) = delete;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QRenderCaptureReplyWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QRenderCaptureReplyWrapper_H

