// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QStencilTestArgumentsWrapper_H
#define SBK_QStencilTestArgumentsWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DRender/qstenciltestarguments.h>

namespace PySide { class DynamicQMetaObject; }

class QStencilTestArgumentsWrapper : public Qt3DRender::QStencilTestArguments
{
public:
    QStencilTestArgumentsWrapper(const QStencilTestArgumentsWrapper &) = delete;
    QStencilTestArgumentsWrapper& operator=(const QStencilTestArgumentsWrapper &) = delete;
    QStencilTestArgumentsWrapper(QStencilTestArgumentsWrapper &&) = delete;
    QStencilTestArgumentsWrapper& operator=(QStencilTestArgumentsWrapper &&) = delete;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QStencilTestArgumentsWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QStencilTestArgumentsWrapper_H

