// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qt3drender_python.h"

// main header
#include "qt3drender_qtexturedataupdate_wrapper.h"

// Argument includes
#include <Qt3DRender/qabstracttexture.h>
#include <Qt3DRender/qtexturedataupdate.h>
#include <Qt3DRender/qtextureimagedata.h>
#include <qsharedpointer.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>

using namespace Qt3DRender;


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_Qt3DRender_QTextureDataUpdate_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::Qt3DRender::QTextureDataUpdate >()))
        return -1;

    ::Qt3DRender::QTextureDataUpdate *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QTextureDataUpdate", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QTextureDataUpdate::QTextureDataUpdate()
    // 1: QTextureDataUpdate::QTextureDataUpdate(Qt3DRender::QTextureDataUpdate)
    if (numArgs == 0) {
        overloadId = 0; // QTextureDataUpdate()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QTextureDataUpdate(Qt3DRender::QTextureDataUpdate)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QTextureDataUpdate()
        {

            // QTextureDataUpdate()
            cptr = new ::Qt3DRender::QTextureDataUpdate();
            break;
        }
        case 1: // QTextureDataUpdate(const Qt3DRender::QTextureDataUpdate &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::Qt3DRender::QTextureDataUpdate cppArg0_local;
            ::Qt3DRender::QTextureDataUpdate *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QTextureDataUpdate(Qt3DRender::QTextureDataUpdate)
                cptr = new ::Qt3DRender::QTextureDataUpdate(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::Qt3DRender::QTextureDataUpdate >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_Qt3DRender_QTextureDataUpdateFunc_data(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QTextureDataUpdate *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // data()const
        QSharedPointer<Qt3DRender::QTextureImageData> cppResult = const_cast<const ::Qt3DRender::QTextureDataUpdate *>(cppSelf)->data();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_QSharedPointer_Qt3DRender_QTextureImageData_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QTextureDataUpdateFunc_face(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QTextureDataUpdate *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // face()const
        Qt3DRender::QAbstractTexture::CubeMapFace cppResult = const_cast<const ::Qt3DRender::QTextureDataUpdate *>(cppSelf)->face();
        pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QAbstractTexture_CubeMapFace_IDX])))->converter, &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QTextureDataUpdateFunc_layer(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QTextureDataUpdate *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // layer()const
        int cppResult = const_cast<const ::Qt3DRender::QTextureDataUpdate *>(cppSelf)->layer();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QTextureDataUpdateFunc_mipLevel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QTextureDataUpdate *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // mipLevel()const
        int cppResult = const_cast<const ::Qt3DRender::QTextureDataUpdate *>(cppSelf)->mipLevel();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QTextureDataUpdateFunc_setData(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QTextureDataUpdate *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QTextureDataUpdate::setData(QSharedPointer<Qt3DRender::QTextureImageData>)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_QSharedPointer_Qt3DRender_QTextureImageData_IDX]), (pyArg)))) {
        overloadId = 0; // setData(QSharedPointer<Qt3DRender::QTextureImageData>)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setData", errInfo, SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QSharedPointer<Qt3DRender::QTextureImageData> cppArg0_local;
        ::QSharedPointer<Qt3DRender::QTextureImageData> *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setData(QSharedPointer<Qt3DRender::QTextureImageData>)
            cppSelf->setData(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_Qt3DRender_QTextureDataUpdateFunc_setFace(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QTextureDataUpdate *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QTextureDataUpdate::setFace(Qt3DRender::QAbstractTexture::CubeMapFace)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QAbstractTexture_CubeMapFace_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setFace(Qt3DRender::QAbstractTexture::CubeMapFace)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setFace", errInfo, SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]);

    // Call function/method
    {
        ::Qt3DRender::QAbstractTexture::CubeMapFace cppArg0 = static_cast< ::Qt3DRender::QAbstractTexture::CubeMapFace>(0);
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setFace(Qt3DRender::QAbstractTexture::CubeMapFace)
            cppSelf->setFace(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_Qt3DRender_QTextureDataUpdateFunc_setLayer(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QTextureDataUpdate *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QTextureDataUpdate::setLayer(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setLayer(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setLayer", errInfo, SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setLayer(int)
            cppSelf->setLayer(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_Qt3DRender_QTextureDataUpdateFunc_setMipLevel(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QTextureDataUpdate *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QTextureDataUpdate::setMipLevel(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setMipLevel(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setMipLevel", errInfo, SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setMipLevel(int)
            cppSelf->setMipLevel(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_Qt3DRender_QTextureDataUpdateFunc_setX(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QTextureDataUpdate *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QTextureDataUpdate::setX(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setX(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setX", errInfo, SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setX(int)
            cppSelf->setX(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_Qt3DRender_QTextureDataUpdateFunc_setY(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QTextureDataUpdate *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QTextureDataUpdate::setY(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setY(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setY", errInfo, SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setY(int)
            cppSelf->setY(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_Qt3DRender_QTextureDataUpdateFunc_setZ(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QTextureDataUpdate *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QTextureDataUpdate::setZ(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setZ(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setZ", errInfo, SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setZ(int)
            cppSelf->setZ(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_Qt3DRender_QTextureDataUpdateFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QTextureDataUpdate *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QTextureDataUpdate::swap(Qt3DRender::QTextureDataUpdate&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), (pyArg)))) {
        overloadId = 0; // swap(Qt3DRender::QTextureDataUpdate&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "swap", errInfo, SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::Qt3DRender::QTextureDataUpdate cppArg0_local;
        ::Qt3DRender::QTextureDataUpdate *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(Qt3DRender::QTextureDataUpdate&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_Qt3DRender_QTextureDataUpdateFunc_x(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QTextureDataUpdate *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // x()const
        int cppResult = const_cast<const ::Qt3DRender::QTextureDataUpdate *>(cppSelf)->x();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QTextureDataUpdateFunc_y(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QTextureDataUpdate *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // y()const
        int cppResult = const_cast<const ::Qt3DRender::QTextureDataUpdate *>(cppSelf)->y();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QTextureDataUpdateFunc_z(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::Qt3DRender::QTextureDataUpdate *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // z()const
        int cppResult = const_cast<const ::Qt3DRender::QTextureDataUpdate *>(cppSelf)->z();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_Qt3DRender_QTextureDataUpdate__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::Qt3DRender::QTextureDataUpdate *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_Qt3DRender_QTextureDataUpdate_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_Qt3DRender_QTextureDataUpdate_methods[] = {
    {"data", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureDataUpdateFunc_data), METH_NOARGS, nullptr},
    {"face", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureDataUpdateFunc_face), METH_NOARGS, nullptr},
    {"layer", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureDataUpdateFunc_layer), METH_NOARGS, nullptr},
    {"mipLevel", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureDataUpdateFunc_mipLevel), METH_NOARGS, nullptr},
    {"setData", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureDataUpdateFunc_setData), METH_O, nullptr},
    {"setFace", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureDataUpdateFunc_setFace), METH_O, nullptr},
    {"setLayer", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureDataUpdateFunc_setLayer), METH_O, nullptr},
    {"setMipLevel", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureDataUpdateFunc_setMipLevel), METH_O, nullptr},
    {"setX", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureDataUpdateFunc_setX), METH_O, nullptr},
    {"setY", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureDataUpdateFunc_setY), METH_O, nullptr},
    {"setZ", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureDataUpdateFunc_setZ), METH_O, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureDataUpdateFunc_swap), METH_O, nullptr},
    {"x", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureDataUpdateFunc_x), METH_NOARGS, nullptr},
    {"y", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureDataUpdateFunc_y), METH_NOARGS, nullptr},
    {"z", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureDataUpdateFunc_z), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_Qt3DRender_QTextureDataUpdate__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_Qt3DRender_QTextureDataUpdate_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::Qt3DRender::QTextureDataUpdate *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), (pyArg)))) {
                // operator!=(const Qt3DRender::QTextureDataUpdate &rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::Qt3DRender::QTextureDataUpdate cppArg0_local;
                ::Qt3DRender::QTextureDataUpdate *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), (pyArg)))) {
                // operator==(const Qt3DRender::QTextureDataUpdate &rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::Qt3DRender::QTextureDataUpdate cppArg0_local;
                ::Qt3DRender::QTextureDataUpdate *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_Qt3DRender_QTextureDataUpdate_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_Qt3DRender_QTextureDataUpdate_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_Qt3DRender_QTextureDataUpdate_Type = nullptr;
static PyTypeObject *Sbk_Qt3DRender_QTextureDataUpdate_TypeF(void)
{
    return _Sbk_Qt3DRender_QTextureDataUpdate_Type;
}

static PyType_Slot Sbk_Qt3DRender_QTextureDataUpdate_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_Qt3DRender_QTextureDataUpdate_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_Qt3DRender_QTextureDataUpdate_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_Qt3DRender_QTextureDataUpdate_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_Qt3DRender_QTextureDataUpdate_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_Qt3DRender_QTextureDataUpdate_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_Qt3DRender_QTextureDataUpdate_spec = {
    "2:PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_Qt3DRender_QTextureDataUpdate_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QTextureDataUpdate_PythonToCpp_QTextureDataUpdate_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_Qt3DRender_QTextureDataUpdate_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QTextureDataUpdate_PythonToCpp_QTextureDataUpdate_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_Qt3DRender_QTextureDataUpdate_TypeF()))
        return QTextureDataUpdate_PythonToCpp_QTextureDataUpdate_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QTextureDataUpdate_PTR_CppToPython_QTextureDataUpdate(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_Qt3DRender_QTextureDataUpdate_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QTextureDataUpdate_COPY_CppToPython_QTextureDataUpdate(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::Qt3DRender::QTextureDataUpdate *>(cppIn);
    return Shiboken::Object::newObject(Sbk_Qt3DRender_QTextureDataUpdate_TypeF(), new ::Qt3DRender::QTextureDataUpdate(*source), true, true);
}

// Python to C++ copy conversion.
static void QTextureDataUpdate_PythonToCpp_QTextureDataUpdate_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::Qt3DRender::QTextureDataUpdate *>(cppOut) = *reinterpret_cast< ::Qt3DRender::QTextureDataUpdate *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QTextureDataUpdate_PythonToCpp_QTextureDataUpdate_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_Qt3DRender_QTextureDataUpdate_TypeF()))
        return QTextureDataUpdate_PythonToCpp_QTextureDataUpdate_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *Qt3DRender_QTextureDataUpdate_SignatureStrings[] = {
    "1:PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate(self)",
    "0:PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate(self,other:PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate)",
    "PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate.data(self)->PySide6.Qt3DRender.Qt3DRender.QTextureImageDataPtr",
    "PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate.face(self)->PySide6.Qt3DRender.Qt3DRender.QAbstractTexture.CubeMapFace",
    "PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate.layer(self)->int",
    "PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate.mipLevel(self)->int",
    "PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate.setData(self,data:PySide6.Qt3DRender.Qt3DRender.QTextureImageDataPtr)",
    "PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate.setFace(self,face:PySide6.Qt3DRender.Qt3DRender.QAbstractTexture.CubeMapFace)",
    "PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate.setLayer(self,layer:int)",
    "PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate.setMipLevel(self,mipLevel:int)",
    "PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate.setX(self,x:int)",
    "PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate.setY(self,y:int)",
    "PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate.setZ(self,z:int)",
    "PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate.swap(self,other:PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate)",
    "PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate.x(self)->int",
    "PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate.y(self)->int",
    "PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate.z(self)->int",
    "PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate.__copy__(self)->typing.Self",
    "PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate.__ne__(self,rhs:PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate)->bool",
    "PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate.__eq__(self,rhs:PySide6.Qt3DRender.Qt3DRender.QTextureDataUpdate)->bool",
    nullptr}; // Sentinel
#else
static constexpr size_t Qt3DRender_QTextureDataUpdate_SignatureByteSize = 268;
static constexpr uint8_t Qt3DRender_QTextureDataUpdate_SignatureBytes[268] = {
    0x78, 0xda, 0xbd, 0x94, 0x4d, 0x6b, 0xc2, 0x40, 0x10, 0x86, 0xef, 0xfe, 0x12, 0x03, 0x6b, 0x68,
    0x29, 0xf4, 0x90, 0x83, 0x50, 0x1a, 0x84, 0x82, 0x82, 0x35, 0x16, 0x6a, 0x2f, 0x61, 0x92, 0x8c,
    0x1a, 0x88, 0xc9, 0xba, 0x99, 0x68, 0xd6, 0x5f, 0x6f, 0x3e, 0xdc, 0xd2, 0xde, 0xdc, 0x49, 0xe9,
    0x65, 0xd9, 0x3d, 0xbc, 0xcf, 0xb3, 0xbc, 0xc3, 0xee, 0xa3, 0xb7, 0xd4, 0x41, 0x9a, 0xe0, 0xb3,
    0xfb, 0x4e, 0x4f, 0xfe, 0x0a, 0xf3, 0x04, 0xd5, 0xaf, 0xed, 0x1a, 0x6b, 0xaa, 0x14, 0xfa, 0x40,
    0xf0, 0x21, 0x13, 0x20, 0x1c, 0x97, 0x98, 0x6d, 0x9d, 0xd1, 0x03, 0x2f, 0x28, 0x0a, 0xda, 0xa3,
    0xb2, 0xce, 0x3a, 0x23, 0xdb, 0x84, 0xdb, 0x2c, 0xd0, 0xdf, 0x75, 0x32, 0xbd, 0x2f, 0xfc, 0x76,
    0x80, 0x5d, 0x47, 0x58, 0x92, 0xb2, 0xf7, 0x6d, 0x21, 0xc6, 0x3b, 0x7d, 0x2f, 0x51, 0x49, 0x0a,
    0x62, 0xba, 0x41, 0xdc, 0xd7, 0x2a, 0xc2, 0x05, 0xc8, 0x59, 0x43, 0xb0, 0xf7, 0x66, 0xa0, 0x51,
    0x19, 0x71, 0x9a, 0x93, 0x3d, 0xe1, 0x90, 0xca, 0x39, 0x9e, 0x30, 0x1b, 0x04, 0x29, 0x91, 0x7c,
    0xd3, 0xb8, 0x68, 0xbb, 0xf7, 0xec, 0x4b, 0x77, 0x58, 0xda, 0x99, 0x29, 0x5e, 0xb4, 0x23, 0xf0,
    0xf8, 0xdd, 0xf3, 0xf4, 0xf3, 0xef, 0xfe, 0x45, 0x37, 0x0a, 0xaf, 0xa9, 0x8f, 0x47, 0x5a, 0xfc,
    0x9c, 0x83, 0x30, 0x53, 0xe1, 0xf3, 0x3e, 0x7b, 0x50, 0xcd, 0x27, 0x6c, 0x7a, 0x82, 0xe6, 0x13,
    0xbe, 0x7a, 0xc2, 0x85, 0x4b, 0x38, 0x83, 0xfc, 0xe7, 0x7f, 0xa3, 0x1e, 0xf4, 0x0c, 0xf4, 0xa0,
    0xf4, 0x65, 0x50, 0x3a, 0x0c, 0xe3, 0x42, 0xea, 0x30, 0x34, 0x10, 0xd2, 0x32, 0xcd, 0x77, 0x6e,
    0xd0, 0x9c, 0x38, 0xb0, 0x1c, 0x6f, 0x28, 0xa1, 0xf6, 0xa5, 0x7d, 0xf3, 0x93, 0x69, 0x54, 0x14,
    0x19, 0x47, 0x8c, 0xc7, 0xbf, 0x10, 0x5f, 0x01, 0x65, 0xc2, 0x6f, 0xc9
};
#endif

PyTypeObject *init_Qt3DRender_QTextureDataUpdate(PyObject *enclosingClass)
{
    if (SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX].type != nullptr)
        return SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX].type;

    Shiboken::AutoDecRef Sbk_Qt3DRender_QTextureDataUpdate_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_Qt3DRender_QTextureDataUpdate_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "QTextureDataUpdate",
        "Qt3DRender::QTextureDataUpdate",
        &Sbk_Qt3DRender_QTextureDataUpdate_spec,
        &Shiboken::callCppDestructor< ::Qt3DRender::QTextureDataUpdate >,
        Sbk_Qt3DRender_QTextureDataUpdate_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_Qt3DRender_QTextureDataUpdate_TypeF(); // references _Sbk_Qt3DRender_QTextureDataUpdate_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, Qt3DRender_QTextureDataUpdate_SignatureStrings);
#else
    InitSignatureBytes(pyType, Qt3DRender_QTextureDataUpdate_SignatureBytes, Qt3DRender_QTextureDataUpdate_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_Qt3DRender_QTextureDataUpdate_PropertyStrings);
    SbkPySide6_Qt3DRenderTypeStructs[SBK_Qt3DRender_QTextureDataUpdate_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QTextureDataUpdate_PythonToCpp_QTextureDataUpdate_PTR,
        is_QTextureDataUpdate_PythonToCpp_QTextureDataUpdate_PTR_Convertible,
        QTextureDataUpdate_PTR_CppToPython_QTextureDataUpdate,
        QTextureDataUpdate_COPY_CppToPython_QTextureDataUpdate);

    Shiboken::Conversions::registerConverterName(converter, "Qt3DRender::QTextureDataUpdate");
    Shiboken::Conversions::registerConverterName(converter, "Qt3DRender::QTextureDataUpdate*");
    Shiboken::Conversions::registerConverterName(converter, "Qt3DRender::QTextureDataUpdate&");
    Shiboken::Conversions::registerConverterAlias(converter, "QTextureDataUpdate");
    Shiboken::Conversions::registerConverterAlias(converter, "QTextureDataUpdate*");
    Shiboken::Conversions::registerConverterAlias(converter, "QTextureDataUpdate&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::Qt3DRender::QTextureDataUpdate).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QTextureDataUpdate_PythonToCpp_QTextureDataUpdate_COPY,
        is_QTextureDataUpdate_PythonToCpp_QTextureDataUpdate_COPY_Convertible);

    qRegisterMetaType< ::Qt3DRender::QTextureDataUpdate >("QTextureDataUpdate");
    qRegisterMetaType< ::Qt3DRender::QTextureDataUpdate >("Qt3DRender::QTextureDataUpdate");

    return pyType;
}
