// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtbluetooth_python.h"

// main header
#include "qlowenergyadvertisingparameters_addressinfo_wrapper.h"

// Argument includes
#include <QtBluetooth/qbluetoothaddress.h>
#include <QtBluetooth/qlowenergyadvertisingparameters.h>
#include <QtBluetooth/qlowenergycontroller.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QLowEnergyAdvertisingParameters_AddressInfo_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QLowEnergyAdvertisingParameters::AddressInfo >()))
        return -1;

    ::QLowEnergyAdvertisingParameters::AddressInfo *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "AddressInfo", 0, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: AddressInfo::AddressInfo()
    // 1: AddressInfo::AddressInfo(QBluetoothAddress,QLowEnergyController::RemoteAddressType)
    // 2: AddressInfo::AddressInfo(QLowEnergyAdvertisingParameters::AddressInfo)
    if (numArgs == 0) {
        overloadId = 0; // AddressInfo()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_AddressInfo_IDX]), (pyArgs[0])))) {
        overloadId = 2; // AddressInfo(QLowEnergyAdvertisingParameters::AddressInfo)
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothAddress_IDX]), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyController_RemoteAddressType_IDX])))->converter, (pyArgs[1])))) {
        overloadId = 1; // AddressInfo(QBluetoothAddress,QLowEnergyController::RemoteAddressType)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_AddressInfo_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_AddressInfo_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // AddressInfo()
        {

            // AddressInfo()
            cptr = new ::QLowEnergyAdvertisingParameters::AddressInfo();
            break;
        }
        case 1: // AddressInfo(const QBluetoothAddress &addr, QLowEnergyController::RemoteAddressType t)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QBluetoothAddress cppArg0_local;
            ::QBluetoothAddress *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);

            ::QLowEnergyController::RemoteAddressType cppArg1{QLowEnergyController::PublicAddress};
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // AddressInfo(QBluetoothAddress,QLowEnergyController::RemoteAddressType)
                cptr = new ::QLowEnergyAdvertisingParameters::AddressInfo(*cppArg0, cppArg1);
            }
            break;
        }
        case 2: // AddressInfo(const QLowEnergyAdvertisingParameters::AddressInfo &AddressInfo)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QLowEnergyAdvertisingParameters::AddressInfo cppArg0_local;
            ::QLowEnergyAdvertisingParameters::AddressInfo *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // AddressInfo(QLowEnergyAdvertisingParameters::AddressInfo)
                cptr = new ::QLowEnergyAdvertisingParameters::AddressInfo(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QLowEnergyAdvertisingParameters::AddressInfo >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_AddressInfo_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QLowEnergyAdvertisingParameters_AddressInfo__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QLowEnergyAdvertisingParameters::AddressInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_AddressInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_AddressInfo_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QLowEnergyAdvertisingParameters_AddressInfo_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QLowEnergyAdvertisingParameters_AddressInfo_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyAdvertisingParameters_AddressInfo__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QLowEnergyAdvertisingParameters_AddressInfo_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QLowEnergyAdvertisingParameters::AddressInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_AddressInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_AddressInfo_IDX]), (pyArg)))) {
                // operator!=(const QLowEnergyAdvertisingParameters::AddressInfo &b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QLowEnergyAdvertisingParameters::AddressInfo cppArg0_local;
                ::QLowEnergyAdvertisingParameters::AddressInfo *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_AddressInfo_IDX]), (pyArg)))) {
                // operator==(const QLowEnergyAdvertisingParameters::AddressInfo &b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QLowEnergyAdvertisingParameters::AddressInfo cppArg0_local;
                ::QLowEnergyAdvertisingParameters::AddressInfo *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

static PyObject *Sbk_QLowEnergyAdvertisingParameters_AddressInfo_get_address(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingParameters::AddressInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_AddressInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->address)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothAddress_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->address))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->address)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothAddress_IDX]), &(cppSelf->address), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QLowEnergyAdvertisingParameters_AddressInfo_set_address(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingParameters::AddressInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_AddressInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("address");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QBluetoothAddress_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("address", "QBluetoothAddress");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->address;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QLowEnergyAdvertisingParameters_AddressInfo_get_type(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingParameters::AddressInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_AddressInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QLowEnergyController::RemoteAddressType cppOut_local = cppSelf->type;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyController_RemoteAddressType_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QLowEnergyAdvertisingParameters_AddressInfo_set_type(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QLowEnergyAdvertisingParameters::AddressInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_AddressInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("type");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyController_RemoteAddressType_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("type", "RemoteAddressType");
        return -1;
    }

    auto cppOut_local = cppSelf->type;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->type = cppOut_local;

    return 0;
}

// Getters and Setters for AddressInfo
static PyGetSetDef Sbk_QLowEnergyAdvertisingParameters_AddressInfo_getsetlist[] = {
    {const_cast<char *>("address"), Sbk_QLowEnergyAdvertisingParameters_AddressInfo_get_address, Sbk_QLowEnergyAdvertisingParameters_AddressInfo_set_address, nullptr, nullptr},
    {const_cast<char *>("type"), Sbk_QLowEnergyAdvertisingParameters_AddressInfo_get_type, Sbk_QLowEnergyAdvertisingParameters_AddressInfo_set_type, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QLowEnergyAdvertisingParameters_AddressInfo_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QLowEnergyAdvertisingParameters_AddressInfo_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QLowEnergyAdvertisingParameters_AddressInfo_Type = nullptr;
static PyTypeObject *Sbk_QLowEnergyAdvertisingParameters_AddressInfo_TypeF(void)
{
    return _Sbk_QLowEnergyAdvertisingParameters_AddressInfo_Type;
}

static PyType_Slot Sbk_QLowEnergyAdvertisingParameters_AddressInfo_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingParameters_AddressInfo_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingParameters_AddressInfo_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingParameters_AddressInfo_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingParameters_AddressInfo_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingParameters_AddressInfo_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QLowEnergyAdvertisingParameters_AddressInfo_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QLowEnergyAdvertisingParameters_AddressInfo_spec = {
    "2:PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.AddressInfo",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QLowEnergyAdvertisingParameters_AddressInfo_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void AddressInfo_PythonToCpp_AddressInfo_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QLowEnergyAdvertisingParameters_AddressInfo_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_AddressInfo_PythonToCpp_AddressInfo_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QLowEnergyAdvertisingParameters_AddressInfo_TypeF()))
        return AddressInfo_PythonToCpp_AddressInfo_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *AddressInfo_PTR_CppToPython_AddressInfo(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QLowEnergyAdvertisingParameters_AddressInfo_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *AddressInfo_COPY_CppToPython_AddressInfo(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QLowEnergyAdvertisingParameters::AddressInfo *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QLowEnergyAdvertisingParameters_AddressInfo_TypeF(), new ::QLowEnergyAdvertisingParameters::AddressInfo(*source), true, true);
}

// Python to C++ copy conversion.
static void AddressInfo_PythonToCpp_AddressInfo_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QLowEnergyAdvertisingParameters::AddressInfo *>(cppOut) = *reinterpret_cast< ::QLowEnergyAdvertisingParameters::AddressInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_AddressInfo_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_AddressInfo_PythonToCpp_AddressInfo_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QLowEnergyAdvertisingParameters_AddressInfo_TypeF()))
        return AddressInfo_PythonToCpp_AddressInfo_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QLowEnergyAdvertisingParameters_AddressInfo_SignatureStrings[] = {
    "2:PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.AddressInfo(self)",
    "1:PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.AddressInfo(self,addr:PySide6.QtBluetooth.QBluetoothAddress,t:PySide6.QtBluetooth.QLowEnergyController.RemoteAddressType)",
    "0:PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.AddressInfo(self,AddressInfo:PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.AddressInfo)",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.AddressInfo.__copy__(self)->typing.Self",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.AddressInfo.__ne__(self,b:PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.AddressInfo)->bool",
    "PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.AddressInfo.__eq__(self,b:PySide6.QtBluetooth.QLowEnergyAdvertisingParameters.AddressInfo)->bool",
    nullptr}; // Sentinel
#else
static constexpr size_t QLowEnergyAdvertisingParameters_AddressInfo_SignatureByteSize = 178;
static constexpr uint8_t QLowEnergyAdvertisingParameters_AddressInfo_SignatureBytes[178] = {
    0x78, 0xda, 0xad, 0x91, 0x3f, 0x0b, 0xc2, 0x40, 0x0c, 0xc5, 0xf7, 0x7e, 0x12, 0x0b, 0xed, 0xa1,
    0x0e, 0x0e, 0x0e, 0x85, 0x2a, 0x0e, 0x82, 0x43, 0x6b, 0xdd, 0x8f, 0xd6, 0x4b, 0xff, 0xc0, 0xf5,
    0x52, 0x73, 0x51, 0xb9, 0x6f, 0x6f, 0xc1, 0x22, 0x0e, 0x82, 0x43, 0x6f, 0x4b, 0x1e, 0x79, 0xbf,
    0xbc, 0x90, 0xf5, 0x36, 0x73, 0x45, 0xa7, 0x60, 0x23, 0x72, 0xde, 0xe9, 0x3b, 0x30, 0x22, 0xb7,
    0x22, 0x3f, 0xe1, 0xf3, 0x60, 0x80, 0x1a, 0x97, 0xaa, 0x07, 0x10, 0x77, 0xb6, 0x33, 0x4d, 0x56,
    0x52, 0xd9, 0x03, 0x03, 0x59, 0x91, 0x2a, 0x45, 0x60, 0xed, 0xd1, 0xd4, 0xb8, 0xb0, 0xa0, 0xeb,
    0x30, 0x58, 0x79, 0xe1, 0x44, 0xe5, 0x28, 0xfc, 0x26, 0x7d, 0xca, 0xc9, 0x13, 0xf1, 0x9f, 0x8d,
    0x7b, 0x34, 0x4c, 0xa8, 0x35, 0x90, 0x38, 0x43, 0x8f, 0x0c, 0x93, 0xf1, 0xe2, 0x06, 0x08, 0x83,
    0xa5, 0x9f, 0xbc, 0x5f, 0xc2, 0x5c, 0x60, 0x18, 0xcc, 0x04, 0x08, 0x29, 0xaf, 0x38, 0x38, 0x29,
    0xdf, 0x2f, 0x89, 0x13, 0x76, 0xc3, 0x38, 0x2c, 0x8a, 0xb1, 0xf3, 0xc0, 0x36, 0x30, 0x91, 0xa3,
    0x6a, 0xf6, 0xa9, 0x71, 0x52, 0x21, 0x6a, 0x0f, 0xa1, 0xe0, 0xe6, 0x3d, 0xd4, 0x0b, 0x49, 0xef,
    0x27, 0xb2
};
#endif

PyTypeObject *init_QLowEnergyAdvertisingParameters_AddressInfo(PyObject *enclosingClass)
{
    if (SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_AddressInfo_IDX].type != nullptr)
        return SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_AddressInfo_IDX].type;

    Shiboken::AutoDecRef Sbk_QLowEnergyAdvertisingParameters_AddressInfo_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QLowEnergyAdvertisingParameters_AddressInfo_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "AddressInfo",
        "QLowEnergyAdvertisingParameters::AddressInfo",
        &Sbk_QLowEnergyAdvertisingParameters_AddressInfo_spec,
        &Shiboken::callCppDestructor< ::QLowEnergyAdvertisingParameters::AddressInfo >,
        Sbk_QLowEnergyAdvertisingParameters_AddressInfo_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QLowEnergyAdvertisingParameters_AddressInfo_TypeF(); // references _Sbk_QLowEnergyAdvertisingParameters_AddressInfo_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QLowEnergyAdvertisingParameters_AddressInfo_SignatureStrings);
#else
    InitSignatureBytes(pyType, QLowEnergyAdvertisingParameters_AddressInfo_SignatureBytes, QLowEnergyAdvertisingParameters_AddressInfo_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QLowEnergyAdvertisingParameters_AddressInfo_PropertyStrings);
    SbkPySide6_QtBluetoothTypeStructs[SBK_QLowEnergyAdvertisingParameters_AddressInfo_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        AddressInfo_PythonToCpp_AddressInfo_PTR,
        is_AddressInfo_PythonToCpp_AddressInfo_PTR_Convertible,
        AddressInfo_PTR_CppToPython_AddressInfo,
        AddressInfo_COPY_CppToPython_AddressInfo);

    Shiboken::Conversions::registerConverterName(converter, "QLowEnergyAdvertisingParameters::AddressInfo");
    Shiboken::Conversions::registerConverterName(converter, "QLowEnergyAdvertisingParameters::AddressInfo*");
    Shiboken::Conversions::registerConverterName(converter, "QLowEnergyAdvertisingParameters::AddressInfo&");
    Shiboken::Conversions::registerConverterAlias(converter, "AddressInfo");
    Shiboken::Conversions::registerConverterAlias(converter, "AddressInfo*");
    Shiboken::Conversions::registerConverterAlias(converter, "AddressInfo&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QLowEnergyAdvertisingParameters::AddressInfo).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        AddressInfo_PythonToCpp_AddressInfo_COPY,
        is_AddressInfo_PythonToCpp_AddressInfo_COPY_Convertible);

    qRegisterMetaType< ::QLowEnergyAdvertisingParameters::AddressInfo >("AddressInfo");
    qRegisterMetaType< ::QLowEnergyAdvertisingParameters::AddressInfo >("QLowEnergyAdvertisingParameters::AddressInfo");

    return pyType;
}
