// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QScatterSeriesWrapper_H
#define SBK_QScatterSeriesWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtCharts/qscatterseries.h>

namespace PySide { class DynamicQMetaObject; }

class QScatterSeriesWrapper : public QScatterSeries
{
public:
    QScatterSeriesWrapper(const QScatterSeriesWrapper &) = delete;
    QScatterSeriesWrapper& operator=(const QScatterSeriesWrapper &) = delete;
    QScatterSeriesWrapper(QScatterSeriesWrapper &&) = delete;
    QScatterSeriesWrapper& operator=(QScatterSeriesWrapper &&) = delete;

    QScatterSeriesWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    ::QColor color() const override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void setBrush(const ::QBrush & brush) override;
    void setColor(const ::QColor & color) override;
    void setPen(const ::QPen & pen) override;
    void timerEvent(::QTimerEvent * event) override;
    ::QAbstractSeries::SeriesType type() const override;
    ~QScatterSeriesWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[12] = {false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QScatterSeriesWrapper_H

