// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAbstractAnimationWrapper_H
#define SBK_QAbstractAnimationWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qabstractanimation.h>

namespace PySide { class DynamicQMetaObject; }

class QAbstractAnimationWrapper : public QAbstractAnimation
{
public:
    QAbstractAnimationWrapper(const QAbstractAnimationWrapper &) = delete;
    QAbstractAnimationWrapper& operator=(const QAbstractAnimationWrapper &) = delete;
    QAbstractAnimationWrapper(QAbstractAnimationWrapper &&) = delete;
    QAbstractAnimationWrapper& operator=(QAbstractAnimationWrapper &&) = delete;

    QAbstractAnimationWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    int duration() const override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    void updateCurrentTime(int currentTime) override;
    void updateDirection(::QAbstractAnimation::Direction direction) override;
    void updateState(::QAbstractAnimation::State newState, ::QAbstractAnimation::State oldState) override;
    ~QAbstractAnimationWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[11] = {false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QAbstractAnimationWrapper_H

