// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAbstractNativeEventFilterWrapper_H
#define SBK_QAbstractNativeEventFilterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qabstractnativeeventfilter.h>

class QAbstractNativeEventFilterWrapper : public QAbstractNativeEventFilter
{
public:
    QAbstractNativeEventFilterWrapper(const QAbstractNativeEventFilterWrapper &) = delete;
    QAbstractNativeEventFilterWrapper& operator=(const QAbstractNativeEventFilterWrapper &) = delete;
    QAbstractNativeEventFilterWrapper(QAbstractNativeEventFilterWrapper &&) = delete;
    QAbstractNativeEventFilterWrapper& operator=(QAbstractNativeEventFilterWrapper &&) = delete;

    QAbstractNativeEventFilterWrapper();
    bool nativeEventFilter(const ::QByteArray & eventType, void * message, ::qintptr * result) override;
    ~QAbstractNativeEventFilterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QAbstractNativeEventFilterWrapper_H

