// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qcalendar_systemid_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QCalendar_SystemId_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(args)
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QCalendar::SystemId >()))
        return -1;

    ::QCalendar::SystemId *cptr{};
    Shiboken::PythonContextMarker pcm;


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_SystemId_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {

        // SystemId()
        cptr = new ::QCalendar::SystemId();
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QCalendar::SystemId >(), cptr)) {
        delete cptr;
        return -1;
    }
    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QCalendar_SystemIdFunc_index(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCalendar::SystemId *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_SystemId_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // index()const
        size_t cppResult = const_cast<const ::QCalendar::SystemId *>(cppSelf)->index();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<size_t>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCalendar_SystemIdFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCalendar::SystemId *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_SystemId_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // isValid()const
        bool cppResult = const_cast<const ::QCalendar::SystemId *>(cppSelf)->isValid();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QCalendar_SystemId_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QCalendar_SystemId_methods[] = {
    {"index", reinterpret_cast<PyCFunction>(Sbk_QCalendar_SystemIdFunc_index), METH_NOARGS, nullptr},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_QCalendar_SystemIdFunc_isValid), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QCalendar_SystemId_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QCalendar_SystemId_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QCalendar_SystemId_Type = nullptr;
static PyTypeObject *Sbk_QCalendar_SystemId_TypeF(void)
{
    return _Sbk_QCalendar_SystemId_Type;
}

static PyType_Slot Sbk_QCalendar_SystemId_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QCalendar_SystemId_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QCalendar_SystemId_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QCalendar_SystemId_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QCalendar_SystemId_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QCalendar_SystemId_spec = {
    "2:PySide6.QtCore.QCalendar.SystemId",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QCalendar_SystemId_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void SystemId_PythonToCpp_SystemId_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QCalendar_SystemId_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_SystemId_PythonToCpp_SystemId_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QCalendar_SystemId_TypeF()))
        return SystemId_PythonToCpp_SystemId_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *SystemId_PTR_CppToPython_SystemId(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QCalendar_SystemId_TypeF(), const_cast<void *>(cppIn), false);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QCalendar_SystemId_SignatureStrings[] = {
    "PySide6.QtCore.QCalendar.SystemId(self)",
    "PySide6.QtCore.QCalendar.SystemId.index(self)->size_t",
    "PySide6.QtCore.QCalendar.SystemId.isValid(self)->bool",
    nullptr}; // Sentinel
#else
static constexpr size_t QCalendar_SystemId_SignatureByteSize = 82;
static constexpr uint8_t QCalendar_SystemId_SignatureBytes[82] = {
    0x78, 0xda, 0x0b, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x71, 0xce, 0x2f, 0x4a,
    0xd5, 0x0b, 0x74, 0x4e, 0xcc, 0x49, 0xcd, 0x4b, 0x49, 0x2c, 0xd2, 0x0b, 0xae, 0x2c, 0x2e, 0x49,
    0xcd, 0xf5, 0x4c, 0xd1, 0x28, 0x4e, 0xcd, 0x49, 0xd3, 0xe4, 0x0a, 0x20, 0xa4, 0x4e, 0x2f, 0x33,
    0x2f, 0x25, 0xb5, 0x02, 0xa2, 0x5a, 0xd7, 0xae, 0x38, 0xb3, 0x2a, 0x35, 0xbe, 0x84, 0x18, 0x5d,
    0xc5, 0x61, 0x89, 0x39, 0x99, 0x29, 0x30, 0x7d, 0x49, 0xf9, 0xf9, 0x39, 0x5c, 0x00, 0x41, 0x91,
    0x34, 0x4b
};
#endif

PyTypeObject *init_QCalendar_SystemId(PyObject *enclosingClass)
{
    if (SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_SystemId_IDX].type != nullptr)
        return SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_SystemId_IDX].type;

    Shiboken::AutoDecRef Sbk_QCalendar_SystemId_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QCalendar_SystemId_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "SystemId",
        "QCalendar::SystemId*",
        &Sbk_QCalendar_SystemId_spec,
        &Shiboken::callCppDestructor< ::QCalendar::SystemId >,
        Sbk_QCalendar_SystemId_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass);
    auto *pyType = Sbk_QCalendar_SystemId_TypeF(); // references _Sbk_QCalendar_SystemId_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QCalendar_SystemId_SignatureStrings);
#else
    InitSignatureBytes(pyType, QCalendar_SystemId_SignatureBytes, QCalendar_SystemId_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QCalendar_SystemId_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_SystemId_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        SystemId_PythonToCpp_SystemId_PTR,
        is_SystemId_PythonToCpp_SystemId_PTR_Convertible,
        SystemId_PTR_CppToPython_SystemId);

    Shiboken::Conversions::registerConverterName(converter, "QCalendar::SystemId");
    Shiboken::Conversions::registerConverterName(converter, "QCalendar::SystemId*");
    Shiboken::Conversions::registerConverterName(converter, "QCalendar::SystemId&");
    Shiboken::Conversions::registerConverterAlias(converter, "SystemId");
    Shiboken::Conversions::registerConverterAlias(converter, "SystemId*");
    Shiboken::Conversions::registerConverterAlias(converter, "SystemId&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QCalendar::SystemId).name());

    qRegisterMetaType< ::QCalendar::SystemId *>();

    return pyType;
}
