// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qcalendar_yearmonthday_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QCalendar_YearMonthDay_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QCalendar::YearMonthDay >()))
        return -1;

    ::QCalendar::YearMonthDay *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 3));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]);

    if (PyArg_ParseTuple(args, "|OOO:YearMonthDay", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: YearMonthDay::YearMonthDay()
    // 1: YearMonthDay::YearMonthDay(QCalendar::YearMonthDay)
    // 2: YearMonthDay::YearMonthDay(int,int=,int=)
    if (numArgs == 0) {
        overloadId = 0; // YearMonthDay()
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 2; // YearMonthDay(int,int,int)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
            if (numArgs == 2) {
                overloadId = 2; // YearMonthDay(int,int,int)
            } else if (numArgs >= 3
                && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[2])))) {
                overloadId = 2; // YearMonthDay(int,int,int)
            }
        }
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]), (pyArgs[0])))) {
        overloadId = 1; // YearMonthDay(QCalendar::YearMonthDay)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // YearMonthDay()
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]);
            }

            // YearMonthDay()
            cptr = new ::QCalendar::YearMonthDay();
            break;
        }
        case 1: // YearMonthDay(const QCalendar::YearMonthDay &YearMonthDay)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]);
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QCalendar::YearMonthDay cppArg0_local;
            ::QCalendar::YearMonthDay *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // YearMonthDay(QCalendar::YearMonthDay)
                cptr = new ::QCalendar::YearMonthDay(*cppArg0);
            }
            break;
        }
        case 2: // YearMonthDay(int y, int m, int d)
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_m = Shiboken::String::createStaticString("m");
                if (PyDict_Contains(kwds, key_m) != 0) {
                    value = PyDict_GetItem(kwds, key_m);
                    if (value != nullptr && pyArgs[1] != nullptr ) {
                        errInfo.reset(key_m);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]);
                    }
                    if (value != nullptr) {
                        pyArgs[1] = value;
                        if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]);
                    }
                    PyDict_DelItem(kwds_dup, key_m);
                }
                static PyObject *const key_d = Shiboken::String::createStaticString("d");
                if (PyDict_Contains(kwds, key_d) != 0) {
                    value = PyDict_GetItem(kwds, key_d);
                    if (value != nullptr && pyArgs[2] != nullptr ) {
                        errInfo.reset(key_d);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]);
                    }
                    if (value != nullptr) {
                        pyArgs[2] = value;
                        if (!(pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[2]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]);
                    }
                    PyDict_DelItem(kwds_dup, key_d);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]);
                }
            }
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            int cppArg1 = 1;
            if (pythonToCpp[1])
                pythonToCpp[1](pyArgs[1], &cppArg1);
            int cppArg2 = 1;
            if (pythonToCpp[2])
                pythonToCpp[2](pyArgs[2], &cppArg2);

            if (Shiboken::Errors::occurred() == nullptr) {
                // YearMonthDay(int,int,int)
                cptr = new ::QCalendar::YearMonthDay(cppArg0, cppArg1, cppArg2);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QCalendar::YearMonthDay >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QCalendar_YearMonthDayFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCalendar::YearMonthDay *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // isValid()const
        bool cppResult = const_cast<const ::QCalendar::YearMonthDay *>(cppSelf)->isValid();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCalendar_YearMonthDay__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QCalendar::YearMonthDay *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QCalendar_YearMonthDay_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QCalendar_YearMonthDay_methods[] = {
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_QCalendar_YearMonthDayFunc_isValid), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QCalendar_YearMonthDay__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QCalendar_YearMonthDay_get_year(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCalendar::YearMonthDay *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->year;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QCalendar_YearMonthDay_set_year(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QCalendar::YearMonthDay *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("year");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("year", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->year;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->year = cppOut_local;

    return 0;
}

static PyObject *Sbk_QCalendar_YearMonthDay_get_month(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCalendar::YearMonthDay *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->month;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QCalendar_YearMonthDay_set_month(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QCalendar::YearMonthDay *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("month");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("month", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->month;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->month = cppOut_local;

    return 0;
}

static PyObject *Sbk_QCalendar_YearMonthDay_get_day(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCalendar::YearMonthDay *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->day;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QCalendar_YearMonthDay_set_day(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QCalendar::YearMonthDay *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("day");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("day", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->day;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->day = cppOut_local;

    return 0;
}

// Getters and Setters for YearMonthDay
static PyGetSetDef Sbk_QCalendar_YearMonthDay_getsetlist[] = {
    {const_cast<char *>("year"), Sbk_QCalendar_YearMonthDay_get_year, Sbk_QCalendar_YearMonthDay_set_year, nullptr, nullptr},
    {const_cast<char *>("month"), Sbk_QCalendar_YearMonthDay_get_month, Sbk_QCalendar_YearMonthDay_set_month, nullptr, nullptr},
    {const_cast<char *>("day"), Sbk_QCalendar_YearMonthDay_get_day, Sbk_QCalendar_YearMonthDay_set_day, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QCalendar_YearMonthDay_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QCalendar_YearMonthDay_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QCalendar_YearMonthDay_Type = nullptr;
static PyTypeObject *Sbk_QCalendar_YearMonthDay_TypeF(void)
{
    return _Sbk_QCalendar_YearMonthDay_Type;
}

static PyType_Slot Sbk_QCalendar_YearMonthDay_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QCalendar_YearMonthDay_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QCalendar_YearMonthDay_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QCalendar_YearMonthDay_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QCalendar_YearMonthDay_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QCalendar_YearMonthDay_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QCalendar_YearMonthDay_spec = {
    "2:PySide6.QtCore.QCalendar.YearMonthDay",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QCalendar_YearMonthDay_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void YearMonthDay_PythonToCpp_YearMonthDay_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QCalendar_YearMonthDay_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_YearMonthDay_PythonToCpp_YearMonthDay_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QCalendar_YearMonthDay_TypeF()))
        return YearMonthDay_PythonToCpp_YearMonthDay_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *YearMonthDay_PTR_CppToPython_YearMonthDay(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QCalendar_YearMonthDay_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *YearMonthDay_COPY_CppToPython_YearMonthDay(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QCalendar::YearMonthDay *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QCalendar_YearMonthDay_TypeF(), new ::QCalendar::YearMonthDay(*source), true, true);
}

// Python to C++ copy conversion.
static void YearMonthDay_PythonToCpp_YearMonthDay_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QCalendar::YearMonthDay *>(cppOut) = *reinterpret_cast< ::QCalendar::YearMonthDay *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_YearMonthDay_PythonToCpp_YearMonthDay_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QCalendar_YearMonthDay_TypeF()))
        return YearMonthDay_PythonToCpp_YearMonthDay_COPY;
    return {};
}

// Implicit conversions.
static void int_PythonToCpp_QCalendar_YearMonthDay(PyObject *pyIn, void *cppOut)
{
    int cppIn;
    Shiboken::Conversions::pythonToCppCopy(Shiboken::Conversions::PrimitiveTypeConverter<int>(), pyIn, &cppIn);
    *reinterpret_cast<::QCalendar::YearMonthDay *>(cppOut) = ::QCalendar::YearMonthDay(cppIn);
}
static PythonToCppFunc is_int_PythonToCpp_QCalendar_YearMonthDay_Convertible(PyObject *pyIn)
{
    if (PyLong_Check(pyIn))
        return int_PythonToCpp_QCalendar_YearMonthDay;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QCalendar_YearMonthDay_SignatureStrings[] = {
    "2:PySide6.QtCore.QCalendar.YearMonthDay(self)",
    "1:PySide6.QtCore.QCalendar.YearMonthDay(self,YearMonthDay:PySide6.QtCore.QCalendar.YearMonthDay)",
    "0:PySide6.QtCore.QCalendar.YearMonthDay(self,y:int,m:int=1,d:int=1)",
    "PySide6.QtCore.QCalendar.YearMonthDay.isValid(self)->bool",
    "PySide6.QtCore.QCalendar.YearMonthDay.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QCalendar_YearMonthDay_SignatureByteSize = 126;
static constexpr uint8_t QCalendar_YearMonthDay_SignatureBytes[126] = {
    0x78, 0xda, 0x33, 0xb2, 0x0a, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x71, 0xce,
    0x2f, 0x4a, 0xd5, 0x0b, 0x74, 0x4e, 0xcc, 0x49, 0xcd, 0x4b, 0x49, 0x2c, 0xd2, 0x8b, 0x4c, 0x4d,
    0x2c, 0xf2, 0xcd, 0xcf, 0x2b, 0xc9, 0x70, 0x49, 0xac, 0xd4, 0x28, 0x4e, 0xcd, 0x49, 0xd3, 0xe4,
    0x32, 0x24, 0x41, 0xb5, 0x0e, 0xb2, 0x08, 0x71, 0xfa, 0x34, 0xb9, 0x0c, 0x48, 0xb1, 0xa0, 0xd2,
    0x2a, 0x33, 0xaf, 0x44, 0x27, 0x17, 0x44, 0xda, 0x1a, 0xea, 0xa4, 0x40, 0x68, 0x4d, 0x2e, 0xa2,
    0x4c, 0xd0, 0xcb, 0x2c, 0x0e, 0x4b, 0xcc, 0xc9, 0x4c, 0x81, 0x78, 0x4c, 0xd7, 0x2e, 0x29, 0x3f,
    0x3f, 0x87, 0x48, 0x9d, 0xf1, 0xf1, 0xc9, 0xf9, 0x05, 0x95, 0xf1, 0xf1, 0x30, 0xad, 0x25, 0x95,
    0x05, 0x99, 0x79, 0xe9, 0x7a, 0xc1, 0x40, 0x1e, 0x17, 0x00, 0x22, 0x81, 0x75, 0xcb
};
#endif

PyTypeObject *init_QCalendar_YearMonthDay(PyObject *enclosingClass)
{
    if (SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX].type != nullptr)
        return SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX].type;

    Shiboken::AutoDecRef Sbk_QCalendar_YearMonthDay_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QCalendar_YearMonthDay_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "YearMonthDay",
        "QCalendar::YearMonthDay",
        &Sbk_QCalendar_YearMonthDay_spec,
        &Shiboken::callCppDestructor< ::QCalendar::YearMonthDay >,
        Sbk_QCalendar_YearMonthDay_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QCalendar_YearMonthDay_TypeF(); // references _Sbk_QCalendar_YearMonthDay_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QCalendar_YearMonthDay_SignatureStrings);
#else
    InitSignatureBytes(pyType, QCalendar_YearMonthDay_SignatureBytes, QCalendar_YearMonthDay_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QCalendar_YearMonthDay_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QCalendar_YearMonthDay_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        YearMonthDay_PythonToCpp_YearMonthDay_PTR,
        is_YearMonthDay_PythonToCpp_YearMonthDay_PTR_Convertible,
        YearMonthDay_PTR_CppToPython_YearMonthDay,
        YearMonthDay_COPY_CppToPython_YearMonthDay);

    Shiboken::Conversions::registerConverterName(converter, "QCalendar::YearMonthDay");
    Shiboken::Conversions::registerConverterName(converter, "QCalendar::YearMonthDay*");
    Shiboken::Conversions::registerConverterName(converter, "QCalendar::YearMonthDay&");
    Shiboken::Conversions::registerConverterAlias(converter, "YearMonthDay");
    Shiboken::Conversions::registerConverterAlias(converter, "YearMonthDay*");
    Shiboken::Conversions::registerConverterAlias(converter, "YearMonthDay&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QCalendar::YearMonthDay).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        YearMonthDay_PythonToCpp_YearMonthDay_COPY,
        is_YearMonthDay_PythonToCpp_YearMonthDay_COPY_Convertible);
    // Add implicit conversions to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        int_PythonToCpp_QCalendar_YearMonthDay,
        is_int_PythonToCpp_QCalendar_YearMonthDay_Convertible);

    qRegisterMetaType< ::QCalendar::YearMonthDay >("YearMonthDay");
    qRegisterMetaType< ::QCalendar::YearMonthDay >("QCalendar::YearMonthDay");

    return pyType;
}
