// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QCoreApplicationWrapper_H
#define SBK_QCoreApplicationWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qcoreapplication.h>

namespace PySide { class DynamicQMetaObject; }

class QCoreApplicationWrapper : public QCoreApplication
{
public:
    QCoreApplicationWrapper(const QCoreApplicationWrapper &) = delete;
    QCoreApplicationWrapper& operator=(const QCoreApplicationWrapper &) = delete;
    QCoreApplicationWrapper(QCoreApplicationWrapper &&) = delete;
    QCoreApplicationWrapper& operator=(QCoreApplicationWrapper &&) = delete;

    QCoreApplicationWrapper(int & argc, char ** argv, int arg__3 = QCoreApplication::ApplicationFlags);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * arg__1) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool notify(::QObject * arg__1, ::QEvent * arg__2) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QCoreApplicationWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_QCoreApplicationWrapper_H

