// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDynamicPropertyChangeEventWrapper_H
#define SBK_QDynamicPropertyChangeEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qcoreevent.h>

class QDynamicPropertyChangeEventWrapper : public QDynamicPropertyChangeEvent
{
public:
    QDynamicPropertyChangeEventWrapper(const QDynamicPropertyChangeEventWrapper &) = delete;
    QDynamicPropertyChangeEventWrapper& operator=(const QDynamicPropertyChangeEventWrapper &) = delete;
    QDynamicPropertyChangeEventWrapper(QDynamicPropertyChangeEventWrapper &&) = delete;
    QDynamicPropertyChangeEventWrapper& operator=(QDynamicPropertyChangeEventWrapper &&) = delete;

    QDynamicPropertyChangeEventWrapper(const ::QByteArray & name);
    QDynamicPropertyChangeEventWrapper(const QDynamicPropertyChangeEvent& self) : QDynamicPropertyChangeEvent(self)
    {
    }

    ::QDynamicPropertyChangeEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QDynamicPropertyChangeEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QDynamicPropertyChangeEventWrapper_H

