// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QFactoryInterfaceWrapper_H
#define SBK_QFactoryInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qfactoryinterface.h>

class QFactoryInterfaceWrapper : public QFactoryInterface
{
public:
    QFactoryInterfaceWrapper(const QFactoryInterfaceWrapper &) = delete;
    QFactoryInterfaceWrapper& operator=(const QFactoryInterfaceWrapper &) = delete;
    QFactoryInterfaceWrapper(QFactoryInterfaceWrapper &&) = delete;
    QFactoryInterfaceWrapper& operator=(QFactoryInterfaceWrapper &&) = delete;

    QFactoryInterfaceWrapper();
    ::QStringList keys() const override;
    ~QFactoryInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QFactoryInterfaceWrapper_H

