// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QItemSelectionModelWrapper_H
#define SBK_QItemSelectionModelWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qitemselectionmodel.h>

namespace PySide { class DynamicQMetaObject; }

class QItemSelectionModelWrapper : public QItemSelectionModel
{
public:
    QItemSelectionModelWrapper(const QItemSelectionModelWrapper &) = delete;
    QItemSelectionModelWrapper& operator=(const QItemSelectionModelWrapper &) = delete;
    QItemSelectionModelWrapper(QItemSelectionModelWrapper &&) = delete;
    QItemSelectionModelWrapper& operator=(QItemSelectionModelWrapper &&) = delete;

    QItemSelectionModelWrapper(::QAbstractItemModel * model = nullptr);
    QItemSelectionModelWrapper(::QAbstractItemModel * model, ::QObject * parent);
    void childEvent(::QChildEvent * event) override;
    void clear() override;
    void clearCurrentIndex() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void reset() override;
    void select(const ::QItemSelection & selection, ::QFlags<QItemSelectionModel::SelectionFlag> command) override;
    void select(const ::QModelIndex & index, ::QFlags<QItemSelectionModel::SelectionFlag> command) override;
    void setCurrentIndex(const ::QModelIndex & index, ::QFlags<QItemSelectionModel::SelectionFlag> command) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QItemSelectionModelWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[13] = {false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QItemSelectionModelWrapper_H

