// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qmetaobject_connection_wrapper.h"

// Argument includes
#include <qobjectdefs.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QMetaObject_Connection_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QMetaObject::Connection >()))
        return -1;

    ::QMetaObject::Connection *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "Connection", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: Connection::Connection()
    // 1: Connection::Connection(QMetaObject::Connection)
    if (numArgs == 0) {
        overloadId = 0; // Connection()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaObject_Connection_IDX]), (pyArgs[0])))) {
        overloadId = 1; // Connection(QMetaObject::Connection)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QMetaObject_Connection_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtCoreTypeStructs[SBK_QMetaObject_Connection_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // Connection()
        {

            // Connection()
            cptr = new ::QMetaObject::Connection();
            break;
        }
        case 1: // Connection(const QMetaObject::Connection &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QMetaObject::Connection cppArg0_local;
            ::QMetaObject::Connection *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // Connection(QMetaObject::Connection)
                cptr = new ::QMetaObject::Connection(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QMetaObject::Connection >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QMetaObject_Connection_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QMetaObject_ConnectionFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QMetaObject::Connection *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaObject_Connection_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Connection::swap(QMetaObject::Connection&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaObject_Connection_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QMetaObject::Connection&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "swap", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QMetaObject_Connection_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QMetaObject::Connection cppArg0_local;
        ::QMetaObject::Connection *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QMetaObject::Connection&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QMetaObject_Connection__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QMetaObject::Connection *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaObject_Connection_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaObject_Connection_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QMetaObject_Connection_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QMetaObject_Connection_methods[] = {
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QMetaObject_ConnectionFunc_swap), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QMetaObject_Connection__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static int Sbk_QMetaObject_Connection___nb_bool(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return -1;
    auto *cppSelf = reinterpret_cast< ::QMetaObject::Connection *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaObject_Connection_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    return *cppSelf ? 1 : 0;
}

} // extern "C"

static int Sbk_QMetaObject_Connection_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QMetaObject_Connection_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QMetaObject_Connection_Type = nullptr;
static PyTypeObject *Sbk_QMetaObject_Connection_TypeF(void)
{
    return _Sbk_QMetaObject_Connection_Type;
}

static PyType_Slot Sbk_QMetaObject_Connection_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QMetaObject_Connection_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QMetaObject_Connection_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QMetaObject_Connection_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QMetaObject_Connection_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    // type supports number protocol
    {Py_nb_bool,        reinterpret_cast<void *>(Sbk_QMetaObject_Connection___nb_bool)},
    {0, nullptr}
};
static PyType_Spec Sbk_QMetaObject_Connection_spec = {
    "2:PySide6.QtCore.QMetaObject.Connection",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QMetaObject_Connection_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void Connection_PythonToCpp_Connection_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QMetaObject_Connection_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_Connection_PythonToCpp_Connection_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QMetaObject_Connection_TypeF()))
        return Connection_PythonToCpp_Connection_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *Connection_PTR_CppToPython_Connection(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QMetaObject_Connection_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *Connection_COPY_CppToPython_Connection(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QMetaObject::Connection *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QMetaObject_Connection_TypeF(), new ::QMetaObject::Connection(*source), true, true);
}

// Python to C++ copy conversion.
static void Connection_PythonToCpp_Connection_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QMetaObject::Connection *>(cppOut) = *reinterpret_cast< ::QMetaObject::Connection *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaObject_Connection_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_Connection_PythonToCpp_Connection_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QMetaObject_Connection_TypeF()))
        return Connection_PythonToCpp_Connection_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QMetaObject_Connection_SignatureStrings[] = {
    "1:PySide6.QtCore.QMetaObject.Connection(self)",
    "0:PySide6.QtCore.QMetaObject.Connection(self,other:PySide6.QtCore.QMetaObject.Connection)",
    "PySide6.QtCore.QMetaObject.Connection.swap(self,other:PySide6.QtCore.QMetaObject.Connection)",
    "PySide6.QtCore.QMetaObject.Connection.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QMetaObject_Connection_SignatureByteSize = 99;
static constexpr uint8_t QMetaObject_Connection_SignatureBytes[99] = {
    0x78, 0xda, 0x33, 0xb4, 0x0a, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x71, 0xce,
    0x2f, 0x4a, 0xd5, 0x0b, 0xf4, 0x4d, 0x2d, 0x49, 0xf4, 0x4f, 0xca, 0x4a, 0x4d, 0x2e, 0xd1, 0x73,
    0xce, 0xcf, 0xcb, 0x03, 0xd2, 0x99, 0xf9, 0x79, 0x1a, 0xc5, 0xa9, 0x39, 0x69, 0x9a, 0x5c, 0x06,
    0x24, 0xa8, 0xd6, 0xc9, 0x2f, 0xc9, 0x48, 0x2d, 0x22, 0x4e, 0x83, 0x26, 0x17, 0x51, 0xca, 0xf4,
    0x8a, 0xcb, 0x13, 0x0b, 0x68, 0x66, 0x78, 0x7c, 0x7c, 0x72, 0x7e, 0x41, 0x65, 0x7c, 0x3c, 0xc4,
    0xaf, 0xba, 0x76, 0x25, 0x95, 0x05, 0x99, 0x79, 0xe9, 0x7a, 0xc1, 0x40, 0x1e, 0x17, 0x00, 0xc4,
    0x8f, 0x69, 0xa8
};
#endif

PyTypeObject *init_QMetaObject_Connection(PyObject *enclosingClass)
{
    if (SbkPySide6_QtCoreTypeStructs[SBK_QMetaObject_Connection_IDX].type != nullptr)
        return SbkPySide6_QtCoreTypeStructs[SBK_QMetaObject_Connection_IDX].type;

    Shiboken::AutoDecRef Sbk_QMetaObject_Connection_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QMetaObject_Connection_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "Connection",
        "QMetaObject::Connection",
        &Sbk_QMetaObject_Connection_spec,
        &Shiboken::callCppDestructor< ::QMetaObject::Connection >,
        Sbk_QMetaObject_Connection_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QMetaObject_Connection_TypeF(); // references _Sbk_QMetaObject_Connection_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QMetaObject_Connection_SignatureStrings);
#else
    InitSignatureBytes(pyType, QMetaObject_Connection_SignatureBytes, QMetaObject_Connection_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QMetaObject_Connection_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QMetaObject_Connection_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        Connection_PythonToCpp_Connection_PTR,
        is_Connection_PythonToCpp_Connection_PTR_Convertible,
        Connection_PTR_CppToPython_Connection,
        Connection_COPY_CppToPython_Connection);

    Shiboken::Conversions::registerConverterName(converter, "QMetaObject::Connection");
    Shiboken::Conversions::registerConverterName(converter, "QMetaObject::Connection*");
    Shiboken::Conversions::registerConverterName(converter, "QMetaObject::Connection&");
    Shiboken::Conversions::registerConverterAlias(converter, "Connection");
    Shiboken::Conversions::registerConverterAlias(converter, "Connection*");
    Shiboken::Conversions::registerConverterAlias(converter, "Connection&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QMetaObject::Connection).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        Connection_PythonToCpp_Connection_COPY,
        is_Connection_PythonToCpp_Connection_COPY_Convertible);


    return pyType;
}
