// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <QtCore/QBuffer>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qregularexpressionmatch_wrapper.h"

// Argument includes
#include <QAnyStringView>
#include <QString>
#include <QStringList>
#include <QStringView>
#include <qregularexpression.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRegularExpressionMatch_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRegularExpressionMatch >()))
        return -1;

    ::QRegularExpressionMatch *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QRegularExpressionMatch", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRegularExpressionMatch::QRegularExpressionMatch()
    // 1: QRegularExpressionMatch::QRegularExpressionMatch(QRegularExpressionMatch)
    if (numArgs == 0) {
        overloadId = 0; // QRegularExpressionMatch()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QRegularExpressionMatch(QRegularExpressionMatch)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRegularExpressionMatch()
        {

            // QRegularExpressionMatch()
            cptr = new ::QRegularExpressionMatch();
            break;
        }
        case 1: // QRegularExpressionMatch(const QRegularExpressionMatch &match)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRegularExpressionMatch cppArg0_local;
            ::QRegularExpressionMatch *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRegularExpressionMatch(QRegularExpressionMatch)
                cptr = new ::QRegularExpressionMatch(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRegularExpressionMatch >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRegularExpressionMatchFunc_captured(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "captured", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);

    if (PyArg_ParseTuple(args, "|O:captured", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QRegularExpressionMatch::captured(QAnyStringView)const->QString
    // 1: QRegularExpressionMatch::captured(int=)const->QString
    if (numArgs == 0) {
        overloadId = 1; // captured(int)const
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        overloadId = 1; // captured(int)const
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        overloadId = 0; // captured(QAnyStringView)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "captured", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);

    // Call function/method
    switch (overloadId) {
        case 0: // captured(QAnyStringView name) const
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments(args, "captured", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
            }
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // captured(QAnyStringView)const
                QString cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->captured(QAnyStringView(cppArg0));
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
            }
            break;
        }
        case 1: // captured(int nth) const
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_nth = Shiboken::String::createStaticString("nth");
                if (PyDict_Contains(kwds, key_nth) != 0) {
                    value = PyDict_GetItem(kwds, key_nth);
                    if (value != nullptr && pyArgs[0] != nullptr ) {
                        errInfo.reset(key_nth);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments(args, "captured", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
                    }
                    if (value != nullptr) {
                        pyArgs[0] = value;
                        if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0]))))
                            return Shiboken::returnWrongArguments(args, "captured", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
                    }
                    PyDict_DelItem(kwds_dup, key_nth);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments(args, "captured", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
                }
            }
            int cppArg0 = 0;
            if (pythonToCpp[0])
                pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // captured(int)const
                QString cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->captured(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchFunc_capturedEnd(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "capturedEnd", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);

    if (PyArg_ParseTuple(args, "|O:capturedEnd", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QRegularExpressionMatch::capturedEnd(QAnyStringView)const->qsizetype
    // 1: QRegularExpressionMatch::capturedEnd(int=)const->qsizetype
    if (numArgs == 0) {
        overloadId = 1; // capturedEnd(int)const
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        overloadId = 1; // capturedEnd(int)const
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        overloadId = 0; // capturedEnd(QAnyStringView)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "capturedEnd", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);

    // Call function/method
    switch (overloadId) {
        case 0: // capturedEnd(QAnyStringView name) const
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments(args, "capturedEnd", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
            }
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // capturedEnd(QAnyStringView)const
                qsizetype cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->capturedEnd(QAnyStringView(cppArg0));
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), &cppResult);
            }
            break;
        }
        case 1: // capturedEnd(int nth) const
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_nth = Shiboken::String::createStaticString("nth");
                if (PyDict_Contains(kwds, key_nth) != 0) {
                    value = PyDict_GetItem(kwds, key_nth);
                    if (value != nullptr && pyArgs[0] != nullptr ) {
                        errInfo.reset(key_nth);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments(args, "capturedEnd", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
                    }
                    if (value != nullptr) {
                        pyArgs[0] = value;
                        if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0]))))
                            return Shiboken::returnWrongArguments(args, "capturedEnd", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
                    }
                    PyDict_DelItem(kwds_dup, key_nth);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments(args, "capturedEnd", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
                }
            }
            int cppArg0 = 0;
            if (pythonToCpp[0])
                pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // capturedEnd(int)const
                qsizetype cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->capturedEnd(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchFunc_capturedLength(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "capturedLength", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);

    if (PyArg_ParseTuple(args, "|O:capturedLength", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QRegularExpressionMatch::capturedLength(QAnyStringView)const->qsizetype
    // 1: QRegularExpressionMatch::capturedLength(int=)const->qsizetype
    if (numArgs == 0) {
        overloadId = 1; // capturedLength(int)const
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        overloadId = 1; // capturedLength(int)const
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        overloadId = 0; // capturedLength(QAnyStringView)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "capturedLength", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);

    // Call function/method
    switch (overloadId) {
        case 0: // capturedLength(QAnyStringView name) const
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments(args, "capturedLength", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
            }
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // capturedLength(QAnyStringView)const
                qsizetype cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->capturedLength(QAnyStringView(cppArg0));
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), &cppResult);
            }
            break;
        }
        case 1: // capturedLength(int nth) const
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_nth = Shiboken::String::createStaticString("nth");
                if (PyDict_Contains(kwds, key_nth) != 0) {
                    value = PyDict_GetItem(kwds, key_nth);
                    if (value != nullptr && pyArgs[0] != nullptr ) {
                        errInfo.reset(key_nth);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments(args, "capturedLength", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
                    }
                    if (value != nullptr) {
                        pyArgs[0] = value;
                        if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0]))))
                            return Shiboken::returnWrongArguments(args, "capturedLength", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
                    }
                    PyDict_DelItem(kwds_dup, key_nth);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments(args, "capturedLength", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
                }
            }
            int cppArg0 = 0;
            if (pythonToCpp[0])
                pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // capturedLength(int)const
                qsizetype cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->capturedLength(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchFunc_capturedStart(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "capturedStart", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);

    if (PyArg_ParseTuple(args, "|O:capturedStart", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QRegularExpressionMatch::capturedStart(QAnyStringView)const->qsizetype
    // 1: QRegularExpressionMatch::capturedStart(int=)const->qsizetype
    if (numArgs == 0) {
        overloadId = 1; // capturedStart(int)const
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        overloadId = 1; // capturedStart(int)const
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        overloadId = 0; // capturedStart(QAnyStringView)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "capturedStart", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);

    // Call function/method
    switch (overloadId) {
        case 0: // capturedStart(QAnyStringView name) const
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments(args, "capturedStart", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
            }
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // capturedStart(QAnyStringView)const
                qsizetype cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->capturedStart(QAnyStringView(cppArg0));
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), &cppResult);
            }
            break;
        }
        case 1: // capturedStart(int nth) const
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_nth = Shiboken::String::createStaticString("nth");
                if (PyDict_Contains(kwds, key_nth) != 0) {
                    value = PyDict_GetItem(kwds, key_nth);
                    if (value != nullptr && pyArgs[0] != nullptr ) {
                        errInfo.reset(key_nth);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments(args, "capturedStart", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
                    }
                    if (value != nullptr) {
                        pyArgs[0] = value;
                        if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0]))))
                            return Shiboken::returnWrongArguments(args, "capturedStart", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
                    }
                    PyDict_DelItem(kwds_dup, key_nth);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments(args, "capturedStart", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
                }
            }
            int cppArg0 = 0;
            if (pythonToCpp[0])
                pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // capturedStart(int)const
                qsizetype cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->capturedStart(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchFunc_capturedTexts(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // capturedTexts()const
        QStringList cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->capturedTexts();
        pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchFunc_capturedView(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "capturedView", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);

    if (PyArg_ParseTuple(args, "|O:capturedView", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QRegularExpressionMatch::capturedView(QAnyStringView)const->QStringView
    // 1: QRegularExpressionMatch::capturedView(int=)const->QStringView
    if (numArgs == 0) {
        overloadId = 1; // capturedView(int)const
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        overloadId = 1; // capturedView(int)const
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        overloadId = 0; // capturedView(QAnyStringView)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "capturedView", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);

    // Call function/method
    switch (overloadId) {
        case 0: // capturedView(QAnyStringView name) const
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments(args, "capturedView", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
            }
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // capturedView(QAnyStringView)const
                QStringView cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->capturedView(QAnyStringView(cppArg0));
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringView_IDX], &cppResult);
            }
            break;
        }
        case 1: // capturedView(int nth) const
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_nth = Shiboken::String::createStaticString("nth");
                if (PyDict_Contains(kwds, key_nth) != 0) {
                    value = PyDict_GetItem(kwds, key_nth);
                    if (value != nullptr && pyArgs[0] != nullptr ) {
                        errInfo.reset(key_nth);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments(args, "capturedView", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
                    }
                    if (value != nullptr) {
                        pyArgs[0] = value;
                        if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0]))))
                            return Shiboken::returnWrongArguments(args, "capturedView", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
                    }
                    PyDict_DelItem(kwds_dup, key_nth);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments(args, "capturedView", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);
                }
            }
            int cppArg0 = 0;
            if (pythonToCpp[0])
                pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // capturedView(int)const
                QStringView cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->capturedView(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringView_IDX], &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchFunc_hasCaptured(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRegularExpressionMatch::hasCaptured(QAnyStringView)const->bool
    // 1: QRegularExpressionMatch::hasCaptured(int)const->bool
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 1; // hasCaptured(int)const
    } else if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // hasCaptured(QAnyStringView)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "hasCaptured", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);

    // Call function/method
    switch (overloadId) {
        case 0: // hasCaptured(QAnyStringView name) const
        {
            ::QString cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // hasCaptured(QAnyStringView)const
                bool cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->hasCaptured(QAnyStringView(cppArg0));
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            }
            break;
        }
        case 1: // hasCaptured(int nth) const
        {
            int cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // hasCaptured(int)const
                bool cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->hasCaptured(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchFunc_hasMatch(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // hasMatch()const
        bool cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->hasMatch();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchFunc_hasPartialMatch(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // hasPartialMatch()const
        bool cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->hasPartialMatch();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // isValid()const
        bool cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->isValid();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchFunc_lastCapturedIndex(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // lastCapturedIndex()const
        int cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->lastCapturedIndex();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchFunc_matchOptions(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // matchOptions()const
        QFlags<QRegularExpression::MatchOption> cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->matchOptions();
        pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QFlags_QRegularExpression_MatchOption_IDX])))->flagsConverter, &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchFunc_matchType(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // matchType()const
        QRegularExpression::MatchType cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->matchType();
        pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpression_MatchType_IDX])))->converter, &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchFunc_regularExpression(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // regularExpression()const
        QRegularExpression cppResult = const_cast<const ::QRegularExpressionMatch *>(cppSelf)->regularExpression();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpression_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRegularExpressionMatch::swap(QRegularExpressionMatch&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QRegularExpressionMatch&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "swap", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QRegularExpressionMatch cppArg0_local;
        ::QRegularExpressionMatch *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QRegularExpressionMatch&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRegularExpressionMatch__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRegularExpressionMatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRegularExpressionMatch_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRegularExpressionMatch_methods[] = {
    {"captured", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchFunc_captured), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"capturedEnd", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchFunc_capturedEnd), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"capturedLength", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchFunc_capturedLength), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"capturedStart", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchFunc_capturedStart), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"capturedTexts", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchFunc_capturedTexts), METH_NOARGS, nullptr},
    {"capturedView", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchFunc_capturedView), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"hasCaptured", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchFunc_hasCaptured), METH_O, nullptr},
    {"hasMatch", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchFunc_hasMatch), METH_NOARGS, nullptr},
    {"hasPartialMatch", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchFunc_hasPartialMatch), METH_NOARGS, nullptr},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchFunc_isValid), METH_NOARGS, nullptr},
    {"lastCapturedIndex", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchFunc_lastCapturedIndex), METH_NOARGS, nullptr},
    {"matchOptions", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchFunc_matchOptions), METH_NOARGS, nullptr},
    {"matchType", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchFunc_matchType), METH_NOARGS, nullptr},
    {"regularExpression", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchFunc_regularExpression), METH_NOARGS, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchFunc_swap), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatch__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRegularExpressionMatch_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRegularExpressionMatch_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
extern "C"
{
static PyObject *Sbk_QRegularExpressionMatch__repr__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    QBuffer buffer;
    buffer.open(QBuffer::ReadWrite);
    QDebug dbg(&buffer);
    dbg << *cppSelf;
    buffer.close();
    QByteArray str = buffer.data();
    const auto idx = str.indexOf('(');
    auto *typeName = Py_TYPE(self)->tp_name;
    if (idx >= 0)
        str.replace(0, idx, typeName);
    str = str.trimmed();
    Shiboken::AutoDecRef tpDict(PepType_GetDict(Py_TYPE(self)));
    PyObject *mod = PyDict_GetItem(tpDict.object(), Shiboken::PyMagicName::module());
    if (mod != nullptr && std::strchr(typeName, '.') == nullptr)
        return Shiboken::String::fromFormat("<%s.%s at %p>", Shiboken::String::toCString(mod), str.constData(), self);
    return Shiboken::String::fromFormat("<%s at %p>", str.constData(), self);
}
} // extern C

// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRegularExpressionMatch_Type = nullptr;
static PyTypeObject *Sbk_QRegularExpressionMatch_TypeF(void)
{
    return _Sbk_QRegularExpressionMatch_Type;
}

static PyType_Slot Sbk_QRegularExpressionMatch_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        reinterpret_cast<void *>(Sbk_QRegularExpressionMatch__repr__)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRegularExpressionMatch_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRegularExpressionMatch_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRegularExpressionMatch_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRegularExpressionMatch_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRegularExpressionMatch_spec = {
    "2:PySide6.QtCore.QRegularExpressionMatch",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRegularExpressionMatch_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRegularExpressionMatch_PythonToCpp_QRegularExpressionMatch_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRegularExpressionMatch_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRegularExpressionMatch_PythonToCpp_QRegularExpressionMatch_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRegularExpressionMatch_TypeF()))
        return QRegularExpressionMatch_PythonToCpp_QRegularExpressionMatch_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRegularExpressionMatch_PTR_CppToPython_QRegularExpressionMatch(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QRegularExpressionMatch_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QRegularExpressionMatch_COPY_CppToPython_QRegularExpressionMatch(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRegularExpressionMatch *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRegularExpressionMatch_TypeF(), new ::QRegularExpressionMatch(*source), true, true);
}

// Python to C++ copy conversion.
static void QRegularExpressionMatch_PythonToCpp_QRegularExpressionMatch_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRegularExpressionMatch *>(cppOut) = *reinterpret_cast< ::QRegularExpressionMatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRegularExpressionMatch_PythonToCpp_QRegularExpressionMatch_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRegularExpressionMatch_TypeF()))
        return QRegularExpressionMatch_PythonToCpp_QRegularExpressionMatch_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QRegularExpressionMatch_SignatureStrings[] = {
    "1:PySide6.QtCore.QRegularExpressionMatch(self)",
    "0:PySide6.QtCore.QRegularExpressionMatch(self,match:PySide6.QtCore.QRegularExpressionMatch)",
    "1:PySide6.QtCore.QRegularExpressionMatch.captured(self,name:QString)->QString",
    "0:PySide6.QtCore.QRegularExpressionMatch.captured(self,nth:int=0)->QString",
    "1:PySide6.QtCore.QRegularExpressionMatch.capturedEnd(self,name:QString)->qsizetype",
    "0:PySide6.QtCore.QRegularExpressionMatch.capturedEnd(self,nth:int=0)->qsizetype",
    "1:PySide6.QtCore.QRegularExpressionMatch.capturedLength(self,name:QString)->qsizetype",
    "0:PySide6.QtCore.QRegularExpressionMatch.capturedLength(self,nth:int=0)->qsizetype",
    "1:PySide6.QtCore.QRegularExpressionMatch.capturedStart(self,name:QString)->qsizetype",
    "0:PySide6.QtCore.QRegularExpressionMatch.capturedStart(self,nth:int=0)->qsizetype",
    "PySide6.QtCore.QRegularExpressionMatch.capturedTexts(self)->QStringList",
    "1:PySide6.QtCore.QRegularExpressionMatch.capturedView(self,name:QString)->QStringView",
    "0:PySide6.QtCore.QRegularExpressionMatch.capturedView(self,nth:int=0)->QStringView",
    "1:PySide6.QtCore.QRegularExpressionMatch.hasCaptured(self,name:QString)->bool",
    "0:PySide6.QtCore.QRegularExpressionMatch.hasCaptured(self,nth:int)->bool",
    "PySide6.QtCore.QRegularExpressionMatch.hasMatch(self)->bool",
    "PySide6.QtCore.QRegularExpressionMatch.hasPartialMatch(self)->bool",
    "PySide6.QtCore.QRegularExpressionMatch.isValid(self)->bool",
    "PySide6.QtCore.QRegularExpressionMatch.lastCapturedIndex(self)->int",
    "PySide6.QtCore.QRegularExpressionMatch.matchOptions(self)->PySide6.QtCore.QRegularExpression.MatchOption",
    "PySide6.QtCore.QRegularExpressionMatch.matchType(self)->PySide6.QtCore.QRegularExpression.MatchType",
    "PySide6.QtCore.QRegularExpressionMatch.regularExpression(self)->PySide6.QtCore.QRegularExpression",
    "PySide6.QtCore.QRegularExpressionMatch.swap(self,other:PySide6.QtCore.QRegularExpressionMatch)",
    "PySide6.QtCore.QRegularExpressionMatch.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QRegularExpressionMatch_SignatureByteSize = 320;
static constexpr uint8_t QRegularExpressionMatch_SignatureBytes[320] = {
    0x78, 0xda, 0xad, 0x95, 0x41, 0x6f, 0x82, 0x30, 0x14, 0x80, 0xef, 0xfc, 0x92, 0x91, 0x6c, 0x44,
    0x2f, 0x3b, 0x90, 0x6c, 0x17, 0xe3, 0x61, 0x89, 0x66, 0x32, 0x88, 0x57, 0xd2, 0xc1, 0x1b, 0x6d,
    0x52, 0xdb, 0xae, 0x7d, 0x46, 0xd8, 0xaf, 0x5f, 0x95, 0x21, 0x4c, 0x8d, 0xb6, 0x86, 0x5b, 0x69,
    0xfb, 0xbe, 0xf7, 0xb5, 0x79, 0xaf, 0x4c, 0xe3, 0x55, 0x93, 0xb2, 0x12, 0x9e, 0xa3, 0x04, 0x67,
    0x52, 0x43, 0x94, 0x7c, 0x40, 0xb5, 0xe5, 0x44, 0xcf, 0x6b, 0xa5, 0xc1, 0x18, 0x26, 0xc5, 0x92,
    0x60, 0x41, 0x1f, 0x0c, 0xf0, 0xaf, 0x30, 0x98, 0xf8, 0x6c, 0x7f, 0xdc, 0xec, 0x87, 0x8e, 0x11,
    0x61, 0x30, 0x75, 0xdc, 0x19, 0x15, 0x44, 0xe1, 0x56, 0x43, 0xd9, 0x26, 0x11, 0x64, 0x03, 0x71,
    0x92, 0xa2, 0x66, 0xa2, 0x0a, 0x9f, 0x5e, 0xff, 0x46, 0xce, 0xa6, 0xa7, 0x34, 0xa4, 0x31, 0x13,
    0xf8, 0x32, 0x19, 0xa0, 0xbc, 0xc5, 0xe6, 0xe2, 0xb2, 0xdb, 0xb7, 0x61, 0x3f, 0x80, 0x8d, 0x02,
    0x7f, 0xbb, 0x1e, 0x39, 0x10, 0xec, 0x79, 0xde, 0x8a, 0x0b, 0x10, 0x15, 0xd2, 0xb1, 0x2d, 0xff,
    0x51, 0xc7, 0x11, 0x4d, 0x91, 0x68, 0x1c, 0xdb, 0x73, 0x08, 0xbd, 0xa8, 0xe9, 0xc9, 0xcb, 0xa0,
    0x46, 0xd3, 0xb6, 0xc8, 0xb1, 0x6c, 0x16, 0xcc, 0xa0, 0xff, 0x71, 0xd7, 0x0c, 0x76, 0xd7, 0xea,
    0x7a, 0xbf, 0xee, 0x7f, 0xde, 0x01, 0xf5, 0xbc, 0xbe, 0x0f, 0x48, 0x67, 0x51, 0x4a, 0xcc, 0xec,
    0x5a, 0xff, 0x7d, 0x4a, 0xc9, 0xdd, 0x05, 0xcf, 0x69, 0xad, 0x5f, 0x07, 0x72, 0xc7, 0x0c, 0x5e,
    0x29, 0xef, 0xd8, 0x95, 0xad, 0x06, 0x46, 0xf8, 0xdd, 0x08, 0x66, 0xd6, 0x84, 0xb3, 0xf2, 0x9e,
    0x50, 0x4e, 0x0c, 0x76, 0x37, 0xf0, 0x26, 0x4a, 0xa8, 0x3b, 0x88, 0xbd, 0x04, 0x57, 0xc6, 0xe1,
    0x99, 0x7d, 0x57, 0x68, 0x27, 0x8e, 0x45, 0x78, 0x33, 0x34, 0x5a, 0xf6, 0x51, 0x5e, 0x89, 0x32,
    0xdb, 0x1f, 0x9e, 0x59, 0x32, 0x8f, 0x96, 0xd2, 0xa7, 0xd3, 0xce, 0xb9, 0x5c, 0x33, 0x98, 0x1d,
    0x51, 0x6d, 0xb1, 0x49, 0xa4, 0xa0, 0x9d, 0xff, 0x4f, 0x8e, 0xf8, 0x3c, 0x2f, 0xa4, 0x6a, 0xf2,
    0xbc, 0xf3, 0xb6, 0xef, 0x89, 0xed, 0x8c, 0x28, 0xb5, 0x5f, 0xc1, 0x2f, 0x1e, 0xa2, 0xbb, 0xdc
};
#endif

PyTypeObject *init_QRegularExpressionMatch(PyObject *module)
{
    if (SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX].type != nullptr)
        return SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX].type;

    Shiboken::AutoDecRef Sbk_QRegularExpressionMatch_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QRegularExpressionMatch_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRegularExpressionMatch",
        "QRegularExpressionMatch",
        &Sbk_QRegularExpressionMatch_spec,
        &Shiboken::callCppDestructor< ::QRegularExpressionMatch >,
        Sbk_QRegularExpressionMatch_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRegularExpressionMatch_TypeF(); // references _Sbk_QRegularExpressionMatch_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QRegularExpressionMatch_SignatureStrings);
#else
    InitSignatureBytes(pyType, QRegularExpressionMatch_SignatureBytes, QRegularExpressionMatch_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRegularExpressionMatch_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRegularExpressionMatch_PythonToCpp_QRegularExpressionMatch_PTR,
        is_QRegularExpressionMatch_PythonToCpp_QRegularExpressionMatch_PTR_Convertible,
        QRegularExpressionMatch_PTR_CppToPython_QRegularExpressionMatch,
        QRegularExpressionMatch_COPY_CppToPython_QRegularExpressionMatch);

    Shiboken::Conversions::registerConverterName(converter, "QRegularExpressionMatch");
    Shiboken::Conversions::registerConverterName(converter, "QRegularExpressionMatch*");
    Shiboken::Conversions::registerConverterName(converter, "QRegularExpressionMatch&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRegularExpressionMatch).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRegularExpressionMatch_PythonToCpp_QRegularExpressionMatch_COPY,
        is_QRegularExpressionMatch_PythonToCpp_QRegularExpressionMatch_COPY_Convertible);

    qRegisterMetaType< ::QRegularExpressionMatch >("QRegularExpressionMatch");

    return pyType;
}
