// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qtcorehelper_qdirlistingiterator_wrapper.h"

// Argument includes
#include <qdirlisting.h>
#include <qtcorehelper.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>

using namespace QtCoreHelper;


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QtCoreHelper_QDirListingIterator_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QtCoreHelper::QDirListingIterator >()))
        return -1;

    ::QtCoreHelper::QDirListingIterator *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QDirListingIterator", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QDirListingIterator::QDirListingIterator()
    // 1: QDirListingIterator::QDirListingIterator(QDirListing)
    // 2: QDirListingIterator::QDirListingIterator(QtCoreHelper::QDirListingIterator)
    if (numArgs == 0) {
        overloadId = 0; // QDirListingIterator()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QDirListingIterator_IDX]), (pyArgs[0])))) {
        overloadId = 2; // QDirListingIterator(QtCoreHelper::QDirListingIterator)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDirListing_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QDirListingIterator(QDirListing)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QDirListingIterator_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QDirListingIterator_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QDirListingIterator()
        {

            // QDirListingIterator()
            cptr = new ::QtCoreHelper::QDirListingIterator();
            break;
        }
        case 1: // QDirListingIterator(const QDirListing &dl)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QDirListing *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QDirListingIterator(QDirListing)
                cptr = new ::QtCoreHelper::QDirListingIterator(*cppArg0);
            }
            break;
        }
        case 2: // QDirListingIterator(const QtCoreHelper::QDirListingIterator &arg__1)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QtCoreHelper::QDirListingIterator cppArg0_local;
            ::QtCoreHelper::QDirListingIterator *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QDirListingIterator(QtCoreHelper::QDirListingIterator)
                cptr = new ::QtCoreHelper::QDirListingIterator(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QtCoreHelper::QDirListingIterator >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QDirListingIterator_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QtCoreHelper_QDirListingIteratorFunc___iter__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QtCoreHelper::QDirListingIterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QDirListingIterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // __iter__()
        // Begin code injection
        // TEMPLATE - __iter__ - START
        Py_INCREF(self);
        pyResult = self;
        // TEMPLATE - __iter__ - END
        // End of code injection

    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QtCoreHelper_QDirListingIteratorFunc___next__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QtCoreHelper::QDirListingIterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QDirListingIterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // __next__()
        // Begin code injection
        // ========================================================================
        // START of custom code block [file: ../glue/qtcore.cpp (qdirlistingiterator-next)]
        if (cppSelf->next()) {
            Py_INCREF(self);
            pyResult = self;
        }
        // END of custom code block [file: ../glue/qtcore.cpp (qdirlistingiterator-next)]
        // ========================================================================
        // End of code injection

    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QtCoreHelper_QDirListingIteratorFunc_atEnd(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QtCoreHelper::QDirListingIterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QDirListingIterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // atEnd()const
        bool cppResult = const_cast<const ::QtCoreHelper::QDirListingIterator *>(cppSelf)->atEnd();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QtCoreHelper_QDirListingIteratorFunc_next(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QtCoreHelper::QDirListingIterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QDirListingIterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // next()
        bool cppResult = cppSelf->next();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QtCoreHelper_QDirListingIteratorFunc_value(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QtCoreHelper::QDirListingIterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QDirListingIterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // value()const
        const QDirListing::DirEntry & cppResult = const_cast<const ::QtCoreHelper::QDirListingIterator *>(cppSelf)->value();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDirListing_DirEntry_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QtCoreHelper_QDirListingIterator__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QtCoreHelper::QDirListingIterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QDirListingIterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QDirListingIterator_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QtCoreHelper_QDirListingIterator_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QtCoreHelper_QDirListingIterator_methods[] = {
    {"atEnd", reinterpret_cast<PyCFunction>(Sbk_QtCoreHelper_QDirListingIteratorFunc_atEnd), METH_NOARGS, nullptr},
    {"next", reinterpret_cast<PyCFunction>(Sbk_QtCoreHelper_QDirListingIteratorFunc_next), METH_NOARGS, nullptr},
    {"value", reinterpret_cast<PyCFunction>(Sbk_QtCoreHelper_QDirListingIteratorFunc_value), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QtCoreHelper_QDirListingIterator__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QtCoreHelper_QDirListingIterator_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QtCoreHelper_QDirListingIterator_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QtCoreHelper_QDirListingIterator_Type = nullptr;
static PyTypeObject *Sbk_QtCoreHelper_QDirListingIterator_TypeF(void)
{
    return _Sbk_QtCoreHelper_QDirListingIterator_Type;
}

static PyType_Slot Sbk_QtCoreHelper_QDirListingIterator_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QtCoreHelper_QDirListingIterator_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QtCoreHelper_QDirListingIterator_clear)},
    {Py_tp_iter,        reinterpret_cast<void *>(Sbk_QtCoreHelper_QDirListingIteratorFunc___iter__)},
    {Py_tp_iternext,    reinterpret_cast<void *>(Sbk_QtCoreHelper_QDirListingIteratorFunc___next__)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QtCoreHelper_QDirListingIterator_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QtCoreHelper_QDirListingIterator_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QtCoreHelper_QDirListingIterator_spec = {
    "2:PySide6.QtCore.QDirListingIterator",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QtCoreHelper_QDirListingIterator_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QDirListingIterator_PythonToCpp_QDirListingIterator_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QtCoreHelper_QDirListingIterator_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QDirListingIterator_PythonToCpp_QDirListingIterator_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QtCoreHelper_QDirListingIterator_TypeF()))
        return QDirListingIterator_PythonToCpp_QDirListingIterator_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QDirListingIterator_PTR_CppToPython_QDirListingIterator(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QtCoreHelper_QDirListingIterator_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QDirListingIterator_COPY_CppToPython_QDirListingIterator(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QtCoreHelper::QDirListingIterator *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QtCoreHelper_QDirListingIterator_TypeF(), new ::QtCoreHelper::QDirListingIterator(*source), true, true);
}

// Python to C++ copy conversion.
static void QDirListingIterator_PythonToCpp_QDirListingIterator_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QtCoreHelper::QDirListingIterator *>(cppOut) = *reinterpret_cast< ::QtCoreHelper::QDirListingIterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QDirListingIterator_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QDirListingIterator_PythonToCpp_QDirListingIterator_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QtCoreHelper_QDirListingIterator_TypeF()))
        return QDirListingIterator_PythonToCpp_QDirListingIterator_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QtCoreHelper_QDirListingIterator_SignatureStrings[] = {
    "2:PySide6.QtCore.QDirListingIterator(self)",
    "1:PySide6.QtCore.QDirListingIterator(self,dl:PySide6.QtCore.QDirListing)",
    "0:PySide6.QtCore.QDirListingIterator(self,arg__1:PySide6.QtCore.QDirListingIterator)",
    "PySide6.QtCore.QDirListingIterator.__iter__(self)->PyObject",
    "PySide6.QtCore.QDirListingIterator.__next__(self)->PyObject",
    "PySide6.QtCore.QDirListingIterator.atEnd(self)->bool",
    "PySide6.QtCore.QDirListingIterator.next(self)->bool",
    "PySide6.QtCore.QDirListingIterator.value(self)->PySide6.QtCore.QDirListing.DirEntry",
    "PySide6.QtCore.QDirListingIterator.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QtCoreHelper_QDirListingIterator_SignatureByteSize = 158;
static constexpr uint8_t QtCoreHelper_QDirListingIterator_SignatureBytes[158] = {
    0x78, 0xda, 0x33, 0xb2, 0x0a, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x71, 0xce,
    0x2f, 0x4a, 0xd5, 0x0b, 0x74, 0xc9, 0x2c, 0xf2, 0xc9, 0x2c, 0x2e, 0xc9, 0xcc, 0x4b, 0xf7, 0x2c,
    0x49, 0x2d, 0x4a, 0x2c, 0xc9, 0x2f, 0xd2, 0x28, 0x4e, 0xcd, 0x49, 0xd3, 0xe4, 0x32, 0x24, 0x56,
    0xa9, 0x4e, 0x4a, 0x0e, 0x1e, 0xa5, 0x9a, 0x5c, 0x06, 0x44, 0x1b, 0x94, 0x58, 0x94, 0x1e, 0x1f,
    0x4f, 0x8c, 0xbd, 0x9a, 0x5c, 0x84, 0xd5, 0xe8, 0xc5, 0xc7, 0x67, 0x02, 0x99, 0xf1, 0xf1, 0x10,
    0xff, 0xe8, 0xda, 0x05, 0x54, 0xfa, 0x27, 0x65, 0xa5, 0x26, 0x97, 0x10, 0xa7, 0x37, 0x2f, 0xb5,
    0xa2, 0x84, 0x3c, 0xbd, 0x89, 0x25, 0xae, 0x79, 0x29, 0x30, 0x8d, 0x49, 0xf9, 0xf9, 0x39, 0xc4,
    0x68, 0x02, 0x59, 0x47, 0xaa, 0x9e, 0xb2, 0xc4, 0x9c, 0xd2, 0x54, 0x84, 0x0b, 0x71, 0xa9, 0xd7,
    0x03, 0x32, 0x5d, 0xf3, 0x4a, 0x8a, 0x2a, 0x89, 0xf3, 0x78, 0x72, 0x7e, 0x41, 0x25, 0xc2, 0xe3,
    0x25, 0x95, 0x05, 0x20, 0x23, 0x82, 0x81, 0x3c, 0x2e, 0x00, 0x2a, 0x18, 0xce, 0x02
};
#endif

PyTypeObject *init_QtCoreHelper_QDirListingIterator(PyObject *module)
{
    if (SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QDirListingIterator_IDX].type != nullptr)
        return SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QDirListingIterator_IDX].type;

    Shiboken::AutoDecRef Sbk_QtCoreHelper_QDirListingIterator_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QtCoreHelper_QDirListingIterator_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QDirListingIterator",
        "QtCoreHelper::QDirListingIterator",
        &Sbk_QtCoreHelper_QDirListingIterator_spec,
        &Shiboken::callCppDestructor< ::QtCoreHelper::QDirListingIterator >,
        Sbk_QtCoreHelper_QDirListingIterator_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QtCoreHelper_QDirListingIterator_TypeF(); // references _Sbk_QtCoreHelper_QDirListingIterator_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QtCoreHelper_QDirListingIterator_SignatureStrings);
#else
    InitSignatureBytes(pyType, QtCoreHelper_QDirListingIterator_SignatureBytes, QtCoreHelper_QDirListingIterator_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QtCoreHelper_QDirListingIterator_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QDirListingIterator_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QDirListingIterator_PythonToCpp_QDirListingIterator_PTR,
        is_QDirListingIterator_PythonToCpp_QDirListingIterator_PTR_Convertible,
        QDirListingIterator_PTR_CppToPython_QDirListingIterator,
        QDirListingIterator_COPY_CppToPython_QDirListingIterator);

    Shiboken::Conversions::registerConverterName(converter, "QtCoreHelper::QDirListingIterator");
    Shiboken::Conversions::registerConverterName(converter, "QtCoreHelper::QDirListingIterator*");
    Shiboken::Conversions::registerConverterName(converter, "QtCoreHelper::QDirListingIterator&");
    Shiboken::Conversions::registerConverterAlias(converter, "QDirListingIterator");
    Shiboken::Conversions::registerConverterAlias(converter, "QDirListingIterator*");
    Shiboken::Conversions::registerConverterAlias(converter, "QDirListingIterator&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QtCoreHelper::QDirListingIterator).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QDirListingIterator_PythonToCpp_QDirListingIterator_COPY,
        is_QDirListingIterator_PythonToCpp_QDirListingIterator_COPY_Convertible);

    qRegisterMetaType< ::QtCoreHelper::QDirListingIterator >("QDirListingIterator");
    qRegisterMetaType< ::QtCoreHelper::QDirListingIterator >("QtCoreHelper::QDirListingIterator");

    return pyType;
}
