// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTextStreamWrapper_H
#define SBK_QTextStreamWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qtextstream.h>

class QTextStreamWrapper : public QTextStream
{
public:
    QTextStreamWrapper(const QTextStreamWrapper &) = delete;
    QTextStreamWrapper& operator=(const QTextStreamWrapper &) = delete;
    QTextStreamWrapper(QTextStreamWrapper &&) = delete;
    QTextStreamWrapper& operator=(QTextStreamWrapper &&) = delete;

    QTextStreamWrapper();
    QTextStreamWrapper(::QByteArray * array, ::QFlags<QIODeviceBase::OpenModeFlag> openMode = QIODeviceBase::OpenModeFlag::ReadWrite);
    QTextStreamWrapper(::QIODevice * device);
    ~QTextStreamWrapper() override;
    static void pysideInitQtMetaTypes();
private:
};

#endif // SBK_QTextStreamWrapper_H

