// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qtextstreammanipulator_wrapper.h"

// Argument includes
#include <qtextstream.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static PyObject *Sbk_QTextStreamManipulatorFunc_exec(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTextStreamManipulator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTextStreamManipulator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    pcm.setBlocking();
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QTextStreamManipulator::exec(QTextStream&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTextStream_IDX]), (pyArg)))) {
        overloadId = 0; // exec(QTextStream&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "exec", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QTextStreamManipulator_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QTextStream *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // exec(QTextStream&)
            cppSelf->exec(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QTextStreamManipulatorFunc_exec_(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTextStreamManipulator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTextStreamManipulator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    pcm.setBlocking();
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QTextStreamManipulator::exec_(QTextStream&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTextStream_IDX]), (pyArg)))) {
        overloadId = 0; // exec_(QTextStream&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "exec_", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QTextStreamManipulator_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QTextStream *cppArg0;
        pythonToCpp(pyArg, &cppArg0);
        SBK_UNUSED(cppArg0)

        if (Shiboken::Errors::occurred() == nullptr) {
            // exec_(QTextStream&)
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: ../glue/qtcore.cpp (qtextstreammanipulator-exec)]
            if (PyErr_WarnEx(PyExc_DeprecationWarning,
                             "'exec_' will be removed in the future. "
                             "Use 'exec' instead.",
                             1)) {
                return nullptr;
            }
            cppSelf->exec((*cppArg0));
            // END of custom code block [file: ../glue/qtcore.cpp (qtextstreammanipulator-exec)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QTextStreamManipulator__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QTextStreamManipulator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTextStreamManipulator_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTextStreamManipulator_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QTextStreamManipulator_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QTextStreamManipulator_methods[] = {
    {"exec", reinterpret_cast<PyCFunction>(Sbk_QTextStreamManipulatorFunc_exec), METH_O, nullptr},
    {"exec_", reinterpret_cast<PyCFunction>(Sbk_QTextStreamManipulatorFunc_exec_), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QTextStreamManipulator__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QTextStreamManipulator_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QTextStreamManipulator_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QTextStreamManipulator_Type = nullptr;
static PyTypeObject *Sbk_QTextStreamManipulator_TypeF(void)
{
    return _Sbk_QTextStreamManipulator_Type;
}

static PyType_Slot Sbk_QTextStreamManipulator_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QTextStreamManipulator_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QTextStreamManipulator_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QTextStreamManipulator_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QTextStreamManipulator_spec = {
    "2:PySide6.QtCore.QTextStreamManipulator",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QTextStreamManipulator_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QTextStreamManipulator_PythonToCpp_QTextStreamManipulator_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QTextStreamManipulator_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QTextStreamManipulator_PythonToCpp_QTextStreamManipulator_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QTextStreamManipulator_TypeF()))
        return QTextStreamManipulator_PythonToCpp_QTextStreamManipulator_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QTextStreamManipulator_PTR_CppToPython_QTextStreamManipulator(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QTextStreamManipulator_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QTextStreamManipulator_COPY_CppToPython_QTextStreamManipulator(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QTextStreamManipulator *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QTextStreamManipulator_TypeF(), new ::QTextStreamManipulator(*source), true, true);
}

// Python to C++ copy conversion.
static void QTextStreamManipulator_PythonToCpp_QTextStreamManipulator_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QTextStreamManipulator *>(cppOut) = *reinterpret_cast< ::QTextStreamManipulator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QTextStreamManipulator_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QTextStreamManipulator_PythonToCpp_QTextStreamManipulator_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QTextStreamManipulator_TypeF()))
        return QTextStreamManipulator_PythonToCpp_QTextStreamManipulator_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QTextStreamManipulator_SignatureStrings[] = {
    "PySide6.QtCore.QTextStreamManipulator.exec(self,s:PySide6.QtCore.QTextStream)",
    "PySide6.QtCore.QTextStreamManipulator.exec_(self,arg__1:PySide6.QtCore.QTextStream)",
    "PySide6.QtCore.QTextStreamManipulator.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QTextStreamManipulator_SignatureByteSize = 101;
static constexpr uint8_t QTextStreamManipulator_SignatureBytes[101] = {
    0x78, 0xda, 0x0b, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x71, 0xce, 0x2f, 0x4a,
    0xd5, 0x0b, 0x0c, 0x49, 0xad, 0x28, 0x09, 0x2e, 0x29, 0x4a, 0x4d, 0xcc, 0xf5, 0x4d, 0xcc, 0xcb,
    0x2c, 0x28, 0xcd, 0x49, 0x2c, 0xc9, 0x2f, 0xd2, 0x4b, 0xad, 0x48, 0x4d, 0xd6, 0x28, 0x4e, 0xcd,
    0x49, 0xd3, 0x29, 0xb6, 0x0a, 0xc0, 0xa9, 0x43, 0x93, 0x2b, 0x80, 0x68, 0xd3, 0xe2, 0x21, 0xc6,
    0x25, 0x16, 0xa5, 0xc7, 0xc7, 0x1b, 0x52, 0xc1, 0xcc, 0xf8, 0xf8, 0xe4, 0xfc, 0x82, 0xca, 0x78,
    0x88, 0xb1, 0x9a, 0xba, 0x76, 0x25, 0x95, 0x05, 0x99, 0x79, 0xe9, 0x7a, 0xc1, 0x40, 0x1e, 0x17,
    0x00, 0x44, 0x10, 0x53, 0x14
};
#endif

PyTypeObject *init_QTextStreamManipulator(PyObject *module)
{
    if (SbkPySide6_QtCoreTypeStructs[SBK_QTextStreamManipulator_IDX].type != nullptr)
        return SbkPySide6_QtCoreTypeStructs[SBK_QTextStreamManipulator_IDX].type;

    Shiboken::AutoDecRef Sbk_QTextStreamManipulator_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QTextStreamManipulator_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QTextStreamManipulator",
        "QTextStreamManipulator",
        &Sbk_QTextStreamManipulator_spec,
        &Shiboken::callCppDestructor< ::QTextStreamManipulator >,
        Sbk_QTextStreamManipulator_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QTextStreamManipulator_TypeF(); // references _Sbk_QTextStreamManipulator_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QTextStreamManipulator_SignatureStrings);
#else
    InitSignatureBytes(pyType, QTextStreamManipulator_SignatureBytes, QTextStreamManipulator_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QTextStreamManipulator_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QTextStreamManipulator_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QTextStreamManipulator_PythonToCpp_QTextStreamManipulator_PTR,
        is_QTextStreamManipulator_PythonToCpp_QTextStreamManipulator_PTR_Convertible,
        QTextStreamManipulator_PTR_CppToPython_QTextStreamManipulator,
        QTextStreamManipulator_COPY_CppToPython_QTextStreamManipulator);

    Shiboken::Conversions::registerConverterName(converter, "QTextStreamManipulator");
    Shiboken::Conversions::registerConverterName(converter, "QTextStreamManipulator*");
    Shiboken::Conversions::registerConverterName(converter, "QTextStreamManipulator&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QTextStreamManipulator).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QTextStreamManipulator_PythonToCpp_QTextStreamManipulator_COPY,
        is_QTextStreamManipulator_PythonToCpp_QTextStreamManipulator_COPY_Convertible);

    qRegisterMetaType< ::QTextStreamManipulator >("QTextStreamManipulator");

    return pyType;
}
