// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qwritelocker_wrapper.h"

// Argument includes
#include <qreadwritelock.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QWriteLocker_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QWriteLocker >()))
        return -1;

    ::QWriteLocker *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QWriteLocker", 1, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QWriteLocker::QWriteLocker(QReadWriteLock*)
    if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QReadWriteLock_IDX]), (pyArgs[0])))) {
        overloadId = 0; // QWriteLocker(QReadWriteLock*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QWriteLocker_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtCoreTypeStructs[SBK_QWriteLocker_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return -1;
        ::QReadWriteLock *cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // QWriteLocker(QReadWriteLock*)
            cptr = new ::QWriteLocker(cppArg0);
            Shiboken::Object::keepReference(reinterpret_cast<SbkObject *>(self), "QWriteLocker(QReadWriteLock*)1", pyArgs[0]);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QWriteLocker >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QWriteLocker_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QWriteLockerFunc___enter__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWriteLocker *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QWriteLocker_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // __enter__()
        // Begin code injection
        // ========================================================================
        // START of custom code block [file: ../glue/qtcore.cpp (default-enter)]
        Py_INCREF(self);
        pyResult = self;
        // END of custom code block [file: ../glue/qtcore.cpp (default-enter)]
        // ========================================================================
        // End of code injection

    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWriteLockerFunc___exit__(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWriteLocker *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QWriteLocker_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "__exit__", 3, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QWriteLocker::__exit__(PyObject*,PyObject*,PyObject*)
    if (numArgs == 3
        && true
        && true
        && true) {
        overloadId = 0; // __exit__(PyObject*,PyObject*,PyObject*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "__exit__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QWriteLocker_IDX]);

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // __exit__(PyObject*,PyObject*,PyObject*)
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: ../glue/qtcore.cpp (unlock)]
            cppSelf->unlock();
            // END of custom code block [file: ../glue/qtcore.cpp (unlock)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWriteLockerFunc_readWriteLock(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWriteLocker *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QWriteLocker_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // readWriteLock()const
        QReadWriteLock * cppResult = const_cast<const ::QWriteLocker *>(cppSelf)->readWriteLock();
        pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QReadWriteLock_IDX]), cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWriteLockerFunc_relock(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWriteLocker *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QWriteLocker_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // relock()
        PyThreadState *_save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
        cppSelf->relock();
        PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWriteLockerFunc_unlock(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWriteLocker *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QWriteLocker_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // unlock()
        cppSelf->unlock();
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}


static const char *Sbk_QWriteLocker_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QWriteLocker_methods[] = {
    {"__enter__", reinterpret_cast<PyCFunction>(Sbk_QWriteLockerFunc___enter__), METH_NOARGS, nullptr},
    {"__exit__", reinterpret_cast<PyCFunction>(Sbk_QWriteLockerFunc___exit__), METH_VARARGS, nullptr},
    {"readWriteLock", reinterpret_cast<PyCFunction>(Sbk_QWriteLockerFunc_readWriteLock), METH_NOARGS, nullptr},
    {"relock", reinterpret_cast<PyCFunction>(Sbk_QWriteLockerFunc_relock), METH_NOARGS, nullptr},
    {"unlock", reinterpret_cast<PyCFunction>(Sbk_QWriteLockerFunc_unlock), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QWriteLocker_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QWriteLocker_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QWriteLocker_Type = nullptr;
static PyTypeObject *Sbk_QWriteLocker_TypeF(void)
{
    return _Sbk_QWriteLocker_Type;
}

static PyType_Slot Sbk_QWriteLocker_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QWriteLocker_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QWriteLocker_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QWriteLocker_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QWriteLocker_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QWriteLocker_spec = {
    "2:PySide6.QtCore.QWriteLocker",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QWriteLocker_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QWriteLocker_PythonToCpp_QWriteLocker_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QWriteLocker_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QWriteLocker_PythonToCpp_QWriteLocker_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QWriteLocker_TypeF()))
        return QWriteLocker_PythonToCpp_QWriteLocker_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QWriteLocker_PTR_CppToPython_QWriteLocker(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QWriteLocker_TypeF(), const_cast<void *>(cppIn), false);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QWriteLocker_SignatureStrings[] = {
    "PySide6.QtCore.QWriteLocker(self,readWriteLock:PySide6.QtCore.QReadWriteLock)",
    "PySide6.QtCore.QWriteLocker.__enter__(self)->PySide6.QtCore.QWriteLocker",
    "PySide6.QtCore.QWriteLocker.__exit__(self,arg__1:PyObject,arg__2:PyObject,arg__3:PyObject)",
    "PySide6.QtCore.QWriteLocker.readWriteLock(self)->PySide6.QtCore.QReadWriteLock",
    "PySide6.QtCore.QWriteLocker.relock(self)",
    "PySide6.QtCore.QWriteLocker.unlock(self)",
    nullptr}; // Sentinel
#else
static constexpr size_t QWriteLocker_SignatureByteSize = 128;
static constexpr uint8_t QWriteLocker_SignatureBytes[128] = {
    0x78, 0xda, 0x0b, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x71, 0xce, 0x2f, 0x4a,
    0xd5, 0x0b, 0x0c, 0x2f, 0xca, 0x2c, 0x49, 0xf5, 0xc9, 0x4f, 0xce, 0x4e, 0x2d, 0xd2, 0x28, 0x4e,
    0xcd, 0x49, 0xd3, 0x29, 0x4a, 0x4d, 0x4c, 0x81, 0x0b, 0x5a, 0x05, 0xa0, 0x29, 0x0f, 0x42, 0x96,
    0xd5, 0xe4, 0x0a, 0xc0, 0x6d, 0x9a, 0x5e, 0x7c, 0x7c, 0x6a, 0x5e, 0x49, 0x6a, 0x51, 0x7c, 0x3c,
    0xd8, 0x5c, 0x4d, 0x5d, 0x3b, 0x3c, 0x8a, 0x09, 0x19, 0x54, 0x91, 0x59, 0x02, 0x35, 0x47, 0x27,
    0xb1, 0x28, 0x3d, 0x3e, 0xde, 0x10, 0xe8, 0x30, 0xff, 0xa4, 0xac, 0xd4, 0xe4, 0x12, 0x08, 0xdf,
    0x08, 0x8d, 0x6f, 0x0c, 0xe7, 0xe3, 0x77, 0x23, 0x8a, 0x67, 0x71, 0xb9, 0x13, 0xc5, 0xcf, 0x04,
    0x8c, 0xcb, 0x81, 0x9b, 0x83, 0x57, 0x61, 0x69, 0x1e, 0x92, 0x42, 0x00, 0x0e, 0x4f, 0x90, 0x11
};
#endif

PyTypeObject *init_QWriteLocker(PyObject *module)
{
    if (SbkPySide6_QtCoreTypeStructs[SBK_QWriteLocker_IDX].type != nullptr)
        return SbkPySide6_QtCoreTypeStructs[SBK_QWriteLocker_IDX].type;

    Shiboken::AutoDecRef Sbk_QWriteLocker_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QWriteLocker_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QWriteLocker",
        "QWriteLocker*",
        &Sbk_QWriteLocker_spec,
        &Shiboken::callCppDestructor< ::QWriteLocker >,
        Sbk_QWriteLocker_Type_bases.object(),
        0);
    auto *pyType = Sbk_QWriteLocker_TypeF(); // references _Sbk_QWriteLocker_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QWriteLocker_SignatureStrings);
#else
    InitSignatureBytes(pyType, QWriteLocker_SignatureBytes, QWriteLocker_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QWriteLocker_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QWriteLocker_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QWriteLocker_PythonToCpp_QWriteLocker_PTR,
        is_QWriteLocker_PythonToCpp_QWriteLocker_PTR_Convertible,
        QWriteLocker_PTR_CppToPython_QWriteLocker);

    Shiboken::Conversions::registerConverterName(converter, "QWriteLocker");
    Shiboken::Conversions::registerConverterName(converter, "QWriteLocker*");
    Shiboken::Conversions::registerConverterName(converter, "QWriteLocker&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QWriteLocker).name());

    qRegisterMetaType< ::QWriteLocker *>();

    return pyType;
}
