// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qxmlstreamnamespacedeclaration_wrapper.h"

// Argument includes
#include <QString>
#include <QStringView>
#include <qxmlstream.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QXmlStreamNamespaceDeclaration_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QXmlStreamNamespaceDeclaration >()))
        return -1;

    ::QXmlStreamNamespaceDeclaration *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QXmlStreamNamespaceDeclaration", 0, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QXmlStreamNamespaceDeclaration::QXmlStreamNamespaceDeclaration()
    // 1: QXmlStreamNamespaceDeclaration::QXmlStreamNamespaceDeclaration(QString,QString)
    // 2: QXmlStreamNamespaceDeclaration::QXmlStreamNamespaceDeclaration(QXmlStreamNamespaceDeclaration)
    if (numArgs == 0) {
        overloadId = 0; // QXmlStreamNamespaceDeclaration()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]), (pyArgs[0])))) {
        overloadId = 2; // QXmlStreamNamespaceDeclaration(QXmlStreamNamespaceDeclaration)
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
        overloadId = 1; // QXmlStreamNamespaceDeclaration(QString,QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QXmlStreamNamespaceDeclaration()
        {

            // QXmlStreamNamespaceDeclaration()
            cptr = new ::QXmlStreamNamespaceDeclaration();
            break;
        }
        case 1: // QXmlStreamNamespaceDeclaration(const QString &prefix, const QString &namespaceUri)
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QXmlStreamNamespaceDeclaration(QString,QString)
                cptr = new ::QXmlStreamNamespaceDeclaration(cppArg0, cppArg1);
            }
            break;
        }
        case 2: // QXmlStreamNamespaceDeclaration(const QXmlStreamNamespaceDeclaration &QXmlStreamNamespaceDeclaration)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QXmlStreamNamespaceDeclaration cppArg0_local;
            ::QXmlStreamNamespaceDeclaration *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QXmlStreamNamespaceDeclaration(QXmlStreamNamespaceDeclaration)
                cptr = new ::QXmlStreamNamespaceDeclaration(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QXmlStreamNamespaceDeclaration >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QXmlStreamNamespaceDeclarationFunc_namespaceUri(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QXmlStreamNamespaceDeclaration *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // namespaceUri()const
        QStringView cppResult = const_cast<const ::QXmlStreamNamespaceDeclaration *>(cppSelf)->namespaceUri();
        pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringView_IDX], &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QXmlStreamNamespaceDeclarationFunc_prefix(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QXmlStreamNamespaceDeclaration *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // prefix()const
        QStringView cppResult = const_cast<const ::QXmlStreamNamespaceDeclaration *>(cppSelf)->prefix();
        pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringView_IDX], &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QXmlStreamNamespaceDeclaration__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QXmlStreamNamespaceDeclaration *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QXmlStreamNamespaceDeclaration_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QXmlStreamNamespaceDeclaration_methods[] = {
    {"namespaceUri", reinterpret_cast<PyCFunction>(Sbk_QXmlStreamNamespaceDeclarationFunc_namespaceUri), METH_NOARGS, nullptr},
    {"prefix", reinterpret_cast<PyCFunction>(Sbk_QXmlStreamNamespaceDeclarationFunc_prefix), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QXmlStreamNamespaceDeclaration__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QXmlStreamNamespaceDeclaration_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QXmlStreamNamespaceDeclaration *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]), (pyArg)))) {
                // operator!=(const QXmlStreamNamespaceDeclaration &rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QXmlStreamNamespaceDeclaration cppArg0_local;
                ::QXmlStreamNamespaceDeclaration *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]), (pyArg)))) {
                // operator==(const QXmlStreamNamespaceDeclaration &rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QXmlStreamNamespaceDeclaration cppArg0_local;
                ::QXmlStreamNamespaceDeclaration *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QXmlStreamNamespaceDeclaration_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QXmlStreamNamespaceDeclaration_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QXmlStreamNamespaceDeclaration_Type = nullptr;
static PyTypeObject *Sbk_QXmlStreamNamespaceDeclaration_TypeF(void)
{
    return _Sbk_QXmlStreamNamespaceDeclaration_Type;
}

static PyType_Slot Sbk_QXmlStreamNamespaceDeclaration_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QXmlStreamNamespaceDeclaration_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QXmlStreamNamespaceDeclaration_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QXmlStreamNamespaceDeclaration_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QXmlStreamNamespaceDeclaration_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QXmlStreamNamespaceDeclaration_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QXmlStreamNamespaceDeclaration_spec = {
    "2:PySide6.QtCore.QXmlStreamNamespaceDeclaration",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QXmlStreamNamespaceDeclaration_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QXmlStreamNamespaceDeclaration_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QXmlStreamNamespaceDeclaration_TypeF()))
        return QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QXmlStreamNamespaceDeclaration_PTR_CppToPython_QXmlStreamNamespaceDeclaration(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QXmlStreamNamespaceDeclaration_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QXmlStreamNamespaceDeclaration_COPY_CppToPython_QXmlStreamNamespaceDeclaration(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QXmlStreamNamespaceDeclaration *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QXmlStreamNamespaceDeclaration_TypeF(), new ::QXmlStreamNamespaceDeclaration(*source), true, true);
}

// Python to C++ copy conversion.
static void QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QXmlStreamNamespaceDeclaration *>(cppOut) = *reinterpret_cast< ::QXmlStreamNamespaceDeclaration *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QXmlStreamNamespaceDeclaration_TypeF()))
        return QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QXmlStreamNamespaceDeclaration_SignatureStrings[] = {
    "2:PySide6.QtCore.QXmlStreamNamespaceDeclaration(self)",
    "1:PySide6.QtCore.QXmlStreamNamespaceDeclaration(self,prefix:QString,namespaceUri:QString)",
    "0:PySide6.QtCore.QXmlStreamNamespaceDeclaration(self,QXmlStreamNamespaceDeclaration:PySide6.QtCore.QXmlStreamNamespaceDeclaration)",
    "PySide6.QtCore.QXmlStreamNamespaceDeclaration.namespaceUri(self)->QStringView",
    "PySide6.QtCore.QXmlStreamNamespaceDeclaration.prefix(self)->QStringView",
    "PySide6.QtCore.QXmlStreamNamespaceDeclaration.__copy__(self)->typing.Self",
    "PySide6.QtCore.QXmlStreamNamespaceDeclaration.__ne__(self,rhs:PySide6.QtCore.QXmlStreamNamespaceDeclaration)->bool",
    "PySide6.QtCore.QXmlStreamNamespaceDeclaration.__eq__(self,rhs:PySide6.QtCore.QXmlStreamNamespaceDeclaration)->bool",
    nullptr}; // Sentinel
#else
static constexpr size_t QXmlStreamNamespaceDeclaration_SignatureByteSize = 168;
static constexpr uint8_t QXmlStreamNamespaceDeclaration_SignatureBytes[168] = {
    0x78, 0xda, 0xa5, 0x90, 0xb1, 0x0a, 0xc2, 0x30, 0x10, 0x86, 0xf7, 0x3e, 0x89, 0x85, 0x34, 0xa8,
    0x83, 0x43, 0x87, 0x2e, 0x3a, 0x8b, 0xa5, 0x28, 0x6e, 0x21, 0xd6, 0xab, 0x06, 0xd2, 0x24, 0x5e,
    0x02, 0x9a, 0xb7, 0x37, 0xd0, 0x16, 0x9c, 0x84, 0x6b, 0xc7, 0x3b, 0xbe, 0xfb, 0x7e, 0xee, 0xdf,
    0x96, 0xa7, 0xd8, 0xa8, 0x3b, 0xec, 0x78, 0x1d, 0xf6, 0x16, 0x81, 0xd7, 0xd7, 0x5e, 0x37, 0x01,
    0x41, 0xf6, 0x47, 0xd9, 0x83, 0x77, 0xb2, 0x85, 0x03, 0xb4, 0x5a, 0xa2, 0x0c, 0xca, 0x9a, 0x95,
    0x07, 0xdd, 0xe5, 0xd9, 0x66, 0xc6, 0x15, 0x73, 0x08, 0x9d, 0xfa, 0x94, 0x75, 0xe2, 0x94, 0x79,
    0x30, 0x33, 0x81, 0x67, 0x54, 0xd3, 0x32, 0xcf, 0xd6, 0x73, 0xcc, 0xff, 0x19, 0x9a, 0x31, 0xcf,
    0x48, 0x38, 0xff, 0x7d, 0x63, 0x68, 0xa7, 0xa8, 0xc6, 0x6f, 0x2e, 0x0a, 0xde, 0x44, 0xdb, 0xd0,
    0xd1, 0x72, 0x8f, 0x10, 0xad, 0x75, 0x51, 0x88, 0xc9, 0x14, 0xa2, 0x4b, 0x22, 0xde, 0xa4, 0x89,
    0x6c, 0x32, 0x30, 0x7a, 0x18, 0x3e, 0x3d, 0xb1, 0xcc, 0xa2, 0xba, 0x59, 0xab, 0xc9, 0x91, 0xf0,
    0x5a, 0x1c, 0xf9, 0x05, 0xd0, 0x0c, 0x0d, 0x43
};
#endif

PyTypeObject *init_QXmlStreamNamespaceDeclaration(PyObject *module)
{
    if (SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX].type != nullptr)
        return SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX].type;

    Shiboken::AutoDecRef Sbk_QXmlStreamNamespaceDeclaration_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QXmlStreamNamespaceDeclaration_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QXmlStreamNamespaceDeclaration",
        "QXmlStreamNamespaceDeclaration",
        &Sbk_QXmlStreamNamespaceDeclaration_spec,
        &Shiboken::callCppDestructor< ::QXmlStreamNamespaceDeclaration >,
        Sbk_QXmlStreamNamespaceDeclaration_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QXmlStreamNamespaceDeclaration_TypeF(); // references _Sbk_QXmlStreamNamespaceDeclaration_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QXmlStreamNamespaceDeclaration_SignatureStrings);
#else
    InitSignatureBytes(pyType, QXmlStreamNamespaceDeclaration_SignatureBytes, QXmlStreamNamespaceDeclaration_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QXmlStreamNamespaceDeclaration_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QXmlStreamNamespaceDeclaration_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_PTR,
        is_QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_PTR_Convertible,
        QXmlStreamNamespaceDeclaration_PTR_CppToPython_QXmlStreamNamespaceDeclaration,
        QXmlStreamNamespaceDeclaration_COPY_CppToPython_QXmlStreamNamespaceDeclaration);

    Shiboken::Conversions::registerConverterName(converter, "QXmlStreamNamespaceDeclaration");
    Shiboken::Conversions::registerConverterName(converter, "QXmlStreamNamespaceDeclaration*");
    Shiboken::Conversions::registerConverterName(converter, "QXmlStreamNamespaceDeclaration&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QXmlStreamNamespaceDeclaration).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_COPY,
        is_QXmlStreamNamespaceDeclaration_PythonToCpp_QXmlStreamNamespaceDeclaration_COPY_Convertible);

    qRegisterMetaType< ::QXmlStreamNamespaceDeclaration >("QXmlStreamNamespaceDeclaration");

    return pyType;
}
