// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <QtCore/QBuffer>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtdbus_python.h"

// main header
#include "qdbuserror_wrapper.h"

// Argument includes
#include <QString>
#include <QtDBus/qdbuserror.h>
#include <QtDBus/qdbusmessage.h>
#include <qobject.h>
#include <qobjectdefs.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QDBusError_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QDBusError >()))
        return -1;

    ::QDBusError *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QDBusError", 0, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QDBusError::QDBusError()
    // 1: QDBusError::QDBusError(QDBusError::ErrorType,QString)
    // 2: QDBusError::QDBusError(QDBusError)
    // 3: QDBusError::QDBusError(QDBusMessage)
    if (numArgs == 0) {
        overloadId = 0; // QDBusError()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusMessage_IDX]), (pyArgs[0])))) {
        overloadId = 3; // QDBusError(QDBusMessage)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX]), (pyArgs[0])))) {
        overloadId = 2; // QDBusError(QDBusError)
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_ErrorType_IDX])))->converter, (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
        overloadId = 1; // QDBusError(QDBusError::ErrorType,QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QDBusError()
        {

            // QDBusError()
            cptr = new ::QDBusError();
            break;
        }
        case 1: // QDBusError(QDBusError::ErrorType error, const QString &message)
        {
            ::QDBusError::ErrorType cppArg0{QDBusError::NoError};
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QDBusError(QDBusError::ErrorType,QString)
                cptr = new ::QDBusError(cppArg0, cppArg1);
            }
            break;
        }
        case 2: // QDBusError(const QDBusError &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QDBusError cppArg0_local;
            ::QDBusError *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QDBusError(QDBusError)
                cptr = new ::QDBusError(*cppArg0);
            }
            break;
        }
        case 3: // QDBusError(const QDBusMessage &msg)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QDBusMessage cppArg0_local;
            ::QDBusMessage *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QDBusError(QDBusMessage)
                cptr = new ::QDBusError(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QDBusError >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QDBusErrorFunc_errorString(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QDBusError::errorString(QDBusError::ErrorType)->QString
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_ErrorType_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // errorString(QDBusError::ErrorType)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "errorString", errInfo, SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX]);

    // Call function/method
    {
        ::QDBusError::ErrorType cppArg0{QDBusError::NoError};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // errorString(QDBusError::ErrorType)
            QString cppResult = ::QDBusError::errorString(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDBusErrorFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDBusError *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // isValid()const
        bool cppResult = const_cast<const ::QDBusError *>(cppSelf)->isValid();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDBusErrorFunc_message(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDBusError *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // message()const
        QString cppResult = const_cast<const ::QDBusError *>(cppSelf)->message();
        pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDBusErrorFunc_name(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDBusError *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // name()const
        QString cppResult = const_cast<const ::QDBusError *>(cppSelf)->name();
        pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDBusErrorFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDBusError *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QDBusError::swap(QDBusError&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QDBusError&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "swap", errInfo, SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QDBusError cppArg0_local;
        ::QDBusError *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QDBusError&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QDBusErrorFunc_type(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDBusError *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // type()const
        QDBusError::ErrorType cppResult = const_cast<const ::QDBusError *>(cppSelf)->type();
        pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_ErrorType_IDX])))->converter, &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDBusError__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QDBusError *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QDBusError_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QDBusError_EnumFlagInfo[] = {
    "ErrorType:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QDBusError_methods[] = {
    {"errorString", reinterpret_cast<PyCFunction>(Sbk_QDBusErrorFunc_errorString), METH_O|METH_STATIC, nullptr},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_QDBusErrorFunc_isValid), METH_NOARGS, nullptr},
    {"message", reinterpret_cast<PyCFunction>(Sbk_QDBusErrorFunc_message), METH_NOARGS, nullptr},
    {"name", reinterpret_cast<PyCFunction>(Sbk_QDBusErrorFunc_name), METH_NOARGS, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QDBusErrorFunc_swap), METH_O, nullptr},
    {"type", reinterpret_cast<PyCFunction>(Sbk_QDBusErrorFunc_type), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QDBusError__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QDBusError_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QDBusError_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
extern "C"
{
static PyObject *Sbk_QDBusError__repr__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDBusError *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    QBuffer buffer;
    buffer.open(QBuffer::ReadWrite);
    QDebug dbg(&buffer);
    dbg << *cppSelf;
    buffer.close();
    QByteArray str = buffer.data();
    const auto idx = str.indexOf('(');
    auto *typeName = Py_TYPE(self)->tp_name;
    if (idx >= 0)
        str.replace(0, idx, typeName);
    str = str.trimmed();
    Shiboken::AutoDecRef tpDict(PepType_GetDict(Py_TYPE(self)));
    PyObject *mod = PyDict_GetItem(tpDict.object(), Shiboken::PyMagicName::module());
    if (mod != nullptr && std::strchr(typeName, '.') == nullptr)
        return Shiboken::String::fromFormat("<%s.%s at %p>", Shiboken::String::toCString(mod), str.constData(), self);
    return Shiboken::String::fromFormat("<%s at %p>", str.constData(), self);
}
} // extern C

// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QDBusError_Type = nullptr;
static PyTypeObject *Sbk_QDBusError_TypeF(void)
{
    return _Sbk_QDBusError_Type;
}

static PyType_Slot Sbk_QDBusError_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        reinterpret_cast<void *>(Sbk_QDBusError__repr__)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QDBusError_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QDBusError_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QDBusError_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QDBusError_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QDBusError_spec = {
    "2:PySide6.QtDBus.QDBusError",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QDBusError_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QDBusError_ErrorType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QDBusError::ErrorType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QDBusError::ErrorType *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QDBusError_ErrorType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_ErrorType_IDX])))
        return Enum_PythonToCpp_QDBusError_ErrorType;
    return {};
}

static PyObject *QDBusError_ErrorType_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QDBusError::ErrorType>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QDBusError::ErrorType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_ErrorType_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QDBusError_PythonToCpp_QDBusError_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QDBusError_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QDBusError_PythonToCpp_QDBusError_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QDBusError_TypeF()))
        return QDBusError_PythonToCpp_QDBusError_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QDBusError_PTR_CppToPython_QDBusError(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QDBusError_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QDBusError_COPY_CppToPython_QDBusError(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QDBusError *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QDBusError_TypeF(), new ::QDBusError(*source), true, true);
}

// Python to C++ copy conversion.
static void QDBusError_PythonToCpp_QDBusError_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QDBusError *>(cppOut) = *reinterpret_cast< ::QDBusError *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QDBusError_PythonToCpp_QDBusError_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QDBusError_TypeF()))
        return QDBusError_PythonToCpp_QDBusError_COPY;
    return {};
}

// Implicit conversions.
static void constQDBusMessageREF_PythonToCpp_QDBusError(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QDBusError *>(cppOut) = ::QDBusError( *reinterpret_cast< ::QDBusMessage *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusMessage_IDX]), reinterpret_cast<SbkObject *>(pyIn))));
}
static PythonToCppFunc is_constQDBusMessageREF_PythonToCpp_QDBusError_Convertible(PyObject *pyIn)
{
    if (SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBusMessage_IDX]), pyIn))
        return constQDBusMessageREF_PythonToCpp_QDBusError;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QDBusError_SignatureStrings[] = {
    "3:PySide6.QtDBus.QDBusError(self)",
    "2:PySide6.QtDBus.QDBusError(self,error:PySide6.QtDBus.QDBusError.ErrorType,message:QString)",
    "1:PySide6.QtDBus.QDBusError(self,other:PySide6.QtDBus.QDBusError)",
    "0:PySide6.QtDBus.QDBusError(self,msg:PySide6.QtDBus.QDBusMessage)",
    "PySide6.QtDBus.QDBusError.errorString(error:PySide6.QtDBus.QDBusError.ErrorType)->QString",
    "PySide6.QtDBus.QDBusError.isValid(self)->bool",
    "PySide6.QtDBus.QDBusError.message(self)->QString",
    "PySide6.QtDBus.QDBusError.name(self)->QString",
    "PySide6.QtDBus.QDBusError.swap(self,other:typing.Union[PySide6.QtDBus.QDBusError, PySide6.QtDBus.QDBusMessage])",
    "PySide6.QtDBus.QDBusError.type(self)->PySide6.QtDBus.QDBusError.ErrorType",
    "PySide6.QtDBus.QDBusError.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QDBusError_SignatureByteSize = 200;
static constexpr uint8_t QDBusError_SignatureBytes[200] = {
    0x78, 0xda, 0x95, 0x90, 0x3d, 0x0b, 0xc2, 0x30, 0x14, 0x45, 0xf7, 0xfc, 0x0a, 0xc7, 0x06, 0xda,
    0xe0, 0x07, 0x38, 0x74, 0xe8, 0x20, 0x3a, 0x0a, 0x96, 0xaa, 0x8b, 0x48, 0x88, 0x1a, 0x6b, 0xa0,
    0x4d, 0x42, 0x12, 0x91, 0xfc, 0x7b, 0xfb, 0x29, 0x0e, 0x36, 0xa9, 0xcb, 0x23, 0x81, 0xf3, 0x0e,
    0xf7, 0xdd, 0x45, 0xbc, 0xb3, 0x19, 0xbb, 0xd1, 0x25, 0x4a, 0xcd, 0x7a, 0xf5, 0xd4, 0x28, 0xad,
    0xe7, 0x46, 0x29, 0xa1, 0x02, 0x4d, 0x8b, 0x3b, 0x04, 0x73, 0x0f, 0x11, 0xd2, 0xfa, 0x39, 0x0c,
    0xa1, 0x66, 0xee, 0xad, 0xa4, 0x61, 0x49, 0xb5, 0x26, 0x39, 0x8d, 0xd3, 0xcc, 0x28, 0xc6, 0x73,
    0x08, 0x66, 0x3e, 0xb7, 0x30, 0x0f, 0xea, 0x70, 0x43, 0x30, 0xf5, 0x19, 0x4a, 0x9d, 0xff, 0x44,
    0xb6, 0x6d, 0x16, 0x08, 0x86, 0x83, 0x37, 0x87, 0xb5, 0x51, 0x83, 0xd1, 0x47, 0xc2, 0x28, 0xe9,
    0xce, 0x73, 0x98, 0x99, 0x3e, 0x92, 0x82, 0xdd, 0xda, 0x86, 0xa3, 0xe4, 0x22, 0x44, 0xe1, 0xa0,
    0xbb, 0xda, 0x7a, 0xda, 0xaf, 0xe7, 0xa4, 0xfc, 0x83, 0xd6, 0x2f, 0x22, 0xbf, 0xdb, 0x36, 0x56,
    0x56, 0x0b, 0xe8, 0xc0, 0x99, 0xe0, 0xa7, 0xc1, 0xb5, 0x70, 0xe2, 0x68, 0xf5, 0xec, 0xaa, 0xb5,
    0xf2, 0x7f, 0xd2, 0x8d, 0x28, 0xd4, 0x61, 0xc2, 0xf8, 0x2a, 0xa4, 0xc5, 0xb8, 0xb7, 0x75, 0xc9,
    0xb3, 0xea, 0x07, 0xde, 0xbe, 0x08, 0xff, 0x14
};
#endif

PyTypeObject *init_QDBusError(PyObject *module)
{
    if (SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX].type != nullptr)
        return SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX].type;

    Shiboken::AutoDecRef Sbk_QDBusError_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QDBusError_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QDBusError",
        "QDBusError",
        &Sbk_QDBusError_spec,
        &Shiboken::callCppDestructor< ::QDBusError >,
        Sbk_QDBusError_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QDBusError_TypeF(); // references _Sbk_QDBusError_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QDBusError_SignatureStrings);
#else
    InitSignatureBytes(pyType, QDBusError_SignatureBytes, QDBusError_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QDBusError_PropertyStrings);
    SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QDBusError_PythonToCpp_QDBusError_PTR,
        is_QDBusError_PythonToCpp_QDBusError_PTR_Convertible,
        QDBusError_PTR_CppToPython_QDBusError,
        QDBusError_COPY_CppToPython_QDBusError);

    Shiboken::Conversions::registerConverterName(converter, "QDBusError");
    Shiboken::Conversions::registerConverterName(converter, "QDBusError*");
    Shiboken::Conversions::registerConverterName(converter, "QDBusError&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QDBusError).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QDBusError_PythonToCpp_QDBusError_COPY,
        is_QDBusError_PythonToCpp_QDBusError_COPY_Convertible);
    // Add implicit conversions to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        constQDBusMessageREF_PythonToCpp_QDBusError,
        is_constQDBusMessageREF_PythonToCpp_QDBusError_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QDBusError_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'ErrorType'.
    const char *ErrorType_Initializer[] = {
        "NoError",
        "Other",
        "Failed",
        "NoMemory",
        "ServiceUnknown",
        "NoReply",
        "BadAddress",
        "NotSupported",
        "LimitsExceeded",
        "AccessDenied",
        "NoServer",
        "Timeout",
        "NoNetwork",
        "AddressInUse",
        "Disconnected",
        "InvalidArgs",
        "UnknownMethod",
        "TimedOut",
        "InvalidSignature",
        "UnknownInterface",
        "UnknownObject",
        "UnknownProperty",
        "PropertyReadOnly",
        "InternalError",
        "InvalidService",
        "InvalidObjectPath",
        "InvalidInterface",
        "InvalidMember",
        "LastErrorType",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t ErrorType_InitializerValues[] = {
        uint8_t(QDBusError::ErrorType::NoError),           //  0x00  0
        uint8_t(QDBusError::ErrorType::Other),             //  0x01  1
        uint8_t(QDBusError::ErrorType::Failed),            //  0x02  2
        uint8_t(QDBusError::ErrorType::NoMemory),          //  0x03  3
        uint8_t(QDBusError::ErrorType::ServiceUnknown),    //  0x04  4
        uint8_t(QDBusError::ErrorType::NoReply),           //  0x05  5
        uint8_t(QDBusError::ErrorType::BadAddress),        //  0x06  6
        uint8_t(QDBusError::ErrorType::NotSupported),      //  0x07  7
        uint8_t(QDBusError::ErrorType::LimitsExceeded),    //  0x08  8
        uint8_t(QDBusError::ErrorType::AccessDenied),      //  0x09  9
        uint8_t(QDBusError::ErrorType::NoServer),          //  0x0a  10
        uint8_t(QDBusError::ErrorType::Timeout),           //  0x0b  11
        uint8_t(QDBusError::ErrorType::NoNetwork),         //  0x0c  12
        uint8_t(QDBusError::ErrorType::AddressInUse),      //  0x0d  13
        uint8_t(QDBusError::ErrorType::Disconnected),      //  0x0e  14
        uint8_t(QDBusError::ErrorType::InvalidArgs),       //  0x0f  15
        uint8_t(QDBusError::ErrorType::UnknownMethod),     //  0x10  16
        uint8_t(QDBusError::ErrorType::TimedOut),          //  0x11  17
        uint8_t(QDBusError::ErrorType::InvalidSignature),  //  0x12  18
        uint8_t(QDBusError::ErrorType::UnknownInterface),  //  0x13  19
        uint8_t(QDBusError::ErrorType::UnknownObject),     //  0x14  20
        uint8_t(QDBusError::ErrorType::UnknownProperty),   //  0x15  21
        uint8_t(QDBusError::ErrorType::PropertyReadOnly),  //  0x16  22
        uint8_t(QDBusError::ErrorType::InternalError),     //  0x17  23
        uint8_t(QDBusError::ErrorType::InvalidService),    //  0x18  24
        uint8_t(QDBusError::ErrorType::InvalidObjectPath), //  0x19  25
        uint8_t(QDBusError::ErrorType::InvalidInterface),  //  0x1a  26
        uint8_t(QDBusError::ErrorType::InvalidMember),     //  0x1b  27
        uint8_t(QDBusError::ErrorType::LastErrorType)      //  0x1b  27
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QDBusError_TypeF(),
        "2:PySide6.QtDBus.QDBusError.ErrorType",
        ErrorType_Initializer, ErrorType_InitializerValues);
    SbkPySide6_QtDBusTypeStructs[SBK_QDBusError_ErrorType_IDX].type = EType;
    // Register converter for enum 'QDBusError::ErrorType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QDBusError_ErrorType_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QDBusError_ErrorType,
            is_Enum_PythonToCpp_QDBusError_ErrorType_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QDBusError::ErrorType");
        Shiboken::Conversions::registerConverterAlias(converter, "ErrorType");
        Shiboken::Enum::setTypeConverter(EType, converter, nullptr);
    }
    // End of 'ErrorType' enum.

    qRegisterMetaType< ::QDBusError >("QDBusError");
    qRegisterMetaType< ::QDBusError::ErrorType >("QDBusError::ErrorType");

    return pyType;
}
