// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDBusInterfaceWrapper_H
#define SBK_QDBusInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDBus/qdbusinterface.h>

namespace PySide { class DynamicQMetaObject; }

class QDBusInterfaceWrapper : public QDBusInterface
{
public:
    QDBusInterfaceWrapper(const QDBusInterfaceWrapper &) = delete;
    QDBusInterfaceWrapper& operator=(const QDBusInterfaceWrapper &) = delete;
    QDBusInterfaceWrapper(QDBusInterfaceWrapper &&) = delete;
    QDBusInterfaceWrapper& operator=(QDBusInterfaceWrapper &&) = delete;

    QDBusInterfaceWrapper(const ::QString & service, const ::QString & path, const ::QString & interface = QString(), const ::QDBusConnection & connection = QDBusConnection::sessionBus(), ::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QDBusInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QDBusInterfaceWrapper_H

