// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDBusServiceWatcherWrapper_H
#define SBK_QDBusServiceWatcherWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDBus/qdbusservicewatcher.h>

namespace PySide { class DynamicQMetaObject; }

class QDBusServiceWatcherWrapper : public QDBusServiceWatcher
{
public:
    QDBusServiceWatcherWrapper(const QDBusServiceWatcherWrapper &) = delete;
    QDBusServiceWatcherWrapper& operator=(const QDBusServiceWatcherWrapper &) = delete;
    QDBusServiceWatcherWrapper(QDBusServiceWatcherWrapper &&) = delete;
    QDBusServiceWatcherWrapper& operator=(QDBusServiceWatcherWrapper &&) = delete;

    QDBusServiceWatcherWrapper(::QObject * parent = nullptr);
    QDBusServiceWatcherWrapper(const ::QString & service, const ::QDBusConnection & connection, ::QFlags<QDBusServiceWatcher::WatchModeFlag> watchMode = QDBusServiceWatcher::WatchModeFlag::WatchForOwnerChange, ::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QDBusServiceWatcherWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QDBusServiceWatcherWrapper_H

