// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_Q3DCameraWrapper_H
#define SBK_Q3DCameraWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDataVisualization/q3dcamera.h>

namespace PySide { class DynamicQMetaObject; }

class Q3DCameraWrapper : public Q3DCamera
{
public:
    Q3DCameraWrapper(const Q3DCameraWrapper &) = delete;
    Q3DCameraWrapper& operator=(const Q3DCameraWrapper &) = delete;
    Q3DCameraWrapper(Q3DCameraWrapper &&) = delete;
    Q3DCameraWrapper& operator=(Q3DCameraWrapper &&) = delete;

    Q3DCameraWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void copyValuesFrom(const ::Q3DObject & source) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~Q3DCameraWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_Q3DCameraWrapper_H

