// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QCustom3DVolumeWrapper_H
#define SBK_QCustom3DVolumeWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDataVisualization/qcustom3dvolume.h>

namespace PySide { class DynamicQMetaObject; }

class QCustom3DVolumeWrapper : public QCustom3DVolume
{
public:
    QCustom3DVolumeWrapper(const QCustom3DVolumeWrapper &) = delete;
    QCustom3DVolumeWrapper& operator=(const QCustom3DVolumeWrapper &) = delete;
    QCustom3DVolumeWrapper(QCustom3DVolumeWrapper &&) = delete;
    QCustom3DVolumeWrapper& operator=(QCustom3DVolumeWrapper &&) = delete;

    QCustom3DVolumeWrapper(::QObject * parent = nullptr);
    QCustom3DVolumeWrapper(const ::QVector3D & position, const ::QVector3D & scaling, const ::QQuaternion & rotation, int textureWidth, int textureHeight, int textureDepth, ::QList<uchar> * textureData, ::QImage::Format textureFormat, const ::QList<unsigned int> & colorTable, ::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QCustom3DVolumeWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QCustom3DVolumeWrapper_H

