// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QItemModelSurfaceDataProxyWrapper_H
#define SBK_QItemModelSurfaceDataProxyWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDataVisualization/qitemmodelsurfacedataproxy.h>

namespace PySide { class DynamicQMetaObject; }

class QItemModelSurfaceDataProxyWrapper : public QItemModelSurfaceDataProxy
{
public:
    QItemModelSurfaceDataProxyWrapper(const QItemModelSurfaceDataProxyWrapper &) = delete;
    QItemModelSurfaceDataProxyWrapper& operator=(const QItemModelSurfaceDataProxyWrapper &) = delete;
    QItemModelSurfaceDataProxyWrapper(QItemModelSurfaceDataProxyWrapper &&) = delete;
    QItemModelSurfaceDataProxyWrapper& operator=(QItemModelSurfaceDataProxyWrapper &&) = delete;

    QItemModelSurfaceDataProxyWrapper(::QAbstractItemModel * itemModel, ::QObject * parent = nullptr);
    QItemModelSurfaceDataProxyWrapper(::QAbstractItemModel * itemModel, const ::QString & rowRole, const ::QString & columnRole, const ::QString & xPosRole, const ::QString & yPosRole, const ::QString & zPosRole, ::QObject * parent = nullptr);
    QItemModelSurfaceDataProxyWrapper(::QAbstractItemModel * itemModel, const ::QString & rowRole, const ::QString & columnRole, const ::QString & xPosRole, const ::QString & yPosRole, const ::QString & zPosRole, const ::QStringList & rowCategories, const ::QStringList & columnCategories, ::QObject * parent = nullptr);
    QItemModelSurfaceDataProxyWrapper(::QAbstractItemModel * itemModel, const ::QString & rowRole, const ::QString & columnRole, const ::QString & yPosRole, ::QObject * parent = nullptr);
    QItemModelSurfaceDataProxyWrapper(::QAbstractItemModel * itemModel, const ::QString & rowRole, const ::QString & columnRole, const ::QString & yPosRole, const ::QStringList & rowCategories, const ::QStringList & columnCategories, ::QObject * parent = nullptr);
    QItemModelSurfaceDataProxyWrapper(::QAbstractItemModel * itemModel, const ::QString & yPosRole, ::QObject * parent = nullptr);
    QItemModelSurfaceDataProxyWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QItemModelSurfaceDataProxyWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QItemModelSurfaceDataProxyWrapper_H

