// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAbstractExtensionFactoryWrapper_H
#define SBK_QAbstractExtensionFactoryWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/extension.h>

class QAbstractExtensionFactoryWrapper : public QAbstractExtensionFactory
{
public:
    QAbstractExtensionFactoryWrapper(const QAbstractExtensionFactoryWrapper &) = delete;
    QAbstractExtensionFactoryWrapper& operator=(const QAbstractExtensionFactoryWrapper &) = delete;
    QAbstractExtensionFactoryWrapper(QAbstractExtensionFactoryWrapper &&) = delete;
    QAbstractExtensionFactoryWrapper& operator=(QAbstractExtensionFactoryWrapper &&) = delete;

    QAbstractExtensionFactoryWrapper();
    ::QObject * extension(::QObject * object, const ::QString & iid) const override;
    ~QAbstractExtensionFactoryWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QAbstractExtensionFactoryWrapper_H

