// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAbstractExtensionManagerWrapper_H
#define SBK_QAbstractExtensionManagerWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/extension.h>

class QAbstractExtensionManagerWrapper : public QAbstractExtensionManager
{
public:
    QAbstractExtensionManagerWrapper(const QAbstractExtensionManagerWrapper &) = delete;
    QAbstractExtensionManagerWrapper& operator=(const QAbstractExtensionManagerWrapper &) = delete;
    QAbstractExtensionManagerWrapper(QAbstractExtensionManagerWrapper &&) = delete;
    QAbstractExtensionManagerWrapper& operator=(QAbstractExtensionManagerWrapper &&) = delete;

    QAbstractExtensionManagerWrapper();
    ::QObject * extension(::QObject * object, const ::QString & iid) const override;
    void registerExtensions(::QAbstractExtensionFactory * factory, const ::QString & iid) override;
    void unregisterExtensions(::QAbstractExtensionFactory * factory, const ::QString & iid) override;
    ~QAbstractExtensionManagerWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QAbstractExtensionManagerWrapper_H

