// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAbstractFormBuilderWrapper_H
#define SBK_QAbstractFormBuilderWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/abstractformbuilder.h>

class QAbstractFormBuilderWrapper : public QAbstractFormBuilder
{
public:
    QAbstractFormBuilderWrapper(const QAbstractFormBuilderWrapper &) = delete;
    QAbstractFormBuilderWrapper& operator=(const QAbstractFormBuilderWrapper &) = delete;
    QAbstractFormBuilderWrapper(QAbstractFormBuilderWrapper &&) = delete;
    QAbstractFormBuilderWrapper& operator=(QAbstractFormBuilderWrapper &&) = delete;

    QAbstractFormBuilderWrapper();
    void addMenuAction(::QAction * action) override;
    bool checkProperty(::QObject * obj, const ::QString & prop) const override;
    ::QAction * createAction(::QObject * parent, const ::QString & name) override;
    ::QActionGroup * createActionGroup(::QObject * parent, const ::QString & name) override;
    ::QLayout * createLayout(const ::QString & layoutName, ::QObject * parent, const ::QString & name) override;
    ::QWidget * createWidget(const ::QString & widgetName, ::QWidget * parentWidget, const ::QString & name) override;
    ::QWidget * load(::QIODevice * dev, ::QWidget * parentWidget = nullptr) override;
    void save(::QIODevice * dev, ::QWidget * widget) override;
    ~QAbstractFormBuilderWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_QAbstractFormBuilderWrapper_H

