// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDesignerCustomWidgetInterfaceWrapper_H
#define SBK_QDesignerCustomWidgetInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtUiPlugin/customwidget.h>

class QDesignerCustomWidgetInterfaceWrapper : public QDesignerCustomWidgetInterface
{
public:
    QDesignerCustomWidgetInterfaceWrapper(const QDesignerCustomWidgetInterfaceWrapper &) = delete;
    QDesignerCustomWidgetInterfaceWrapper& operator=(const QDesignerCustomWidgetInterfaceWrapper &) = delete;
    QDesignerCustomWidgetInterfaceWrapper(QDesignerCustomWidgetInterfaceWrapper &&) = delete;
    QDesignerCustomWidgetInterfaceWrapper& operator=(QDesignerCustomWidgetInterfaceWrapper &&) = delete;

    QDesignerCustomWidgetInterfaceWrapper();
    ::QString codeTemplate() const override;
    ::QWidget * createWidget(::QWidget * parent) override;
    ::QString domXml() const override;
    ::QString group() const override;
    ::QIcon icon() const override;
    ::QString includeFile() const override;
    void initialize(::QDesignerFormEditorInterface * core) override;
    bool isContainer() const override;
    bool isInitialized() const override;
    ::QString name() const override;
    ::QString toolTip() const override;
    ::QString whatsThis() const override;
    ~QDesignerCustomWidgetInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[12] = {false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QDesignerCustomWidgetInterfaceWrapper_H

