// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDesignerDynamicPropertySheetExtensionWrapper_H
#define SBK_QDesignerDynamicPropertySheetExtensionWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/dynamicpropertysheet.h>

class QDesignerDynamicPropertySheetExtensionWrapper : public QDesignerDynamicPropertySheetExtension
{
public:
    QDesignerDynamicPropertySheetExtensionWrapper(const QDesignerDynamicPropertySheetExtensionWrapper &) = delete;
    QDesignerDynamicPropertySheetExtensionWrapper& operator=(const QDesignerDynamicPropertySheetExtensionWrapper &) = delete;
    QDesignerDynamicPropertySheetExtensionWrapper(QDesignerDynamicPropertySheetExtensionWrapper &&) = delete;
    QDesignerDynamicPropertySheetExtensionWrapper& operator=(QDesignerDynamicPropertySheetExtensionWrapper &&) = delete;

    QDesignerDynamicPropertySheetExtensionWrapper();
    int addDynamicProperty(const ::QString & propertyName, const ::QVariant & value) override;
    bool canAddDynamicProperty(const ::QString & propertyName) const override;
    bool dynamicPropertiesAllowed() const override;
    bool isDynamicProperty(int index) const override;
    bool removeDynamicProperty(int index) override;
    ~QDesignerDynamicPropertySheetExtensionWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[5] = {false, false, false, false, false};
};

#endif // SBK_QDesignerDynamicPropertySheetExtensionWrapper_H

