// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDesignerFormWindowCursorInterfaceWrapper_H
#define SBK_QDesignerFormWindowCursorInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/abstractformwindowcursor.h>

class QDesignerFormWindowCursorInterfaceWrapper : public QDesignerFormWindowCursorInterface
{
public:
    QDesignerFormWindowCursorInterfaceWrapper(const QDesignerFormWindowCursorInterfaceWrapper &) = delete;
    QDesignerFormWindowCursorInterfaceWrapper& operator=(const QDesignerFormWindowCursorInterfaceWrapper &) = delete;
    QDesignerFormWindowCursorInterfaceWrapper(QDesignerFormWindowCursorInterfaceWrapper &&) = delete;
    QDesignerFormWindowCursorInterfaceWrapper& operator=(QDesignerFormWindowCursorInterfaceWrapper &&) = delete;

    QDesignerFormWindowCursorInterfaceWrapper();
    ::QWidget * current() const override;
    ::QDesignerFormWindowInterface * formWindow() const override;
    bool hasSelection() const override;
    bool movePosition(::QDesignerFormWindowCursorInterface::MoveOperation op, ::QDesignerFormWindowCursorInterface::MoveMode mode = QDesignerFormWindowCursorInterface::MoveMode::MoveAnchor) override;
    int position() const override;
    void resetWidgetProperty(::QWidget * widget, const ::QString & name) override;
    ::QWidget * selectedWidget(int index) const override;
    int selectedWidgetCount() const override;
    void setPosition(int pos, ::QDesignerFormWindowCursorInterface::MoveMode mode = QDesignerFormWindowCursorInterface::MoveMode::MoveAnchor) override;
    void setProperty(const ::QString & name, const ::QVariant & value) override;
    void setWidgetProperty(::QWidget * widget, const ::QString & name, const ::QVariant & value) override;
    ::QWidget * widget(int index) const override;
    int widgetCount() const override;
    ~QDesignerFormWindowCursorInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[13] = {false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QDesignerFormWindowCursorInterfaceWrapper_H

