// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDesignerFormWindowManagerInterfaceWrapper_H
#define SBK_QDesignerFormWindowManagerInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/abstractformwindowmanager.h>

namespace PySide { class DynamicQMetaObject; }

class QDesignerFormWindowManagerInterfaceWrapper : public QDesignerFormWindowManagerInterface
{
public:
    QDesignerFormWindowManagerInterfaceWrapper(const QDesignerFormWindowManagerInterfaceWrapper &) = delete;
    QDesignerFormWindowManagerInterfaceWrapper& operator=(const QDesignerFormWindowManagerInterfaceWrapper &) = delete;
    QDesignerFormWindowManagerInterfaceWrapper(QDesignerFormWindowManagerInterfaceWrapper &&) = delete;
    QDesignerFormWindowManagerInterfaceWrapper& operator=(QDesignerFormWindowManagerInterfaceWrapper &&) = delete;

    QDesignerFormWindowManagerInterfaceWrapper(::QObject * parent = nullptr);
    ::QAction * action(::QDesignerFormWindowManagerInterface::Action action) const override;
    ::QActionGroup * actionGroup(::QDesignerFormWindowManagerInterface::ActionGroup actionGroup) const override;
    ::QDesignerFormWindowInterface * activeFormWindow() const override;
    void addFormWindow(::QDesignerFormWindowInterface * formWindow) override;
    void childEvent(::QChildEvent * event) override;
    void closeAllPreviews() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QDesignerFormEditorInterface * core() const override;
    ::QDesignerFormWindowInterface * createFormWindow(::QWidget * parentWidget = nullptr, ::QFlags<Qt::WindowType> flags = Qt::WindowFlags()) override;
    ::QPixmap createPreviewPixmap() const override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    void dragItems(const ::QList<QDesignerDnDItemInterface*> & item_list) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QDesignerFormWindowInterface * formWindow(int index) const override;
    int formWindowCount() const override;
    void removeFormWindow(::QDesignerFormWindowInterface * formWindow) override;
    void setActiveFormWindow(::QDesignerFormWindowInterface * formWindow) override;
    void showPluginDialog() override;
    void showPreview() override;
    void timerEvent(::QTimerEvent * event) override;
    ~QDesignerFormWindowManagerInterfaceWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[22] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QDesignerFormWindowManagerInterfaceWrapper_H

