// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDesignerFormWindowToolInterfaceWrapper_H
#define SBK_QDesignerFormWindowToolInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/abstractformwindowtool.h>

namespace PySide { class DynamicQMetaObject; }

class QDesignerFormWindowToolInterfaceWrapper : public QDesignerFormWindowToolInterface
{
public:
    QDesignerFormWindowToolInterfaceWrapper(const QDesignerFormWindowToolInterfaceWrapper &) = delete;
    QDesignerFormWindowToolInterfaceWrapper& operator=(const QDesignerFormWindowToolInterfaceWrapper &) = delete;
    QDesignerFormWindowToolInterfaceWrapper(QDesignerFormWindowToolInterfaceWrapper &&) = delete;
    QDesignerFormWindowToolInterfaceWrapper& operator=(QDesignerFormWindowToolInterfaceWrapper &&) = delete;

    QDesignerFormWindowToolInterfaceWrapper(::QObject * parent = nullptr);
    ::QAction * action() const override;
    void activated() override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QDesignerFormEditorInterface * core() const override;
    void customEvent(::QEvent * event) override;
    void deactivated() override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    ::QWidget * editor() const override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QDesignerFormWindowInterface * formWindow() const override;
    bool handleEvent(::QWidget * widget, ::QWidget * managedWidget, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QDesignerFormWindowToolInterfaceWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[14] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QDesignerFormWindowToolInterfaceWrapper_H

