// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDesignerPropertySheetExtensionWrapper_H
#define SBK_QDesignerPropertySheetExtensionWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/propertysheet.h>

class QDesignerPropertySheetExtensionWrapper : public QDesignerPropertySheetExtension
{
public:
    QDesignerPropertySheetExtensionWrapper(const QDesignerPropertySheetExtensionWrapper &) = delete;
    QDesignerPropertySheetExtensionWrapper& operator=(const QDesignerPropertySheetExtensionWrapper &) = delete;
    QDesignerPropertySheetExtensionWrapper(QDesignerPropertySheetExtensionWrapper &&) = delete;
    QDesignerPropertySheetExtensionWrapper& operator=(QDesignerPropertySheetExtensionWrapper &&) = delete;

    QDesignerPropertySheetExtensionWrapper() noexcept;
    int count() const override;
    bool hasReset(int index) const override;
    int indexOf(const ::QString & name) const override;
    bool isAttribute(int index) const override;
    bool isChanged(int index) const override;
    bool isEnabled(int index) const override;
    bool isVisible(int index) const override;
    ::QVariant property(int index) const override;
    ::QString propertyGroup(int index) const override;
    ::QString propertyName(int index) const override;
    bool reset(int index) override;
    void setAttribute(int index, bool b) override;
    void setChanged(int index, bool changed) override;
    void setProperty(int index, const ::QVariant & value) override;
    void setPropertyGroup(int index, const ::QString & group) override;
    void setVisible(int index, bool b) override;
    ~QDesignerPropertySheetExtensionWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[16] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QDesignerPropertySheetExtensionWrapper_H

