// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDesignerWidgetBoxInterfaceWrapper_H
#define SBK_QDesignerWidgetBoxInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/abstractwidgetbox.h>

namespace PySide { class DynamicQMetaObject; }

class QDesignerWidgetBoxInterfaceWrapper : public QDesignerWidgetBoxInterface
{
public:
    QDesignerWidgetBoxInterfaceWrapper(const QDesignerWidgetBoxInterfaceWrapper &) = delete;
    QDesignerWidgetBoxInterfaceWrapper& operator=(const QDesignerWidgetBoxInterfaceWrapper &) = delete;
    QDesignerWidgetBoxInterfaceWrapper(QDesignerWidgetBoxInterfaceWrapper &&) = delete;
    QDesignerWidgetBoxInterfaceWrapper& operator=(QDesignerWidgetBoxInterfaceWrapper &&) = delete;

    QDesignerWidgetBoxInterfaceWrapper(::QWidget * parent = nullptr, ::QFlags<Qt::WindowType> flags = Qt::WindowFlags());
    void actionEvent(::QActionEvent * event) override;
    void addCategory(const ::QDesignerWidgetBoxInterface::Category & cat) override;
    void addWidget(int cat_idx, const ::QDesignerWidgetBoxInterface::Widget & wgt) override;
    ::QDesignerWidgetBoxInterface::Category category(int cat_idx) const override;
    int categoryCount() const override;
    void changeEvent(::QEvent * event) override;
    void childEvent(::QChildEvent * event) override;
    void closeEvent(::QCloseEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void contextMenuEvent(::QContextMenuEvent * event) override;
    void customEvent(::QEvent * event) override;
    int devType() const override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    void dragEnterEvent(::QDragEnterEvent * event) override;
    void dragLeaveEvent(::QDragLeaveEvent * event) override;
    void dragMoveEvent(::QDragMoveEvent * event) override;
    void dropEvent(::QDropEvent * event) override;
    void dropWidgets(const ::QList<QDesignerDnDItemInterface*> & item_list, const ::QPoint & global_mouse_pos) override;
    void enterEvent(::QEnterEvent * event) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QString fileName() const override;
    void focusInEvent(::QFocusEvent * event) override;
    bool focusNextPrevChild(bool next) override;
    void focusOutEvent(::QFocusEvent * event) override;
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    void hideEvent(::QHideEvent * event) override;
    void initPainter(::QPainter * painter) const override;
    void inputMethodEvent(::QInputMethodEvent * event) override;
    ::QVariant inputMethodQuery(::Qt::InputMethodQuery arg__1) const override;
    void keyPressEvent(::QKeyEvent * event) override;
    void keyReleaseEvent(::QKeyEvent * event) override;
    void leaveEvent(::QEvent * event) override;
    bool load() override;
    int metric(::QPaintDevice::PaintDeviceMetric arg__1) const override;
    ::QSize minimumSizeHint() const override;
    void mouseDoubleClickEvent(::QMouseEvent * event) override;
    void mouseMoveEvent(::QMouseEvent * event) override;
    void mousePressEvent(::QMouseEvent * event) override;
    void mouseReleaseEvent(::QMouseEvent * event) override;
    void moveEvent(::QMoveEvent * event) override;
    bool nativeEvent(const ::QByteArray & eventType, void * message, ::qintptr * result) override;
    ::QPaintEngine * paintEngine() const override;
    void paintEvent(::QPaintEvent * event) override;
    ::QPaintDevice * redirected(::QPoint * offset) const override;
    void removeCategory(int cat_idx) override;
    void removeWidget(int cat_idx, int wgt_idx) override;
    void resizeEvent(::QResizeEvent * event) override;
    bool save() override;
    void setFileName(const ::QString & file_name) override;
    void setVisible(bool visible) override;
    ::QPainter * sharedPainter() const override;
    void showEvent(::QShowEvent * event) override;
    ::QSize sizeHint() const override;
    void tabletEvent(::QTabletEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    void wheelEvent(::QWheelEvent * event) override;
    ::QDesignerWidgetBoxInterface::Widget widget(int cat_idx, int wgt_idx) const override;
    int widgetCount(int cat_idx) const override;
    ~QDesignerWidgetBoxInterfaceWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[60] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QDesignerWidgetBoxInterfaceWrapper_H

