// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPyDesignerContainerExtensionWrapper_H
#define SBK_QPyDesignerContainerExtensionWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qpydesignerextensions.h>

namespace PySide { class DynamicQMetaObject; }

class QPyDesignerContainerExtensionWrapper : public QPyDesignerContainerExtension
{
public:
    QPyDesignerContainerExtensionWrapper(const QPyDesignerContainerExtensionWrapper &) = delete;
    QPyDesignerContainerExtensionWrapper& operator=(const QPyDesignerContainerExtensionWrapper &) = delete;
    QPyDesignerContainerExtensionWrapper(QPyDesignerContainerExtensionWrapper &&) = delete;
    QPyDesignerContainerExtensionWrapper& operator=(QPyDesignerContainerExtensionWrapper &&) = delete;

    QPyDesignerContainerExtensionWrapper(::QObject * parent = nullptr);
    void addWidget(::QWidget * widget) override;
    bool canAddWidget() const override;
    bool canRemove(int index) const override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    int count() const override;
    int currentIndex() const override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void insertWidget(int index, ::QWidget * widget) override;
    void remove(int index) override;
    void setCurrentIndex(int index) override;
    void timerEvent(::QTimerEvent * event) override;
    ::QWidget * widget(int index) const override;
    ~QPyDesignerContainerExtensionWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[16] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QPyDesignerContainerExtensionWrapper_H

