// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPyDesignerMemberSheetExtensionWrapper_H
#define SBK_QPyDesignerMemberSheetExtensionWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qpydesignerextensions.h>

namespace PySide { class DynamicQMetaObject; }

class QPyDesignerMemberSheetExtensionWrapper : public QPyDesignerMemberSheetExtension
{
public:
    QPyDesignerMemberSheetExtensionWrapper(const QPyDesignerMemberSheetExtensionWrapper &) = delete;
    QPyDesignerMemberSheetExtensionWrapper& operator=(const QPyDesignerMemberSheetExtensionWrapper &) = delete;
    QPyDesignerMemberSheetExtensionWrapper(QPyDesignerMemberSheetExtensionWrapper &&) = delete;
    QPyDesignerMemberSheetExtensionWrapper& operator=(QPyDesignerMemberSheetExtensionWrapper &&) = delete;

    QPyDesignerMemberSheetExtensionWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    int count() const override;
    void customEvent(::QEvent * event) override;
    ::QString declaredInClass(int index) const override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    int indexOf(const ::QString & name) const override;
    bool inheritedFromWidget(int index) const override;
    bool isSignal(int index) const override;
    bool isSlot(int index) const override;
    bool isVisible(int index) const override;
    ::QString memberGroup(int index) const override;
    ::QString memberName(int index) const override;
    ::QList<QByteArray> parameterNames(int index) const override;
    ::QList<QByteArray> parameterTypes(int index) const override;
    void setMemberGroup(int index, const ::QString & group) override;
    void setVisible(int index, bool b) override;
    ::QString signature(int index) const override;
    void timerEvent(::QTimerEvent * event) override;
    ~QPyDesignerMemberSheetExtensionWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[21] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QPyDesignerMemberSheetExtensionWrapper_H

