// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgraphs_python.h"

// main header
#include "qgraphsthemedirtybitfield_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QGraphsThemeDirtyBitField_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QGraphsThemeDirtyBitField >()))
        return -1;

    ::QGraphsThemeDirtyBitField *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QGraphsThemeDirtyBitField", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QGraphsThemeDirtyBitField::QGraphsThemeDirtyBitField()
    // 1: QGraphsThemeDirtyBitField::QGraphsThemeDirtyBitField(QGraphsThemeDirtyBitField)
    if (numArgs == 0) {
        overloadId = 0; // QGraphsThemeDirtyBitField()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QGraphsThemeDirtyBitField(QGraphsThemeDirtyBitField)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QGraphsThemeDirtyBitField()
        {

            // QGraphsThemeDirtyBitField()
            cptr = new ::QGraphsThemeDirtyBitField();
            break;
        }
        case 1: // QGraphsThemeDirtyBitField(const QGraphsThemeDirtyBitField &QGraphsThemeDirtyBitField)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QGraphsThemeDirtyBitField cppArg0_local;
            ::QGraphsThemeDirtyBitField *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QGraphsThemeDirtyBitField(QGraphsThemeDirtyBitField)
                cptr = new ::QGraphsThemeDirtyBitField(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QGraphsThemeDirtyBitField >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QGraphsThemeDirtyBitField_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QGraphsThemeDirtyBitField_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QGraphsThemeDirtyBitField__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_plotAreaBackgroundColorDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->plotAreaBackgroundColorDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_plotAreaBackgroundColorDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("plotAreaBackgroundColorDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("plotAreaBackgroundColorDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->plotAreaBackgroundColorDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->plotAreaBackgroundColorDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_plotAreaBackgroundVisibilityDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->plotAreaBackgroundVisibilityDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_plotAreaBackgroundVisibilityDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("plotAreaBackgroundVisibilityDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("plotAreaBackgroundVisibilityDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->plotAreaBackgroundVisibilityDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->plotAreaBackgroundVisibilityDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_seriesColorsDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->seriesColorsDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_seriesColorsDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("seriesColorsDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("seriesColorsDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->seriesColorsDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->seriesColorsDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_seriesGradientDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->seriesGradientDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_seriesGradientDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("seriesGradientDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("seriesGradientDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->seriesGradientDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->seriesGradientDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_colorSchemeDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->colorSchemeDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_colorSchemeDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("colorSchemeDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("colorSchemeDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->colorSchemeDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->colorSchemeDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_colorStyleDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->colorStyleDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_colorStyleDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("colorStyleDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("colorStyleDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->colorStyleDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->colorStyleDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_labelFontDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->labelFontDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_labelFontDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("labelFontDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("labelFontDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->labelFontDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->labelFontDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_gridVisibilityDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->gridVisibilityDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_gridVisibilityDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("gridVisibilityDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("gridVisibilityDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->gridVisibilityDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->gridVisibilityDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_gridDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->gridDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_gridDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("gridDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("gridDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->gridDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->gridDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_labelBackgroundColorDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->labelBackgroundColorDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_labelBackgroundColorDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("labelBackgroundColorDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("labelBackgroundColorDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->labelBackgroundColorDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->labelBackgroundColorDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_labelBackgroundVisibilityDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->labelBackgroundVisibilityDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_labelBackgroundVisibilityDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("labelBackgroundVisibilityDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("labelBackgroundVisibilityDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->labelBackgroundVisibilityDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->labelBackgroundVisibilityDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_labelBorderVisibilityDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->labelBorderVisibilityDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_labelBorderVisibilityDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("labelBorderVisibilityDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("labelBorderVisibilityDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->labelBorderVisibilityDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->labelBorderVisibilityDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_labelTextColorDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->labelTextColorDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_labelTextColorDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("labelTextColorDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("labelTextColorDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->labelTextColorDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->labelTextColorDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_axisXDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->axisXDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_axisXDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("axisXDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("axisXDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->axisXDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->axisXDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_axisYDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->axisYDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_axisYDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("axisYDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("axisYDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->axisYDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->axisYDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_axisZDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->axisZDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_axisZDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("axisZDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("axisZDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->axisZDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->axisZDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_labelsVisibilityDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->labelsVisibilityDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_labelsVisibilityDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("labelsVisibilityDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("labelsVisibilityDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->labelsVisibilityDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->labelsVisibilityDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_multiHighlightColorDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->multiHighlightColorDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_multiHighlightColorDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("multiHighlightColorDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("multiHighlightColorDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->multiHighlightColorDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->multiHighlightColorDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_multiHighlightGradientDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->multiHighlightGradientDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_multiHighlightGradientDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("multiHighlightGradientDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("multiHighlightGradientDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->multiHighlightGradientDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->multiHighlightGradientDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_singleHighlightColorDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->singleHighlightColorDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_singleHighlightColorDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("singleHighlightColorDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("singleHighlightColorDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->singleHighlightColorDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->singleHighlightColorDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_singleHighlightGradientDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->singleHighlightGradientDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_singleHighlightGradientDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("singleHighlightGradientDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("singleHighlightGradientDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->singleHighlightGradientDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->singleHighlightGradientDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_themeDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->themeDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_themeDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("themeDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("themeDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->themeDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->themeDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_backgroundColorDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->backgroundColorDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_backgroundColorDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("backgroundColorDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("backgroundColorDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->backgroundColorDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->backgroundColorDirty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QGraphsThemeDirtyBitField_get_backgroundVisibilityDirty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->backgroundVisibilityDirty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QGraphsThemeDirtyBitField_set_backgroundVisibilityDirty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("backgroundVisibilityDirty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("backgroundVisibilityDirty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->backgroundVisibilityDirty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->backgroundVisibilityDirty = cppOut_local;

    return 0;
}

// Getters and Setters for QGraphsThemeDirtyBitField
static PyGetSetDef Sbk_QGraphsThemeDirtyBitField_getsetlist[] = {
    {const_cast<char *>("plotAreaBackgroundColorDirty"), Sbk_QGraphsThemeDirtyBitField_get_plotAreaBackgroundColorDirty, Sbk_QGraphsThemeDirtyBitField_set_plotAreaBackgroundColorDirty, nullptr, nullptr},
    {const_cast<char *>("plotAreaBackgroundVisibilityDirty"), Sbk_QGraphsThemeDirtyBitField_get_plotAreaBackgroundVisibilityDirty, Sbk_QGraphsThemeDirtyBitField_set_plotAreaBackgroundVisibilityDirty, nullptr, nullptr},
    {const_cast<char *>("seriesColorsDirty"), Sbk_QGraphsThemeDirtyBitField_get_seriesColorsDirty, Sbk_QGraphsThemeDirtyBitField_set_seriesColorsDirty, nullptr, nullptr},
    {const_cast<char *>("seriesGradientDirty"), Sbk_QGraphsThemeDirtyBitField_get_seriesGradientDirty, Sbk_QGraphsThemeDirtyBitField_set_seriesGradientDirty, nullptr, nullptr},
    {const_cast<char *>("colorSchemeDirty"), Sbk_QGraphsThemeDirtyBitField_get_colorSchemeDirty, Sbk_QGraphsThemeDirtyBitField_set_colorSchemeDirty, nullptr, nullptr},
    {const_cast<char *>("colorStyleDirty"), Sbk_QGraphsThemeDirtyBitField_get_colorStyleDirty, Sbk_QGraphsThemeDirtyBitField_set_colorStyleDirty, nullptr, nullptr},
    {const_cast<char *>("labelFontDirty"), Sbk_QGraphsThemeDirtyBitField_get_labelFontDirty, Sbk_QGraphsThemeDirtyBitField_set_labelFontDirty, nullptr, nullptr},
    {const_cast<char *>("gridVisibilityDirty"), Sbk_QGraphsThemeDirtyBitField_get_gridVisibilityDirty, Sbk_QGraphsThemeDirtyBitField_set_gridVisibilityDirty, nullptr, nullptr},
    {const_cast<char *>("gridDirty"), Sbk_QGraphsThemeDirtyBitField_get_gridDirty, Sbk_QGraphsThemeDirtyBitField_set_gridDirty, nullptr, nullptr},
    {const_cast<char *>("labelBackgroundColorDirty"), Sbk_QGraphsThemeDirtyBitField_get_labelBackgroundColorDirty, Sbk_QGraphsThemeDirtyBitField_set_labelBackgroundColorDirty, nullptr, nullptr},
    {const_cast<char *>("labelBackgroundVisibilityDirty"), Sbk_QGraphsThemeDirtyBitField_get_labelBackgroundVisibilityDirty, Sbk_QGraphsThemeDirtyBitField_set_labelBackgroundVisibilityDirty, nullptr, nullptr},
    {const_cast<char *>("labelBorderVisibilityDirty"), Sbk_QGraphsThemeDirtyBitField_get_labelBorderVisibilityDirty, Sbk_QGraphsThemeDirtyBitField_set_labelBorderVisibilityDirty, nullptr, nullptr},
    {const_cast<char *>("labelTextColorDirty"), Sbk_QGraphsThemeDirtyBitField_get_labelTextColorDirty, Sbk_QGraphsThemeDirtyBitField_set_labelTextColorDirty, nullptr, nullptr},
    {const_cast<char *>("axisXDirty"), Sbk_QGraphsThemeDirtyBitField_get_axisXDirty, Sbk_QGraphsThemeDirtyBitField_set_axisXDirty, nullptr, nullptr},
    {const_cast<char *>("axisYDirty"), Sbk_QGraphsThemeDirtyBitField_get_axisYDirty, Sbk_QGraphsThemeDirtyBitField_set_axisYDirty, nullptr, nullptr},
    {const_cast<char *>("axisZDirty"), Sbk_QGraphsThemeDirtyBitField_get_axisZDirty, Sbk_QGraphsThemeDirtyBitField_set_axisZDirty, nullptr, nullptr},
    {const_cast<char *>("labelsVisibilityDirty"), Sbk_QGraphsThemeDirtyBitField_get_labelsVisibilityDirty, Sbk_QGraphsThemeDirtyBitField_set_labelsVisibilityDirty, nullptr, nullptr},
    {const_cast<char *>("multiHighlightColorDirty"), Sbk_QGraphsThemeDirtyBitField_get_multiHighlightColorDirty, Sbk_QGraphsThemeDirtyBitField_set_multiHighlightColorDirty, nullptr, nullptr},
    {const_cast<char *>("multiHighlightGradientDirty"), Sbk_QGraphsThemeDirtyBitField_get_multiHighlightGradientDirty, Sbk_QGraphsThemeDirtyBitField_set_multiHighlightGradientDirty, nullptr, nullptr},
    {const_cast<char *>("singleHighlightColorDirty"), Sbk_QGraphsThemeDirtyBitField_get_singleHighlightColorDirty, Sbk_QGraphsThemeDirtyBitField_set_singleHighlightColorDirty, nullptr, nullptr},
    {const_cast<char *>("singleHighlightGradientDirty"), Sbk_QGraphsThemeDirtyBitField_get_singleHighlightGradientDirty, Sbk_QGraphsThemeDirtyBitField_set_singleHighlightGradientDirty, nullptr, nullptr},
    {const_cast<char *>("themeDirty"), Sbk_QGraphsThemeDirtyBitField_get_themeDirty, Sbk_QGraphsThemeDirtyBitField_set_themeDirty, nullptr, nullptr},
    {const_cast<char *>("backgroundColorDirty"), Sbk_QGraphsThemeDirtyBitField_get_backgroundColorDirty, Sbk_QGraphsThemeDirtyBitField_set_backgroundColorDirty, nullptr, nullptr},
    {const_cast<char *>("backgroundVisibilityDirty"), Sbk_QGraphsThemeDirtyBitField_get_backgroundVisibilityDirty, Sbk_QGraphsThemeDirtyBitField_set_backgroundVisibilityDirty, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QGraphsThemeDirtyBitField_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QGraphsThemeDirtyBitField_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QGraphsThemeDirtyBitField_Type = nullptr;
static PyTypeObject *Sbk_QGraphsThemeDirtyBitField_TypeF(void)
{
    return _Sbk_QGraphsThemeDirtyBitField_Type;
}

static PyType_Slot Sbk_QGraphsThemeDirtyBitField_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QGraphsThemeDirtyBitField_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QGraphsThemeDirtyBitField_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QGraphsThemeDirtyBitField_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QGraphsThemeDirtyBitField_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QGraphsThemeDirtyBitField_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QGraphsThemeDirtyBitField_spec = {
    "2:PySide6.QtGraphs.QGraphsThemeDirtyBitField",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QGraphsThemeDirtyBitField_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QGraphsThemeDirtyBitField_PythonToCpp_QGraphsThemeDirtyBitField_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QGraphsThemeDirtyBitField_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QGraphsThemeDirtyBitField_PythonToCpp_QGraphsThemeDirtyBitField_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QGraphsThemeDirtyBitField_TypeF()))
        return QGraphsThemeDirtyBitField_PythonToCpp_QGraphsThemeDirtyBitField_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QGraphsThemeDirtyBitField_PTR_CppToPython_QGraphsThemeDirtyBitField(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QGraphsThemeDirtyBitField_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QGraphsThemeDirtyBitField_COPY_CppToPython_QGraphsThemeDirtyBitField(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QGraphsThemeDirtyBitField *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QGraphsThemeDirtyBitField_TypeF(), new ::QGraphsThemeDirtyBitField(*source), true, true);
}

// Python to C++ copy conversion.
static void QGraphsThemeDirtyBitField_PythonToCpp_QGraphsThemeDirtyBitField_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QGraphsThemeDirtyBitField *>(cppOut) = *reinterpret_cast< ::QGraphsThemeDirtyBitField *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QGraphsThemeDirtyBitField_PythonToCpp_QGraphsThemeDirtyBitField_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QGraphsThemeDirtyBitField_TypeF()))
        return QGraphsThemeDirtyBitField_PythonToCpp_QGraphsThemeDirtyBitField_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QGraphsThemeDirtyBitField_SignatureStrings[] = {
    "1:PySide6.QtGraphs.QGraphsThemeDirtyBitField(self)",
    "0:PySide6.QtGraphs.QGraphsThemeDirtyBitField(self,QGraphsThemeDirtyBitField:PySide6.QtGraphs.QGraphsThemeDirtyBitField)",
    "PySide6.QtGraphs.QGraphsThemeDirtyBitField.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QGraphsThemeDirtyBitField_SignatureByteSize = 92;
static constexpr uint8_t QGraphsThemeDirtyBitField_SignatureBytes[92] = {
    0x78, 0xda, 0x33, 0xb4, 0x0a, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x71, 0x2f,
    0x4a, 0x2c, 0xc8, 0x28, 0xd6, 0x0b, 0x84, 0xd0, 0x21, 0x19, 0xa9, 0xb9, 0xa9, 0x2e, 0x99, 0x45,
    0x25, 0x95, 0x4e, 0x99, 0x25, 0x6e, 0x99, 0xa9, 0x39, 0x29, 0x1a, 0xc5, 0xa9, 0x39, 0x69, 0x9a,
    0x5c, 0x06, 0xa4, 0x6a, 0xd1, 0xc1, 0x29, 0x4d, 0x82, 0x49, 0x9a, 0x5c, 0xc4, 0xab, 0xd5, 0x8b,
    0x8f, 0x4f, 0xce, 0x2f, 0xa8, 0x8c, 0x8f, 0x87, 0xb8, 0x58, 0xd7, 0xae, 0xa4, 0xb2, 0x20, 0x33,
    0x2f, 0x5d, 0x2f, 0x18, 0xc8, 0xe3, 0x02, 0x00, 0xb8, 0xa3, 0x58, 0x2e
};
#endif

PyTypeObject *init_QGraphsThemeDirtyBitField(PyObject *module)
{
    if (SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX].type != nullptr)
        return SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX].type;

    Shiboken::AutoDecRef Sbk_QGraphsThemeDirtyBitField_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QGraphsThemeDirtyBitField_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QGraphsThemeDirtyBitField",
        "QGraphsThemeDirtyBitField",
        &Sbk_QGraphsThemeDirtyBitField_spec,
        &Shiboken::callCppDestructor< ::QGraphsThemeDirtyBitField >,
        Sbk_QGraphsThemeDirtyBitField_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QGraphsThemeDirtyBitField_TypeF(); // references _Sbk_QGraphsThemeDirtyBitField_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QGraphsThemeDirtyBitField_SignatureStrings);
#else
    InitSignatureBytes(pyType, QGraphsThemeDirtyBitField_SignatureBytes, QGraphsThemeDirtyBitField_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QGraphsThemeDirtyBitField_PropertyStrings);
    SbkPySide6_QtGraphsTypeStructs[SBK_QGraphsThemeDirtyBitField_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QGraphsThemeDirtyBitField_PythonToCpp_QGraphsThemeDirtyBitField_PTR,
        is_QGraphsThemeDirtyBitField_PythonToCpp_QGraphsThemeDirtyBitField_PTR_Convertible,
        QGraphsThemeDirtyBitField_PTR_CppToPython_QGraphsThemeDirtyBitField,
        QGraphsThemeDirtyBitField_COPY_CppToPython_QGraphsThemeDirtyBitField);

    Shiboken::Conversions::registerConverterName(converter, "QGraphsThemeDirtyBitField");
    Shiboken::Conversions::registerConverterName(converter, "QGraphsThemeDirtyBitField*");
    Shiboken::Conversions::registerConverterName(converter, "QGraphsThemeDirtyBitField&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QGraphsThemeDirtyBitField).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QGraphsThemeDirtyBitField_PythonToCpp_QGraphsThemeDirtyBitField_COPY,
        is_QGraphsThemeDirtyBitField_PythonToCpp_QGraphsThemeDirtyBitField_COPY_Convertible);

    qRegisterMetaType< ::QGraphsThemeDirtyBitField >("QGraphsThemeDirtyBitField");

    return pyType;
}
