// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_Q3DSurfaceWidgetItemWrapper_H
#define SBK_Q3DSurfaceWidgetItemWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGraphsWidgets/q3dsurfacewidgetitem.h>

namespace PySide { class DynamicQMetaObject; }

class Q3DSurfaceWidgetItemWrapper : public Q3DSurfaceWidgetItem
{
public:
    Q3DSurfaceWidgetItemWrapper(const Q3DSurfaceWidgetItemWrapper &) = delete;
    Q3DSurfaceWidgetItemWrapper& operator=(const Q3DSurfaceWidgetItemWrapper &) = delete;
    Q3DSurfaceWidgetItemWrapper(Q3DSurfaceWidgetItemWrapper &&) = delete;
    Q3DSurfaceWidgetItemWrapper& operator=(Q3DSurfaceWidgetItemWrapper &&) = delete;

    Q3DSurfaceWidgetItemWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * obj, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~Q3DSurfaceWidgetItemWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_Q3DSurfaceWidgetItemWrapper_H

