// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only


#ifndef SBK_QTGUI_PYTHON_P_H
#define SBK_QTGUI_PYTHON_P_H

#include <qnativeinterface.h>
#include <rhi/qrhi.h>
#include <rhi/qshader.h>


QT_BEGIN_NAMESPACE
class QRhiColorAttachment;
class QRhiDepthStencilClearValue;
struct QRhiGles2InitParams;
struct QRhiGles2NativeHandles;
struct QRhiInitParams;
struct QRhiNativeHandles;
struct QRhiNullInitParams;
class QRhiReadbackDescription;
struct QRhiReadbackResult;
class QRhiRenderPassDescriptor;
class QRhiRenderTarget;
class QRhiResourceUpdateBatch;
class QRhiScissor;
struct QRhiStats;
class QRhiSwapChainRenderTarget;
class QRhiTextureCopyDescription;
class QRhiTextureRenderTargetDescription;
class QRhiTextureSubresourceUploadDescription;
class QRhiTextureUploadDescription;
class QRhiTextureUploadEntry;
class QRhiVertexInputLayout;
class QRhiViewport;
class QShaderCode;
class QShaderKey;

namespace QNativeInterface {
    struct QX11Application;
}
QT_END_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_DEPRECATED
namespace Shiboken
{

// PyType functions, to get the PyObjectType for a type T
#if QT_CONFIG(xcb)
template<> inline PyTypeObject *SbkType< ::QNativeInterface::QX11Application >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QNativeInterface_QX11Application_IDX]); }
#endif
template<> inline PyTypeObject *SbkType< ::QRhi::Implementation >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhi_Implementation_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhi::Flag >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhi_Flag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhi::Flag> >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFlags_QRhi_Flag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhi::FrameOpResult >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhi_FrameOpResult_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhi::Feature >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhi_Feature_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhi::BeginFrameFlag >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhi_BeginFrameFlag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhi::BeginFrameFlag> >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFlags_QRhi_BeginFrameFlag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhi::EndFrameFlag >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhi_EndFrameFlag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhi::EndFrameFlag> >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFlags_QRhi_EndFrameFlag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhi::ResourceLimit >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhi_ResourceLimit_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhi >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhi_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiBuffer::Type >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiBuffer_Type_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiBuffer::UsageFlag >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiBuffer_UsageFlag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiBuffer::UsageFlag> >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFlags_QRhiBuffer_UsageFlag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiBuffer >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiBuffer_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiColorAttachment >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiColorAttachment_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiCommandBuffer::IndexFormat >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiCommandBuffer_IndexFormat_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiCommandBuffer::BeginPassFlag >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiCommandBuffer_BeginPassFlag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiCommandBuffer::BeginPassFlag> >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFlags_QRhiCommandBuffer_BeginPassFlag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiCommandBuffer >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiCommandBuffer_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiComputePipeline::Flag >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiComputePipeline_Flag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiComputePipeline::Flag> >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFlags_QRhiComputePipeline_Flag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiComputePipeline >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiComputePipeline_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiDepthStencilClearValue >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDepthStencilClearValue_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiDriverInfo::DeviceType >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDriverInfo_DeviceType_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiDriverInfo >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiDriverInfo_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGles2InitParams >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2InitParams_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGles2NativeHandles >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGles2NativeHandles_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::Flag >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_Flag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiGraphicsPipeline::Flag> >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFlags_QRhiGraphicsPipeline_Flag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::Topology >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_Topology_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::CullMode >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_CullMode_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::FrontFace >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_FrontFace_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::ColorMaskComponent >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_ColorMaskComponent_IDX]); }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiGraphicsPipeline::ColorMaskComponent> >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFlags_QRhiGraphicsPipeline_ColorMaskComponent_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::BlendFactor >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_BlendFactor_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::BlendOp >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_BlendOp_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::CompareOp >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_CompareOp_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::StencilOp >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOp_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::PolygonMode >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_PolygonMode_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::StencilOpState >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOpState_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::TargetBlend >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_TargetBlend_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiInitParams >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiInitParams_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiNativeHandles >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiNativeHandles_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiNullInitParams >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiNullInitParams_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiReadbackDescription >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiReadbackDescription_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiReadbackResult >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiReadbackResult_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiRenderBuffer::Type >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiRenderBuffer_Type_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiRenderBuffer::Flag >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiRenderBuffer_Flag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiRenderBuffer::Flag> >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFlags_QRhiRenderBuffer_Flag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiRenderBuffer >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiRenderBuffer_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiRenderPassDescriptor >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiRenderPassDescriptor_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiRenderTarget >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiRenderTarget_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiResource::Type >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiResource_Type_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiResource >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiResource_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiResourceUpdateBatch >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiSampler::Filter >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiSampler_Filter_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiSampler::AddressMode >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiSampler_AddressMode_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiSampler::CompareOp >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiSampler_CompareOp_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiSampler >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiSampler_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiScissor >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiScissor_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiShaderResourceBinding::Type >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Type_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiShaderResourceBinding::StageFlag >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_StageFlag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiShaderResourceBinding::StageFlag> >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFlags_QRhiShaderResourceBinding_StageFlag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiShaderResourceBinding >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiShaderResourceBinding::Data >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiShaderResourceBinding::Data::StorageBufferData >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageBufferData_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiShaderResourceBinding::Data::StorageImageData >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageImageData_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiShaderResourceBinding::TextureAndSampler >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_TextureAndSampler_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiShaderResourceBindings::UpdateFlag >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBindings_UpdateFlag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiShaderResourceBindings::UpdateFlag> >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFlags_QRhiShaderResourceBindings_UpdateFlag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiShaderResourceBindings >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBindings_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiShaderStage::Type >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_Type_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiShaderStage >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderStage_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiStats >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiStats_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiSwapChain::Flag >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiSwapChain_Flag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiSwapChain::Flag> >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFlags_QRhiSwapChain_Flag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiSwapChain::Format >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiSwapChain_Format_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiSwapChain::StereoTargetBuffer >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiSwapChain_StereoTargetBuffer_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiSwapChain >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiSwapChain_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiSwapChainRenderTarget >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiSwapChainRenderTarget_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiTexture::Flag >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTexture_Flag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiTexture::Flag> >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFlags_QRhiTexture_Flag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiTexture::Format >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTexture_Format_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiTexture >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTexture_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiTexture::ViewFormat >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTexture_ViewFormat_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiTextureCopyDescription >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiTextureRenderTarget::Flag >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureRenderTarget_Flag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiTextureRenderTarget::Flag> >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFlags_QRhiTextureRenderTarget_Flag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiTextureRenderTarget >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureRenderTarget_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiTextureRenderTargetDescription >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureRenderTargetDescription_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiTextureSubresourceUploadDescription >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiTextureUploadDescription >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiTextureUploadEntry >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiVertexInputAttribute::Format >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_Format_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiVertexInputAttribute >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputAttribute_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiVertexInputBinding::Classification >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_Classification_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiVertexInputBinding >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputBinding_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiVertexInputLayout >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiVertexInputLayout_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiViewport >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiViewport_IDX]); }
template<> inline PyTypeObject *SbkType< ::QShader::Stage >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QShader_Stage_IDX]); }
template<> inline PyTypeObject *SbkType< ::QShader::Source >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QShader_Source_IDX]); }
template<> inline PyTypeObject *SbkType< ::QShader::Variant >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QShader_Variant_IDX]); }
template<> inline PyTypeObject *SbkType< ::QShader::SerializedFormatVersion >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QShader_SerializedFormatVersion_IDX]); }
template<> inline PyTypeObject *SbkType< ::QShader >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QShader_IDX]); }
template<> inline PyTypeObject *SbkType< ::QShaderCode >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QShaderCode_IDX]); }
template<> inline PyTypeObject *SbkType< ::QShaderKey >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QShaderKey_IDX]); }
template<> inline PyTypeObject *SbkType< ::QShaderVersion::Flag >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QShaderVersion_Flag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QFlags<QShaderVersion::Flag> >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFlags_QShaderVersion_Flag_IDX]); }
template<> inline PyTypeObject *SbkType< ::QShaderVersion >() { return Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QShaderVersion_IDX]); }

} // namespace Shiboken

QT_WARNING_POP
#endif
