// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAccessibleAnnouncementEventWrapper_H
#define SBK_QAccessibleAnnouncementEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

class QAccessibleAnnouncementEventWrapper : public QAccessibleAnnouncementEvent
{
public:
    QAccessibleAnnouncementEventWrapper(const QAccessibleAnnouncementEventWrapper &) = delete;
    QAccessibleAnnouncementEventWrapper& operator=(const QAccessibleAnnouncementEventWrapper &) = delete;
    QAccessibleAnnouncementEventWrapper(QAccessibleAnnouncementEventWrapper &&) = delete;
    QAccessibleAnnouncementEventWrapper& operator=(QAccessibleAnnouncementEventWrapper &&) = delete;

    QAccessibleAnnouncementEventWrapper(::QAccessibleInterface * iface, const ::QString & message);
    QAccessibleAnnouncementEventWrapper(::QObject * object, const ::QString & message);
    ::QAccessibleInterface * accessibleInterface() const override;
    ~QAccessibleAnnouncementEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QAccessibleAnnouncementEventWrapper_H

