// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAccessibleAttributesInterfaceWrapper_H
#define SBK_QAccessibleAttributesInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

class QAccessibleAttributesInterfaceWrapper : public QAccessibleAttributesInterface
{
public:
    QAccessibleAttributesInterfaceWrapper(const QAccessibleAttributesInterfaceWrapper &) = delete;
    QAccessibleAttributesInterfaceWrapper& operator=(const QAccessibleAttributesInterfaceWrapper &) = delete;
    QAccessibleAttributesInterfaceWrapper(QAccessibleAttributesInterfaceWrapper &&) = delete;
    QAccessibleAttributesInterfaceWrapper& operator=(QAccessibleAttributesInterfaceWrapper &&) = delete;

    QAccessibleAttributesInterfaceWrapper();
    ::QList<QAccessible::Attribute> attributeKeys() const override;
    ::QVariant attributeValue(::QAccessible::Attribute key) const override;
    ~QAccessibleAttributesInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QAccessibleAttributesInterfaceWrapper_H

