// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAccessibleSelectionInterfaceWrapper_H
#define SBK_QAccessibleSelectionInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

class QAccessibleSelectionInterfaceWrapper : public QAccessibleSelectionInterface
{
public:
    QAccessibleSelectionInterfaceWrapper(const QAccessibleSelectionInterfaceWrapper &) = delete;
    QAccessibleSelectionInterfaceWrapper& operator=(const QAccessibleSelectionInterfaceWrapper &) = delete;
    QAccessibleSelectionInterfaceWrapper(QAccessibleSelectionInterfaceWrapper &&) = delete;
    QAccessibleSelectionInterfaceWrapper& operator=(QAccessibleSelectionInterfaceWrapper &&) = delete;

    QAccessibleSelectionInterfaceWrapper();
    bool clear() override;
    bool isSelected(::QAccessibleInterface * childItem) const override;
    bool select(::QAccessibleInterface * childItem) override;
    bool selectAll() override;
    ::QAccessibleInterface * selectedItem(int selectionIndex) const override;
    int selectedItemCount() const override;
    ::QList<QAccessibleInterface*> selectedItems() const override;
    bool unselect(::QAccessibleInterface * childItem) override;
    ~QAccessibleSelectionInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_QAccessibleSelectionInterfaceWrapper_H

