// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAccessibleStateChangeEventWrapper_H
#define SBK_QAccessibleStateChangeEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

class QAccessibleStateChangeEventWrapper : public QAccessibleStateChangeEvent
{
public:
    QAccessibleStateChangeEventWrapper(const QAccessibleStateChangeEventWrapper &) = delete;
    QAccessibleStateChangeEventWrapper& operator=(const QAccessibleStateChangeEventWrapper &) = delete;
    QAccessibleStateChangeEventWrapper(QAccessibleStateChangeEventWrapper &&) = delete;
    QAccessibleStateChangeEventWrapper& operator=(QAccessibleStateChangeEventWrapper &&) = delete;

    QAccessibleStateChangeEventWrapper(::QAccessibleInterface * iface, ::QAccessible::State state);
    QAccessibleStateChangeEventWrapper(::QObject * obj, ::QAccessible::State state);
    ::QAccessibleInterface * accessibleInterface() const override;
    ~QAccessibleStateChangeEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QAccessibleStateChangeEventWrapper_H

