// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAccessibleTableCellInterfaceWrapper_H
#define SBK_QAccessibleTableCellInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

class QAccessibleTableCellInterfaceWrapper : public QAccessibleTableCellInterface
{
public:
    QAccessibleTableCellInterfaceWrapper(const QAccessibleTableCellInterfaceWrapper &) = delete;
    QAccessibleTableCellInterfaceWrapper& operator=(const QAccessibleTableCellInterfaceWrapper &) = delete;
    QAccessibleTableCellInterfaceWrapper(QAccessibleTableCellInterfaceWrapper &&) = delete;
    QAccessibleTableCellInterfaceWrapper& operator=(QAccessibleTableCellInterfaceWrapper &&) = delete;

    QAccessibleTableCellInterfaceWrapper();
    int columnExtent() const override;
    ::QList<QAccessibleInterface*> columnHeaderCells() const override;
    int columnIndex() const override;
    bool isSelected() const override;
    int rowExtent() const override;
    ::QList<QAccessibleInterface*> rowHeaderCells() const override;
    int rowIndex() const override;
    ::QAccessibleInterface * table() const override;
    ~QAccessibleTableCellInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_QAccessibleTableCellInterfaceWrapper_H

