// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAccessibleTextCursorEventWrapper_H
#define SBK_QAccessibleTextCursorEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

class QAccessibleTextCursorEventWrapper : public QAccessibleTextCursorEvent
{
public:
    QAccessibleTextCursorEventWrapper(const QAccessibleTextCursorEventWrapper &) = delete;
    QAccessibleTextCursorEventWrapper& operator=(const QAccessibleTextCursorEventWrapper &) = delete;
    QAccessibleTextCursorEventWrapper(QAccessibleTextCursorEventWrapper &&) = delete;
    QAccessibleTextCursorEventWrapper& operator=(QAccessibleTextCursorEventWrapper &&) = delete;

    QAccessibleTextCursorEventWrapper(::QAccessibleInterface * iface, int cursorPos);
    QAccessibleTextCursorEventWrapper(::QObject * obj, int cursorPos);
    ::QAccessibleInterface * accessibleInterface() const override;
    ~QAccessibleTextCursorEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QAccessibleTextCursorEventWrapper_H

