// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAccessibleTextRemoveEventWrapper_H
#define SBK_QAccessibleTextRemoveEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

class QAccessibleTextRemoveEventWrapper : public QAccessibleTextRemoveEvent
{
public:
    QAccessibleTextRemoveEventWrapper(const QAccessibleTextRemoveEventWrapper &) = delete;
    QAccessibleTextRemoveEventWrapper& operator=(const QAccessibleTextRemoveEventWrapper &) = delete;
    QAccessibleTextRemoveEventWrapper(QAccessibleTextRemoveEventWrapper &&) = delete;
    QAccessibleTextRemoveEventWrapper& operator=(QAccessibleTextRemoveEventWrapper &&) = delete;

    QAccessibleTextRemoveEventWrapper(::QAccessibleInterface * iface, int position, const ::QString & text);
    QAccessibleTextRemoveEventWrapper(::QObject * obj, int position, const ::QString & text);
    ::QAccessibleInterface * accessibleInterface() const override;
    ~QAccessibleTextRemoveEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QAccessibleTextRemoveEventWrapper_H

