// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAccessibleTextUpdateEventWrapper_H
#define SBK_QAccessibleTextUpdateEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

class QAccessibleTextUpdateEventWrapper : public QAccessibleTextUpdateEvent
{
public:
    QAccessibleTextUpdateEventWrapper(const QAccessibleTextUpdateEventWrapper &) = delete;
    QAccessibleTextUpdateEventWrapper& operator=(const QAccessibleTextUpdateEventWrapper &) = delete;
    QAccessibleTextUpdateEventWrapper(QAccessibleTextUpdateEventWrapper &&) = delete;
    QAccessibleTextUpdateEventWrapper& operator=(QAccessibleTextUpdateEventWrapper &&) = delete;

    QAccessibleTextUpdateEventWrapper(::QAccessibleInterface * iface, int position, const ::QString & oldText, const ::QString & text);
    QAccessibleTextUpdateEventWrapper(::QObject * obj, int position, const ::QString & oldText, const ::QString & text);
    ::QAccessibleInterface * accessibleInterface() const override;
    ~QAccessibleTextUpdateEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QAccessibleTextUpdateEventWrapper_H

