// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAccessibleValueInterfaceWrapper_H
#define SBK_QAccessibleValueInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

class QAccessibleValueInterfaceWrapper : public QAccessibleValueInterface
{
public:
    QAccessibleValueInterfaceWrapper(const QAccessibleValueInterfaceWrapper &) = delete;
    QAccessibleValueInterfaceWrapper& operator=(const QAccessibleValueInterfaceWrapper &) = delete;
    QAccessibleValueInterfaceWrapper(QAccessibleValueInterfaceWrapper &&) = delete;
    QAccessibleValueInterfaceWrapper& operator=(QAccessibleValueInterfaceWrapper &&) = delete;

    QAccessibleValueInterfaceWrapper();
    ::QVariant currentValue() const override;
    ::QVariant maximumValue() const override;
    ::QVariant minimumStepSize() const override;
    ::QVariant minimumValue() const override;
    void setCurrentValue(const ::QVariant & value) override;
    ~QAccessibleValueInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[5] = {false, false, false, false, false};
};

#endif // SBK_QAccessibleValueInterfaceWrapper_H

