// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QActionEventWrapper_H
#define SBK_QActionEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

class QActionEventWrapper : public QActionEvent
{
public:
    QActionEventWrapper(const QActionEventWrapper &) = delete;
    QActionEventWrapper& operator=(const QActionEventWrapper &) = delete;
    QActionEventWrapper(QActionEventWrapper &&) = delete;
    QActionEventWrapper& operator=(QActionEventWrapper &&) = delete;

    QActionEventWrapper(const QActionEvent& self) : QActionEvent(self)
    {
    }

    QActionEventWrapper(int type, ::QAction * action, ::QAction * before = nullptr);
    ::QActionEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QActionEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QActionEventWrapper_H

