// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qcolorconstants_wrapper.h"

// inner classes
#include "qcolorconstants_svg_wrapper.h"

// Extra includes
#include <QColor>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {

static const char *Sbk_QColorConstants_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QColorConstants_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QColorConstants_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QColorConstants_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QColorConstants_Type = nullptr;
static PyTypeObject *Sbk_QColorConstants_TypeF(void)
{
    return _Sbk_QColorConstants_Type;
}

static PyType_Slot Sbk_QColorConstants_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QColorConstants_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QColorConstants_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QColorConstants_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QColorConstants_spec = {
    "2:PySide6.QtGui.QColorConstants",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QColorConstants_slots
};

} //extern "C"

// Type conversion functions.

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QtGuiQColorConstants_SignatureStrings[] = {
    nullptr}; // Sentinel
#else
static constexpr size_t QtGuiQColorConstants_SignatureByteSize = 0;
static constexpr uint8_t QtGuiQColorConstants_SignatureBytes[1] = {
    0x00
};
#endif

PyTypeObject *init_QtGuiQColorConstants(PyObject *module)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QtGuiQColorConstants_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QtGuiQColorConstants_IDX].type;

    Shiboken::AutoDecRef Sbk_QColorConstants_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QColorConstants_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QColorConstants",
        "QColorConstants",
        &Sbk_QColorConstants_spec,
        nullptr,
        Sbk_QColorConstants_Type_bases.object(),
        0);
    auto *pyType = Sbk_QColorConstants_TypeF(); // references _Sbk_QColorConstants_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QtGuiQColorConstants_SignatureStrings);
#else
    InitSignatureBytes(pyType, QtGuiQColorConstants_SignatureBytes, QtGuiQColorConstants_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QColorConstants_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QtGuiQColorConstants_IDX].type = pyType;



    return pyType;
}

PyTypeObject *init_QtGuiQColorConstantsStaticFields(PyObject *module)
{
    auto *obType = PyObject_GetAttrString(module, "QColorConstants");
    auto *type = reinterpret_cast<PyTypeObject *>(obType);
    Shiboken::AutoDecRef dict(PepType_GetDict(type));
    PyDict_SetItemString(dict, "Color0",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::Color0));
    PyDict_SetItemString(dict, "Color1",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::Color1));
    PyDict_SetItemString(dict, "Black",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::Black));
    PyDict_SetItemString(dict, "White",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::White));
    PyDict_SetItemString(dict, "DarkGray",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::DarkGray));
    PyDict_SetItemString(dict, "Gray",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::Gray));
    PyDict_SetItemString(dict, "LightGray",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::LightGray));
    PyDict_SetItemString(dict, "Red",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::Red));
    PyDict_SetItemString(dict, "Green",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::Green));
    PyDict_SetItemString(dict, "Blue",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::Blue));
    PyDict_SetItemString(dict, "Cyan",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::Cyan));
    PyDict_SetItemString(dict, "Magenta",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::Magenta));
    PyDict_SetItemString(dict, "Yellow",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::Yellow));
    PyDict_SetItemString(dict, "DarkRed",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::DarkRed));
    PyDict_SetItemString(dict, "DarkGreen",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::DarkGreen));
    PyDict_SetItemString(dict, "DarkBlue",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::DarkBlue));
    PyDict_SetItemString(dict, "DarkCyan",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::DarkCyan));
    PyDict_SetItemString(dict, "DarkMagenta",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::DarkMagenta));
    PyDict_SetItemString(dict, "DarkYellow",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::DarkYellow));
    PyDict_SetItemString(dict, "Transparent",
                         Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &QColorConstants::Transparent));
    return type;
}
