// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QContextMenuEventWrapper_H
#define SBK_QContextMenuEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

class QContextMenuEventWrapper : public QContextMenuEvent
{
public:
    QContextMenuEventWrapper(const QContextMenuEventWrapper &) = delete;
    QContextMenuEventWrapper& operator=(const QContextMenuEventWrapper &) = delete;
    QContextMenuEventWrapper(QContextMenuEventWrapper &&) = delete;
    QContextMenuEventWrapper& operator=(QContextMenuEventWrapper &&) = delete;

    QContextMenuEventWrapper(::QContextMenuEvent::Reason reason, const ::QPoint & pos);
    QContextMenuEventWrapper(::QContextMenuEvent::Reason reason, const ::QPoint & pos, const ::QPoint & globalPos, ::QFlags<Qt::KeyboardModifier> modifiers = Qt::NoModifier);
    QContextMenuEventWrapper(const QContextMenuEvent& self) : QContextMenuEvent(self)
    {
    }

    ::QContextMenuEvent * clone() const override;
    void setAccepted(bool accepted) override;
    void setTimestamp(quint64 timestamp) override;
    ~QContextMenuEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QContextMenuEventWrapper_H

