// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDragEnterEventWrapper_H
#define SBK_QDragEnterEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

class QDragEnterEventWrapper : public QDragEnterEvent
{
public:
    QDragEnterEventWrapper(const QDragEnterEventWrapper &) = delete;
    QDragEnterEventWrapper& operator=(const QDragEnterEventWrapper &) = delete;
    QDragEnterEventWrapper(QDragEnterEventWrapper &&) = delete;
    QDragEnterEventWrapper& operator=(QDragEnterEventWrapper &&) = delete;

    QDragEnterEventWrapper(const QDragEnterEvent& self) : QDragEnterEvent(self)
    {
    }

    QDragEnterEventWrapper(const ::QPoint & pos, ::QFlags<Qt::DropAction> actions, const ::QMimeData * data, ::QFlags<Qt::MouseButton> buttons, ::QFlags<Qt::KeyboardModifier> modifiers);
    ::QDragEnterEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QDragEnterEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QDragEnterEventWrapper_H

