// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDragMoveEventWrapper_H
#define SBK_QDragMoveEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

class QDragMoveEventWrapper : public QDragMoveEvent
{
public:
    QDragMoveEventWrapper(const QDragMoveEventWrapper &) = delete;
    QDragMoveEventWrapper& operator=(const QDragMoveEventWrapper &) = delete;
    QDragMoveEventWrapper(QDragMoveEventWrapper &&) = delete;
    QDragMoveEventWrapper& operator=(QDragMoveEventWrapper &&) = delete;

    QDragMoveEventWrapper(const QDragMoveEvent& self) : QDragMoveEvent(self)
    {
    }

    QDragMoveEventWrapper(const ::QPoint & pos, ::QFlags<Qt::DropAction> actions, const ::QMimeData * data, ::QFlags<Qt::MouseButton> buttons, ::QFlags<Qt::KeyboardModifier> modifiers, ::QEvent::Type type = QEvent::Type::DragMove);
    ::QDragMoveEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QDragMoveEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QDragMoveEventWrapper_H

