// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDropEventWrapper_H
#define SBK_QDropEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

class QDropEventWrapper : public QDropEvent
{
public:
    QDropEventWrapper(const QDropEventWrapper &) = delete;
    QDropEventWrapper& operator=(const QDropEventWrapper &) = delete;
    QDropEventWrapper(QDropEventWrapper &&) = delete;
    QDropEventWrapper& operator=(QDropEventWrapper &&) = delete;

    QDropEventWrapper(const QDropEvent& self) : QDropEvent(self)
    {
    }

    QDropEventWrapper(const ::QPointF & pos, ::QFlags<Qt::DropAction> actions, const ::QMimeData * data, ::QFlags<Qt::MouseButton> buttons, ::QFlags<Qt::KeyboardModifier> modifiers, ::QEvent::Type type = QEvent::Type::Drop);
    ::QDropEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QDropEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QDropEventWrapper_H

