// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QExposeEventWrapper_H
#define SBK_QExposeEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

class QExposeEventWrapper : public QExposeEvent
{
public:
    QExposeEventWrapper(const QExposeEventWrapper &) = delete;
    QExposeEventWrapper& operator=(const QExposeEventWrapper &) = delete;
    QExposeEventWrapper(QExposeEventWrapper &&) = delete;
    QExposeEventWrapper& operator=(QExposeEventWrapper &&) = delete;

    QExposeEventWrapper(const QExposeEvent& self) : QExposeEvent(self)
    {
    }

    QExposeEventWrapper(const ::QRegion & m_region);
    ::QExposeEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QExposeEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QExposeEventWrapper_H

