// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QFileOpenEventWrapper_H
#define SBK_QFileOpenEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

class QFileOpenEventWrapper : public QFileOpenEvent
{
public:
    QFileOpenEventWrapper(const QFileOpenEventWrapper &) = delete;
    QFileOpenEventWrapper& operator=(const QFileOpenEventWrapper &) = delete;
    QFileOpenEventWrapper(QFileOpenEventWrapper &&) = delete;
    QFileOpenEventWrapper& operator=(QFileOpenEventWrapper &&) = delete;

    QFileOpenEventWrapper(const QFileOpenEvent& self) : QFileOpenEvent(self)
    {
    }

    QFileOpenEventWrapper(const ::QString & file);
    QFileOpenEventWrapper(const ::QUrl & url);
    ::QFileOpenEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QFileOpenEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QFileOpenEventWrapper_H

