// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qfontmetricsf_wrapper.h"

// Argument includes
#include <QString>
#include <QtGui/qfont.h>
#include <QtGui/qfontmetrics.h>
#include <QtGui/qpaintdevice.h>
#include <QtGui/qtextoption.h>
#include <qchar.h>
#include <qnamespace.h>
#include <qrect.h>
#include <qsize.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QFontMetricsF_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QFontMetricsF >()))
        return -1;

    ::QFontMetricsF *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QFontMetricsF", 1, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QFontMetricsF::QFontMetricsF(QFont)
    // 1: QFontMetricsF::QFontMetricsF(QFont,const QPaintDevice*)
    // 2: QFontMetricsF::QFontMetricsF(QFontMetrics)
    // 3: QFontMetricsF::QFontMetricsF(QFontMetricsF)
    if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetrics_IDX]), (pyArgs[0])))) {
        overloadId = 2; // QFontMetricsF(QFontMetrics)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), (pyArgs[0])))) {
        overloadId = 3; // QFontMetricsF(QFontMetricsF)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFont_IDX]), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // QFontMetricsF(QFont)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPaintDevice_IDX]), (pyArgs[1])))) {
            overloadId = 1; // QFontMetricsF(QFont,const QPaintDevice*)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QFontMetricsF(const QFont &font)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QFont cppArg0_local;
            ::QFont *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QFontMetricsF(QFont)
                cptr = new ::QFontMetricsF(*cppArg0);
            }
            break;
        }
        case 1: // QFontMetricsF(const QFont &font, const QPaintDevice *pd)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QFont cppArg0_local;
            ::QFont *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);

            if (!Shiboken::Object::isValid(pyArgs[1]))
                return -1;
            ::QPaintDevice *cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QFontMetricsF(QFont,const QPaintDevice*)
                cptr = new ::QFontMetricsF(*cppArg0, cppArg1);
            }
            break;
        }
        case 2: // QFontMetricsF(const QFontMetrics &arg__1)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QFontMetrics cppArg0_local = ::QFontMetrics(::QFont());
            ::QFontMetrics *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QFontMetricsF(QFontMetrics)
                cptr = new ::QFontMetricsF(*cppArg0);
            }
            break;
        }
        case 3: // QFontMetricsF(const QFontMetricsF &arg__1)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QFontMetricsF cppArg0_local = ::QFontMetricsF(::QFontMetrics(::QFont()));
            ::QFontMetricsF *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QFontMetricsF(QFontMetricsF)
                cptr = new ::QFontMetricsF(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QFontMetricsF >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QFontMetricsFFunc_ascent(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // ascent()const
        qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->ascent();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_averageCharWidth(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // averageCharWidth()const
        qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->averageCharWidth();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_boundingRect(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[5];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr, nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 5));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "boundingRect", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);

    if (PyArg_ParseTuple(args, "|OOOOO:boundingRect", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2]), &(pyArgs[3]), &(pyArgs[4])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QFontMetricsF::boundingRect(QRectF,int,QString,int=,PyObject=)const->QRectF
    // 1: QFontMetricsF::boundingRect(QString)const->QRectF
    // 2: QFontMetricsF::boundingRect(QString,QTextOption)const->QRectF
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 1; // boundingRect(QString)const
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextOption_IDX]), (pyArgs[1])))) {
            overloadId = 2; // boundingRect(QString,QTextOption)const
        }
    } else if (numArgs >= 3
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRectF_IDX]), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[2])))) {
        if (numArgs == 3) {
            overloadId = 0; // boundingRect(QRectF,int,QString,int,int*)const
        } else if (numArgs >= 4
            && (pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[3])))) {
            if (numArgs == 4) {
                overloadId = 0; // boundingRect(QRectF,int,QString,int,int*)const
            } else if (numArgs >= 5) {
                overloadId = 0; // boundingRect(QRectF,int,QString,int,int*)const
            }
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "boundingRect", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);

    // Call function/method
    switch (overloadId) {
        case 0: // boundingRect(const QRectF &r, int flags, const QString &string, int tabstops, int *tabarray) const
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_tabstops = Shiboken::String::createStaticString("tabstops");
                if (PyDict_Contains(kwds, key_tabstops) != 0) {
                    value = PyDict_GetItem(kwds, key_tabstops);
                    if (value != nullptr && pyArgs[3] != nullptr ) {
                        errInfo.reset(key_tabstops);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments(args, "boundingRect", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
                    }
                    if (value != nullptr) {
                        pyArgs[3] = value;
                        if (!(pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[3]))))
                            return Shiboken::returnWrongArguments(args, "boundingRect", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
                    }
                    PyDict_DelItem(kwds_dup, key_tabstops);
                }
                static PyObject *const key_tabarray = Shiboken::String::createStaticString("tabarray");
                if (PyDict_Contains(kwds, key_tabarray) != 0) {
                    value = PyDict_GetItem(kwds, key_tabarray);
                    if (value != nullptr && pyArgs[4] != nullptr ) {
                        errInfo.reset(key_tabarray);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments(args, "boundingRect", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
                    }
                    if (value != nullptr) {
                        pyArgs[4] = value;
                        if (!true)
                            return Shiboken::returnWrongArguments(args, "boundingRect", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
                    }
                    PyDict_DelItem(kwds_dup, key_tabarray);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments(args, "boundingRect", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
                }
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QRectF cppArg0_local;
            ::QRectF *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);

            int cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            ::QString cppArg2;
            pythonToCpp[2](pyArgs[2], &cppArg2);
            int cppArg3 = 0;
            if (pythonToCpp[3])
                pythonToCpp[3](pyArgs[3], &cppArg3);

            if (Shiboken::Errors::occurred() == nullptr) {
                // boundingRect(QRectF,int,QString,int,int*)const
                // Begin code injection
                // ========================================================================
                // START of custom code block [file: ../glue/qtgui.cpp (qfontmetricsf-boundingrect)]
                int *array = nullptr;
                bool errorOccurred = false;

                if (numArgs == 5) {
                    array = Shiboken::sequenceToIntArray(pyArgs[5-1], true);
                    if (PyErr_Occurred()) {
                        delete [] array;
                        errorOccurred = true;
                    }
                }

                if (!errorOccurred) {
                    ::QRectF retval = cppSelf->boundingRect((*cppArg0), cppArg1, cppArg2, cppArg3, array);

                    delete [] array;

                    pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRectF_IDX]), &retval);
                }
                // END of custom code block [file: ../glue/qtgui.cpp (qfontmetricsf-boundingrect)]
                // ========================================================================
                // End of code injection

            }
            break;
        }
        case 1: // boundingRect(const QString &string) const
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments(args, "boundingRect", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
            }
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // boundingRect(QString)const
                QRectF cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->boundingRect(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRectF_IDX]), &cppResult);
            }
            break;
        }
        case 2: // boundingRect(const QString &text, const QTextOption &textOption) const
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments(args, "boundingRect", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
            }
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QTextOption cppArg1_local;
            ::QTextOption *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (Shiboken::Errors::occurred() == nullptr) {
                // boundingRect(QString,QTextOption)const
                QRectF cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->boundingRect(cppArg0, *cppArg1);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRectF_IDX]), &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_boundingRectChar(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QFontMetricsF::boundingRect(char)const->QRectF
    if (SbkChar_Check(pyArg) && (pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<char>(), (pyArg)))) {
        overloadId = 0; // boundingRect(QChar)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "boundingRectChar", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // boundingRect(QChar)const
            // Begin code injection
            // TEMPLATE - QFontCharFix - START
            int size = Shiboken::String::len(pyArg);
            if (size == 1) {
                const char *str = Shiboken::String::toCString(pyArg);
                const QChar ch(static_cast<unsigned short>(str[0]));
                ::QRectF cppResult = cppSelf->boundingRect(ch);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRectF_IDX]), &cppResult);
            } else {
                PyErr_SetString(PyExc_TypeError, "String must have only one character");
            }
            // TEMPLATE - QFontCharFix - END
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_capHeight(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // capHeight()const
        qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->capHeight();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_descent(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // descent()const
        qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->descent();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_elidedText(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[4];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 3, 4));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "elidedText", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);

    if (PyArg_ParseTuple(args, "|OOOO:elidedText", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2]), &(pyArgs[3])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QFontMetricsF::elidedText(QString,Qt::TextElideMode,qreal,int=)const->QString
    if (numArgs >= 3
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_Qt_TextElideMode_IDX])))->converter, (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyArgs[2])))) {
        if (numArgs == 3) {
            overloadId = 0; // elidedText(QString,Qt::TextElideMode,qreal,int)const
        } else if (numArgs >= 4
            && (pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[3])))) {
            overloadId = 0; // elidedText(QString,Qt::TextElideMode,qreal,int)const
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "elidedText", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_flags = Shiboken::String::createStaticString("flags");
            if (PyDict_Contains(kwds, key_flags) != 0) {
                value = PyDict_GetItem(kwds, key_flags);
                if (value != nullptr && pyArgs[3] != nullptr ) {
                    errInfo.reset(key_flags);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, "elidedText", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[3] = value;
                    if (!(pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[3]))))
                        return Shiboken::returnWrongArguments(args, "elidedText", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_flags);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, "elidedText", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
            }
        }
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::Qt::TextElideMode cppArg1{Qt::ElideLeft};
        pythonToCpp[1](pyArgs[1], &cppArg1);
        qreal cppArg2;
        pythonToCpp[2](pyArgs[2], &cppArg2);
        int cppArg3 = 0;
        if (pythonToCpp[3])
            pythonToCpp[3](pyArgs[3], &cppArg3);

        if (Shiboken::Errors::occurred() == nullptr) {
            // elidedText(QString,Qt::TextElideMode,qreal,int)const
            QString cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->elidedText(cppArg0, cppArg1, cppArg2, cppArg3);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_fontDpi(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // fontDpi()const
        qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->fontDpi();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_height(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // height()const
        qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->height();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_horizontalAdvance(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "horizontalAdvance", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);

    if (PyArg_ParseTuple(args, "|OO:horizontalAdvance", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QFontMetricsF::horizontalAdvance(QString,QTextOption)const->qreal
    // 1: QFontMetricsF::horizontalAdvance(QString,int=)const->qreal
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 1; // horizontalAdvance(QString,int)const
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
            overloadId = 1; // horizontalAdvance(QString,int)const
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextOption_IDX]), (pyArgs[1])))) {
            overloadId = 0; // horizontalAdvance(QString,QTextOption)const
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "horizontalAdvance", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);

    // Call function/method
    switch (overloadId) {
        case 0: // horizontalAdvance(const QString &string, const QTextOption &textOption) const
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments(args, "horizontalAdvance", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
            }
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QTextOption cppArg1_local;
            ::QTextOption *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (Shiboken::Errors::occurred() == nullptr) {
                // horizontalAdvance(QString,QTextOption)const
                qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->horizontalAdvance(cppArg0, *cppArg1);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
            }
            break;
        }
        case 1: // horizontalAdvance(const QString &string, int length) const
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_length = Shiboken::String::createStaticString("length");
                if (PyDict_Contains(kwds, key_length) != 0) {
                    value = PyDict_GetItem(kwds, key_length);
                    if (value != nullptr && pyArgs[1] != nullptr ) {
                        errInfo.reset(key_length);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments(args, "horizontalAdvance", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
                    }
                    if (value != nullptr) {
                        pyArgs[1] = value;
                        if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1]))))
                            return Shiboken::returnWrongArguments(args, "horizontalAdvance", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
                    }
                    PyDict_DelItem(kwds_dup, key_length);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments(args, "horizontalAdvance", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
                }
            }
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            int cppArg1 = -1;
            if (pythonToCpp[1])
                pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // horizontalAdvance(QString,int)const
                qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->horizontalAdvance(cppArg0, cppArg1);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_horizontalAdvanceChar(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QFontMetricsF::horizontalAdvance(char)const->qreal
    if (SbkChar_Check(pyArg) && (pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<char>(), (pyArg)))) {
        overloadId = 0; // horizontalAdvance(QChar)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "horizontalAdvanceChar", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // horizontalAdvance(QChar)const
            // Begin code injection
            // TEMPLATE - QFontCharFix - START
            int size = Shiboken::String::len(pyArg);
            if (size == 1) {
                const char *str = Shiboken::String::toCString(pyArg);
                const QChar ch(static_cast<unsigned short>(str[0]));
                qreal cppResult = cppSelf->horizontalAdvance(ch);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
            } else {
                PyErr_SetString(PyExc_TypeError, "String must have only one character");
            }
            // TEMPLATE - QFontCharFix - END
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_inFont(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QFontMetricsF::inFont(QChar)const->bool
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QChar_IDX], (pyArg)))) {
        overloadId = 0; // inFont(QChar)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "inFont", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);

    // Call function/method
    {
        ::QChar cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // inFont(QChar)const
            bool cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->inFont(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_inFontUcs4(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QFontMetricsF::inFontUcs4(uint)const->bool
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uint>(), (pyArg)))) {
        overloadId = 0; // inFontUcs4(uint)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "inFontUcs4", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);

    // Call function/method
    {
        uint cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // inFontUcs4(uint)const
            bool cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->inFontUcs4(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_leading(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // leading()const
        qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->leading();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_leftBearing(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QFontMetricsF::leftBearing(QChar)const->qreal
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QChar_IDX], (pyArg)))) {
        overloadId = 0; // leftBearing(QChar)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "leftBearing", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);

    // Call function/method
    {
        ::QChar cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // leftBearing(QChar)const
            qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->leftBearing(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_lineSpacing(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // lineSpacing()const
        qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->lineSpacing();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_lineWidth(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // lineWidth()const
        qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->lineWidth();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_maxWidth(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // maxWidth()const
        qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->maxWidth();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_minLeftBearing(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // minLeftBearing()const
        qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->minLeftBearing();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_minRightBearing(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // minRightBearing()const
        qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->minRightBearing();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_overlinePos(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // overlinePos()const
        qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->overlinePos();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_rightBearing(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QFontMetricsF::rightBearing(QChar)const->qreal
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QChar_IDX], (pyArg)))) {
        overloadId = 0; // rightBearing(QChar)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "rightBearing", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);

    // Call function/method
    {
        ::QChar cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // rightBearing(QChar)const
            qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->rightBearing(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_size(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[4];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 2, 4));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "size", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);

    if (PyArg_ParseTuple(args, "|OOOO:size", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2]), &(pyArgs[3])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QFontMetricsF::size(int,QString,int=,PyObject=)const->QSizeF
    if (numArgs >= 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
        if (numArgs == 2) {
            overloadId = 0; // size(int,QString,int,int*)const
        } else if (numArgs >= 3
            && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[2])))) {
            if (numArgs == 3) {
                overloadId = 0; // size(int,QString,int,int*)const
            } else if (numArgs >= 4) {
                overloadId = 0; // size(int,QString,int,int*)const
            }
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "size", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_tabstops = Shiboken::String::createStaticString("tabstops");
            if (PyDict_Contains(kwds, key_tabstops) != 0) {
                value = PyDict_GetItem(kwds, key_tabstops);
                if (value != nullptr && pyArgs[2] != nullptr ) {
                    errInfo.reset(key_tabstops);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, "size", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[2] = value;
                    if (!(pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[2]))))
                        return Shiboken::returnWrongArguments(args, "size", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_tabstops);
            }
            static PyObject *const key_tabarray = Shiboken::String::createStaticString("tabarray");
            if (PyDict_Contains(kwds, key_tabarray) != 0) {
                value = PyDict_GetItem(kwds, key_tabarray);
                if (value != nullptr && pyArgs[3] != nullptr ) {
                    errInfo.reset(key_tabarray);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, "size", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[3] = value;
                    if (!true)
                        return Shiboken::returnWrongArguments(args, "size", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_tabarray);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, "size", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);
            }
        }
        int cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);
        int cppArg2 = 0;
        if (pythonToCpp[2])
            pythonToCpp[2](pyArgs[2], &cppArg2);

        if (Shiboken::Errors::occurred() == nullptr) {
            // size(int,QString,int,int*)const
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: ../glue/qtgui.cpp (qfontmetricsf-size)]
            int *array = nullptr;
            bool errorOccurred = false;

            if (numArgs == 4) {
                array = Shiboken::sequenceToIntArray(pyArgs[4-1], true);
                if (PyErr_Occurred()) {
                    delete [] array;
                    errorOccurred = true;
                }
            }

            if (!errorOccurred) {
                ::QSizeF retval = cppSelf->size(cppArg0, cppArg1, cppArg2, array);

                delete [] array;

                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSizeF_IDX]), &retval);
            }
            // END of custom code block [file: ../glue/qtgui.cpp (qfontmetricsf-size)]
            // ========================================================================
            // End of code injection

        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_strikeOutPos(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // strikeOutPos()const
        qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->strikeOutPos();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QFontMetricsF::swap(QFontMetricsF&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QFontMetricsF&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "swap", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QFontMetricsF cppArg0_local = ::QFontMetricsF(::QFontMetrics(::QFont()));
        ::QFontMetricsF *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QFontMetricsF&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QFontMetricsFFunc_tightBoundingRect(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "tightBoundingRect", 1, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QFontMetricsF::tightBoundingRect(QString)const->QRectF
    // 1: QFontMetricsF::tightBoundingRect(QString,QTextOption)const->QRectF
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // tightBoundingRect(QString)const
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextOption_IDX]), (pyArgs[1])))) {
            overloadId = 1; // tightBoundingRect(QString,QTextOption)const
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "tightBoundingRect", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]);

    // Call function/method
    switch (overloadId) {
        case 0: // tightBoundingRect(const QString &text) const
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // tightBoundingRect(QString)const
                QRectF cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->tightBoundingRect(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRectF_IDX]), &cppResult);
            }
            break;
        }
        case 1: // tightBoundingRect(const QString &text, const QTextOption &textOption) const
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QTextOption cppArg1_local;
            ::QTextOption *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (Shiboken::Errors::occurred() == nullptr) {
                // tightBoundingRect(QString,QTextOption)const
                QRectF cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->tightBoundingRect(cppArg0, *cppArg1);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRectF_IDX]), &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_underlinePos(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // underlinePos()const
        qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->underlinePos();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsFFunc_xHeight(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // xHeight()const
        qreal cppResult = const_cast<const ::QFontMetricsF *>(cppSelf)->xHeight();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontMetricsF__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QFontMetricsF_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QFontMetricsF_methods[] = {
    {"ascent", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_ascent), METH_NOARGS, nullptr},
    {"averageCharWidth", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_averageCharWidth), METH_NOARGS, nullptr},
    {"boundingRect", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_boundingRect), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"boundingRectChar", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_boundingRectChar), METH_O, nullptr},
    {"capHeight", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_capHeight), METH_NOARGS, nullptr},
    {"descent", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_descent), METH_NOARGS, nullptr},
    {"elidedText", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_elidedText), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"fontDpi", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_fontDpi), METH_NOARGS, nullptr},
    {"height", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_height), METH_NOARGS, nullptr},
    {"horizontalAdvance", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_horizontalAdvance), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"horizontalAdvanceChar", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_horizontalAdvanceChar), METH_O, nullptr},
    {"inFont", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_inFont), METH_O, nullptr},
    {"inFontUcs4", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_inFontUcs4), METH_O, nullptr},
    {"leading", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_leading), METH_NOARGS, nullptr},
    {"leftBearing", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_leftBearing), METH_O, nullptr},
    {"lineSpacing", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_lineSpacing), METH_NOARGS, nullptr},
    {"lineWidth", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_lineWidth), METH_NOARGS, nullptr},
    {"maxWidth", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_maxWidth), METH_NOARGS, nullptr},
    {"minLeftBearing", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_minLeftBearing), METH_NOARGS, nullptr},
    {"minRightBearing", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_minRightBearing), METH_NOARGS, nullptr},
    {"overlinePos", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_overlinePos), METH_NOARGS, nullptr},
    {"rightBearing", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_rightBearing), METH_O, nullptr},
    {"size", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_size), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"strikeOutPos", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_strikeOutPos), METH_NOARGS, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_swap), METH_O, nullptr},
    {"tightBoundingRect", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_tightBoundingRect), METH_VARARGS, nullptr},
    {"underlinePos", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_underlinePos), METH_NOARGS, nullptr},
    {"xHeight", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsFFunc_xHeight), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QFontMetricsF__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QFontMetricsF_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), (pyArg)))) {
                // operator!=(const QFontMetricsF &other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QFontMetricsF cppArg0_local = ::QFontMetricsF(::QFontMetrics(::QFont()));
                ::QFontMetricsF *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), (pyArg)))) {
                // operator==(const QFontMetricsF &other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QFontMetricsF cppArg0_local = ::QFontMetricsF(::QFontMetrics(::QFont()));
                ::QFontMetricsF *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QFontMetricsF_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QFontMetricsF_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QFontMetricsF_Type = nullptr;
static PyTypeObject *Sbk_QFontMetricsF_TypeF(void)
{
    return _Sbk_QFontMetricsF_Type;
}

static PyType_Slot Sbk_QFontMetricsF_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QFontMetricsF_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QFontMetricsF_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QFontMetricsF_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QFontMetricsF_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QFontMetricsF_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QFontMetricsF_spec = {
    "2:PySide6.QtGui.QFontMetricsF",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QFontMetricsF_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QFontMetricsF_PythonToCpp_QFontMetricsF_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QFontMetricsF_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QFontMetricsF_PythonToCpp_QFontMetricsF_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QFontMetricsF_TypeF()))
        return QFontMetricsF_PythonToCpp_QFontMetricsF_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QFontMetricsF_PTR_CppToPython_QFontMetricsF(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QFontMetricsF_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QFontMetricsF_COPY_CppToPython_QFontMetricsF(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QFontMetricsF *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QFontMetricsF_TypeF(), new ::QFontMetricsF(*source), true, true);
}

// Python to C++ copy conversion.
static void QFontMetricsF_PythonToCpp_QFontMetricsF_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QFontMetricsF *>(cppOut) = *reinterpret_cast< ::QFontMetricsF *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QFontMetricsF_PythonToCpp_QFontMetricsF_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QFontMetricsF_TypeF()))
        return QFontMetricsF_PythonToCpp_QFontMetricsF_COPY;
    return {};
}

// Implicit conversions.
static void constQFontMetricsREF_PythonToCpp_QFontMetricsF(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QFontMetricsF *>(cppOut) = ::QFontMetricsF( *reinterpret_cast< ::QFontMetrics *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetrics_IDX]), reinterpret_cast<SbkObject *>(pyIn))));
}
static PythonToCppFunc is_constQFontMetricsREF_PythonToCpp_QFontMetricsF_Convertible(PyObject *pyIn)
{
    if (SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontMetrics_IDX]), pyIn))
        return constQFontMetricsREF_PythonToCpp_QFontMetricsF;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QFontMetricsF_SignatureStrings[] = {
    "3:PySide6.QtGui.QFontMetricsF(self,font:typing.Union[PySide6.QtGui.QFont, QString, QStringList])",
    "2:PySide6.QtGui.QFontMetricsF(self,font:typing.Union[PySide6.QtGui.QFont, QString, QStringList],pd:PySide6.QtGui.QPaintDevice)",
    "1:PySide6.QtGui.QFontMetricsF(self,arg__1:PySide6.QtGui.QFontMetrics)",
    "0:PySide6.QtGui.QFontMetricsF(self,arg__1:PySide6.QtGui.QFontMetricsF)",
    "PySide6.QtGui.QFontMetricsF.ascent(self)->qreal",
    "PySide6.QtGui.QFontMetricsF.averageCharWidth(self)->qreal",
    "2:PySide6.QtGui.QFontMetricsF.boundingRect(self,r:typing.Union[PySide6.QtCore.QRectF, PySide6.QtCore.QRect],flags:int,string:QString,tabstops:int=0,tabarray:PyObject=nullptr)->PySide6.QtCore.QRectF",
    "1:PySide6.QtGui.QFontMetricsF.boundingRect(self,string:QString)->PySide6.QtCore.QRectF",
    "0:PySide6.QtGui.QFontMetricsF.boundingRect(self,text:QString,textOption:typing.Union[PySide6.QtGui.QTextOption, PySide6.QtCore.Qt.AlignmentFlag])->PySide6.QtCore.QRectF",
    "PySide6.QtGui.QFontMetricsF.boundingRectChar(self,arg__1:char)->PySide6.QtCore.QRectF",
    "PySide6.QtGui.QFontMetricsF.capHeight(self)->qreal",
    "PySide6.QtGui.QFontMetricsF.descent(self)->qreal",
    "PySide6.QtGui.QFontMetricsF.elidedText(self,text:QString,mode:PySide6.QtCore.Qt.TextElideMode,width:qreal,flags:int=0)->QString",
    "PySide6.QtGui.QFontMetricsF.fontDpi(self)->qreal",
    "PySide6.QtGui.QFontMetricsF.height(self)->qreal",
    "1:PySide6.QtGui.QFontMetricsF.horizontalAdvance(self,string:QString,textOption:typing.Union[PySide6.QtGui.QTextOption, PySide6.QtCore.Qt.AlignmentFlag])->qreal",
    "0:PySide6.QtGui.QFontMetricsF.horizontalAdvance(self,string:QString,length:int=-1)->qreal",
    "PySide6.QtGui.QFontMetricsF.horizontalAdvanceChar(self,arg__1:char)->qreal",
    "PySide6.QtGui.QFontMetricsF.inFont(self,arg__1:QChar)->bool",
    "PySide6.QtGui.QFontMetricsF.inFontUcs4(self,ucs4:uint)->bool",
    "PySide6.QtGui.QFontMetricsF.leading(self)->qreal",
    "PySide6.QtGui.QFontMetricsF.leftBearing(self,arg__1:QChar)->qreal",
    "PySide6.QtGui.QFontMetricsF.lineSpacing(self)->qreal",
    "PySide6.QtGui.QFontMetricsF.lineWidth(self)->qreal",
    "PySide6.QtGui.QFontMetricsF.maxWidth(self)->qreal",
    "PySide6.QtGui.QFontMetricsF.minLeftBearing(self)->qreal",
    "PySide6.QtGui.QFontMetricsF.minRightBearing(self)->qreal",
    "PySide6.QtGui.QFontMetricsF.overlinePos(self)->qreal",
    "PySide6.QtGui.QFontMetricsF.rightBearing(self,arg__1:QChar)->qreal",
    "PySide6.QtGui.QFontMetricsF.size(self,flags:int,str:QString,tabstops:int=0,tabarray:PyObject=nullptr)->PySide6.QtCore.QSizeF",
    "PySide6.QtGui.QFontMetricsF.strikeOutPos(self)->qreal",
    "PySide6.QtGui.QFontMetricsF.swap(self,other:typing.Union[PySide6.QtGui.QFontMetricsF, PySide6.QtGui.QFontMetrics])",
    "1:PySide6.QtGui.QFontMetricsF.tightBoundingRect(self,text:QString)->PySide6.QtCore.QRectF",
    "0:PySide6.QtGui.QFontMetricsF.tightBoundingRect(self,text:QString,textOption:typing.Union[PySide6.QtGui.QTextOption, PySide6.QtCore.Qt.AlignmentFlag])->PySide6.QtCore.QRectF",
    "PySide6.QtGui.QFontMetricsF.underlinePos(self)->qreal",
    "PySide6.QtGui.QFontMetricsF.xHeight(self)->qreal",
    "PySide6.QtGui.QFontMetricsF.__copy__(self)->typing.Self",
    "PySide6.QtGui.QFontMetricsF.__ne__(self,other:typing.Union[PySide6.QtGui.QFontMetricsF, PySide6.QtGui.QFontMetrics])->bool",
    "PySide6.QtGui.QFontMetricsF.__eq__(self,other:typing.Union[PySide6.QtGui.QFontMetricsF, PySide6.QtGui.QFontMetrics])->bool",
    nullptr}; // Sentinel
#else
static constexpr size_t QFontMetricsF_SignatureByteSize = 590;
static constexpr uint8_t QFontMetricsF_SignatureBytes[590] = {
    0x78, 0xda, 0xcd, 0x56, 0x5d, 0x6f, 0xda, 0x30, 0x14, 0x7d, 0xe7, 0x57, 0xf4, 0x71, 0x91, 0xd2,
    0x88, 0x6e, 0xd3, 0x1e, 0x22, 0x31, 0xa9, 0xa3, 0x63, 0x7b, 0x68, 0x05, 0x94, 0x55, 0x7b, 0x98,
    0x50, 0x64, 0x92, 0x4b, 0xe2, 0xcd, 0xd8, 0xa9, 0xed, 0x50, 0xe8, 0xaf, 0xdf, 0x35, 0x81, 0x76,
    0xa4, 0xc1, 0x71, 0x10, 0x48, 0x7b, 0x8b, 0x3f, 0xce, 0x3d, 0xf7, 0x1e, 0x1f, 0xfb, 0xe6, 0x43,
    0x38, 0x5a, 0x4f, 0x68, 0x02, 0x9f, 0x82, 0xb1, 0xfe, 0x56, 0xd0, 0x60, 0x3c, 0x10, 0x5c, 0xdf,
    0x81, 0x96, 0x34, 0x56, 0x83, 0x77, 0x0a, 0xd8, 0xdc, 0x9f, 0xe3, 0x4c, 0xa8, 0xd7, 0x39, 0xe5,
    0x69, 0xf0, 0xc0, 0xa9, 0xe0, 0xbf, 0x6a, 0x20, 0xfe, 0xc5, 0x78, 0x82, 0x20, 0x9e, 0xbe, 0x7c,
    0xdc, 0x52, 0xa5, 0xa7, 0x5e, 0xe7, 0xfd, 0x79, 0x09, 0xfc, 0x3c, 0xa9, 0x12, 0x8c, 0x08, 0xe5,
    0xfa, 0x06, 0x96, 0x34, 0x06, 0xaf, 0x73, 0xd5, 0x4c, 0x4f, 0x64, 0x1a, 0x45, 0xb6, 0x7d, 0x5e,
    0xa7, 0x7b, 0x82, 0x28, 0x03, 0xaf, 0x63, 0x59, 0x0c, 0x88, 0x8a, 0x81, 0xeb, 0x4d, 0x2c, 0xef,
    0xf2, 0xf3, 0xa3, 0x04, 0xc2, 0xec, 0xfb, 0x97, 0x20, 0x49, 0x0a, 0xfd, 0x8c, 0xc8, 0x9f, 0x34,
    0xd1, 0xd9, 0x3e, 0xd2, 0xaa, 0x7a, 0x30, 0x13, 0x05, 0x4f, 0x50, 0xc1, 0x7b, 0x88, 0x4b, 0x46,
    0x5f, 0x1e, 0xd2, 0xbf, 0x2f, 0x24, 0x04, 0x63, 0xb3, 0x71, 0xe0, 0x5f, 0xd4, 0x4d, 0x4f, 0xfd,
    0x39, 0x23, 0xa9, 0x0a, 0x51, 0x73, 0x5f, 0x6d, 0xce, 0x25, 0xdc, 0x1d, 0x94, 0x26, 0x33, 0xa5,
    0x45, 0xbe, 0x59, 0xeb, 0x75, 0xcd, 0x90, 0x48, 0x49, 0xd6, 0x98, 0xda, 0x70, 0xf6, 0x1b, 0xa1,
    0x3d, 0x5e, 0x30, 0x96, 0x6b, 0x89, 0x59, 0xd7, 0x12, 0xda, 0x0f, 0xaf, 0xa6, 0x8a, 0x7d, 0xfe,
    0x83, 0x61, 0xbb, 0x2d, 0xc3, 0x6a, 0x58, 0xe9, 0xd7, 0xa2, 0x70, 0x30, 0xcc, 0x35, 0xaa, 0x64,
    0xb5, 0xec, 0x8f, 0x97, 0x6d, 0x6f, 0x65, 0xd3, 0xc1, 0x35, 0xa3, 0x29, 0x5f, 0xe0, 0x79, 0x0f,
    0x50, 0xbb, 0xe9, 0xc1, 0x44, 0x5d, 0xd3, 0x34, 0x26, 0xd8, 0x73, 0x61, 0x8c, 0x13, 0x47, 0x45,
    0x8d, 0x49, 0xfe, 0x1d, 0x68, 0x9a, 0xb5, 0x30, 0x62, 0x02, 0x2d, 0x9d, 0x0b, 0x0c, 0x97, 0x12,
    0x23, 0x50, 0x8d, 0xbc, 0x0b, 0x91, 0x40, 0xf8, 0x56, 0x30, 0xb3, 0xfb, 0xab, 0xc1, 0xdd, 0xe1,
    0xba, 0xff, 0x64, 0x0c, 0x1f, 0x6e, 0x98, 0x5e, 0xdd, 0xd7, 0xeb, 0x22, 0xfb, 0x36, 0x8c, 0x95,
    0xdf, 0x3c, 0x37, 0x37, 0x39, 0x75, 0x4f, 0x38, 0xab, 0x51, 0xc4, 0x6e, 0xcd, 0x4c, 0x48, 0xfa,
    0x8c, 0x13, 0x84, 0x5d, 0x27, 0x4b, 0xc2, 0x63, 0xa8, 0xf3, 0xe7, 0x99, 0xac, 0x54, 0xe6, 0xd7,
    0x3d, 0x41, 0x7e, 0x0c, 0x78, 0x8a, 0x3a, 0x1b, 0x6d, 0x2f, 0xaf, 0xdc, 0x94, 0xaa, 0xc6, 0x3d,
    0xe4, 0xcc, 0xe6, 0x50, 0x94, 0x9b, 0xe1, 0x1e, 0x76, 0xdc, 0x2f, 0xc1, 0x33, 0x21, 0x5c, 0xb0,
    0x0f, 0xb1, 0xfa, 0x58, 0xe2, 0x0b, 0xfc, 0x0a, 0x0b, 0xac, 0xc3, 0x05, 0xcc, 0x80, 0x98, 0x7b,
    0xe5, 0x6e, 0x0f, 0x06, 0x73, 0xfd, 0x05, 0x88, 0xdc, 0x81, 0xaa, 0xe9, 0x3a, 0x44, 0xa0, 0x1c,
    0x26, 0x39, 0x89, 0xdb, 0xd1, 0x22, 0xa8, 0xe6, 0xe5, 0xb7, 0x41, 0x16, 0x64, 0xd5, 0x16, 0x41,
    0xf9, 0x6d, 0xa5, 0x3c, 0x57, 0xdc, 0xbd, 0xb9, 0x34, 0xad, 0x81, 0x02, 0xdb, 0x9a, 0xa9, 0x6c,
    0x24, 0x94, 0x3b, 0x48, 0x56, 0xa9, 0xda, 0x1f, 0x81, 0xa2, 0xcf, 0xdb, 0x4b, 0xb0, 0xd7, 0xce,
    0x4e, 0xd1, 0xcb, 0x26, 0x18, 0xda, 0xfe, 0xea, 0x9a, 0x7b, 0xf7, 0x07, 0x86, 0x85, 0x6e, 0x55,
    0xb5, 0x7a, 0x22, 0x79, 0x99, 0xb2, 0xd0, 0x19, 0xc8, 0xc6, 0x3f, 0xa8, 0x1d, 0xf0, 0xdf, 0x57,
    0xa4, 0xba, 0x38, 0x6d, 0xf8, 0x63, 0x0a, 0xf4, 0x46, 0x6a, 0x6b, 0x8b, 0x3c, 0xb2, 0xef, 0x3a,
    0x44, 0xfe, 0x6f, 0x9a, 0x2f, 0x26, 0x79, 0x84, 0x4d, 0x57, 0x6d, 0x5b, 0x6b, 0x14, 0xc5, 0x22,
    0x5f, 0x47, 0xd1, 0x0e, 0xb1, 0xad, 0x79, 0x82, 0xa3, 0x06, 0x1c, 0x87, 0x2d, 0xea, 0xa4, 0xde,
    0x70, 0x78, 0x3d, 0xa3, 0x08, 0x1e, 0xcf, 0x48, 0xfd, 0x17, 0xfc, 0x02, 0x89, 0xb1
};
#endif

PyTypeObject *init_QFontMetricsF(PyObject *module)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX].type;

    Shiboken::AutoDecRef Sbk_QFontMetricsF_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QFontMetricsF_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QFontMetricsF",
        "QFontMetricsF",
        &Sbk_QFontMetricsF_spec,
        &Shiboken::callCppDestructor< ::QFontMetricsF >,
        Sbk_QFontMetricsF_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QFontMetricsF_TypeF(); // references _Sbk_QFontMetricsF_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QFontMetricsF_SignatureStrings);
#else
    InitSignatureBytes(pyType, QFontMetricsF_SignatureBytes, QFontMetricsF_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QFontMetricsF_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QFontMetricsF_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QFontMetricsF_PythonToCpp_QFontMetricsF_PTR,
        is_QFontMetricsF_PythonToCpp_QFontMetricsF_PTR_Convertible,
        QFontMetricsF_PTR_CppToPython_QFontMetricsF,
        QFontMetricsF_COPY_CppToPython_QFontMetricsF);

    Shiboken::Conversions::registerConverterName(converter, "QFontMetricsF");
    Shiboken::Conversions::registerConverterName(converter, "QFontMetricsF*");
    Shiboken::Conversions::registerConverterName(converter, "QFontMetricsF&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QFontMetricsF).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QFontMetricsF_PythonToCpp_QFontMetricsF_COPY,
        is_QFontMetricsF_PythonToCpp_QFontMetricsF_COPY_Convertible);
    // Add implicit conversions to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        constQFontMetricsREF_PythonToCpp_QFontMetricsF,
        is_constQFontMetricsREF_PythonToCpp_QFontMetricsF_Convertible);


    return pyType;
}
