// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QHelpEventWrapper_H
#define SBK_QHelpEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

class QHelpEventWrapper : public QHelpEvent
{
public:
    QHelpEventWrapper(const QHelpEventWrapper &) = delete;
    QHelpEventWrapper& operator=(const QHelpEventWrapper &) = delete;
    QHelpEventWrapper(QHelpEventWrapper &&) = delete;
    QHelpEventWrapper& operator=(QHelpEventWrapper &&) = delete;

    QHelpEventWrapper(::QEvent::Type type, const ::QPoint & pos, const ::QPoint & globalPos);
    QHelpEventWrapper(const QHelpEvent& self) : QHelpEvent(self)
    {
    }

    ::QHelpEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QHelpEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QHelpEventWrapper_H

