// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QHideEventWrapper_H
#define SBK_QHideEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

class QHideEventWrapper : public QHideEvent
{
public:
    QHideEventWrapper(const QHideEventWrapper &) = delete;
    QHideEventWrapper& operator=(const QHideEventWrapper &) = delete;
    QHideEventWrapper(QHideEventWrapper &&) = delete;
    QHideEventWrapper& operator=(QHideEventWrapper &&) = delete;

    QHideEventWrapper();
    QHideEventWrapper(const QHideEvent& self) : QHideEvent(self)
    {
    }

    ::QHideEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QHideEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QHideEventWrapper_H

