// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QIconEngineWrapper_H
#define SBK_QIconEngineWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qiconengine.h>

class QIconEngineWrapper : public QIconEngine
{
public:
    QIconEngineWrapper(const QIconEngineWrapper &) = delete;
    QIconEngineWrapper& operator=(const QIconEngineWrapper &) = delete;
    QIconEngineWrapper(QIconEngineWrapper &&) = delete;
    QIconEngineWrapper& operator=(QIconEngineWrapper &&) = delete;

    QIconEngineWrapper();
    QIconEngineWrapper(const QIconEngine& self) : QIconEngine(self)
    {
    }

    ::QSize actualSize(const ::QSize & size, ::QIcon::Mode mode, ::QIcon::State state) override;
    void addFile(const ::QString & fileName, const ::QSize & size, ::QIcon::Mode mode, ::QIcon::State state) override;
    void addPixmap(const ::QPixmap & pixmap, ::QIcon::Mode mode, ::QIcon::State state) override;
    ::QList<QSize> availableSizes(::QIcon::Mode mode = QIcon::Normal, ::QIcon::State state = QIcon::Off) override;
    ::QIconEngine * clone() const override;
    ::QString iconName() override;
    bool isNull() override;
    ::QString key() const override;
    void paint(::QPainter * painter, const ::QRect & rect, ::QIcon::Mode mode, ::QIcon::State state) override;
    ::QPixmap pixmap(const ::QSize & size, ::QIcon::Mode mode, ::QIcon::State state) override;
    bool read(::QDataStream & in) override;
    ::QPixmap scaledPixmap(const ::QSize & size, ::QIcon::Mode mode, ::QIcon::State state, qreal scale) override;
    bool write(::QDataStream & out) const override;
    ~QIconEngineWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[13] = {false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QIconEngineWrapper_H

