// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QImageIOHandlerWrapper_H
#define SBK_QImageIOHandlerWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qimageiohandler.h>

class QImageIOHandlerWrapper : public QImageIOHandler
{
public:
    QImageIOHandlerWrapper(const QImageIOHandlerWrapper &) = delete;
    QImageIOHandlerWrapper& operator=(const QImageIOHandlerWrapper &) = delete;
    QImageIOHandlerWrapper(QImageIOHandlerWrapper &&) = delete;
    QImageIOHandlerWrapper& operator=(QImageIOHandlerWrapper &&) = delete;

    QImageIOHandlerWrapper();
    bool canRead() const override;
    int currentImageNumber() const override;
    ::QRect currentImageRect() const override;
    int imageCount() const override;
    bool jumpToImage(int imageNumber) override;
    bool jumpToNextImage() override;
    int loopCount() const override;
    int nextImageDelay() const override;
    ::QVariant option(::QImageIOHandler::ImageOption option) const override;
    bool read(::QImage * image) override;
    void setOption(::QImageIOHandler::ImageOption option, const ::QVariant & value) override;
    bool supportsOption(::QImageIOHandler::ImageOption option) const override;
    bool write(const ::QImage & image) override;
    ~QImageIOHandlerWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[13] = {false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QImageIOHandlerWrapper_H

