// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QInputMethodQueryEventWrapper_H
#define SBK_QInputMethodQueryEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

class QInputMethodQueryEventWrapper : public QInputMethodQueryEvent
{
public:
    QInputMethodQueryEventWrapper(const QInputMethodQueryEventWrapper &) = delete;
    QInputMethodQueryEventWrapper& operator=(const QInputMethodQueryEventWrapper &) = delete;
    QInputMethodQueryEventWrapper(QInputMethodQueryEventWrapper &&) = delete;
    QInputMethodQueryEventWrapper& operator=(QInputMethodQueryEventWrapper &&) = delete;

    QInputMethodQueryEventWrapper(::QFlags<Qt::InputMethodQuery> queries);
    QInputMethodQueryEventWrapper(const QInputMethodQueryEvent& self) : QInputMethodQueryEvent(self)
    {
    }

    ::QInputMethodQueryEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QInputMethodQueryEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QInputMethodQueryEventWrapper_H

