// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qnativeinterface_qx11application_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>

using namespace QNativeInterface;


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QNativeInterface_QX11Application_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(args)
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PyTypeObject *type = self->ob_type;
    PyTypeObject *myType = Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QNativeInterface_QX11Application_IDX]);
    SBK_UNUSED(sbkSelf)
    SBK_UNUSED(type)
    SBK_UNUSED(myType)
    Shiboken::Errors::setInstantiateAbstractClassDisabledWrapper("QNativeInterface::QX11Application");
    return -1;
}

static PyObject *Sbk_QNativeInterface_QX11ApplicationFunc_connection(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNativeInterface::QX11Application *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QNativeInterface_QX11Application_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // connection()const
        if (Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))) {
            Shiboken::Errors::setPureVirtualMethodError("QX11Application.connection");
            return {};
        }
        // Begin code injection
        // ========================================================================
        // START of custom code block [file: ../glue/qtgui.cpp (qx11application-resource-ptr)]
         auto *resource = cppSelf->connection();
        pyResult = PyLong_FromVoidPtr(resource);
        // END of custom code block [file: ../glue/qtgui.cpp (qx11application-resource-ptr)]
        // ========================================================================
        // End of code injection

    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNativeInterface_QX11ApplicationFunc_display(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNativeInterface::QX11Application *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QNativeInterface_QX11Application_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // display()const
        if (Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))) {
            Shiboken::Errors::setPureVirtualMethodError("QX11Application.display");
            return {};
        }
        // Begin code injection
        // ========================================================================
        // START of custom code block [file: ../glue/qtgui.cpp (qx11application-resource-ptr)]
         auto *resource = cppSelf->display();
        pyResult = PyLong_FromVoidPtr(resource);
        // END of custom code block [file: ../glue/qtgui.cpp (qx11application-resource-ptr)]
        // ========================================================================
        // End of code injection

    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QNativeInterface_QX11Application_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QNativeInterface_QX11Application_methods[] = {
    {"connection", reinterpret_cast<PyCFunction>(Sbk_QNativeInterface_QX11ApplicationFunc_connection), METH_NOARGS, nullptr},
    {"display", reinterpret_cast<PyCFunction>(Sbk_QNativeInterface_QX11ApplicationFunc_display), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static int Sbk_QNativeInterface_QX11Application_setattro(PyObject *self, PyObject *name, PyObject *value)
{
    PySide::Feature::Select(self);
    return PyObject_GenericSetAttr(self, name, value);
}

} // extern "C"

static int Sbk_QNativeInterface_QX11Application_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QNativeInterface_QX11Application_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QNativeInterface_QX11Application_Type = nullptr;
static PyTypeObject *Sbk_QNativeInterface_QX11Application_TypeF(void)
{
    return _Sbk_QNativeInterface_QX11Application_Type;
}

static PyType_Slot Sbk_QNativeInterface_QX11Application_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_setattro,    reinterpret_cast<void *>(Sbk_QNativeInterface_QX11Application_setattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QNativeInterface_QX11Application_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QNativeInterface_QX11Application_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QNativeInterface_QX11Application_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QNativeInterface_QX11Application_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QNativeInterface_QX11Application_spec = {
    "2:PySide6.QtGui.QNativeInterface.QX11Application",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QNativeInterface_QX11Application_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QX11Application_PythonToCpp_QX11Application_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QNativeInterface_QX11Application_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QX11Application_PythonToCpp_QX11Application_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QNativeInterface_QX11Application_TypeF()))
        return QX11Application_PythonToCpp_QX11Application_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QX11Application_PTR_CppToPython_QX11Application(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    auto *tCppIn = reinterpret_cast<const ::QNativeInterface::QX11Application *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    return Shiboken::Object::newObjectForPointer(Sbk_QNativeInterface_QX11Application_TypeF(), const_cast<void *>(cppIn), false, typeName);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QNativeInterface_QX11Application_SignatureStrings[] = {
    "PySide6.QtGui.QNativeInterface.QX11Application(self)",
    "PySide6.QtGui.QNativeInterface.QX11Application.connection(self)->int",
    "PySide6.QtGui.QNativeInterface.QX11Application.display(self)->int",
    nullptr}; // Sentinel
#else
static constexpr size_t QNativeInterface_QX11Application_SignatureByteSize = 89;
static constexpr uint8_t QNativeInterface_QX11Application_SignatureBytes[89] = {
    0x78, 0xda, 0x0b, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x71, 0x2f, 0xcd, 0xd4,
    0x0b, 0xf4, 0x4b, 0x2c, 0xc9, 0x2c, 0x4b, 0xf5, 0xcc, 0x2b, 0x49, 0x2d, 0x4a, 0x4b, 0x4c, 0x4e,
    0xd5, 0x0b, 0x8c, 0x30, 0x34, 0x74, 0x2c, 0x28, 0xc8, 0xc9, 0x4c, 0x06, 0x4a, 0xe4, 0xe7, 0x69,
    0x14, 0xa7, 0xe6, 0xa4, 0x69, 0x72, 0x05, 0x90, 0xa4, 0x49, 0x2f, 0x39, 0x3f, 0x2f, 0x2f, 0x35,
    0x19, 0xa1, 0x5f, 0xd7, 0x2e, 0x33, 0xaf, 0x84, 0x54, 0x43, 0x52, 0x32, 0x8b, 0x0b, 0x72, 0x12,
    0x2b, 0x91, 0x4d, 0x00, 0x00, 0xd7, 0x90, 0x43, 0x3e
};
#endif

PyTypeObject *init_QNativeInterface_QX11Application(PyObject *enclosingClass)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QNativeInterface_QX11Application_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QNativeInterface_QX11Application_IDX].type;

    Shiboken::AutoDecRef Sbk_QNativeInterface_QX11Application_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QNativeInterface_QX11Application_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "QX11Application",
        "QNativeInterface::QX11Application*",
        &Sbk_QNativeInterface_QX11Application_spec,
        &Shiboken::callCppDestructor< ::QNativeInterface::QX11Application >,
        Sbk_QNativeInterface_QX11Application_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass);
    auto *pyType = Sbk_QNativeInterface_QX11Application_TypeF(); // references _Sbk_QNativeInterface_QX11Application_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QNativeInterface_QX11Application_SignatureStrings);
#else
    InitSignatureBytes(pyType, QNativeInterface_QX11Application_SignatureBytes, QNativeInterface_QX11Application_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QNativeInterface_QX11Application_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QNativeInterface_QX11Application_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QX11Application_PythonToCpp_QX11Application_PTR,
        is_QX11Application_PythonToCpp_QX11Application_PTR_Convertible,
        QX11Application_PTR_CppToPython_QX11Application);

    Shiboken::Conversions::registerConverterName(converter, "QNativeInterface::QX11Application");
    Shiboken::Conversions::registerConverterName(converter, "QNativeInterface::QX11Application*");
    Shiboken::Conversions::registerConverterName(converter, "QNativeInterface::QX11Application&");
    Shiboken::Conversions::registerConverterAlias(converter, "QX11Application");
    Shiboken::Conversions::registerConverterAlias(converter, "QX11Application*");
    Shiboken::Conversions::registerConverterAlias(converter, "QX11Application&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QNativeInterface::QX11Application).name());

    qRegisterMetaType< ::QNativeInterface::QX11Application *>();

    return pyType;
}
