// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qpainter_pixmapfragment_wrapper.h"

// Argument includes
#include <QPainter>
#include <qpoint.h>
#include <qrect.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QPainter_PixmapFragment_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QPainter::PixmapFragment >()))
        return -1;

    ::QPainter::PixmapFragment *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "PixmapFragment", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: PixmapFragment::PixmapFragment()
    // 1: PixmapFragment::PixmapFragment(QPainter::PixmapFragment)
    if (numArgs == 0) {
        overloadId = 0; // PixmapFragment()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), (pyArgs[0])))) {
        overloadId = 1; // PixmapFragment(QPainter::PixmapFragment)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // PixmapFragment()
        {

            // PixmapFragment()
            cptr = new ::QPainter::PixmapFragment();
            break;
        }
        case 1: // PixmapFragment(const QPainter::PixmapFragment &PixmapFragment)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QPainter::PixmapFragment cppArg0_local;
            ::QPainter::PixmapFragment *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // PixmapFragment(QPainter::PixmapFragment)
                cptr = new ::QPainter::PixmapFragment(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QPainter::PixmapFragment >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QPainter_PixmapFragmentFunc_create(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[6];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr, nullptr, nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 2, 6));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "create", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]);

    if (PyArg_ParseTuple(args, "|OOOOOO:create", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2]), &(pyArgs[3]), &(pyArgs[4]), &(pyArgs[5])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static PixmapFragment::create(QPointF,QRectF,qreal=,qreal=,qreal=,qreal=)->QPainter::PixmapFragment
    if (numArgs >= 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QPointF_IDX]), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRectF_IDX]), (pyArgs[1])))) {
        if (numArgs == 2) {
            overloadId = 0; // create(QPointF,QRectF,qreal,qreal,qreal,qreal)
        } else if (numArgs >= 3
            && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyArgs[2])))) {
            if (numArgs == 3) {
                overloadId = 0; // create(QPointF,QRectF,qreal,qreal,qreal,qreal)
            } else if (numArgs >= 4
                && (pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyArgs[3])))) {
                if (numArgs == 4) {
                    overloadId = 0; // create(QPointF,QRectF,qreal,qreal,qreal,qreal)
                } else if (numArgs >= 5
                    && (pythonToCpp[4] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyArgs[4])))) {
                    if (numArgs == 5) {
                        overloadId = 0; // create(QPointF,QRectF,qreal,qreal,qreal,qreal)
                    } else if (numArgs >= 6
                        && (pythonToCpp[5] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyArgs[5])))) {
                        overloadId = 0; // create(QPointF,QRectF,qreal,qreal,qreal,qreal)
                    }
                }
            }
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "create", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_scaleX = Shiboken::String::createStaticString("scaleX");
            if (PyDict_Contains(kwds, key_scaleX) != 0) {
                value = PyDict_GetItem(kwds, key_scaleX);
                if (value != nullptr && pyArgs[2] != nullptr ) {
                    errInfo.reset(key_scaleX);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, "create", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[2] = value;
                    if (!(pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyArgs[2]))))
                        return Shiboken::returnWrongArguments(args, "create", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_scaleX);
            }
            static PyObject *const key_scaleY = Shiboken::String::createStaticString("scaleY");
            if (PyDict_Contains(kwds, key_scaleY) != 0) {
                value = PyDict_GetItem(kwds, key_scaleY);
                if (value != nullptr && pyArgs[3] != nullptr ) {
                    errInfo.reset(key_scaleY);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, "create", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[3] = value;
                    if (!(pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyArgs[3]))))
                        return Shiboken::returnWrongArguments(args, "create", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_scaleY);
            }
            static PyObject *const key_rotation = Shiboken::String::createStaticString("rotation");
            if (PyDict_Contains(kwds, key_rotation) != 0) {
                value = PyDict_GetItem(kwds, key_rotation);
                if (value != nullptr && pyArgs[4] != nullptr ) {
                    errInfo.reset(key_rotation);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, "create", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[4] = value;
                    if (!(pythonToCpp[4] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyArgs[4]))))
                        return Shiboken::returnWrongArguments(args, "create", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_rotation);
            }
            static PyObject *const key_opacity = Shiboken::String::createStaticString("opacity");
            if (PyDict_Contains(kwds, key_opacity) != 0) {
                value = PyDict_GetItem(kwds, key_opacity);
                if (value != nullptr && pyArgs[5] != nullptr ) {
                    errInfo.reset(key_opacity);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, "create", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[5] = value;
                    if (!(pythonToCpp[5] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyArgs[5]))))
                        return Shiboken::returnWrongArguments(args, "create", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_opacity);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, "create", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]);
            }
        }
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return {};
        ::QPointF cppArg0_local;
        ::QPointF *cppArg0 = &cppArg0_local;
        if (pythonToCpp[0].isValue())
            pythonToCpp[0](pyArgs[0], &cppArg0_local);
        else
            pythonToCpp[0](pyArgs[0], &cppArg0);

        if (!Shiboken::Object::isValid(pyArgs[1]))
            return {};
        ::QRectF cppArg1_local;
        ::QRectF *cppArg1 = &cppArg1_local;
        if (pythonToCpp[1].isValue())
            pythonToCpp[1](pyArgs[1], &cppArg1_local);
        else
            pythonToCpp[1](pyArgs[1], &cppArg1);

        qreal cppArg2 = 1;
        if (pythonToCpp[2])
            pythonToCpp[2](pyArgs[2], &cppArg2);
        qreal cppArg3 = 1;
        if (pythonToCpp[3])
            pythonToCpp[3](pyArgs[3], &cppArg3);
        qreal cppArg4 = 0;
        if (pythonToCpp[4])
            pythonToCpp[4](pyArgs[4], &cppArg4);
        qreal cppArg5 = 1;
        if (pythonToCpp[5])
            pythonToCpp[5](pyArgs[5], &cppArg5);

        if (Shiboken::Errors::occurred() == nullptr) {
            // create(QPointF,QRectF,qreal,qreal,qreal,qreal)
            QPainter::PixmapFragment cppResult = ::QPainter::PixmapFragment::create(*cppArg0, *cppArg1, cppArg2, cppArg3, cppArg4, cppArg5);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPainter_PixmapFragment__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QPainter_PixmapFragment_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QPainter_PixmapFragment_methods[] = {
    {"create", reinterpret_cast<PyCFunction>(Sbk_QPainter_PixmapFragmentFunc_create), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QPainter_PixmapFragment__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QPainter_PixmapFragment_get_x(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppSelf->x);
    return pyOut;
}
static int Sbk_QPainter_PixmapFragment_set_x(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("x");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("x", "qreal");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->x;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QPainter_PixmapFragment_get_y(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppSelf->y);
    return pyOut;
}
static int Sbk_QPainter_PixmapFragment_set_y(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("y");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("y", "qreal");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->y;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QPainter_PixmapFragment_get_sourceLeft(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppSelf->sourceLeft);
    return pyOut;
}
static int Sbk_QPainter_PixmapFragment_set_sourceLeft(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("sourceLeft");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("sourceLeft", "qreal");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->sourceLeft;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QPainter_PixmapFragment_get_sourceTop(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppSelf->sourceTop);
    return pyOut;
}
static int Sbk_QPainter_PixmapFragment_set_sourceTop(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("sourceTop");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("sourceTop", "qreal");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->sourceTop;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QPainter_PixmapFragment_get_width(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppSelf->width);
    return pyOut;
}
static int Sbk_QPainter_PixmapFragment_set_width(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("width");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("width", "qreal");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->width;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QPainter_PixmapFragment_get_height(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppSelf->height);
    return pyOut;
}
static int Sbk_QPainter_PixmapFragment_set_height(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("height");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("height", "qreal");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->height;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QPainter_PixmapFragment_get_scaleX(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppSelf->scaleX);
    return pyOut;
}
static int Sbk_QPainter_PixmapFragment_set_scaleX(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("scaleX");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("scaleX", "qreal");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->scaleX;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QPainter_PixmapFragment_get_scaleY(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppSelf->scaleY);
    return pyOut;
}
static int Sbk_QPainter_PixmapFragment_set_scaleY(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("scaleY");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("scaleY", "qreal");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->scaleY;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QPainter_PixmapFragment_get_rotation(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppSelf->rotation);
    return pyOut;
}
static int Sbk_QPainter_PixmapFragment_set_rotation(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("rotation");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("rotation", "qreal");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->rotation;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QPainter_PixmapFragment_get_opacity(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), &cppSelf->opacity);
    return pyOut;
}
static int Sbk_QPainter_PixmapFragment_set_opacity(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("opacity");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qreal>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("opacity", "qreal");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->opacity;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for PixmapFragment
static PyGetSetDef Sbk_QPainter_PixmapFragment_getsetlist[] = {
    {const_cast<char *>("x"), Sbk_QPainter_PixmapFragment_get_x, Sbk_QPainter_PixmapFragment_set_x, nullptr, nullptr},
    {const_cast<char *>("y"), Sbk_QPainter_PixmapFragment_get_y, Sbk_QPainter_PixmapFragment_set_y, nullptr, nullptr},
    {const_cast<char *>("sourceLeft"), Sbk_QPainter_PixmapFragment_get_sourceLeft, Sbk_QPainter_PixmapFragment_set_sourceLeft, nullptr, nullptr},
    {const_cast<char *>("sourceTop"), Sbk_QPainter_PixmapFragment_get_sourceTop, Sbk_QPainter_PixmapFragment_set_sourceTop, nullptr, nullptr},
    {const_cast<char *>("width"), Sbk_QPainter_PixmapFragment_get_width, Sbk_QPainter_PixmapFragment_set_width, nullptr, nullptr},
    {const_cast<char *>("height"), Sbk_QPainter_PixmapFragment_get_height, Sbk_QPainter_PixmapFragment_set_height, nullptr, nullptr},
    {const_cast<char *>("scaleX"), Sbk_QPainter_PixmapFragment_get_scaleX, Sbk_QPainter_PixmapFragment_set_scaleX, nullptr, nullptr},
    {const_cast<char *>("scaleY"), Sbk_QPainter_PixmapFragment_get_scaleY, Sbk_QPainter_PixmapFragment_set_scaleY, nullptr, nullptr},
    {const_cast<char *>("rotation"), Sbk_QPainter_PixmapFragment_get_rotation, Sbk_QPainter_PixmapFragment_set_rotation, nullptr, nullptr},
    {const_cast<char *>("opacity"), Sbk_QPainter_PixmapFragment_get_opacity, Sbk_QPainter_PixmapFragment_set_opacity, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QPainter_PixmapFragment_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QPainter_PixmapFragment_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QPainter_PixmapFragment_Type = nullptr;
static PyTypeObject *Sbk_QPainter_PixmapFragment_TypeF(void)
{
    return _Sbk_QPainter_PixmapFragment_Type;
}

static PyType_Slot Sbk_QPainter_PixmapFragment_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QPainter_PixmapFragment_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QPainter_PixmapFragment_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QPainter_PixmapFragment_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QPainter_PixmapFragment_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QPainter_PixmapFragment_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QPainter_PixmapFragment_spec = {
    "2:PySide6.QtGui.QPainter.PixmapFragment",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QPainter_PixmapFragment_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void PixmapFragment_PythonToCpp_PixmapFragment_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QPainter_PixmapFragment_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_PixmapFragment_PythonToCpp_PixmapFragment_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QPainter_PixmapFragment_TypeF()))
        return PixmapFragment_PythonToCpp_PixmapFragment_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *PixmapFragment_PTR_CppToPython_PixmapFragment(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QPainter_PixmapFragment_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *PixmapFragment_COPY_CppToPython_PixmapFragment(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QPainter::PixmapFragment *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QPainter_PixmapFragment_TypeF(), new ::QPainter::PixmapFragment(*source), true, true);
}

// Python to C++ copy conversion.
static void PixmapFragment_PythonToCpp_PixmapFragment_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QPainter::PixmapFragment *>(cppOut) = *reinterpret_cast< ::QPainter::PixmapFragment *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_PixmapFragment_PythonToCpp_PixmapFragment_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QPainter_PixmapFragment_TypeF()))
        return PixmapFragment_PythonToCpp_PixmapFragment_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QPainter_PixmapFragment_SignatureStrings[] = {
    "1:PySide6.QtGui.QPainter.PixmapFragment(self)",
    "0:PySide6.QtGui.QPainter.PixmapFragment(self,PixmapFragment:PySide6.QtGui.QPainter.PixmapFragment)",
    "PySide6.QtGui.QPainter.PixmapFragment.create(pos:typing.Union[PySide6.QtCore.QPointF, PySide6.QtCore.QPoint, PySide6.QtGui.QPainterPath.Element],sourceRect:typing.Union[PySide6.QtCore.QRectF, PySide6.QtCore.QRect],scaleX:qreal=1,scaleY:qreal=1,rotation:qreal=0,opacity:qreal=1)->PySide6.QtGui.QPainter.PixmapFragment",
    "PySide6.QtGui.QPainter.PixmapFragment.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QPainter_PixmapFragment_SignatureByteSize = 201;
static constexpr uint8_t QPainter_PixmapFragment_SignatureBytes[201] = {
    0x78, 0xda, 0x95, 0x91, 0x41, 0x0b, 0x82, 0x40, 0x10, 0x85, 0xef, 0xfe, 0x8a, 0x8e, 0x0a, 0xba,
    0xe8, 0xa5, 0x83, 0x90, 0x97, 0xc8, 0xae, 0x9a, 0x04, 0x45, 0x84, 0x2c, 0xdb, 0x64, 0x0b, 0xba,
    0xbb, 0xad, 0x23, 0xe4, 0xbf, 0x6f, 0x45, 0x2b, 0x03, 0x09, 0x3b, 0xbe, 0x8f, 0xf7, 0xe6, 0xed,
    0xcc, 0x06, 0x61, 0xd2, 0x66, 0xfc, 0x02, 0x4b, 0x92, 0xe2, 0xb6, 0xe1, 0x24, 0x4d, 0x28, 0x17,
    0x08, 0x9a, 0x24, 0xfc, 0x51, 0x51, 0x15, 0x6b, 0x5a, 0x54, 0x20, 0xd0, 0xae, 0xa1, 0xbc, 0x3a,
    0x96, 0xff, 0x87, 0xdb, 0xfd, 0x66, 0xf3, 0x92, 0x8e, 0x35, 0xcb, 0x46, 0x98, 0x06, 0x8a, 0x60,
    0x2b, 0x59, 0x87, 0xd8, 0x2a, 0x2e, 0x0a, 0xb2, 0x17, 0x5c, 0x8a, 0xd3, 0x27, 0xbd, 0x96, 0x1a,
    0x4c, 0x5c, 0x9a, 0x78, 0xec, 0x2e, 0x26, 0xf9, 0x18, 0x8f, 0xcb, 0x12, 0x8a, 0x37, 0xb2, 0x29,
    0xa1, 0x6b, 0x3a, 0xbb, 0xb5, 0x6c, 0x34, 0x83, 0x1d, 0x30, 0xfc, 0x5d, 0xd5, 0x39, 0x26, 0x9a,
    0x3a, 0x6c, 0x86, 0x30, 0x5a, 0xc2, 0x21, 0xbc, 0x9b, 0x67, 0x97, 0xab, 0xa0, 0x97, 0xc7, 0xb7,
    0xd4, 0x12, 0x29, 0x9a, 0x99, 0x03, 0xf0, 0x5d, 0xa9, 0x28, 0xe3, 0xd8, 0xbe, 0x0c, 0x8e, 0x17,
    0xcd, 0x3a, 0xcb, 0xcc, 0xe3, 0xe5, 0x39, 0x93, 0xaa, 0xcd, 0xf3, 0xfe, 0x53, 0xbd, 0x68, 0x58,
    0x2b, 0x33, 0xca, 0x7a, 0x02, 0x64, 0xc8, 0xbd, 0xf4
};
#endif

PyTypeObject *init_QPainter_PixmapFragment(PyObject *enclosingClass)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX].type;

    Shiboken::AutoDecRef Sbk_QPainter_PixmapFragment_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QPainter_PixmapFragment_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "PixmapFragment",
        "QPainter::PixmapFragment",
        &Sbk_QPainter_PixmapFragment_spec,
        &Shiboken::callCppDestructor< ::QPainter::PixmapFragment >,
        Sbk_QPainter_PixmapFragment_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QPainter_PixmapFragment_TypeF(); // references _Sbk_QPainter_PixmapFragment_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QPainter_PixmapFragment_SignatureStrings);
#else
    InitSignatureBytes(pyType, QPainter_PixmapFragment_SignatureBytes, QPainter_PixmapFragment_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QPainter_PixmapFragment_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QPainter_PixmapFragment_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        PixmapFragment_PythonToCpp_PixmapFragment_PTR,
        is_PixmapFragment_PythonToCpp_PixmapFragment_PTR_Convertible,
        PixmapFragment_PTR_CppToPython_PixmapFragment,
        PixmapFragment_COPY_CppToPython_PixmapFragment);

    Shiboken::Conversions::registerConverterName(converter, "QPainter::PixmapFragment");
    Shiboken::Conversions::registerConverterName(converter, "QPainter::PixmapFragment*");
    Shiboken::Conversions::registerConverterName(converter, "QPainter::PixmapFragment&");
    Shiboken::Conversions::registerConverterAlias(converter, "PixmapFragment");
    Shiboken::Conversions::registerConverterAlias(converter, "PixmapFragment*");
    Shiboken::Conversions::registerConverterAlias(converter, "PixmapFragment&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QPainter::PixmapFragment).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        PixmapFragment_PythonToCpp_PixmapFragment_COPY,
        is_PixmapFragment_PythonToCpp_PixmapFragment_COPY_Convertible);

    qRegisterMetaType< ::QPainter::PixmapFragment >("PixmapFragment");
    qRegisterMetaType< ::QPainter::PixmapFragment >("QPainter::PixmapFragment");

    return pyType;
}
