// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPaintEventWrapper_H
#define SBK_QPaintEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

class QPaintEventWrapper : public QPaintEvent
{
public:
    QPaintEventWrapper(const QPaintEventWrapper &) = delete;
    QPaintEventWrapper& operator=(const QPaintEventWrapper &) = delete;
    QPaintEventWrapper(QPaintEventWrapper &&) = delete;
    QPaintEventWrapper& operator=(QPaintEventWrapper &&) = delete;

    QPaintEventWrapper(const QPaintEvent& self) : QPaintEvent(self)
    {
    }

    QPaintEventWrapper(const ::QRect & paintRect);
    QPaintEventWrapper(const ::QRegion & paintRegion);
    ::QPaintEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QPaintEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QPaintEventWrapper_H

