// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPdfWriterWrapper_H
#define SBK_QPdfWriterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qpdfwriter.h>

namespace PySide { class DynamicQMetaObject; }

class QPdfWriterWrapper : public QPdfWriter
{
public:
    QPdfWriterWrapper(const QPdfWriterWrapper &) = delete;
    QPdfWriterWrapper& operator=(const QPdfWriterWrapper &) = delete;
    QPdfWriterWrapper(QPdfWriterWrapper &&) = delete;
    QPdfWriterWrapper& operator=(QPdfWriterWrapper &&) = delete;

    QPdfWriterWrapper(::QIODevice * device);
    QPdfWriterWrapper(const ::QString & filename);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    int devType() const override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void initPainter(::QPainter * painter) const override;
    int metric(::QPaintDevice::PaintDeviceMetric id) const override;
    bool newPage() override;
    ::QPaintEngine * paintEngine() const override;
    ::QPaintDevice * redirected(::QPoint * offset) const override;
    bool setPageLayout(const ::QPageLayout & pageLayout) override;
    bool setPageMargins(const ::QMarginsF & margins, ::QPageLayout::Unit units = QPageLayout::Millimeter) override;
    bool setPageOrientation(::QPageLayout::Orientation orientation) override;
    void setPageRanges(const ::QPageRanges & ranges) override;
    bool setPageSize(const ::QPageSize & pageSize) override;
    ::QPainter * sharedPainter() const override;
    void timerEvent(::QTimerEvent * event) override;
    ~QPdfWriterWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[19] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QPdfWriterWrapper_H

