// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPictureWrapper_H
#define SBK_QPictureWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qpicture.h>

class QPictureWrapper : public QPicture
{
public:
    QPictureWrapper(const QPictureWrapper &) = delete;
    QPictureWrapper& operator=(const QPictureWrapper &) = delete;
    QPictureWrapper(QPictureWrapper &&) = delete;
    QPictureWrapper& operator=(QPictureWrapper &&) = delete;

    QPictureWrapper(const QPicture& self) : QPicture(self)
    {
    }

    QPictureWrapper(int formatVersion = -1);
    int devType() const override;
    void initPainter(::QPainter * painter) const override;
    int metric(::QPaintDevice::PaintDeviceMetric m) const override;
    ::QPaintEngine * paintEngine() const override;
    ::QPaintDevice * redirected(::QPoint * offset) const override;
    void setData(const char * data, uint size) override;
    ::QPainter * sharedPainter() const override;
    ~QPictureWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QPictureWrapper_H

