// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPointingDeviceWrapper_H
#define SBK_QPointingDeviceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qpointingdevice.h>

namespace PySide { class DynamicQMetaObject; }

class QPointingDeviceWrapper : public QPointingDevice
{
public:
    QPointingDeviceWrapper(const QPointingDeviceWrapper &) = delete;
    QPointingDeviceWrapper& operator=(const QPointingDeviceWrapper &) = delete;
    QPointingDeviceWrapper(QPointingDeviceWrapper &&) = delete;
    QPointingDeviceWrapper& operator=(QPointingDeviceWrapper &&) = delete;

    QPointingDeviceWrapper(::QObject * parent = nullptr);
    QPointingDeviceWrapper(const ::QString & name, qint64 systemId, ::QInputDevice::DeviceType devType, ::QPointingDevice::PointerType pType, ::QFlags<QInputDevice::Capability> caps, int maxPoints, int buttonCount, const ::QString & seatName = QString(), ::QPointingDeviceUniqueId uniqueId = QPointingDeviceUniqueId(), ::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QPointingDeviceWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QPointingDeviceWrapper_H

