// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRhiBufferWrapper_H
#define SBK_QRhiBufferWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

class QRhiBufferWrapper : public QRhiBuffer
{
public:
    QRhiBufferWrapper(const QRhiBufferWrapper &) = delete;
    QRhiBufferWrapper& operator=(const QRhiBufferWrapper &) = delete;
    QRhiBufferWrapper(QRhiBufferWrapper &&) = delete;
    QRhiBufferWrapper& operator=(QRhiBufferWrapper &&) = delete;

    bool create() override;
    void destroy() override;
    void endFullDynamicBufferUpdateForCurrentFrame() override;
    void fullDynamicBufferUpdateForCurrentFrame(const void * data, quint32 size = 0) override;
    ::QRhiResource::Type resourceType() const override;
    ~QRhiBufferWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[5] = {false, false, false, false, false};
};

#endif // SBK_QRhiBufferWrapper_H

