// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRhiComputePipelineWrapper_H
#define SBK_QRhiComputePipelineWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

class QRhiComputePipelineWrapper : public QRhiComputePipeline
{
public:
    QRhiComputePipelineWrapper(const QRhiComputePipelineWrapper &) = delete;
    QRhiComputePipelineWrapper& operator=(const QRhiComputePipelineWrapper &) = delete;
    QRhiComputePipelineWrapper(QRhiComputePipelineWrapper &&) = delete;
    QRhiComputePipelineWrapper& operator=(QRhiComputePipelineWrapper &&) = delete;

    bool create() override;
    void destroy() override;
    ::QRhiResource::Type resourceType() const override;
    ~QRhiComputePipelineWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QRhiComputePipelineWrapper_H

