// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRhiRenderPassDescriptorWrapper_H
#define SBK_QRhiRenderPassDescriptorWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

class QRhiRenderPassDescriptorWrapper : public QRhiRenderPassDescriptor
{
public:
    QRhiRenderPassDescriptorWrapper(const QRhiRenderPassDescriptorWrapper &) = delete;
    QRhiRenderPassDescriptorWrapper& operator=(const QRhiRenderPassDescriptorWrapper &) = delete;
    QRhiRenderPassDescriptorWrapper(QRhiRenderPassDescriptorWrapper &&) = delete;
    QRhiRenderPassDescriptorWrapper& operator=(QRhiRenderPassDescriptorWrapper &&) = delete;

    void destroy() override;
    bool isCompatible(const ::QRhiRenderPassDescriptor * other) const override;
    const ::QRhiNativeHandles * nativeHandles() override;
    ::QRhiRenderPassDescriptor * newCompatibleRenderPassDescriptor() const override;
    ::QRhiResource::Type resourceType() const override;
    ::QList<quint32> serializedFormat() const override;
    ~QRhiRenderPassDescriptorWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[6] = {false, false, false, false, false, false};
};

#endif // SBK_QRhiRenderPassDescriptorWrapper_H

