// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhiresourceupdatebatch_wrapper.h"

// Argument includes
#include <QtGui/qimage.h>
#include <rhi/qrhi.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static PyObject *Sbk_QRhiResourceUpdateBatchFunc_copyTexture(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiResourceUpdateBatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 2, 3));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "copyTexture", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]);

    if (PyArg_ParseTuple(args, "|OOO:copyTexture", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QRhiResourceUpdateBatch::copyTexture(QRhiTexture*,QRhiTexture*,const QRhiTextureCopyDescription&=)
    if (numArgs >= 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTexture_IDX]), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTexture_IDX]), (pyArgs[1])))) {
        if (numArgs == 2) {
            overloadId = 0; // copyTexture(QRhiTexture*,QRhiTexture*,QRhiTextureCopyDescription)
        } else if (numArgs >= 3
            && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), (pyArgs[2])))) {
            overloadId = 0; // copyTexture(QRhiTexture*,QRhiTexture*,QRhiTextureCopyDescription)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "copyTexture", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_desc = Shiboken::String::createStaticString("desc");
            if (PyDict_Contains(kwds, key_desc) != 0) {
                value = PyDict_GetItem(kwds, key_desc);
                if (value != nullptr && pyArgs[2] != nullptr ) {
                    errInfo.reset(key_desc);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, "copyTexture", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[2] = value;
                    if (!(pythonToCpp[2] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), (pyArgs[2]))))
                        return Shiboken::returnWrongArguments(args, "copyTexture", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_desc);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, "copyTexture", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]);
            }
        }
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return {};
        ::QRhiTexture *cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        if (!Shiboken::Object::isValid(pyArgs[1]))
            return {};
        ::QRhiTexture *cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);
        if (!Shiboken::Object::isValid(pyArgs[2]))
            return {};
        ::QRhiTextureCopyDescription cppArg2_local = QRhiTextureCopyDescription();
        ::QRhiTextureCopyDescription *cppArg2 = &cppArg2_local;
        if (pythonToCpp[2]) {
            if (pythonToCpp[2].isValue())
                pythonToCpp[2](pyArgs[2], &cppArg2_local);
            else
                pythonToCpp[2](pyArgs[2], &cppArg2);
            }

        if (Shiboken::Errors::occurred() == nullptr) {
            // copyTexture(QRhiTexture*,QRhiTexture*,QRhiTextureCopyDescription)
            cppSelf->copyTexture(cppArg0, cppArg1, *cppArg2);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiResourceUpdateBatchFunc_generateMips(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiResourceUpdateBatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiResourceUpdateBatch::generateMips(QRhiTexture*)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTexture_IDX]), (pyArg)))) {
        overloadId = 0; // generateMips(QRhiTexture*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "generateMips", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QRhiTexture *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // generateMips(QRhiTexture*)
            cppSelf->generateMips(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiResourceUpdateBatchFunc_hasOptimalCapacity(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiResourceUpdateBatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // hasOptimalCapacity()const
        bool cppResult = const_cast<const ::QRhiResourceUpdateBatch *>(cppSelf)->hasOptimalCapacity();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiResourceUpdateBatchFunc_merge(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiResourceUpdateBatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiResourceUpdateBatch::merge(QRhiResourceUpdateBatch*)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]), (pyArg)))) {
        overloadId = 0; // merge(QRhiResourceUpdateBatch*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "merge", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QRhiResourceUpdateBatch *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // merge(QRhiResourceUpdateBatch*)
            cppSelf->merge(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiResourceUpdateBatchFunc_readBackBuffer(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiResourceUpdateBatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[4];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "readBackBuffer", 4, 4, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2]), &(pyArgs[3])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QRhiResourceUpdateBatch::readBackBuffer(QRhiBuffer*,quint32,quint32,QRhiReadbackResult*)
    if (numArgs == 4
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiBuffer_IDX]), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArgs[2])))
        && (pythonToCpp[3] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiReadbackResult_IDX]), (pyArgs[3])))) {
        overloadId = 0; // readBackBuffer(QRhiBuffer*,quint32,quint32,QRhiReadbackResult*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "readBackBuffer", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return {};
        ::QRhiBuffer *cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        quint32 cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);
        quint32 cppArg2;
        pythonToCpp[2](pyArgs[2], &cppArg2);
        if (!Shiboken::Object::isValid(pyArgs[3]))
            return {};
        ::QRhiReadbackResult *cppArg3;
        pythonToCpp[3](pyArgs[3], &cppArg3);

        if (Shiboken::Errors::occurred() == nullptr) {
            // readBackBuffer(QRhiBuffer*,quint32,quint32,QRhiReadbackResult*)
            cppSelf->readBackBuffer(cppArg0, cppArg1, cppArg2, cppArg3);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiResourceUpdateBatchFunc_readBackTexture(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiResourceUpdateBatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "readBackTexture", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QRhiResourceUpdateBatch::readBackTexture(QRhiReadbackDescription,QRhiReadbackResult*)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiReadbackDescription_IDX]), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiReadbackResult_IDX]), (pyArgs[1])))) {
        overloadId = 0; // readBackTexture(QRhiReadbackDescription,QRhiReadbackResult*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "readBackTexture", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return {};
        ::QRhiReadbackDescription cppArg0_local;
        ::QRhiReadbackDescription *cppArg0 = &cppArg0_local;
        if (pythonToCpp[0].isValue())
            pythonToCpp[0](pyArgs[0], &cppArg0_local);
        else
            pythonToCpp[0](pyArgs[0], &cppArg0);

        if (!Shiboken::Object::isValid(pyArgs[1]))
            return {};
        ::QRhiReadbackResult *cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // readBackTexture(QRhiReadbackDescription,QRhiReadbackResult*)
            cppSelf->readBackTexture(*cppArg0, cppArg1);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiResourceUpdateBatchFunc_release(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiResourceUpdateBatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // release()
        cppSelf->release();
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiResourceUpdateBatchFunc_updateDynamicBuffer(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiResourceUpdateBatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[4];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "updateDynamicBuffer", 4, 4, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2]), &(pyArgs[3])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QRhiResourceUpdateBatch::updateDynamicBuffer(QRhiBuffer*,quint32,quint32,const void*)
    if (numArgs == 4
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiBuffer_IDX]), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArgs[2])))
        && (pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<void *>(), (pyArgs[3])))) {
        overloadId = 0; // updateDynamicBuffer(QRhiBuffer*,quint32,quint32,const void*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "updateDynamicBuffer", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return {};
        ::QRhiBuffer *cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        quint32 cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);
        quint32 cppArg2;
        pythonToCpp[2](pyArgs[2], &cppArg2);
        void* cppArg3;
        pythonToCpp[3](pyArgs[3], &cppArg3);

        if (Shiboken::Errors::occurred() == nullptr) {
            // updateDynamicBuffer(QRhiBuffer*,quint32,quint32,const void*)
            cppSelf->updateDynamicBuffer(cppArg0, cppArg1, cppArg2, cppArg3);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiResourceUpdateBatchFunc_uploadStaticBuffer(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiResourceUpdateBatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[4];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr, nullptr};

    // invalid argument lengths
    if (numArgs == 3)
        return Shiboken::returnWrongArguments(args, "uploadStaticBuffer", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]);

    if (PyArg_UnpackTuple(args, "uploadStaticBuffer", 2, 4, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2]), &(pyArgs[3])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QRhiResourceUpdateBatch::uploadStaticBuffer(QRhiBuffer*,const void*)
    // 1: QRhiResourceUpdateBatch::uploadStaticBuffer(QRhiBuffer*,quint32,quint32,const void*)
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiBuffer_IDX]), (pyArgs[0])))) {
        if (numArgs == 4
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArgs[1])))
            && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArgs[2])))
            && (pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<void *>(), (pyArgs[3])))) {
            overloadId = 1; // uploadStaticBuffer(QRhiBuffer*,quint32,quint32,const void*)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<void *>(), (pyArgs[1])))) {
            overloadId = 0; // uploadStaticBuffer(QRhiBuffer*,const void*)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "uploadStaticBuffer", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]);

    // Call function/method
    switch (overloadId) {
        case 0: // uploadStaticBuffer(QRhiBuffer *buf, const void *data)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QRhiBuffer *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            void* cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // uploadStaticBuffer(QRhiBuffer*,const void*)
                cppSelf->uploadStaticBuffer(cppArg0, cppArg1);
            }
            break;
        }
        case 1: // uploadStaticBuffer(QRhiBuffer *buf, quint32 offset, quint32 size, const void *data)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QRhiBuffer *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            quint32 cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            quint32 cppArg2;
            pythonToCpp[2](pyArgs[2], &cppArg2);
            void* cppArg3;
            pythonToCpp[3](pyArgs[3], &cppArg3);

            if (Shiboken::Errors::occurred() == nullptr) {
                // uploadStaticBuffer(QRhiBuffer*,quint32,quint32,const void*)
                cppSelf->uploadStaticBuffer(cppArg0, cppArg1, cppArg2, cppArg3);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiResourceUpdateBatchFunc_uploadTexture(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiResourceUpdateBatch *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "uploadTexture", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QRhiResourceUpdateBatch::uploadTexture(QRhiTexture*,QImage)
    // 1: QRhiResourceUpdateBatch::uploadTexture(QRhiTexture*,QRhiTextureUploadDescription)
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTexture_IDX]), (pyArgs[0])))) {
        if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]), (pyArgs[1])))) {
            overloadId = 1; // uploadTexture(QRhiTexture*,QRhiTextureUploadDescription)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QImage_IDX]), (pyArgs[1])))) {
            overloadId = 0; // uploadTexture(QRhiTexture*,QImage)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "uploadTexture", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]);

    // Call function/method
    switch (overloadId) {
        case 0: // uploadTexture(QRhiTexture *tex, const QImage &image)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QRhiTexture *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QImage cppArg1_local;
            ::QImage *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (Shiboken::Errors::occurred() == nullptr) {
                // uploadTexture(QRhiTexture*,QImage)
                cppSelf->uploadTexture(cppArg0, *cppArg1);
            }
            break;
        }
        case 1: // uploadTexture(QRhiTexture *tex, const QRhiTextureUploadDescription &desc)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QRhiTexture *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QRhiTextureUploadDescription cppArg1_local;
            ::QRhiTextureUploadDescription *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (Shiboken::Errors::occurred() == nullptr) {
                // uploadTexture(QRhiTexture*,QRhiTextureUploadDescription)
                cppSelf->uploadTexture(cppArg0, *cppArg1);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}


static const char *Sbk_QRhiResourceUpdateBatch_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiResourceUpdateBatch_methods[] = {
    {"copyTexture", reinterpret_cast<PyCFunction>(Sbk_QRhiResourceUpdateBatchFunc_copyTexture), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"generateMips", reinterpret_cast<PyCFunction>(Sbk_QRhiResourceUpdateBatchFunc_generateMips), METH_O, nullptr},
    {"hasOptimalCapacity", reinterpret_cast<PyCFunction>(Sbk_QRhiResourceUpdateBatchFunc_hasOptimalCapacity), METH_NOARGS, nullptr},
    {"merge", reinterpret_cast<PyCFunction>(Sbk_QRhiResourceUpdateBatchFunc_merge), METH_O, nullptr},
    {"readBackBuffer", reinterpret_cast<PyCFunction>(Sbk_QRhiResourceUpdateBatchFunc_readBackBuffer), METH_VARARGS, nullptr},
    {"readBackTexture", reinterpret_cast<PyCFunction>(Sbk_QRhiResourceUpdateBatchFunc_readBackTexture), METH_VARARGS, nullptr},
    {"release", reinterpret_cast<PyCFunction>(Sbk_QRhiResourceUpdateBatchFunc_release), METH_NOARGS, nullptr},
    {"updateDynamicBuffer", reinterpret_cast<PyCFunction>(Sbk_QRhiResourceUpdateBatchFunc_updateDynamicBuffer), METH_VARARGS, nullptr},
    {"uploadStaticBuffer", reinterpret_cast<PyCFunction>(Sbk_QRhiResourceUpdateBatchFunc_uploadStaticBuffer), METH_VARARGS, nullptr},
    {"uploadTexture", reinterpret_cast<PyCFunction>(Sbk_QRhiResourceUpdateBatchFunc_uploadTexture), METH_VARARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRhiResourceUpdateBatch_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiResourceUpdateBatch_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiResourceUpdateBatch_Type = nullptr;
static PyTypeObject *Sbk_QRhiResourceUpdateBatch_TypeF(void)
{
    return _Sbk_QRhiResourceUpdateBatch_Type;
}

static PyType_Slot Sbk_QRhiResourceUpdateBatch_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiResourceUpdateBatch_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiResourceUpdateBatch_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiResourceUpdateBatch_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiResourceUpdateBatch_spec = {
    "2:PySide6.QtGui.QRhiResourceUpdateBatch",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiResourceUpdateBatch_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRhiResourceUpdateBatch_PythonToCpp_QRhiResourceUpdateBatch_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiResourceUpdateBatch_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRhiResourceUpdateBatch_PythonToCpp_QRhiResourceUpdateBatch_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiResourceUpdateBatch_TypeF()))
        return QRhiResourceUpdateBatch_PythonToCpp_QRhiResourceUpdateBatch_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRhiResourceUpdateBatch_PTR_CppToPython_QRhiResourceUpdateBatch(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QRhiResourceUpdateBatch_TypeF(), const_cast<void *>(cppIn), false);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QRhiResourceUpdateBatch_SignatureStrings[] = {
    "PySide6.QtGui.QRhiResourceUpdateBatch.copyTexture(self,dst:PySide6.QtGui.QRhiTexture,src:PySide6.QtGui.QRhiTexture,desc:PySide6.QtGui.QRhiTextureCopyDescription=QRhiTextureCopyDescription())",
    "PySide6.QtGui.QRhiResourceUpdateBatch.generateMips(self,tex:PySide6.QtGui.QRhiTexture)",
    "PySide6.QtGui.QRhiResourceUpdateBatch.hasOptimalCapacity(self)->bool",
    "PySide6.QtGui.QRhiResourceUpdateBatch.merge(self,other:PySide6.QtGui.QRhiResourceUpdateBatch)",
    "PySide6.QtGui.QRhiResourceUpdateBatch.readBackBuffer(self,buf:PySide6.QtGui.QRhiBuffer,offset:quint32,size:quint32,result:PySide6.QtGui.QRhiReadbackResult)",
    "PySide6.QtGui.QRhiResourceUpdateBatch.readBackTexture(self,rb:typing.Union[PySide6.QtGui.QRhiReadbackDescription, PySide6.QtGui.QRhiTexture],result:PySide6.QtGui.QRhiReadbackResult)",
    "PySide6.QtGui.QRhiResourceUpdateBatch.release(self)",
    "PySide6.QtGui.QRhiResourceUpdateBatch.updateDynamicBuffer(self,buf:PySide6.QtGui.QRhiBuffer,offset:quint32,size:quint32,data:void)",
    "1:PySide6.QtGui.QRhiResourceUpdateBatch.uploadStaticBuffer(self,buf:PySide6.QtGui.QRhiBuffer,data:void)",
    "0:PySide6.QtGui.QRhiResourceUpdateBatch.uploadStaticBuffer(self,buf:PySide6.QtGui.QRhiBuffer,offset:quint32,size:quint32,data:void)",
    "1:PySide6.QtGui.QRhiResourceUpdateBatch.uploadTexture(self,tex:PySide6.QtGui.QRhiTexture,image:PySide6.QtGui.QImage)",
    "0:PySide6.QtGui.QRhiResourceUpdateBatch.uploadTexture(self,tex:PySide6.QtGui.QRhiTexture,desc:typing.Union[PySide6.QtGui.QRhiTextureUploadDescription, PySide6.QtGui.QRhiTextureUploadEntry])",
    nullptr}; // Sentinel
#else
static constexpr size_t QRhiResourceUpdateBatch_SignatureByteSize = 339;
static constexpr uint8_t QRhiResourceUpdateBatch_SignatureBytes[339] = {
    0x78, 0xda, 0xb5, 0x94, 0x4d, 0x4f, 0xc3, 0x30, 0x0c, 0x86, 0xef, 0xfb, 0x15, 0x1c, 0x57, 0xa9,
    0x54, 0x7c, 0x48, 0x1c, 0x2a, 0xc1, 0x61, 0x1b, 0x42, 0x1c, 0x10, 0xfb, 0x60, 0x27, 0xb4, 0x83,
    0x9b, 0xb8, 0x6d, 0x44, 0x97, 0x94, 0xc4, 0x41, 0x2b, 0xbf, 0x9e, 0xd0, 0x4e, 0x68, 0x83, 0xb5,
    0xa4, 0xd2, 0x76, 0x4b, 0xe2, 0xd7, 0x7e, 0x9f, 0xd4, 0x4e, 0xa7, 0xd5, 0x42, 0x70, 0xbc, 0x89,
    0x66, 0xf4, 0x60, 0x45, 0x34, 0x9b, 0xe7, 0x62, 0x8e, 0x46, 0x59, 0xcd, 0x70, 0x59, 0x72, 0x20,
    0x1c, 0x01, 0xb1, 0x3c, 0x62, 0xaa, 0xac, 0x5e, 0x70, 0x43, 0x56, 0xe3, 0xd0, 0x60, 0x91, 0x86,
    0xdc, 0x50, 0x3c, 0xfd, 0x93, 0xba, 0x95, 0x84, 0x46, 0xb3, 0x8e, 0x28, 0x47, 0xd3, 0x11, 0x1e,
    0x3b, 0xab, 0x89, 0x53, 0x68, 0x51, 0x92, 0x50, 0xf2, 0xb6, 0x3d, 0x34, 0x0c, 0x82, 0xc1, 0xd4,
    0x0b, 0x3f, 0x43, 0x89, 0xda, 0xed, 0x9e, 0x44, 0x69, 0x1a, 0x7e, 0xc2, 0x4d, 0x3b, 0x82, 0x6f,
    0xd9, 0x1c, 0xcc, 0xb3, 0x23, 0x59, 0x43, 0x31, 0x86, 0x12, 0x98, 0xa0, 0xaa, 0x2e, 0x1e, 0x9c,
    0xdf, 0x25, 0x4a, 0x15, 0x9e, 0x45, 0xd6, 0xa8, 0xb3, 0xed, 0x47, 0x55, 0x94, 0xa3, 0x8e, 0xbd,
    0xd2, 0x7c, 0x11, 0x35, 0x02, 0x1f, 0x01, 0x7b, 0x1b, 0xd9, 0x34, 0x45, 0xdd, 0xd8, 0x24, 0x36,
    0x3d, 0x60, 0xd2, 0x28, 0x42, 0x95, 0xa6, 0x06, 0x29, 0x7e, 0xb7, 0x42, 0xd2, 0xf5, 0x55, 0x68,
    0xc4, 0x27, 0xfe, 0x6c, 0x34, 0x1a, 0x5b, 0xd0, 0x41, 0x40, 0xe0, 0x89, 0x73, 0x99, 0xd7, 0x82,
    0xbe, 0x6c, 0x7b, 0x83, 0xa5, 0x93, 0x98, 0xaa, 0x52, 0xc8, 0x2c, 0x5a, 0x4a, 0xd7, 0xe3, 0xd7,
    0x76, 0xb3, 0x9d, 0x49, 0x08, 0xcf, 0x5a, 0x7b, 0xb9, 0x3a, 0x3e, 0x75, 0x81, 0x60, 0x1a, 0x5a,
    0xdf, 0x1c, 0x5b, 0xaf, 0x27, 0x95, 0x84, 0xb5, 0x60, 0x47, 0x69, 0x85, 0xab, 0x07, 0xf1, 0x87,
    0x12, 0x3c, 0x18, 0x5c, 0xc6, 0xbe, 0x10, 0x85, 0x02, 0xbe, 0x20, 0xa0, 0x1e, 0x0c, 0x3b, 0x3e,
    0x17, 0xa7, 0xf4, 0x39, 0xc9, 0x5d, 0xf7, 0x06, 0xab, 0xf3, 0xc5, 0x87, 0xee, 0x11, 0x67, 0xf8,
    0x3b, 0xfe, 0xf8, 0x7d, 0xd8, 0xf7, 0xe2, 0x3d, 0x4c, 0xeb, 0x1f, 0xe1, 0x3f, 0xd3, 0xbe, 0xd5,
    0x2e, 0xeb, 0xda, 0x7e, 0x23, 0xdf, 0x68, 0xef, 0x25, 0xe9, 0x6a, 0x15, 0x0c, 0xbe, 0x00, 0x9b,
    0xa6, 0x26, 0x8d
};
#endif

PyTypeObject *init_QRhiResourceUpdateBatch(PyObject *module)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX].type;

    Shiboken::AutoDecRef Sbk_QRhiResourceUpdateBatch_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QRhiResourceUpdateBatch_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRhiResourceUpdateBatch",
        "QRhiResourceUpdateBatch*",
        &Sbk_QRhiResourceUpdateBatch_spec,
        &Shiboken::callCppDestructor< ::QRhiResourceUpdateBatch >,
        Sbk_QRhiResourceUpdateBatch_Type_bases.object(),
        0);
    auto *pyType = Sbk_QRhiResourceUpdateBatch_TypeF(); // references _Sbk_QRhiResourceUpdateBatch_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QRhiResourceUpdateBatch_SignatureStrings);
#else
    InitSignatureBytes(pyType, QRhiResourceUpdateBatch_SignatureBytes, QRhiResourceUpdateBatch_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiResourceUpdateBatch_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRhiResourceUpdateBatch_PythonToCpp_QRhiResourceUpdateBatch_PTR,
        is_QRhiResourceUpdateBatch_PythonToCpp_QRhiResourceUpdateBatch_PTR_Convertible,
        QRhiResourceUpdateBatch_PTR_CppToPython_QRhiResourceUpdateBatch);

    Shiboken::Conversions::registerConverterName(converter, "QRhiResourceUpdateBatch");
    Shiboken::Conversions::registerConverterName(converter, "QRhiResourceUpdateBatch*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiResourceUpdateBatch&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiResourceUpdateBatch).name());

    qRegisterMetaType< ::QRhiResourceUpdateBatch *>();

    return pyType;
}
