// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRhiSamplerWrapper_H
#define SBK_QRhiSamplerWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

class QRhiSamplerWrapper : public QRhiSampler
{
public:
    QRhiSamplerWrapper(const QRhiSamplerWrapper &) = delete;
    QRhiSamplerWrapper& operator=(const QRhiSamplerWrapper &) = delete;
    QRhiSamplerWrapper(QRhiSamplerWrapper &&) = delete;
    QRhiSamplerWrapper& operator=(QRhiSamplerWrapper &&) = delete;

    bool create() override;
    void destroy() override;
    ::QRhiResource::Type resourceType() const override;
    ~QRhiSamplerWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QRhiSamplerWrapper_H

