// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhishaderresourcebinding_data_storagebufferdata_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiShaderResourceBinding::Data::StorageBufferData >()))
        return -1;

    ::QRhiShaderResourceBinding::Data::StorageBufferData *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "StorageBufferData", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: StorageBufferData::StorageBufferData()
    // 1: StorageBufferData::StorageBufferData(QRhiShaderResourceBinding::Data::StorageBufferData)
    if (numArgs == 0) {
        overloadId = 0; // StorageBufferData()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageBufferData_IDX]), (pyArgs[0])))) {
        overloadId = 1; // StorageBufferData(QRhiShaderResourceBinding::Data::StorageBufferData)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageBufferData_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageBufferData_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // StorageBufferData()
        {

            // StorageBufferData()
            cptr = new ::QRhiShaderResourceBinding::Data::StorageBufferData();
            break;
        }
        case 1: // StorageBufferData(const QRhiShaderResourceBinding::Data::StorageBufferData &StorageBufferData)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiShaderResourceBinding::Data::StorageBufferData cppArg0_local;
            ::QRhiShaderResourceBinding::Data::StorageBufferData *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // StorageBufferData(QRhiShaderResourceBinding::Data::StorageBufferData)
                cptr = new ::QRhiShaderResourceBinding::Data::StorageBufferData(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiShaderResourceBinding::Data::StorageBufferData >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageBufferData_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiShaderResourceBinding_Data_StorageBufferData__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiShaderResourceBinding::Data::StorageBufferData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageBufferData_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageBufferData_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiShaderResourceBinding_Data_StorageBufferData__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_get_buf(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiShaderResourceBinding::Data::StorageBufferData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageBufferData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiBuffer_IDX]), cppSelf->buf);
    return pyOut;
}
static int Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_set_buf(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiShaderResourceBinding::Data::StorageBufferData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageBufferData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("buf");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiBuffer_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("buf", "QRhiBuffer");
        return -1;
    }

    auto *&cppOut_ptr = cppSelf->buf;
    pythonToCpp(pyIn, &cppOut_ptr);

    Shiboken::Object::keepReference(reinterpret_cast<SbkObject *>(self), "buf", pyIn);
    return 0;
}

static PyObject *Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_get_offset(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiShaderResourceBinding::Data::StorageBufferData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageBufferData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    quint32 cppOut_local = cppSelf->offset;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_set_offset(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiShaderResourceBinding::Data::StorageBufferData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageBufferData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("offset");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("offset", "quint32");
        return -1;
    }

    auto cppOut_local = cppSelf->offset;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->offset = cppOut_local;

    return 0;
}

static PyObject *Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_get_maybeSize(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiShaderResourceBinding::Data::StorageBufferData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageBufferData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    quint32 cppOut_local = cppSelf->maybeSize;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_set_maybeSize(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiShaderResourceBinding::Data::StorageBufferData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageBufferData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("maybeSize");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("maybeSize", "quint32");
        return -1;
    }

    auto cppOut_local = cppSelf->maybeSize;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->maybeSize = cppOut_local;

    return 0;
}

// Getters and Setters for StorageBufferData
static PyGetSetDef Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_getsetlist[] = {
    {const_cast<char *>("buf"), Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_get_buf, Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_set_buf, nullptr, nullptr},
    {const_cast<char *>("offset"), Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_get_offset, Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_set_offset, nullptr, nullptr},
    {const_cast<char *>("maybeSize"), Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_get_maybeSize, Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_set_maybeSize, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_Type = nullptr;
static PyTypeObject *Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_TypeF(void)
{
    return _Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_Type;
}

static PyType_Slot Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_spec = {
    "2:PySide6.QtGui.QRhiShaderResourceBinding.Data.StorageBufferData",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void StorageBufferData_PythonToCpp_StorageBufferData_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_StorageBufferData_PythonToCpp_StorageBufferData_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_TypeF()))
        return StorageBufferData_PythonToCpp_StorageBufferData_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *StorageBufferData_PTR_CppToPython_StorageBufferData(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *StorageBufferData_COPY_CppToPython_StorageBufferData(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiShaderResourceBinding::Data::StorageBufferData *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_TypeF(), new ::QRhiShaderResourceBinding::Data::StorageBufferData(*source), true, true);
}

// Python to C++ copy conversion.
static void StorageBufferData_PythonToCpp_StorageBufferData_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiShaderResourceBinding::Data::StorageBufferData *>(cppOut) = *reinterpret_cast< ::QRhiShaderResourceBinding::Data::StorageBufferData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageBufferData_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_StorageBufferData_PythonToCpp_StorageBufferData_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_TypeF()))
        return StorageBufferData_PythonToCpp_StorageBufferData_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QRhiShaderResourceBinding_Data_StorageBufferData_SignatureStrings[] = {
    "1:PySide6.QtGui.QRhiShaderResourceBinding.Data.StorageBufferData(self)",
    "0:PySide6.QtGui.QRhiShaderResourceBinding.Data.StorageBufferData(self,StorageBufferData:PySide6.QtGui.QRhiShaderResourceBinding.Data.StorageBufferData)",
    "PySide6.QtGui.QRhiShaderResourceBinding.Data.StorageBufferData.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QRhiShaderResourceBinding_Data_StorageBufferData_SignatureByteSize = 112;
static constexpr uint8_t QRhiShaderResourceBinding_Data_StorageBufferData_SignatureBytes[112] = {
    0x78, 0xda, 0x33, 0xb4, 0x0a, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x71, 0x2f,
    0xcd, 0xd4, 0x0b, 0x0c, 0xca, 0xc8, 0x0c, 0xce, 0x48, 0x4c, 0x49, 0x2d, 0x0a, 0x4a, 0x2d, 0xce,
    0x2f, 0x2d, 0x4a, 0x4e, 0x75, 0xca, 0xcc, 0x4b, 0xc9, 0xcc, 0x4b, 0xd7, 0x73, 0x49, 0x2c, 0x49,
    0xd4, 0x0b, 0x2e, 0xc9, 0x2f, 0x4a, 0x4c, 0x4f, 0x75, 0x2a, 0x4d, 0x4b, 0x4b, 0x2d, 0x02, 0x89,
    0x68, 0x14, 0xa7, 0xe6, 0xa4, 0x69, 0x72, 0x19, 0x50, 0xc3, 0x18, 0x1d, 0x0c, 0x61, 0x0a, 0x4d,
    0xd5, 0xe4, 0xa2, 0x4c, 0xbf, 0x5e, 0x7c, 0x7c, 0x72, 0x7e, 0x41, 0x65, 0x7c, 0x3c, 0xc4, 0x97,
    0xba, 0x76, 0x25, 0x95, 0x05, 0x20, 0xd5, 0xc1, 0x40, 0x1e, 0x17, 0x00, 0x3b, 0x72, 0x72, 0x73
};
#endif

PyTypeObject *init_QRhiShaderResourceBinding_Data_StorageBufferData(PyObject *enclosingClass)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageBufferData_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageBufferData_IDX].type;

    Shiboken::AutoDecRef Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "StorageBufferData",
        "QRhiShaderResourceBinding::Data::StorageBufferData",
        &Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_spec,
        &Shiboken::callCppDestructor< ::QRhiShaderResourceBinding::Data::StorageBufferData >,
        Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_TypeF(); // references _Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QRhiShaderResourceBinding_Data_StorageBufferData_SignatureStrings);
#else
    InitSignatureBytes(pyType, QRhiShaderResourceBinding_Data_StorageBufferData_SignatureBytes, QRhiShaderResourceBinding_Data_StorageBufferData_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiShaderResourceBinding_Data_StorageBufferData_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageBufferData_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        StorageBufferData_PythonToCpp_StorageBufferData_PTR,
        is_StorageBufferData_PythonToCpp_StorageBufferData_PTR_Convertible,
        StorageBufferData_PTR_CppToPython_StorageBufferData,
        StorageBufferData_COPY_CppToPython_StorageBufferData);

    Shiboken::Conversions::registerConverterName(converter, "QRhiShaderResourceBinding::Data::StorageBufferData");
    Shiboken::Conversions::registerConverterName(converter, "QRhiShaderResourceBinding::Data::StorageBufferData*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiShaderResourceBinding::Data::StorageBufferData&");
    Shiboken::Conversions::registerConverterAlias(converter, "Data::StorageBufferData");
    Shiboken::Conversions::registerConverterAlias(converter, "Data::StorageBufferData*");
    Shiboken::Conversions::registerConverterAlias(converter, "Data::StorageBufferData&");
    Shiboken::Conversions::registerConverterAlias(converter, "StorageBufferData");
    Shiboken::Conversions::registerConverterAlias(converter, "StorageBufferData*");
    Shiboken::Conversions::registerConverterAlias(converter, "StorageBufferData&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiShaderResourceBinding::Data::StorageBufferData).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        StorageBufferData_PythonToCpp_StorageBufferData_COPY,
        is_StorageBufferData_PythonToCpp_StorageBufferData_COPY_Convertible);

    qRegisterMetaType< ::QRhiShaderResourceBinding::Data::StorageBufferData >("StorageBufferData");
    qRegisterMetaType< ::QRhiShaderResourceBinding::Data::StorageBufferData >("Data::StorageBufferData");
    qRegisterMetaType< ::QRhiShaderResourceBinding::Data::StorageBufferData >("QRhiShaderResourceBinding::Data::StorageBufferData");

    return pyType;
}
