// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhishaderresourcebinding_data_storageimagedata_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiShaderResourceBinding_Data_StorageImageData_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiShaderResourceBinding::Data::StorageImageData >()))
        return -1;

    ::QRhiShaderResourceBinding::Data::StorageImageData *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "StorageImageData", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: StorageImageData::StorageImageData()
    // 1: StorageImageData::StorageImageData(QRhiShaderResourceBinding::Data::StorageImageData)
    if (numArgs == 0) {
        overloadId = 0; // StorageImageData()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageImageData_IDX]), (pyArgs[0])))) {
        overloadId = 1; // StorageImageData(QRhiShaderResourceBinding::Data::StorageImageData)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageImageData_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageImageData_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // StorageImageData()
        {

            // StorageImageData()
            cptr = new ::QRhiShaderResourceBinding::Data::StorageImageData();
            break;
        }
        case 1: // StorageImageData(const QRhiShaderResourceBinding::Data::StorageImageData &StorageImageData)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiShaderResourceBinding::Data::StorageImageData cppArg0_local;
            ::QRhiShaderResourceBinding::Data::StorageImageData *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // StorageImageData(QRhiShaderResourceBinding::Data::StorageImageData)
                cptr = new ::QRhiShaderResourceBinding::Data::StorageImageData(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiShaderResourceBinding::Data::StorageImageData >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageImageData_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiShaderResourceBinding_Data_StorageImageData__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiShaderResourceBinding::Data::StorageImageData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageImageData_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageImageData_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiShaderResourceBinding_Data_StorageImageData_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiShaderResourceBinding_Data_StorageImageData_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiShaderResourceBinding_Data_StorageImageData__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QRhiShaderResourceBinding_Data_StorageImageData_get_tex(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiShaderResourceBinding::Data::StorageImageData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageImageData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTexture_IDX]), cppSelf->tex);
    return pyOut;
}
static int Sbk_QRhiShaderResourceBinding_Data_StorageImageData_set_tex(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiShaderResourceBinding::Data::StorageImageData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageImageData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("tex");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTexture_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("tex", "QRhiTexture");
        return -1;
    }

    auto *&cppOut_ptr = cppSelf->tex;
    pythonToCpp(pyIn, &cppOut_ptr);

    Shiboken::Object::keepReference(reinterpret_cast<SbkObject *>(self), "tex", pyIn);
    return 0;
}

static PyObject *Sbk_QRhiShaderResourceBinding_Data_StorageImageData_get_level(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiShaderResourceBinding::Data::StorageImageData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageImageData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->level;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QRhiShaderResourceBinding_Data_StorageImageData_set_level(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiShaderResourceBinding::Data::StorageImageData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageImageData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("level");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("level", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->level;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->level = cppOut_local;

    return 0;
}

// Getters and Setters for StorageImageData
static PyGetSetDef Sbk_QRhiShaderResourceBinding_Data_StorageImageData_getsetlist[] = {
    {const_cast<char *>("tex"), Sbk_QRhiShaderResourceBinding_Data_StorageImageData_get_tex, Sbk_QRhiShaderResourceBinding_Data_StorageImageData_set_tex, nullptr, nullptr},
    {const_cast<char *>("level"), Sbk_QRhiShaderResourceBinding_Data_StorageImageData_get_level, Sbk_QRhiShaderResourceBinding_Data_StorageImageData_set_level, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRhiShaderResourceBinding_Data_StorageImageData_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiShaderResourceBinding_Data_StorageImageData_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiShaderResourceBinding_Data_StorageImageData_Type = nullptr;
static PyTypeObject *Sbk_QRhiShaderResourceBinding_Data_StorageImageData_TypeF(void)
{
    return _Sbk_QRhiShaderResourceBinding_Data_StorageImageData_Type;
}

static PyType_Slot Sbk_QRhiShaderResourceBinding_Data_StorageImageData_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiShaderResourceBinding_Data_StorageImageData_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiShaderResourceBinding_Data_StorageImageData_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiShaderResourceBinding_Data_StorageImageData_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QRhiShaderResourceBinding_Data_StorageImageData_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiShaderResourceBinding_Data_StorageImageData_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiShaderResourceBinding_Data_StorageImageData_spec = {
    "2:PySide6.QtGui.QRhiShaderResourceBinding.Data.StorageImageData",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiShaderResourceBinding_Data_StorageImageData_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void StorageImageData_PythonToCpp_StorageImageData_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiShaderResourceBinding_Data_StorageImageData_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_StorageImageData_PythonToCpp_StorageImageData_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiShaderResourceBinding_Data_StorageImageData_TypeF()))
        return StorageImageData_PythonToCpp_StorageImageData_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *StorageImageData_PTR_CppToPython_StorageImageData(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QRhiShaderResourceBinding_Data_StorageImageData_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *StorageImageData_COPY_CppToPython_StorageImageData(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiShaderResourceBinding::Data::StorageImageData *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiShaderResourceBinding_Data_StorageImageData_TypeF(), new ::QRhiShaderResourceBinding::Data::StorageImageData(*source), true, true);
}

// Python to C++ copy conversion.
static void StorageImageData_PythonToCpp_StorageImageData_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiShaderResourceBinding::Data::StorageImageData *>(cppOut) = *reinterpret_cast< ::QRhiShaderResourceBinding::Data::StorageImageData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageImageData_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_StorageImageData_PythonToCpp_StorageImageData_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiShaderResourceBinding_Data_StorageImageData_TypeF()))
        return StorageImageData_PythonToCpp_StorageImageData_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QRhiShaderResourceBinding_Data_StorageImageData_SignatureStrings[] = {
    "1:PySide6.QtGui.QRhiShaderResourceBinding.Data.StorageImageData(self)",
    "0:PySide6.QtGui.QRhiShaderResourceBinding.Data.StorageImageData(self,StorageImageData:PySide6.QtGui.QRhiShaderResourceBinding.Data.StorageImageData)",
    "PySide6.QtGui.QRhiShaderResourceBinding.Data.StorageImageData.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QRhiShaderResourceBinding_Data_StorageImageData_SignatureByteSize = 110;
static constexpr uint8_t QRhiShaderResourceBinding_Data_StorageImageData_SignatureBytes[110] = {
    0x78, 0xda, 0x33, 0xb4, 0x0a, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x71, 0x2f,
    0xcd, 0xd4, 0x0b, 0x0c, 0xca, 0xc8, 0x0c, 0xce, 0x48, 0x4c, 0x49, 0x2d, 0x0a, 0x4a, 0x2d, 0xce,
    0x2f, 0x2d, 0x4a, 0x4e, 0x75, 0xca, 0xcc, 0x4b, 0xc9, 0xcc, 0x4b, 0xd7, 0x73, 0x49, 0x2c, 0x49,
    0xd4, 0x0b, 0x2e, 0xc9, 0x2f, 0x4a, 0x4c, 0x4f, 0xf5, 0xcc, 0x05, 0x12, 0x20, 0x01, 0x8d, 0xe2,
    0xd4, 0x9c, 0x34, 0x4d, 0x2e, 0x03, 0x2a, 0x98, 0xa2, 0x83, 0x2e, 0x4a, 0x99, 0x99, 0x9a, 0x5c,
    0x14, 0x69, 0xd7, 0x8b, 0x8f, 0x4f, 0xce, 0x2f, 0xa8, 0x8c, 0x8f, 0x87, 0xf8, 0x50, 0xd7, 0xae,
    0xa4, 0xb2, 0x00, 0xa4, 0x38, 0x18, 0xc8, 0xe3, 0x02, 0x00, 0xb9, 0xa2, 0x70, 0x20
};
#endif

PyTypeObject *init_QRhiShaderResourceBinding_Data_StorageImageData(PyObject *enclosingClass)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageImageData_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageImageData_IDX].type;

    Shiboken::AutoDecRef Sbk_QRhiShaderResourceBinding_Data_StorageImageData_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QRhiShaderResourceBinding_Data_StorageImageData_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "StorageImageData",
        "QRhiShaderResourceBinding::Data::StorageImageData",
        &Sbk_QRhiShaderResourceBinding_Data_StorageImageData_spec,
        &Shiboken::callCppDestructor< ::QRhiShaderResourceBinding::Data::StorageImageData >,
        Sbk_QRhiShaderResourceBinding_Data_StorageImageData_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiShaderResourceBinding_Data_StorageImageData_TypeF(); // references _Sbk_QRhiShaderResourceBinding_Data_StorageImageData_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QRhiShaderResourceBinding_Data_StorageImageData_SignatureStrings);
#else
    InitSignatureBytes(pyType, QRhiShaderResourceBinding_Data_StorageImageData_SignatureBytes, QRhiShaderResourceBinding_Data_StorageImageData_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiShaderResourceBinding_Data_StorageImageData_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_Data_StorageImageData_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        StorageImageData_PythonToCpp_StorageImageData_PTR,
        is_StorageImageData_PythonToCpp_StorageImageData_PTR_Convertible,
        StorageImageData_PTR_CppToPython_StorageImageData,
        StorageImageData_COPY_CppToPython_StorageImageData);

    Shiboken::Conversions::registerConverterName(converter, "QRhiShaderResourceBinding::Data::StorageImageData");
    Shiboken::Conversions::registerConverterName(converter, "QRhiShaderResourceBinding::Data::StorageImageData*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiShaderResourceBinding::Data::StorageImageData&");
    Shiboken::Conversions::registerConverterAlias(converter, "Data::StorageImageData");
    Shiboken::Conversions::registerConverterAlias(converter, "Data::StorageImageData*");
    Shiboken::Conversions::registerConverterAlias(converter, "Data::StorageImageData&");
    Shiboken::Conversions::registerConverterAlias(converter, "StorageImageData");
    Shiboken::Conversions::registerConverterAlias(converter, "StorageImageData*");
    Shiboken::Conversions::registerConverterAlias(converter, "StorageImageData&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiShaderResourceBinding::Data::StorageImageData).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        StorageImageData_PythonToCpp_StorageImageData_COPY,
        is_StorageImageData_PythonToCpp_StorageImageData_COPY_Convertible);

    qRegisterMetaType< ::QRhiShaderResourceBinding::Data::StorageImageData >("StorageImageData");
    qRegisterMetaType< ::QRhiShaderResourceBinding::Data::StorageImageData >("Data::StorageImageData");
    qRegisterMetaType< ::QRhiShaderResourceBinding::Data::StorageImageData >("QRhiShaderResourceBinding::Data::StorageImageData");

    return pyType;
}
