// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhishaderresourcebinding_textureandsampler_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiShaderResourceBinding_TextureAndSampler_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiShaderResourceBinding::TextureAndSampler >()))
        return -1;

    ::QRhiShaderResourceBinding::TextureAndSampler *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "TextureAndSampler", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: TextureAndSampler::TextureAndSampler()
    // 1: TextureAndSampler::TextureAndSampler(QRhiShaderResourceBinding::TextureAndSampler)
    if (numArgs == 0) {
        overloadId = 0; // TextureAndSampler()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_TextureAndSampler_IDX]), (pyArgs[0])))) {
        overloadId = 1; // TextureAndSampler(QRhiShaderResourceBinding::TextureAndSampler)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_TextureAndSampler_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_TextureAndSampler_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // TextureAndSampler()
        {

            // TextureAndSampler()
            cptr = new ::QRhiShaderResourceBinding::TextureAndSampler();
            break;
        }
        case 1: // TextureAndSampler(const QRhiShaderResourceBinding::TextureAndSampler &TextureAndSampler)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiShaderResourceBinding::TextureAndSampler cppArg0_local;
            ::QRhiShaderResourceBinding::TextureAndSampler *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // TextureAndSampler(QRhiShaderResourceBinding::TextureAndSampler)
                cptr = new ::QRhiShaderResourceBinding::TextureAndSampler(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiShaderResourceBinding::TextureAndSampler >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_TextureAndSampler_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiShaderResourceBinding_TextureAndSampler__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiShaderResourceBinding::TextureAndSampler *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_TextureAndSampler_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_TextureAndSampler_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiShaderResourceBinding_TextureAndSampler_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiShaderResourceBinding_TextureAndSampler_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiShaderResourceBinding_TextureAndSampler__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QRhiShaderResourceBinding_TextureAndSampler_get_tex(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiShaderResourceBinding::TextureAndSampler *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_TextureAndSampler_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTexture_IDX]), cppSelf->tex);
    return pyOut;
}
static int Sbk_QRhiShaderResourceBinding_TextureAndSampler_set_tex(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiShaderResourceBinding::TextureAndSampler *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_TextureAndSampler_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("tex");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTexture_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("tex", "QRhiTexture");
        return -1;
    }

    auto *&cppOut_ptr = cppSelf->tex;
    pythonToCpp(pyIn, &cppOut_ptr);

    Shiboken::Object::keepReference(reinterpret_cast<SbkObject *>(self), "tex", pyIn);
    return 0;
}

static PyObject *Sbk_QRhiShaderResourceBinding_TextureAndSampler_get_sampler(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiShaderResourceBinding::TextureAndSampler *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_TextureAndSampler_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiSampler_IDX]), cppSelf->sampler);
    return pyOut;
}
static int Sbk_QRhiShaderResourceBinding_TextureAndSampler_set_sampler(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiShaderResourceBinding::TextureAndSampler *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_TextureAndSampler_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("sampler");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiSampler_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("sampler", "QRhiSampler");
        return -1;
    }

    auto *&cppOut_ptr = cppSelf->sampler;
    pythonToCpp(pyIn, &cppOut_ptr);

    Shiboken::Object::keepReference(reinterpret_cast<SbkObject *>(self), "sampler", pyIn);
    return 0;
}

// Getters and Setters for TextureAndSampler
static PyGetSetDef Sbk_QRhiShaderResourceBinding_TextureAndSampler_getsetlist[] = {
    {const_cast<char *>("tex"), Sbk_QRhiShaderResourceBinding_TextureAndSampler_get_tex, Sbk_QRhiShaderResourceBinding_TextureAndSampler_set_tex, nullptr, nullptr},
    {const_cast<char *>("sampler"), Sbk_QRhiShaderResourceBinding_TextureAndSampler_get_sampler, Sbk_QRhiShaderResourceBinding_TextureAndSampler_set_sampler, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRhiShaderResourceBinding_TextureAndSampler_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiShaderResourceBinding_TextureAndSampler_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiShaderResourceBinding_TextureAndSampler_Type = nullptr;
static PyTypeObject *Sbk_QRhiShaderResourceBinding_TextureAndSampler_TypeF(void)
{
    return _Sbk_QRhiShaderResourceBinding_TextureAndSampler_Type;
}

static PyType_Slot Sbk_QRhiShaderResourceBinding_TextureAndSampler_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiShaderResourceBinding_TextureAndSampler_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiShaderResourceBinding_TextureAndSampler_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiShaderResourceBinding_TextureAndSampler_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QRhiShaderResourceBinding_TextureAndSampler_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiShaderResourceBinding_TextureAndSampler_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiShaderResourceBinding_TextureAndSampler_spec = {
    "2:PySide6.QtGui.QRhiShaderResourceBinding.TextureAndSampler",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiShaderResourceBinding_TextureAndSampler_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void TextureAndSampler_PythonToCpp_TextureAndSampler_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiShaderResourceBinding_TextureAndSampler_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_TextureAndSampler_PythonToCpp_TextureAndSampler_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiShaderResourceBinding_TextureAndSampler_TypeF()))
        return TextureAndSampler_PythonToCpp_TextureAndSampler_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *TextureAndSampler_PTR_CppToPython_TextureAndSampler(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QRhiShaderResourceBinding_TextureAndSampler_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *TextureAndSampler_COPY_CppToPython_TextureAndSampler(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiShaderResourceBinding::TextureAndSampler *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiShaderResourceBinding_TextureAndSampler_TypeF(), new ::QRhiShaderResourceBinding::TextureAndSampler(*source), true, true);
}

// Python to C++ copy conversion.
static void TextureAndSampler_PythonToCpp_TextureAndSampler_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiShaderResourceBinding::TextureAndSampler *>(cppOut) = *reinterpret_cast< ::QRhiShaderResourceBinding::TextureAndSampler *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_TextureAndSampler_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_TextureAndSampler_PythonToCpp_TextureAndSampler_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiShaderResourceBinding_TextureAndSampler_TypeF()))
        return TextureAndSampler_PythonToCpp_TextureAndSampler_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QRhiShaderResourceBinding_TextureAndSampler_SignatureStrings[] = {
    "1:PySide6.QtGui.QRhiShaderResourceBinding.TextureAndSampler(self)",
    "0:PySide6.QtGui.QRhiShaderResourceBinding.TextureAndSampler(self,TextureAndSampler:PySide6.QtGui.QRhiShaderResourceBinding.TextureAndSampler)",
    "PySide6.QtGui.QRhiShaderResourceBinding.TextureAndSampler.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QRhiShaderResourceBinding_TextureAndSampler_SignatureByteSize = 109;
static constexpr uint8_t QRhiShaderResourceBinding_TextureAndSampler_SignatureBytes[109] = {
    0x78, 0xda, 0x33, 0xb4, 0x0a, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x71, 0x2f,
    0xcd, 0xd4, 0x0b, 0x0c, 0xca, 0xc8, 0x0c, 0xce, 0x48, 0x4c, 0x49, 0x2d, 0x0a, 0x4a, 0x2d, 0xce,
    0x2f, 0x2d, 0x4a, 0x4e, 0x75, 0xca, 0xcc, 0x4b, 0xc9, 0xcc, 0x4b, 0xd7, 0x0b, 0x49, 0xad, 0x28,
    0x29, 0x2d, 0x4a, 0x75, 0xcc, 0x4b, 0x09, 0x4e, 0xcc, 0x2d, 0xc8, 0x49, 0x2d, 0xd2, 0x28, 0x4e,
    0xcd, 0x49, 0xd3, 0xe4, 0x32, 0xa0, 0xd0, 0x04, 0x1d, 0x0c, 0x61, 0xf2, 0x0d, 0xd4, 0xe4, 0x22,
    0x5b, 0xab, 0x5e, 0x7c, 0x7c, 0x72, 0x7e, 0x41, 0x65, 0x7c, 0x3c, 0xc4, 0x5b, 0xba, 0x76, 0x25,
    0x95, 0x05, 0x20, 0x85, 0xc1, 0x40, 0x1e, 0x17, 0x00, 0x73, 0x78, 0x6c, 0xbe
};
#endif

PyTypeObject *init_QRhiShaderResourceBinding_TextureAndSampler(PyObject *enclosingClass)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_TextureAndSampler_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_TextureAndSampler_IDX].type;

    Shiboken::AutoDecRef Sbk_QRhiShaderResourceBinding_TextureAndSampler_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QRhiShaderResourceBinding_TextureAndSampler_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "TextureAndSampler",
        "QRhiShaderResourceBinding::TextureAndSampler",
        &Sbk_QRhiShaderResourceBinding_TextureAndSampler_spec,
        &Shiboken::callCppDestructor< ::QRhiShaderResourceBinding::TextureAndSampler >,
        Sbk_QRhiShaderResourceBinding_TextureAndSampler_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiShaderResourceBinding_TextureAndSampler_TypeF(); // references _Sbk_QRhiShaderResourceBinding_TextureAndSampler_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QRhiShaderResourceBinding_TextureAndSampler_SignatureStrings);
#else
    InitSignatureBytes(pyType, QRhiShaderResourceBinding_TextureAndSampler_SignatureBytes, QRhiShaderResourceBinding_TextureAndSampler_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiShaderResourceBinding_TextureAndSampler_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiShaderResourceBinding_TextureAndSampler_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        TextureAndSampler_PythonToCpp_TextureAndSampler_PTR,
        is_TextureAndSampler_PythonToCpp_TextureAndSampler_PTR_Convertible,
        TextureAndSampler_PTR_CppToPython_TextureAndSampler,
        TextureAndSampler_COPY_CppToPython_TextureAndSampler);

    Shiboken::Conversions::registerConverterName(converter, "QRhiShaderResourceBinding::TextureAndSampler");
    Shiboken::Conversions::registerConverterName(converter, "QRhiShaderResourceBinding::TextureAndSampler*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiShaderResourceBinding::TextureAndSampler&");
    Shiboken::Conversions::registerConverterAlias(converter, "TextureAndSampler");
    Shiboken::Conversions::registerConverterAlias(converter, "TextureAndSampler*");
    Shiboken::Conversions::registerConverterAlias(converter, "TextureAndSampler&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiShaderResourceBinding::TextureAndSampler).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        TextureAndSampler_PythonToCpp_TextureAndSampler_COPY,
        is_TextureAndSampler_PythonToCpp_TextureAndSampler_COPY_Convertible);

    qRegisterMetaType< ::QRhiShaderResourceBinding::TextureAndSampler >("TextureAndSampler");
    qRegisterMetaType< ::QRhiShaderResourceBinding::TextureAndSampler >("QRhiShaderResourceBinding::TextureAndSampler");

    return pyType;
}
