// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRhiShaderResourceBindingsWrapper_H
#define SBK_QRhiShaderResourceBindingsWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

class QRhiShaderResourceBindingsWrapper : public QRhiShaderResourceBindings
{
public:
    QRhiShaderResourceBindingsWrapper(const QRhiShaderResourceBindingsWrapper &) = delete;
    QRhiShaderResourceBindingsWrapper& operator=(const QRhiShaderResourceBindingsWrapper &) = delete;
    QRhiShaderResourceBindingsWrapper(QRhiShaderResourceBindingsWrapper &&) = delete;
    QRhiShaderResourceBindingsWrapper& operator=(QRhiShaderResourceBindingsWrapper &&) = delete;

    bool create() override;
    void destroy() override;
    ::QRhiResource::Type resourceType() const override;
    void updateResources(::QFlags<QRhiShaderResourceBindings::UpdateFlag> flags = {}) override;
    ~QRhiShaderResourceBindingsWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[4] = {false, false, false, false};
};

#endif // SBK_QRhiShaderResourceBindingsWrapper_H

