// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRhiTextureWrapper_H
#define SBK_QRhiTextureWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

class QRhiTextureWrapper : public QRhiTexture
{
public:
    QRhiTextureWrapper(const QRhiTextureWrapper &) = delete;
    QRhiTextureWrapper& operator=(const QRhiTextureWrapper &) = delete;
    QRhiTextureWrapper(QRhiTextureWrapper &&) = delete;
    QRhiTextureWrapper& operator=(QRhiTextureWrapper &&) = delete;

    bool create() override;
    void destroy() override;
    ::QRhiResource::Type resourceType() const override;
    void setNativeLayout(int layout) override;
    ~QRhiTextureWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[4] = {false, false, false, false};
};

#endif // SBK_QRhiTextureWrapper_H

