// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhitexturecopydescription_wrapper.h"

// Argument includes
#include <qpoint.h>
#include <qsize.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiTextureCopyDescription_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiTextureCopyDescription >()))
        return -1;

    ::QRhiTextureCopyDescription *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QRhiTextureCopyDescription", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRhiTextureCopyDescription::QRhiTextureCopyDescription()
    // 1: QRhiTextureCopyDescription::QRhiTextureCopyDescription(QRhiTextureCopyDescription)
    if (numArgs == 0) {
        overloadId = 0; // QRhiTextureCopyDescription()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QRhiTextureCopyDescription(QRhiTextureCopyDescription)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRhiTextureCopyDescription()
        {

            // QRhiTextureCopyDescription()
            cptr = new ::QRhiTextureCopyDescription();
            break;
        }
        case 1: // QRhiTextureCopyDescription(const QRhiTextureCopyDescription &QRhiTextureCopyDescription)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiTextureCopyDescription cppArg0_local;
            ::QRhiTextureCopyDescription *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureCopyDescription(QRhiTextureCopyDescription)
                cptr = new ::QRhiTextureCopyDescription(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiTextureCopyDescription >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiTextureCopyDescriptionFunc_destinationLayer(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureCopyDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // destinationLayer()const
        int cppResult = const_cast<const ::QRhiTextureCopyDescription *>(cppSelf)->destinationLayer();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureCopyDescriptionFunc_destinationLevel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureCopyDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // destinationLevel()const
        int cppResult = const_cast<const ::QRhiTextureCopyDescription *>(cppSelf)->destinationLevel();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureCopyDescriptionFunc_destinationTopLeft(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureCopyDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // destinationTopLeft()const
        QPoint cppResult = const_cast<const ::QRhiTextureCopyDescription *>(cppSelf)->destinationTopLeft();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QPoint_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureCopyDescriptionFunc_pixelSize(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureCopyDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // pixelSize()const
        QSize cppResult = const_cast<const ::QRhiTextureCopyDescription *>(cppSelf)->pixelSize();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureCopyDescriptionFunc_setDestinationLayer(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureCopyDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureCopyDescription::setDestinationLayer(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setDestinationLayer(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setDestinationLayer", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setDestinationLayer(int)
            cppSelf->setDestinationLayer(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureCopyDescriptionFunc_setDestinationLevel(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureCopyDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureCopyDescription::setDestinationLevel(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setDestinationLevel(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setDestinationLevel", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setDestinationLevel(int)
            cppSelf->setDestinationLevel(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureCopyDescriptionFunc_setDestinationTopLeft(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureCopyDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureCopyDescription::setDestinationTopLeft(QPoint)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QPoint_IDX]), (pyArg)))) {
        overloadId = 0; // setDestinationTopLeft(QPoint)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setDestinationTopLeft", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QPoint cppArg0_local;
        ::QPoint *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setDestinationTopLeft(QPoint)
            cppSelf->setDestinationTopLeft(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureCopyDescriptionFunc_setPixelSize(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureCopyDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureCopyDescription::setPixelSize(QSize)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX]), (pyArg)))) {
        overloadId = 0; // setPixelSize(QSize)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setPixelSize", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QSize cppArg0_local;
        ::QSize *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setPixelSize(QSize)
            cppSelf->setPixelSize(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureCopyDescriptionFunc_setSourceLayer(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureCopyDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureCopyDescription::setSourceLayer(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setSourceLayer(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setSourceLayer", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setSourceLayer(int)
            cppSelf->setSourceLayer(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureCopyDescriptionFunc_setSourceLevel(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureCopyDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureCopyDescription::setSourceLevel(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setSourceLevel(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setSourceLevel", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setSourceLevel(int)
            cppSelf->setSourceLevel(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureCopyDescriptionFunc_setSourceTopLeft(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureCopyDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureCopyDescription::setSourceTopLeft(QPoint)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QPoint_IDX]), (pyArg)))) {
        overloadId = 0; // setSourceTopLeft(QPoint)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setSourceTopLeft", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QPoint cppArg0_local;
        ::QPoint *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setSourceTopLeft(QPoint)
            cppSelf->setSourceTopLeft(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureCopyDescriptionFunc_sourceLayer(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureCopyDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // sourceLayer()const
        int cppResult = const_cast<const ::QRhiTextureCopyDescription *>(cppSelf)->sourceLayer();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureCopyDescriptionFunc_sourceLevel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureCopyDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // sourceLevel()const
        int cppResult = const_cast<const ::QRhiTextureCopyDescription *>(cppSelf)->sourceLevel();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureCopyDescriptionFunc_sourceTopLeft(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureCopyDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // sourceTopLeft()const
        QPoint cppResult = const_cast<const ::QRhiTextureCopyDescription *>(cppSelf)->sourceTopLeft();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QPoint_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureCopyDescription__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiTextureCopyDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiTextureCopyDescription_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiTextureCopyDescription_methods[] = {
    {"destinationLayer", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureCopyDescriptionFunc_destinationLayer), METH_NOARGS, nullptr},
    {"destinationLevel", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureCopyDescriptionFunc_destinationLevel), METH_NOARGS, nullptr},
    {"destinationTopLeft", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureCopyDescriptionFunc_destinationTopLeft), METH_NOARGS, nullptr},
    {"pixelSize", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureCopyDescriptionFunc_pixelSize), METH_NOARGS, nullptr},
    {"setDestinationLayer", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureCopyDescriptionFunc_setDestinationLayer), METH_O, nullptr},
    {"setDestinationLevel", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureCopyDescriptionFunc_setDestinationLevel), METH_O, nullptr},
    {"setDestinationTopLeft", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureCopyDescriptionFunc_setDestinationTopLeft), METH_O, nullptr},
    {"setPixelSize", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureCopyDescriptionFunc_setPixelSize), METH_O, nullptr},
    {"setSourceLayer", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureCopyDescriptionFunc_setSourceLayer), METH_O, nullptr},
    {"setSourceLevel", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureCopyDescriptionFunc_setSourceLevel), METH_O, nullptr},
    {"setSourceTopLeft", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureCopyDescriptionFunc_setSourceTopLeft), METH_O, nullptr},
    {"sourceLayer", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureCopyDescriptionFunc_sourceLayer), METH_NOARGS, nullptr},
    {"sourceLevel", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureCopyDescriptionFunc_sourceLevel), METH_NOARGS, nullptr},
    {"sourceTopLeft", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureCopyDescriptionFunc_sourceTopLeft), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureCopyDescription__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRhiTextureCopyDescription_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiTextureCopyDescription_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiTextureCopyDescription_Type = nullptr;
static PyTypeObject *Sbk_QRhiTextureCopyDescription_TypeF(void)
{
    return _Sbk_QRhiTextureCopyDescription_Type;
}

static PyType_Slot Sbk_QRhiTextureCopyDescription_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiTextureCopyDescription_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiTextureCopyDescription_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiTextureCopyDescription_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiTextureCopyDescription_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiTextureCopyDescription_spec = {
    "2:PySide6.QtGui.QRhiTextureCopyDescription",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiTextureCopyDescription_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRhiTextureCopyDescription_PythonToCpp_QRhiTextureCopyDescription_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiTextureCopyDescription_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRhiTextureCopyDescription_PythonToCpp_QRhiTextureCopyDescription_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiTextureCopyDescription_TypeF()))
        return QRhiTextureCopyDescription_PythonToCpp_QRhiTextureCopyDescription_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRhiTextureCopyDescription_PTR_CppToPython_QRhiTextureCopyDescription(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QRhiTextureCopyDescription_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QRhiTextureCopyDescription_COPY_CppToPython_QRhiTextureCopyDescription(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiTextureCopyDescription *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiTextureCopyDescription_TypeF(), new ::QRhiTextureCopyDescription(*source), true, true);
}

// Python to C++ copy conversion.
static void QRhiTextureCopyDescription_PythonToCpp_QRhiTextureCopyDescription_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiTextureCopyDescription *>(cppOut) = *reinterpret_cast< ::QRhiTextureCopyDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRhiTextureCopyDescription_PythonToCpp_QRhiTextureCopyDescription_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiTextureCopyDescription_TypeF()))
        return QRhiTextureCopyDescription_PythonToCpp_QRhiTextureCopyDescription_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QRhiTextureCopyDescription_SignatureStrings[] = {
    "1:PySide6.QtGui.QRhiTextureCopyDescription(self)",
    "0:PySide6.QtGui.QRhiTextureCopyDescription(self,QRhiTextureCopyDescription:PySide6.QtGui.QRhiTextureCopyDescription)",
    "PySide6.QtGui.QRhiTextureCopyDescription.destinationLayer(self)->int",
    "PySide6.QtGui.QRhiTextureCopyDescription.destinationLevel(self)->int",
    "PySide6.QtGui.QRhiTextureCopyDescription.destinationTopLeft(self)->PySide6.QtCore.QPoint",
    "PySide6.QtGui.QRhiTextureCopyDescription.pixelSize(self)->PySide6.QtCore.QSize",
    "PySide6.QtGui.QRhiTextureCopyDescription.setDestinationLayer(self,layer:int)",
    "PySide6.QtGui.QRhiTextureCopyDescription.setDestinationLevel(self,level:int)",
    "PySide6.QtGui.QRhiTextureCopyDescription.setDestinationTopLeft(self,p:PySide6.QtCore.QPoint)",
    "PySide6.QtGui.QRhiTextureCopyDescription.setPixelSize(self,sz:PySide6.QtCore.QSize)",
    "PySide6.QtGui.QRhiTextureCopyDescription.setSourceLayer(self,layer:int)",
    "PySide6.QtGui.QRhiTextureCopyDescription.setSourceLevel(self,level:int)",
    "PySide6.QtGui.QRhiTextureCopyDescription.setSourceTopLeft(self,p:PySide6.QtCore.QPoint)",
    "PySide6.QtGui.QRhiTextureCopyDescription.sourceLayer(self)->int",
    "PySide6.QtGui.QRhiTextureCopyDescription.sourceLevel(self)->int",
    "PySide6.QtGui.QRhiTextureCopyDescription.sourceTopLeft(self)->PySide6.QtCore.QPoint",
    "PySide6.QtGui.QRhiTextureCopyDescription.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QRhiTextureCopyDescription_SignatureByteSize = 226;
static constexpr uint8_t QRhiTextureCopyDescription_SignatureBytes[226] = {
    0x78, 0xda, 0xad, 0x93, 0xbd, 0x0a, 0x83, 0x30, 0x10, 0x80, 0x77, 0x9f, 0xa4, 0x42, 0x1a, 0xda,
    0xa5, 0x83, 0x43, 0x17, 0x85, 0x2e, 0x1d, 0xb4, 0xba, 0x4b, 0xd1, 0xb3, 0x3d, 0x08, 0x26, 0x24,
    0xb1, 0xa8, 0x4f, 0x5f, 0xc5, 0xfe, 0x8a, 0x82, 0x51, 0xb7, 0x4b, 0xee, 0xee, 0xe3, 0xee, 0x83,
    0xdb, 0x3b, 0x7e, 0x15, 0x62, 0x0a, 0x07, 0x1a, 0xe8, 0x53, 0x81, 0x34, 0xb8, 0xdc, 0x31, 0x82,
    0x52, 0x17, 0x12, 0x5c, 0x2e, 0x2a, 0x0f, 0x54, 0x22, 0x51, 0x68, 0xe4, 0xf9, 0x46, 0x01, 0xcb,
    0x6c, 0x6b, 0x67, 0xd6, 0x40, 0xc6, 0xf3, 0x93, 0x41, 0xb6, 0x35, 0xb5, 0x92, 0xa6, 0xa0, 0x34,
    0xe6, 0xd7, 0x36, 0x3e, 0x5f, 0x2b, 0x90, 0xdd, 0xd0, 0xdb, 0x23, 0xe6, 0x7a, 0x1e, 0x04, 0x1e,
    0xc0, 0x96, 0x42, 0x22, 0x2e, 0xce, 0x90, 0xe9, 0x37, 0xe6, 0x8b, 0x70, 0xb9, 0x04, 0x1a, 0xf8,
    0xdc, 0x08, 0x2c, 0xb0, 0x04, 0x16, 0x62, 0x0d, 0x63, 0xbc, 0x36, 0x37, 0x1d, 0xa7, 0x40, 0x7b,
    0x43, 0xd2, 0x08, 0x6b, 0x43, 0xa7, 0x19, 0xcd, 0x9e, 0x0d, 0xfb, 0xc8, 0x23, 0xac, 0x0d, 0x17,
    0xc1, 0x7e, 0x25, 0x12, 0xe1, 0x0c, 0x4a, 0x34, 0x83, 0xfb, 0x7f, 0x22, 0x89, 0xaa, 0x9d, 0x21,
    0x93, 0x66, 0xcc, 0x90, 0x17, 0x32, 0x81, 0xe5, 0x16, 0x5f, 0x9c, 0xc5, 0x02, 0x3b, 0xce, 0xda,
    0xee, 0x7a, 0x4b, 0x9a, 0x9e, 0x86, 0xea, 0x2d, 0x37, 0xaf, 0x7f, 0xdd, 0xab, 0x8a, 0xe3, 0xa4,
    0xf9, 0x89, 0xe3, 0x37, 0x4e, 0x57, 0x02, 0xf3, 0x1b, 0x0d, 0x9b, 0x97, 0xf5, 0x04, 0x51, 0x21,
    0xe8, 0x91
};
#endif

PyTypeObject *init_QRhiTextureCopyDescription(PyObject *module)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX].type;

    Shiboken::AutoDecRef Sbk_QRhiTextureCopyDescription_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QRhiTextureCopyDescription_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRhiTextureCopyDescription",
        "QRhiTextureCopyDescription",
        &Sbk_QRhiTextureCopyDescription_spec,
        &Shiboken::callCppDestructor< ::QRhiTextureCopyDescription >,
        Sbk_QRhiTextureCopyDescription_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiTextureCopyDescription_TypeF(); // references _Sbk_QRhiTextureCopyDescription_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QRhiTextureCopyDescription_SignatureStrings);
#else
    InitSignatureBytes(pyType, QRhiTextureCopyDescription_SignatureBytes, QRhiTextureCopyDescription_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiTextureCopyDescription_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureCopyDescription_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRhiTextureCopyDescription_PythonToCpp_QRhiTextureCopyDescription_PTR,
        is_QRhiTextureCopyDescription_PythonToCpp_QRhiTextureCopyDescription_PTR_Convertible,
        QRhiTextureCopyDescription_PTR_CppToPython_QRhiTextureCopyDescription,
        QRhiTextureCopyDescription_COPY_CppToPython_QRhiTextureCopyDescription);

    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureCopyDescription");
    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureCopyDescription*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureCopyDescription&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiTextureCopyDescription).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRhiTextureCopyDescription_PythonToCpp_QRhiTextureCopyDescription_COPY,
        is_QRhiTextureCopyDescription_PythonToCpp_QRhiTextureCopyDescription_COPY_Convertible);

    qRegisterMetaType< ::QRhiTextureCopyDescription >("QRhiTextureCopyDescription");

    return pyType;
}
