// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhitexturesubresourceuploaddescription_wrapper.h"

// Argument includes
#include <QtGui/qimage.h>
#include <qbytearray.h>
#include <qpoint.h>
#include <qsize.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiTextureSubresourceUploadDescription_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiTextureSubresourceUploadDescription >()))
        return -1;

    ::QRhiTextureSubresourceUploadDescription *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QRhiTextureSubresourceUploadDescription", 0, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRhiTextureSubresourceUploadDescription::QRhiTextureSubresourceUploadDescription()
    // 1: QRhiTextureSubresourceUploadDescription::QRhiTextureSubresourceUploadDescription(QByteArray)
    // 2: QRhiTextureSubresourceUploadDescription::QRhiTextureSubresourceUploadDescription(QImage)
    // 3: QRhiTextureSubresourceUploadDescription::QRhiTextureSubresourceUploadDescription(QRhiTextureSubresourceUploadDescription)
    // 4: QRhiTextureSubresourceUploadDescription::QRhiTextureSubresourceUploadDescription(const void*,quint32)
    if (numArgs == 0) {
        overloadId = 0; // QRhiTextureSubresourceUploadDescription()
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<void *>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArgs[1])))) {
        overloadId = 4; // QRhiTextureSubresourceUploadDescription(const void*,quint32)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), (pyArgs[0])))) {
        overloadId = 3; // QRhiTextureSubresourceUploadDescription(QRhiTextureSubresourceUploadDescription)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QImage_IDX]), (pyArgs[0])))) {
        overloadId = 2; // QRhiTextureSubresourceUploadDescription(QImage)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QRhiTextureSubresourceUploadDescription(QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRhiTextureSubresourceUploadDescription()
        {

            // QRhiTextureSubresourceUploadDescription()
            cptr = new ::QRhiTextureSubresourceUploadDescription();
            break;
        }
        case 1: // QRhiTextureSubresourceUploadDescription(const QByteArray &data)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QByteArray cppArg0_local;
            ::QByteArray *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureSubresourceUploadDescription(QByteArray)
                cptr = new ::QRhiTextureSubresourceUploadDescription(*cppArg0);
            }
            break;
        }
        case 2: // QRhiTextureSubresourceUploadDescription(const QImage &image)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QImage cppArg0_local;
            ::QImage *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureSubresourceUploadDescription(QImage)
                cptr = new ::QRhiTextureSubresourceUploadDescription(*cppArg0);
            }
            break;
        }
        case 3: // QRhiTextureSubresourceUploadDescription(const QRhiTextureSubresourceUploadDescription &QRhiTextureSubresourceUploadDescription)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiTextureSubresourceUploadDescription cppArg0_local;
            ::QRhiTextureSubresourceUploadDescription *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureSubresourceUploadDescription(QRhiTextureSubresourceUploadDescription)
                cptr = new ::QRhiTextureSubresourceUploadDescription(*cppArg0);
            }
            break;
        }
        case 4: // QRhiTextureSubresourceUploadDescription(const void *data, quint32 size)
        {
            void* cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            quint32 cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureSubresourceUploadDescription(const void*,quint32)
                cptr = new ::QRhiTextureSubresourceUploadDescription(cppArg0, cppArg1);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiTextureSubresourceUploadDescription >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiTextureSubresourceUploadDescriptionFunc_data(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureSubresourceUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // data()const
        QByteArray cppResult = const_cast<const ::QRhiTextureSubresourceUploadDescription *>(cppSelf)->data();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureSubresourceUploadDescriptionFunc_dataStride(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureSubresourceUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // dataStride()const
        quint32 cppResult = const_cast<const ::QRhiTextureSubresourceUploadDescription *>(cppSelf)->dataStride();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureSubresourceUploadDescriptionFunc_destinationTopLeft(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureSubresourceUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // destinationTopLeft()const
        QPoint cppResult = const_cast<const ::QRhiTextureSubresourceUploadDescription *>(cppSelf)->destinationTopLeft();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QPoint_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureSubresourceUploadDescriptionFunc_image(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureSubresourceUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // image()const
        QImage cppResult = const_cast<const ::QRhiTextureSubresourceUploadDescription *>(cppSelf)->image();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QImage_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureSubresourceUploadDescriptionFunc_setData(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureSubresourceUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureSubresourceUploadDescription::setData(QByteArray)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArg)))) {
        overloadId = 0; // setData(QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setData", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QByteArray cppArg0_local;
        ::QByteArray *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setData(QByteArray)
            cppSelf->setData(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureSubresourceUploadDescriptionFunc_setDataStride(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureSubresourceUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureSubresourceUploadDescription::setDataStride(quint32)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), (pyArg)))) {
        overloadId = 0; // setDataStride(quint32)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setDataStride", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]);

    // Call function/method
    {
        quint32 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setDataStride(quint32)
            cppSelf->setDataStride(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureSubresourceUploadDescriptionFunc_setDestinationTopLeft(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureSubresourceUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureSubresourceUploadDescription::setDestinationTopLeft(QPoint)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QPoint_IDX]), (pyArg)))) {
        overloadId = 0; // setDestinationTopLeft(QPoint)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setDestinationTopLeft", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QPoint cppArg0_local;
        ::QPoint *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setDestinationTopLeft(QPoint)
            cppSelf->setDestinationTopLeft(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureSubresourceUploadDescriptionFunc_setImage(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureSubresourceUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureSubresourceUploadDescription::setImage(QImage)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QImage_IDX]), (pyArg)))) {
        overloadId = 0; // setImage(QImage)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setImage", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QImage cppArg0_local;
        ::QImage *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setImage(QImage)
            cppSelf->setImage(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureSubresourceUploadDescriptionFunc_setSourceSize(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureSubresourceUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureSubresourceUploadDescription::setSourceSize(QSize)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX]), (pyArg)))) {
        overloadId = 0; // setSourceSize(QSize)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setSourceSize", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QSize cppArg0_local;
        ::QSize *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setSourceSize(QSize)
            cppSelf->setSourceSize(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureSubresourceUploadDescriptionFunc_setSourceTopLeft(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureSubresourceUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureSubresourceUploadDescription::setSourceTopLeft(QPoint)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QPoint_IDX]), (pyArg)))) {
        overloadId = 0; // setSourceTopLeft(QPoint)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setSourceTopLeft", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QPoint cppArg0_local;
        ::QPoint *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setSourceTopLeft(QPoint)
            cppSelf->setSourceTopLeft(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRhiTextureSubresourceUploadDescriptionFunc_sourceSize(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureSubresourceUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // sourceSize()const
        QSize cppResult = const_cast<const ::QRhiTextureSubresourceUploadDescription *>(cppSelf)->sourceSize();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureSubresourceUploadDescriptionFunc_sourceTopLeft(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureSubresourceUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // sourceTopLeft()const
        QPoint cppResult = const_cast<const ::QRhiTextureSubresourceUploadDescription *>(cppSelf)->sourceTopLeft();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QPoint_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRhiTextureSubresourceUploadDescription__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiTextureSubresourceUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiTextureSubresourceUploadDescription_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiTextureSubresourceUploadDescription_methods[] = {
    {"data", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureSubresourceUploadDescriptionFunc_data), METH_NOARGS, nullptr},
    {"dataStride", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureSubresourceUploadDescriptionFunc_dataStride), METH_NOARGS, nullptr},
    {"destinationTopLeft", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureSubresourceUploadDescriptionFunc_destinationTopLeft), METH_NOARGS, nullptr},
    {"image", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureSubresourceUploadDescriptionFunc_image), METH_NOARGS, nullptr},
    {"setData", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureSubresourceUploadDescriptionFunc_setData), METH_O, nullptr},
    {"setDataStride", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureSubresourceUploadDescriptionFunc_setDataStride), METH_O, nullptr},
    {"setDestinationTopLeft", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureSubresourceUploadDescriptionFunc_setDestinationTopLeft), METH_O, nullptr},
    {"setImage", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureSubresourceUploadDescriptionFunc_setImage), METH_O, nullptr},
    {"setSourceSize", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureSubresourceUploadDescriptionFunc_setSourceSize), METH_O, nullptr},
    {"setSourceTopLeft", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureSubresourceUploadDescriptionFunc_setSourceTopLeft), METH_O, nullptr},
    {"sourceSize", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureSubresourceUploadDescriptionFunc_sourceSize), METH_NOARGS, nullptr},
    {"sourceTopLeft", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureSubresourceUploadDescriptionFunc_sourceTopLeft), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureSubresourceUploadDescription__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRhiTextureSubresourceUploadDescription_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiTextureSubresourceUploadDescription_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiTextureSubresourceUploadDescription_Type = nullptr;
static PyTypeObject *Sbk_QRhiTextureSubresourceUploadDescription_TypeF(void)
{
    return _Sbk_QRhiTextureSubresourceUploadDescription_Type;
}

static PyType_Slot Sbk_QRhiTextureSubresourceUploadDescription_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiTextureSubresourceUploadDescription_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiTextureSubresourceUploadDescription_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiTextureSubresourceUploadDescription_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiTextureSubresourceUploadDescription_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiTextureSubresourceUploadDescription_spec = {
    "2:PySide6.QtGui.QRhiTextureSubresourceUploadDescription",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiTextureSubresourceUploadDescription_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRhiTextureSubresourceUploadDescription_PythonToCpp_QRhiTextureSubresourceUploadDescription_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiTextureSubresourceUploadDescription_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRhiTextureSubresourceUploadDescription_PythonToCpp_QRhiTextureSubresourceUploadDescription_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiTextureSubresourceUploadDescription_TypeF()))
        return QRhiTextureSubresourceUploadDescription_PythonToCpp_QRhiTextureSubresourceUploadDescription_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRhiTextureSubresourceUploadDescription_PTR_CppToPython_QRhiTextureSubresourceUploadDescription(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QRhiTextureSubresourceUploadDescription_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QRhiTextureSubresourceUploadDescription_COPY_CppToPython_QRhiTextureSubresourceUploadDescription(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiTextureSubresourceUploadDescription *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiTextureSubresourceUploadDescription_TypeF(), new ::QRhiTextureSubresourceUploadDescription(*source), true, true);
}

// Python to C++ copy conversion.
static void QRhiTextureSubresourceUploadDescription_PythonToCpp_QRhiTextureSubresourceUploadDescription_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiTextureSubresourceUploadDescription *>(cppOut) = *reinterpret_cast< ::QRhiTextureSubresourceUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRhiTextureSubresourceUploadDescription_PythonToCpp_QRhiTextureSubresourceUploadDescription_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiTextureSubresourceUploadDescription_TypeF()))
        return QRhiTextureSubresourceUploadDescription_PythonToCpp_QRhiTextureSubresourceUploadDescription_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QRhiTextureSubresourceUploadDescription_SignatureStrings[] = {
    "4:PySide6.QtGui.QRhiTextureSubresourceUploadDescription(self)",
    "3:PySide6.QtGui.QRhiTextureSubresourceUploadDescription(self,data:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "2:PySide6.QtGui.QRhiTextureSubresourceUploadDescription(self,image:PySide6.QtGui.QImage)",
    "1:PySide6.QtGui.QRhiTextureSubresourceUploadDescription(self,QRhiTextureSubresourceUploadDescription:PySide6.QtGui.QRhiTextureSubresourceUploadDescription)",
    "0:PySide6.QtGui.QRhiTextureSubresourceUploadDescription(self,data:void,size:quint32)",
    "PySide6.QtGui.QRhiTextureSubresourceUploadDescription.data(self)->PySide6.QtCore.QByteArray",
    "PySide6.QtGui.QRhiTextureSubresourceUploadDescription.dataStride(self)->quint32",
    "PySide6.QtGui.QRhiTextureSubresourceUploadDescription.destinationTopLeft(self)->PySide6.QtCore.QPoint",
    "PySide6.QtGui.QRhiTextureSubresourceUploadDescription.image(self)->PySide6.QtGui.QImage",
    "PySide6.QtGui.QRhiTextureSubresourceUploadDescription.setData(self,data:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "PySide6.QtGui.QRhiTextureSubresourceUploadDescription.setDataStride(self,stride:quint32)",
    "PySide6.QtGui.QRhiTextureSubresourceUploadDescription.setDestinationTopLeft(self,p:PySide6.QtCore.QPoint)",
    "PySide6.QtGui.QRhiTextureSubresourceUploadDescription.setImage(self,image:PySide6.QtGui.QImage)",
    "PySide6.QtGui.QRhiTextureSubresourceUploadDescription.setSourceSize(self,size:PySide6.QtCore.QSize)",
    "PySide6.QtGui.QRhiTextureSubresourceUploadDescription.setSourceTopLeft(self,p:PySide6.QtCore.QPoint)",
    "PySide6.QtGui.QRhiTextureSubresourceUploadDescription.sourceSize(self)->PySide6.QtCore.QSize",
    "PySide6.QtGui.QRhiTextureSubresourceUploadDescription.sourceTopLeft(self)->PySide6.QtCore.QPoint",
    "PySide6.QtGui.QRhiTextureSubresourceUploadDescription.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QRhiTextureSubresourceUploadDescription_SignatureByteSize = 305;
static constexpr uint8_t QRhiTextureSubresourceUploadDescription_SignatureBytes[305] = {
    0x78, 0xda, 0xb5, 0x93, 0x31, 0x4f, 0xc3, 0x30, 0x10, 0x85, 0x77, 0xff, 0x0a, 0x46, 0x82, 0x42,
    0x04, 0x2d, 0x62, 0xc8, 0x80, 0x54, 0xa8, 0x84, 0x2a, 0x31, 0x34, 0xb8, 0x9d, 0x10, 0x8a, 0x4c,
    0x72, 0x6d, 0x4f, 0x2a, 0xb1, 0xb1, 0x2f, 0x88, 0xf0, 0xeb, 0x89, 0x43, 0x42, 0x4b, 0x49, 0x51,
    0x65, 0xab, 0x9b, 0xe3, 0x8b, 0xbf, 0x67, 0xdf, 0xbb, 0x77, 0x15, 0x4f, 0x2b, 0x8e, 0x39, 0x5c,
    0x47, 0x09, 0xdd, 0x97, 0x18, 0x25, 0x8f, 0x2b, 0x9c, 0xc1, 0x07, 0x95, 0x1a, 0x78, 0xf9, 0xa2,
    0xc1, 0xc8, 0x52, 0x67, 0x30, 0x57, 0x6b, 0x29, 0xf2, 0x31, 0x98, 0x4c, 0xa3, 0x22, 0x94, 0xc5,
    0xa9, 0x81, 0xf5, 0x22, 0x60, 0x43, 0x8f, 0xd3, 0x61, 0x2e, 0x48, 0xc4, 0x54, 0x29, 0x2c, 0x96,
    0xd1, 0xbc, 0xa8, 0xb7, 0x9f, 0x36, 0xb0, 0x3b, 0xa9, 0x21, 0x4a, 0x6e, 0x2b, 0x82, 0x91, 0xd6,
    0xa2, 0x0a, 0x4f, 0xb2, 0x95, 0xd0, 0x67, 0xcf, 0x01, 0x1b, 0xf8, 0x28, 0xe2, 0xab, 0x58, 0xc2,
    0x2e, 0x60, 0x62, 0x37, 0x03, 0x76, 0xe9, 0x03, 0x3e, 0xf0, 0x67, 0x37, 0x89, 0x80, 0x5d, 0x78,
    0xb7, 0xf9, 0x5d, 0x62, 0x1e, 0x1a, 0xfc, 0x84, 0xf8, 0xad, 0xc4, 0x82, 0x86, 0x83, 0x80, 0x39,
    0x21, 0x23, 0x4b, 0xfb, 0x36, 0xff, 0xfc, 0x66, 0xaf, 0x5d, 0x1e, 0x6c, 0x4e, 0xba, 0x3e, 0xd9,
    0x29, 0xb4, 0x97, 0x75, 0xe5, 0x81, 0x21, 0x2c, 0x84, 0x5d, 0xcf, 0xa4, 0x7a, 0x80, 0x05, 0xed,
    0xbb, 0xf9, 0x54, 0xd6, 0x3a, 0x8e, 0x2a, 0xcd, 0x50, 0xfd, 0x05, 0x6f, 0x66, 0xcb, 0x91, 0x6b,
    0x80, 0xc6, 0x5d, 0xb3, 0xdd, 0xb2, 0xe2, 0xa5, 0xbb, 0x65, 0x44, 0x68, 0x9a, 0xb5, 0xef, 0xe8,
    0x58, 0x70, 0xbf, 0x23, 0xa1, 0x8a, 0x7b, 0x1d, 0xf1, 0x50, 0x9a, 0xfc, 0xb8, 0xf2, 0x6f, 0xea,
    0x9d, 0xf9, 0xbc, 0x29, 0xf1, 0x3a, 0x51, 0x6d, 0x8b, 0x6c, 0xb6, 0x76, 0x1f, 0x61, 0xcb, 0xde,
    0x1a, 0x47, 0x6d, 0xd4, 0xef, 0x57, 0xf4, 0x24, 0xc3, 0xd6, 0xbc, 0xe0, 0x47, 0x4c, 0x5e, 0x9a,
    0x66, 0x52, 0x55, 0x69, 0xda, 0xb1, 0xdb, 0x7c, 0xf0, 0xfa, 0x8b, 0x7d, 0x01, 0x22, 0x88, 0x8d,
    0x31
};
#endif

PyTypeObject *init_QRhiTextureSubresourceUploadDescription(PyObject *module)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX].type;

    Shiboken::AutoDecRef Sbk_QRhiTextureSubresourceUploadDescription_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QRhiTextureSubresourceUploadDescription_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRhiTextureSubresourceUploadDescription",
        "QRhiTextureSubresourceUploadDescription",
        &Sbk_QRhiTextureSubresourceUploadDescription_spec,
        &Shiboken::callCppDestructor< ::QRhiTextureSubresourceUploadDescription >,
        Sbk_QRhiTextureSubresourceUploadDescription_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiTextureSubresourceUploadDescription_TypeF(); // references _Sbk_QRhiTextureSubresourceUploadDescription_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QRhiTextureSubresourceUploadDescription_SignatureStrings);
#else
    InitSignatureBytes(pyType, QRhiTextureSubresourceUploadDescription_SignatureBytes, QRhiTextureSubresourceUploadDescription_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiTextureSubresourceUploadDescription_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureSubresourceUploadDescription_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRhiTextureSubresourceUploadDescription_PythonToCpp_QRhiTextureSubresourceUploadDescription_PTR,
        is_QRhiTextureSubresourceUploadDescription_PythonToCpp_QRhiTextureSubresourceUploadDescription_PTR_Convertible,
        QRhiTextureSubresourceUploadDescription_PTR_CppToPython_QRhiTextureSubresourceUploadDescription,
        QRhiTextureSubresourceUploadDescription_COPY_CppToPython_QRhiTextureSubresourceUploadDescription);

    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureSubresourceUploadDescription");
    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureSubresourceUploadDescription*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureSubresourceUploadDescription&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiTextureSubresourceUploadDescription).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRhiTextureSubresourceUploadDescription_PythonToCpp_QRhiTextureSubresourceUploadDescription_COPY,
        is_QRhiTextureSubresourceUploadDescription_PythonToCpp_QRhiTextureSubresourceUploadDescription_COPY_Convertible);

    qRegisterMetaType< ::QRhiTextureSubresourceUploadDescription >("QRhiTextureSubresourceUploadDescription");

    return pyType;
}
