// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QShowEventWrapper_H
#define SBK_QShowEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

class QShowEventWrapper : public QShowEvent
{
public:
    QShowEventWrapper(const QShowEventWrapper &) = delete;
    QShowEventWrapper& operator=(const QShowEventWrapper &) = delete;
    QShowEventWrapper(QShowEventWrapper &&) = delete;
    QShowEventWrapper& operator=(QShowEventWrapper &&) = delete;

    QShowEventWrapper();
    QShowEventWrapper(const QShowEvent& self) : QShowEvent(self)
    {
    }

    ::QShowEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QShowEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QShowEventWrapper_H

