// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qtextblock_iterator_wrapper.h"

// Argument includes
#include <QTextBlock>
#include <QtGui/qtextobject.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static PyObject *Sbk_QTextBlock_iteratorFunc___iter__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTextBlock::iterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // __iter__()
        // Begin code injection
        // TEMPLATE - __iter__ - START
        Py_INCREF(self);
        pyResult = self;
        // TEMPLATE - __iter__ - END
        // End of code injection

    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QTextBlock_iteratorFunc___next__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTextBlock::iterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // __next__()
        // Begin code injection
        // TEMPLATE - __next__ - START
        if (!cppSelf->atEnd()) {
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), &*cppSelf);
            ++(*cppSelf);
        }
        // TEMPLATE - __next__ - END
        // End of code injection

    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QTextBlock_iteratorFunc_atEnd(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTextBlock::iterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // atEnd()const
        bool cppResult = const_cast<const ::QTextBlock::iterator *>(cppSelf)->atEnd();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QTextBlock_iteratorFunc_fragment(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTextBlock::iterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // fragment()const
        QTextFragment cppResult = const_cast<const ::QTextBlock::iterator *>(cppSelf)->fragment();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextFragment_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static int
Sbk_QTextBlock_iterator_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(args)
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QTextBlock::iterator >()))
        return -1;

    ::QTextBlock::iterator *cptr{};
    Shiboken::PythonContextMarker pcm;


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {

        // iterator()
        cptr = new ::QTextBlock::iterator();
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QTextBlock::iterator >(), cptr)) {
        delete cptr;
        return -1;
    }
    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QTextBlock_iterator__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QTextBlock::iterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QTextBlock_iterator_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QTextBlock_iterator_methods[] = {
    {"atEnd", reinterpret_cast<PyCFunction>(Sbk_QTextBlock_iteratorFunc_atEnd), METH_NOARGS, nullptr},
    {"fragment", reinterpret_cast<PyCFunction>(Sbk_QTextBlock_iteratorFunc_fragment), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QTextBlock_iterator__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QTextBlock_iteratorFunc___iadd__(PyObject *self, PyObject *pyArg)
{
    bool isReverse = SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), pyArg)
                    && !SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), self);
    if (isReverse)
        std::swap(self, pyArg);
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTextBlock::iterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: iterator::operator++(int)->QTextBlock::iterator
    if (!isReverse
        && (pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // operator++(int)
    }

    if (isReverse && overloadId == -1) {
        Shiboken::Errors::setReverseOperatorNotImplemented();
        return {};
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "operator++", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // operator++(int)

            for (int i = 0; i < cppArg0; ++i, ++(*cppSelf));
            QTextBlock::iterator cppResult = (*cppSelf);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QTextBlock_iteratorFunc___isub__(PyObject *self, PyObject *pyArg)
{
    bool isReverse = SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), pyArg)
                    && !SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), self);
    if (isReverse)
        std::swap(self, pyArg);
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTextBlock::iterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: iterator::operator--(int)->QTextBlock::iterator
    if (!isReverse
        && (pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // operator--(int)
    }

    if (isReverse && overloadId == -1) {
        Shiboken::Errors::setReverseOperatorNotImplemented();
        return {};
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "operator--", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // operator--(int)

            for (int i = 0; i < cppArg0; ++i, --(*cppSelf));
            QTextBlock::iterator cppResult = (*cppSelf);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

// Rich comparison
static PyObject * Sbk_QTextBlock_iterator_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QTextBlock::iterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), (pyArg)))) {
                // operator!=(const QTextBlock::iterator &o) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QTextBlock::iterator cppArg0_local;
                ::QTextBlock::iterator *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), (pyArg)))) {
                // operator==(const QTextBlock::iterator &o) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QTextBlock::iterator cppArg0_local;
                ::QTextBlock::iterator *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QTextBlock_iterator_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QTextBlock_iterator_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QTextBlock_iterator_Type = nullptr;
static PyTypeObject *Sbk_QTextBlock_iterator_TypeF(void)
{
    return _Sbk_QTextBlock_iterator_Type;
}

static PyType_Slot Sbk_QTextBlock_iterator_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QTextBlock_iterator_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QTextBlock_iterator_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QTextBlock_iterator_richcompare)},
    {Py_tp_iter,        reinterpret_cast<void *>(Sbk_QTextBlock_iteratorFunc___iter__)},
    {Py_tp_iternext,    reinterpret_cast<void *>(Sbk_QTextBlock_iteratorFunc___next__)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QTextBlock_iterator_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QTextBlock_iterator_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    // type supports number protocol
    {Py_nb_inplace_add, reinterpret_cast<void *>(Sbk_QTextBlock_iteratorFunc___iadd__)},
    {Py_nb_inplace_subtract,reinterpret_cast<void *>(Sbk_QTextBlock_iteratorFunc___isub__)},
    {0, nullptr}
};
static PyType_Spec Sbk_QTextBlock_iterator_spec = {
    "2:PySide6.QtGui.QTextBlock.iterator",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QTextBlock_iterator_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void iterator_PythonToCpp_iterator_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QTextBlock_iterator_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_iterator_PythonToCpp_iterator_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QTextBlock_iterator_TypeF()))
        return iterator_PythonToCpp_iterator_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *iterator_PTR_CppToPython_iterator(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QTextBlock_iterator_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *iterator_COPY_CppToPython_iterator(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QTextBlock::iterator *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QTextBlock_iterator_TypeF(), new ::QTextBlock::iterator(*source), true, true);
}

// Python to C++ copy conversion.
static void iterator_PythonToCpp_iterator_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QTextBlock::iterator *>(cppOut) = *reinterpret_cast< ::QTextBlock::iterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_iterator_PythonToCpp_iterator_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QTextBlock_iterator_TypeF()))
        return iterator_PythonToCpp_iterator_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QTextBlock_iterator_SignatureStrings[] = {
    "PySide6.QtGui.QTextBlock.iterator.__iter__(self)->PyObject",
    "PySide6.QtGui.QTextBlock.iterator.__next__(self)->PyObject",
    "PySide6.QtGui.QTextBlock.iterator.atEnd(self)->bool",
    "PySide6.QtGui.QTextBlock.iterator.fragment(self)->PySide6.QtGui.QTextFragment",
    "PySide6.QtGui.QTextBlock.iterator(self)",
    "PySide6.QtGui.QTextBlock.iterator.__copy__(self)->typing.Self",
    "PySide6.QtGui.QTextBlock.iterator.__iadd__(self,arg__1:int)->PySide6.QtGui.QTextBlock.iterator",
    "PySide6.QtGui.QTextBlock.iterator.__isub__(self,arg__1:int)->PySide6.QtGui.QTextBlock.iterator",
    "PySide6.QtGui.QTextBlock.iterator.__ne__(self,o:PySide6.QtGui.QTextBlock.iterator)->bool",
    "PySide6.QtGui.QTextBlock.iterator.__eq__(self,o:PySide6.QtGui.QTextBlock.iterator)->bool",
    nullptr}; // Sentinel
#else
static constexpr size_t QTextBlock_iterator_SignatureByteSize = 172;
static constexpr uint8_t QTextBlock_iterator_SignatureBytes[172] = {
    0x78, 0xda, 0xb5, 0x91, 0xc1, 0x0a, 0xc2, 0x30, 0x0c, 0x40, 0xef, 0x7e, 0x89, 0x82, 0x16, 0xbc,
    0x78, 0xd8, 0xc1, 0x83, 0xa0, 0x1e, 0xed, 0x98, 0xf7, 0xd0, 0xad, 0x59, 0xa9, 0xd6, 0x76, 0x76,
    0x19, 0xd8, 0xbf, 0x77, 0xe2, 0xc6, 0x10, 0x85, 0x95, 0x81, 0xb7, 0x24, 0xe4, 0xbd, 0x24, 0x84,
    0x87, 0x4c, 0x4b, 0xdc, 0xb0, 0x94, 0x8e, 0x8d, 0x66, 0xe9, 0x19, 0x1f, 0xb4, 0x33, 0xae, 0xb8,
    0x32, 0x4d, 0xe8, 0x05, 0x39, 0xcf, 0x00, 0x5e, 0x21, 0xc0, 0xbc, 0x46, 0x53, 0x2e, 0x56, 0x5b,
    0x1e, 0x4e, 0xf9, 0x05, 0x0b, 0x9a, 0xf1, 0x08, 0xd4, 0xb6, 0xc5, 0x49, 0xa8, 0xa0, 0xbd, 0x95,
    0x3d, 0x97, 0x3b, 0x67, 0x22, 0x98, 0xd2, 0x0b, 0x75, 0x43, 0x4b, 0xc3, 0xb8, 0x2f, 0xe2, 0xd0,
    0xb5, 0x8c, 0xdb, 0xde, 0x92, 0xa8, 0x23, 0x0b, 0x57, 0x85, 0xe1, 0x48, 0x0a, 0x95, 0xb6, 0x8a,
    0x65, 0x6d, 0x16, 0x45, 0x6b, 0x21, 0x65, 0x47, 0x2f, 0x85, 0x57, 0x00, 0xeb, 0x44, 0x5b, 0xfa,
    0xbd, 0xfe, 0x27, 0x1c, 0xa7, 0xaf, 0x9b, 0xfc, 0x8f, 0x7a, 0x8b, 0xbd, 0xdc, 0x25, 0xa3, 0xfd,
    0xf1, 0xaf, 0x04, 0xc0, 0xfb, 0x04, 0xf1, 0x13, 0x73, 0x2b, 0x01, 0xf6
};
#endif

PyTypeObject *init_QTextBlock_iterator(PyObject *enclosingClass)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX].type;

    Shiboken::AutoDecRef Sbk_QTextBlock_iterator_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QTextBlock_iterator_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "iterator",
        "QTextBlock::iterator",
        &Sbk_QTextBlock_iterator_spec,
        &Shiboken::callCppDestructor< ::QTextBlock::iterator >,
        Sbk_QTextBlock_iterator_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QTextBlock_iterator_TypeF(); // references _Sbk_QTextBlock_iterator_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QTextBlock_iterator_SignatureStrings);
#else
    InitSignatureBytes(pyType, QTextBlock_iterator_SignatureBytes, QTextBlock_iterator_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QTextBlock_iterator_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QTextBlock_iterator_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        iterator_PythonToCpp_iterator_PTR,
        is_iterator_PythonToCpp_iterator_PTR_Convertible,
        iterator_PTR_CppToPython_iterator,
        iterator_COPY_CppToPython_iterator);

    Shiboken::Conversions::registerConverterName(converter, "QTextBlock::iterator");
    Shiboken::Conversions::registerConverterName(converter, "QTextBlock::iterator*");
    Shiboken::Conversions::registerConverterName(converter, "QTextBlock::iterator&");
    Shiboken::Conversions::registerConverterAlias(converter, "iterator");
    Shiboken::Conversions::registerConverterAlias(converter, "iterator*");
    Shiboken::Conversions::registerConverterAlias(converter, "iterator&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QTextBlock::iterator).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        iterator_PythonToCpp_iterator_COPY,
        is_iterator_PythonToCpp_iterator_COPY_Convertible);

    qRegisterMetaType< ::QTextBlock::iterator >("iterator");
    qRegisterMetaType< ::QTextBlock::iterator >("QTextBlock::iterator");

    return pyType;
}
