// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTextBlockGroupWrapper_H
#define SBK_QTextBlockGroupWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qtextobject.h>

namespace PySide { class DynamicQMetaObject; }

class QTextBlockGroupWrapper : public QTextBlockGroup
{
public:
    QTextBlockGroupWrapper(const QTextBlockGroupWrapper &) = delete;
    QTextBlockGroupWrapper& operator=(const QTextBlockGroupWrapper &) = delete;
    QTextBlockGroupWrapper(QTextBlockGroupWrapper &&) = delete;
    QTextBlockGroupWrapper& operator=(QTextBlockGroupWrapper &&) = delete;

    QTextBlockGroupWrapper(::QTextDocument * doc);
    void blockFormatChanged(const ::QTextBlock & block) override;
    void blockInserted(const ::QTextBlock & block) override;
    void blockRemoved(const ::QTextBlock & block) override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QTextBlockGroupWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[10] = {false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QTextBlockGroupWrapper_H

