// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QToolBarChangeEventWrapper_H
#define SBK_QToolBarChangeEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

class QToolBarChangeEventWrapper : public QToolBarChangeEvent
{
public:
    QToolBarChangeEventWrapper(const QToolBarChangeEventWrapper &) = delete;
    QToolBarChangeEventWrapper& operator=(const QToolBarChangeEventWrapper &) = delete;
    QToolBarChangeEventWrapper(QToolBarChangeEventWrapper &&) = delete;
    QToolBarChangeEventWrapper& operator=(QToolBarChangeEventWrapper &&) = delete;

    QToolBarChangeEventWrapper(bool t);
    QToolBarChangeEventWrapper(const QToolBarChangeEvent& self) : QToolBarChangeEvent(self)
    {
    }

    ::QToolBarChangeEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QToolBarChangeEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QToolBarChangeEventWrapper_H

