// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QUndoCommandWrapper_H
#define SBK_QUndoCommandWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qundostack.h>

class QUndoCommandWrapper : public QUndoCommand
{
public:
    QUndoCommandWrapper(const QUndoCommandWrapper &) = delete;
    QUndoCommandWrapper& operator=(const QUndoCommandWrapper &) = delete;
    QUndoCommandWrapper(QUndoCommandWrapper &&) = delete;
    QUndoCommandWrapper& operator=(QUndoCommandWrapper &&) = delete;

    QUndoCommandWrapper(::QUndoCommand * parent = nullptr);
    QUndoCommandWrapper(const ::QString & text, ::QUndoCommand * parent = nullptr);
    int id() const override;
    bool mergeWith(const ::QUndoCommand * other) override;
    void redo() override;
    void undo() override;
    ~QUndoCommandWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[4] = {false, false, false, false};
};

#endif // SBK_QUndoCommandWrapper_H

