// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QWhatsThisClickedEventWrapper_H
#define SBK_QWhatsThisClickedEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

class QWhatsThisClickedEventWrapper : public QWhatsThisClickedEvent
{
public:
    QWhatsThisClickedEventWrapper(const QWhatsThisClickedEventWrapper &) = delete;
    QWhatsThisClickedEventWrapper& operator=(const QWhatsThisClickedEventWrapper &) = delete;
    QWhatsThisClickedEventWrapper(QWhatsThisClickedEventWrapper &&) = delete;
    QWhatsThisClickedEventWrapper& operator=(QWhatsThisClickedEventWrapper &&) = delete;

    QWhatsThisClickedEventWrapper(const ::QString & href);
    QWhatsThisClickedEventWrapper(const QWhatsThisClickedEvent& self) : QWhatsThisClickedEvent(self)
    {
    }

    ::QWhatsThisClickedEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QWhatsThisClickedEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QWhatsThisClickedEventWrapper_H

