// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QWindowStateChangeEventWrapper_H
#define SBK_QWindowStateChangeEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

class QWindowStateChangeEventWrapper : public QWindowStateChangeEvent
{
public:
    QWindowStateChangeEventWrapper(const QWindowStateChangeEventWrapper &) = delete;
    QWindowStateChangeEventWrapper& operator=(const QWindowStateChangeEventWrapper &) = delete;
    QWindowStateChangeEventWrapper(QWindowStateChangeEventWrapper &&) = delete;
    QWindowStateChangeEventWrapper& operator=(QWindowStateChangeEventWrapper &&) = delete;

    QWindowStateChangeEventWrapper(::QFlags<Qt::WindowState> oldState, bool isOverride = false);
    QWindowStateChangeEventWrapper(const QWindowStateChangeEvent& self) : QWindowStateChangeEvent(self)
    {
    }

    ::QWindowStateChangeEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QWindowStateChangeEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QWindowStateChangeEventWrapper_H

