// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qthelp_python.h"

// main header
#include "qhelpcontentitem_wrapper.h"

// Argument includes
#include <QString>
#include <QtHelp/qhelpcontentitem.h>
#include <qurl.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static PyObject *Sbk_QHelpContentItemFunc_child(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QHelpContentItem *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpContentItem_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QHelpContentItem::child(int)const->QHelpContentItem*
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // child(int)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "child", errInfo, SbkPySide6_QtHelpTypeStructs[SBK_QHelpContentItem_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // child(int)const
            QHelpContentItem * cppResult = const_cast<const ::QHelpContentItem *>(cppSelf)->child(cppArg0);
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpContentItem_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QHelpContentItemFunc_childCount(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QHelpContentItem *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpContentItem_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // childCount()const
        int cppResult = const_cast<const ::QHelpContentItem *>(cppSelf)->childCount();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QHelpContentItemFunc_childPosition(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QHelpContentItem *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpContentItem_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QHelpContentItem::childPosition(QHelpContentItem*)const->int
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpContentItem_IDX]), (pyArg)))) {
        overloadId = 0; // childPosition(QHelpContentItem*)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "childPosition", errInfo, SbkPySide6_QtHelpTypeStructs[SBK_QHelpContentItem_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QHelpContentItem *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // childPosition(QHelpContentItem*)const
            int cppResult = const_cast<const ::QHelpContentItem *>(cppSelf)->childPosition(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QHelpContentItemFunc_parent(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QHelpContentItem *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpContentItem_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // parent()const
        QHelpContentItem * cppResult = const_cast<const ::QHelpContentItem *>(cppSelf)->parent();
        pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpContentItem_IDX]), cppResult);

        // Ownership transferences.
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QHelpContentItemFunc_row(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QHelpContentItem *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpContentItem_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // row()const
        int cppResult = const_cast<const ::QHelpContentItem *>(cppSelf)->row();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QHelpContentItemFunc_title(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QHelpContentItem *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpContentItem_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // title()const
        QString cppResult = const_cast<const ::QHelpContentItem *>(cppSelf)->title();
        pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QHelpContentItemFunc_url(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QHelpContentItem *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHelpTypeStructs[SBK_QHelpContentItem_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // url()const
        QUrl cppResult = const_cast<const ::QHelpContentItem *>(cppSelf)->url();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QHelpContentItem_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QHelpContentItem_methods[] = {
    {"child", reinterpret_cast<PyCFunction>(Sbk_QHelpContentItemFunc_child), METH_O, nullptr},
    {"childCount", reinterpret_cast<PyCFunction>(Sbk_QHelpContentItemFunc_childCount), METH_NOARGS, nullptr},
    {"childPosition", reinterpret_cast<PyCFunction>(Sbk_QHelpContentItemFunc_childPosition), METH_O, nullptr},
    {"parent", reinterpret_cast<PyCFunction>(Sbk_QHelpContentItemFunc_parent), METH_NOARGS, nullptr},
    {"row", reinterpret_cast<PyCFunction>(Sbk_QHelpContentItemFunc_row), METH_NOARGS, nullptr},
    {"title", reinterpret_cast<PyCFunction>(Sbk_QHelpContentItemFunc_title), METH_NOARGS, nullptr},
    {"url", reinterpret_cast<PyCFunction>(Sbk_QHelpContentItemFunc_url), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QHelpContentItem_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QHelpContentItem_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QHelpContentItem_Type = nullptr;
static PyTypeObject *Sbk_QHelpContentItem_TypeF(void)
{
    return _Sbk_QHelpContentItem_Type;
}

static PyType_Slot Sbk_QHelpContentItem_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QHelpContentItem_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QHelpContentItem_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QHelpContentItem_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QHelpContentItem_spec = {
    "2:PySide6.QtHelp.QHelpContentItem",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC,
    Sbk_QHelpContentItem_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QHelpContentItem_PythonToCpp_QHelpContentItem_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QHelpContentItem_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QHelpContentItem_PythonToCpp_QHelpContentItem_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QHelpContentItem_TypeF()))
        return QHelpContentItem_PythonToCpp_QHelpContentItem_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QHelpContentItem_PTR_CppToPython_QHelpContentItem(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QHelpContentItem_TypeF(), const_cast<void *>(cppIn), false);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QHelpContentItem_SignatureStrings[] = {
    "PySide6.QtHelp.QHelpContentItem.child(self,row:int)->PySide6.QtHelp.QHelpContentItem",
    "PySide6.QtHelp.QHelpContentItem.childCount(self)->int",
    "PySide6.QtHelp.QHelpContentItem.childPosition(self,child:PySide6.QtHelp.QHelpContentItem)->int",
    "PySide6.QtHelp.QHelpContentItem.parent(self)->PySide6.QtHelp.QHelpContentItem",
    "PySide6.QtHelp.QHelpContentItem.row(self)->int",
    "PySide6.QtHelp.QHelpContentItem.title(self)->QString",
    "PySide6.QtHelp.QHelpContentItem.url(self)->PySide6.QtCore.QUrl",
    nullptr}; // Sentinel
#else
static constexpr size_t QHelpContentItem_SignatureByteSize = 143;
static constexpr uint8_t QHelpContentItem_SignatureBytes[143] = {
    0x78, 0xda, 0x0b, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0xf1, 0x48, 0xcd, 0x29,
    0xd0, 0x0b, 0x04, 0x91, 0xce, 0xf9, 0x79, 0x25, 0xa9, 0x79, 0x25, 0x9e, 0x25, 0xa9, 0xb9, 0x7a,
    0xc9, 0x19, 0x99, 0x39, 0x29, 0x1a, 0xc5, 0xa9, 0x39, 0x69, 0x3a, 0x45, 0xf9, 0xe5, 0x56, 0x99,
    0x79, 0x25, 0x9a, 0xba, 0x76, 0x01, 0xf8, 0x35, 0x71, 0x05, 0x10, 0x63, 0xa8, 0x73, 0x7e, 0x69,
    0x5e, 0x09, 0xd8, 0x64, 0xa0, 0x89, 0x40, 0x73, 0x89, 0xd3, 0x15, 0x90, 0x5f, 0x9c, 0x59, 0x92,
    0x99, 0x9f, 0x07, 0x71, 0x12, 0x58, 0xc8, 0x8a, 0x80, 0x46, 0x22, 0x8d, 0x2f, 0x48, 0x2c, 0x4a,
    0x45, 0x38, 0x88, 0x52, 0x2f, 0x02, 0x03, 0x8b, 0x14, 0xbf, 0x95, 0x64, 0x96, 0xe4, 0xa4, 0xc2,
    0x34, 0x04, 0x06, 0x97, 0x14, 0x65, 0xe6, 0xa5, 0x13, 0xd4, 0x54, 0x5a, 0x94, 0x83, 0xe9, 0x5c,
    0xe7, 0xfc, 0xa2, 0x54, 0xbd, 0xc0, 0xd0, 0xa2, 0x1c, 0x2e, 0x00, 0x44, 0x50, 0xaa, 0x56
};
#endif

PyTypeObject *init_QHelpContentItem(PyObject *module)
{
    if (SbkPySide6_QtHelpTypeStructs[SBK_QHelpContentItem_IDX].type != nullptr)
        return SbkPySide6_QtHelpTypeStructs[SBK_QHelpContentItem_IDX].type;

    Shiboken::AutoDecRef Sbk_QHelpContentItem_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QHelpContentItem_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QHelpContentItem",
        "QHelpContentItem*",
        &Sbk_QHelpContentItem_spec,
        &Shiboken::callCppDestructor< ::QHelpContentItem >,
        Sbk_QHelpContentItem_Type_bases.object(),
        0);
    auto *pyType = Sbk_QHelpContentItem_TypeF(); // references _Sbk_QHelpContentItem_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QHelpContentItem_SignatureStrings);
#else
    InitSignatureBytes(pyType, QHelpContentItem_SignatureBytes, QHelpContentItem_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QHelpContentItem_PropertyStrings);
    SbkPySide6_QtHelpTypeStructs[SBK_QHelpContentItem_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QHelpContentItem_PythonToCpp_QHelpContentItem_PTR,
        is_QHelpContentItem_PythonToCpp_QHelpContentItem_PTR_Convertible,
        QHelpContentItem_PTR_CppToPython_QHelpContentItem);

    Shiboken::Conversions::registerConverterName(converter, "QHelpContentItem");
    Shiboken::Conversions::registerConverterName(converter, "QHelpContentItem*");
    Shiboken::Conversions::registerConverterName(converter, "QHelpContentItem&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QHelpContentItem).name());

    qRegisterMetaType< ::QHelpContentItem *>();

    return pyType;
}
