// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QHttpServerRouterRuleWrapper_H
#define SBK_QHttpServerRouterRuleWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtHttpServer/qhttpserverrouterrule.h>

class QHttpServerRouterRuleWrapper : public QHttpServerRouterRule
{
public:
    QHttpServerRouterRuleWrapper(const QHttpServerRouterRuleWrapper &) = delete;
    QHttpServerRouterRuleWrapper& operator=(const QHttpServerRouterRuleWrapper &) = delete;
    QHttpServerRouterRuleWrapper(QHttpServerRouterRuleWrapper &&) = delete;
    QHttpServerRouterRuleWrapper& operator=(QHttpServerRouterRuleWrapper &&) = delete;

    bool matches(const ::QHttpServerRequest & request, ::QRegularExpressionMatch * match) const override;
    ~QHttpServerRouterRuleWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QHttpServerRouterRuleWrapper_H

