// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qthttpserver_python.h"

// main header
#include "qhttpserverwebsocketupgraderesponse_wrapper.h"

// Argument includes
#include <QtHttpServer/qhttpserverwebsocketupgraderesponse.h>
#include <qbytearray.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QHttpServerWebSocketUpgradeResponse_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QHttpServerWebSocketUpgradeResponse >()))
        return -1;

    ::QHttpServerWebSocketUpgradeResponse *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QHttpServerWebSocketUpgradeResponse", 1, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QHttpServerWebSocketUpgradeResponse::QHttpServerWebSocketUpgradeResponse(QHttpServerWebSocketUpgradeResponse)
    if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX]), (pyArgs[0])))) {
        overloadId = 0; // QHttpServerWebSocketUpgradeResponse(QHttpServerWebSocketUpgradeResponse)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return -1;
        ::QHttpServerWebSocketUpgradeResponse *cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // QHttpServerWebSocketUpgradeResponse(QHttpServerWebSocketUpgradeResponse)
            cptr = new ::QHttpServerWebSocketUpgradeResponse(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QHttpServerWebSocketUpgradeResponse >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QHttpServerWebSocketUpgradeResponseFunc_accept(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // accept()
        QHttpServerWebSocketUpgradeResponse* cppResult = new QHttpServerWebSocketUpgradeResponse(::QHttpServerWebSocketUpgradeResponse::accept());
        pyResult = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX]), cppResult, true, true);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QHttpServerWebSocketUpgradeResponseFunc_deny(PyObject *self, PyObject *args)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    if (numArgs == 1)
        return Shiboken::returnWrongArguments(args, "deny", errInfo, SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX]);

    if (PyArg_UnpackTuple(args, "deny", 0, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QHttpServerWebSocketUpgradeResponse::deny()->QHttpServerWebSocketUpgradeResponse
    // 1: static QHttpServerWebSocketUpgradeResponse::deny(int,QByteArray)->QHttpServerWebSocketUpgradeResponse
    if (numArgs == 0) {
        overloadId = 0; // deny()
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArgs[1])))) {
        overloadId = 1; // deny(int,QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "deny", errInfo, SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX]);

    // Call function/method
    switch (overloadId) {
        case 0: // deny()
        {

            // deny()
            QHttpServerWebSocketUpgradeResponse* cppResult = new QHttpServerWebSocketUpgradeResponse(::QHttpServerWebSocketUpgradeResponse::deny());
            pyResult = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX]), cppResult, true, true);
            break;
        }
        case 1: // deny(int status, QByteArray message)
        {
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QByteArray cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // deny(int,QByteArray)
                QHttpServerWebSocketUpgradeResponse* cppResult = new QHttpServerWebSocketUpgradeResponse(::QHttpServerWebSocketUpgradeResponse::deny(cppArg0, cppArg1));
                pyResult = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX]), cppResult, true, true);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QHttpServerWebSocketUpgradeResponseFunc_denyMessage(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QHttpServerWebSocketUpgradeResponse *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // denyMessage()
        QByteArray cppResult = cppSelf->denyMessage();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QHttpServerWebSocketUpgradeResponseFunc_denyStatus(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QHttpServerWebSocketUpgradeResponse *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // denyStatus()const
        int cppResult = const_cast<const ::QHttpServerWebSocketUpgradeResponse *>(cppSelf)->denyStatus();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QHttpServerWebSocketUpgradeResponseFunc_passToNext(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // passToNext()
        QHttpServerWebSocketUpgradeResponse* cppResult = new QHttpServerWebSocketUpgradeResponse(::QHttpServerWebSocketUpgradeResponse::passToNext());
        pyResult = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX]), cppResult, true, true);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QHttpServerWebSocketUpgradeResponseFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QHttpServerWebSocketUpgradeResponse *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QHttpServerWebSocketUpgradeResponse::swap(QHttpServerWebSocketUpgradeResponse&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QHttpServerWebSocketUpgradeResponse&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "swap", errInfo, SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QHttpServerWebSocketUpgradeResponse *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QHttpServerWebSocketUpgradeResponse&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QHttpServerWebSocketUpgradeResponseFunc_type(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QHttpServerWebSocketUpgradeResponse *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // type()const
        QHttpServerWebSocketUpgradeResponse::ResponseType cppResult = const_cast<const ::QHttpServerWebSocketUpgradeResponse *>(cppSelf)->type();
        pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_ResponseType_IDX])))->converter, &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QHttpServerWebSocketUpgradeResponse_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QHttpServerWebSocketUpgradeResponse_EnumFlagInfo[] = {
    "ResponseType:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QHttpServerWebSocketUpgradeResponse_methods[] = {
    {"accept", reinterpret_cast<PyCFunction>(Sbk_QHttpServerWebSocketUpgradeResponseFunc_accept), METH_NOARGS|METH_STATIC, nullptr},
    {"deny", reinterpret_cast<PyCFunction>(Sbk_QHttpServerWebSocketUpgradeResponseFunc_deny), METH_VARARGS|METH_STATIC, nullptr},
    {"denyMessage", reinterpret_cast<PyCFunction>(Sbk_QHttpServerWebSocketUpgradeResponseFunc_denyMessage), METH_NOARGS, nullptr},
    {"denyStatus", reinterpret_cast<PyCFunction>(Sbk_QHttpServerWebSocketUpgradeResponseFunc_denyStatus), METH_NOARGS, nullptr},
    {"passToNext", reinterpret_cast<PyCFunction>(Sbk_QHttpServerWebSocketUpgradeResponseFunc_passToNext), METH_NOARGS|METH_STATIC, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QHttpServerWebSocketUpgradeResponseFunc_swap), METH_O, nullptr},
    {"type", reinterpret_cast<PyCFunction>(Sbk_QHttpServerWebSocketUpgradeResponseFunc_type), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QHttpServerWebSocketUpgradeResponse_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QHttpServerWebSocketUpgradeResponse_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QHttpServerWebSocketUpgradeResponse_Type = nullptr;
static PyTypeObject *Sbk_QHttpServerWebSocketUpgradeResponse_TypeF(void)
{
    return _Sbk_QHttpServerWebSocketUpgradeResponse_Type;
}

static PyType_Slot Sbk_QHttpServerWebSocketUpgradeResponse_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QHttpServerWebSocketUpgradeResponse_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QHttpServerWebSocketUpgradeResponse_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QHttpServerWebSocketUpgradeResponse_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QHttpServerWebSocketUpgradeResponse_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QHttpServerWebSocketUpgradeResponse_spec = {
    "2:PySide6.QtHttpServer.QHttpServerWebSocketUpgradeResponse",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC,
    Sbk_QHttpServerWebSocketUpgradeResponse_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QHttpServerWebSocketUpgradeResponse_ResponseType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QHttpServerWebSocketUpgradeResponse::ResponseType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QHttpServerWebSocketUpgradeResponse::ResponseType *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QHttpServerWebSocketUpgradeResponse_ResponseType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_ResponseType_IDX])))
        return Enum_PythonToCpp_QHttpServerWebSocketUpgradeResponse_ResponseType;
    return {};
}

static PyObject *QHttpServerWebSocketUpgradeResponse_ResponseType_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QHttpServerWebSocketUpgradeResponse::ResponseType>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QHttpServerWebSocketUpgradeResponse::ResponseType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_ResponseType_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QHttpServerWebSocketUpgradeResponse_PythonToCpp_QHttpServerWebSocketUpgradeResponse_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QHttpServerWebSocketUpgradeResponse_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QHttpServerWebSocketUpgradeResponse_PythonToCpp_QHttpServerWebSocketUpgradeResponse_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QHttpServerWebSocketUpgradeResponse_TypeF()))
        return QHttpServerWebSocketUpgradeResponse_PythonToCpp_QHttpServerWebSocketUpgradeResponse_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QHttpServerWebSocketUpgradeResponse_PTR_CppToPython_QHttpServerWebSocketUpgradeResponse(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QHttpServerWebSocketUpgradeResponse_TypeF(), const_cast<void *>(cppIn), false);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QHttpServerWebSocketUpgradeResponse_SignatureStrings[] = {
    "PySide6.QtHttpServer.QHttpServerWebSocketUpgradeResponse(self,other:PySide6.QtHttpServer.QHttpServerWebSocketUpgradeResponse)",
    "PySide6.QtHttpServer.QHttpServerWebSocketUpgradeResponse.accept()->PySide6.QtHttpServer.QHttpServerWebSocketUpgradeResponse",
    "1:PySide6.QtHttpServer.QHttpServerWebSocketUpgradeResponse.deny()->PySide6.QtHttpServer.QHttpServerWebSocketUpgradeResponse",
    "0:PySide6.QtHttpServer.QHttpServerWebSocketUpgradeResponse.deny(status:int,message:typing.Union[PySide6.QtCore.QByteArray, char*])->PySide6.QtHttpServer.QHttpServerWebSocketUpgradeResponse",
    "PySide6.QtHttpServer.QHttpServerWebSocketUpgradeResponse.denyMessage(self)->PySide6.QtCore.QByteArray",
    "PySide6.QtHttpServer.QHttpServerWebSocketUpgradeResponse.denyStatus(self)->int",
    "PySide6.QtHttpServer.QHttpServerWebSocketUpgradeResponse.passToNext()->PySide6.QtHttpServer.QHttpServerWebSocketUpgradeResponse",
    "PySide6.QtHttpServer.QHttpServerWebSocketUpgradeResponse.swap(self,other:PySide6.QtHttpServer.QHttpServerWebSocketUpgradeResponse)",
    "PySide6.QtHttpServer.QHttpServerWebSocketUpgradeResponse.type(self)->PySide6.QtHttpServer.QHttpServerWebSocketUpgradeResponse.ResponseType",
    nullptr}; // Sentinel
#else
static constexpr size_t QHttpServerWebSocketUpgradeResponse_SignatureByteSize = 218;
static constexpr uint8_t QHttpServerWebSocketUpgradeResponse_SignatureBytes[218] = {
    0x78, 0xda, 0xc5, 0x93, 0x3d, 0x6f, 0xc2, 0x30, 0x14, 0x45, 0xf7, 0xfc, 0x0a, 0x46, 0x82, 0x52,
    0xab, 0x5d, 0x18, 0x32, 0x20, 0xd1, 0x2e, 0x2c, 0x54, 0x84, 0x80, 0x3a, 0x54, 0x0c, 0x26, 0xb9,
    0x4d, 0x22, 0xa8, 0x6d, 0xf9, 0x3d, 0x3e, 0xfc, 0xef, 0x1b, 0x51, 0x45, 0x11, 0x88, 0x05, 0x7b,
    0x60, 0x7b, 0x8b, 0xcf, 0x3d, 0x7a, 0xbe, 0x6f, 0xe1, 0xf2, 0xa6, 0xc4, 0x58, 0x64, 0x3c, 0x63,
    0x36, 0x39, 0xec, 0x11, 0x56, 0x64, 0xfd, 0xfc, 0x85, 0x6d, 0xae, 0x8b, 0x1d, 0x78, 0x6d, 0x2a,
    0x2b, 0x4b, 0x2c, 0x41, 0x46, 0x2b, 0xc2, 0x90, 0xb0, 0xff, 0x49, 0x34, 0xd7, 0xb0, 0xe9, 0xc2,
    0x93, 0x11, 0x47, 0xbe, 0x2f, 0x85, 0x2c, 0x0a, 0x18, 0x1e, 0xc6, 0x2f, 0x13, 0x5f, 0x44, 0xf4,
    0xe6, 0xed, 0x2d, 0x4a, 0x28, 0x17, 0x94, 0xfd, 0x1a, 0x98, 0x4d, 0x2c, 0xf9, 0x40, 0x69, 0xa3,
    0x38, 0xf9, 0x05, 0x91, 0xac, 0x90, 0xb2, 0x33, 0x8d, 0xaa, 0xc4, 0x5a, 0x35, 0x5a, 0x7d, 0xf7,
    0xf4, 0x0f, 0x6d, 0x21, 0xb2, 0x77, 0xc7, 0x98, 0x5a, 0x2b, 0x5d, 0x32, 0x28, 0x6a, 0x69, 0x47,
    0x9b, 0x10, 0xf9, 0x20, 0xf5, 0xf9, 0xbf, 0xee, 0xa5, 0x3e, 0x57, 0x12, 0x37, 0xa2, 0x61, 0x29,
    0xf9, 0x65, 0x3f, 0x5d, 0x48, 0xbb, 0x26, 0x7f, 0x9c, 0x91, 0x44, 0x2b, 0xfd, 0x89, 0x73, 0x58,
    0xdb, 0xbc, 0xf3, 0xe9, 0x24, 0xcd, 0x93, 0x8f, 0xad, 0xad, 0xd6, 0x9d, 0x0f, 0x7b, 0x10, 0xd2,
    0x0d, 0xab, 0x16, 0x16, 0xfd, 0x01, 0x5f, 0x5f, 0xaf, 0xa6
};
#endif

PyTypeObject *init_QHttpServerWebSocketUpgradeResponse(PyObject *module)
{
    if (SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX].type != nullptr)
        return SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX].type;

    Shiboken::AutoDecRef Sbk_QHttpServerWebSocketUpgradeResponse_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QHttpServerWebSocketUpgradeResponse_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QHttpServerWebSocketUpgradeResponse",
        "QHttpServerWebSocketUpgradeResponse*",
        &Sbk_QHttpServerWebSocketUpgradeResponse_spec,
        &Shiboken::callCppDestructor< ::QHttpServerWebSocketUpgradeResponse >,
        Sbk_QHttpServerWebSocketUpgradeResponse_Type_bases.object(),
        0);
    auto *pyType = Sbk_QHttpServerWebSocketUpgradeResponse_TypeF(); // references _Sbk_QHttpServerWebSocketUpgradeResponse_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QHttpServerWebSocketUpgradeResponse_SignatureStrings);
#else
    InitSignatureBytes(pyType, QHttpServerWebSocketUpgradeResponse_SignatureBytes, QHttpServerWebSocketUpgradeResponse_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QHttpServerWebSocketUpgradeResponse_PropertyStrings);
    SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QHttpServerWebSocketUpgradeResponse_PythonToCpp_QHttpServerWebSocketUpgradeResponse_PTR,
        is_QHttpServerWebSocketUpgradeResponse_PythonToCpp_QHttpServerWebSocketUpgradeResponse_PTR_Convertible,
        QHttpServerWebSocketUpgradeResponse_PTR_CppToPython_QHttpServerWebSocketUpgradeResponse);

    Shiboken::Conversions::registerConverterName(converter, "QHttpServerWebSocketUpgradeResponse");
    Shiboken::Conversions::registerConverterName(converter, "QHttpServerWebSocketUpgradeResponse*");
    Shiboken::Conversions::registerConverterName(converter, "QHttpServerWebSocketUpgradeResponse&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QHttpServerWebSocketUpgradeResponse).name());

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QHttpServerWebSocketUpgradeResponse_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'ResponseType'.
    const char *ResponseType_Initializer[] = {
        "Accept",
        "Deny",
        "PassToNext",
        nullptr};
    // "int8_t" used instead of "int"
    constexpr int8_t ResponseType_InitializerValues[] = {
        int8_t(QHttpServerWebSocketUpgradeResponse::ResponseType::Accept),    //  0x00  0
        int8_t(QHttpServerWebSocketUpgradeResponse::ResponseType::Deny),      //  0x01  1
        int8_t(QHttpServerWebSocketUpgradeResponse::ResponseType::PassToNext) //  0x02  2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QHttpServerWebSocketUpgradeResponse_TypeF(),
        "2:PySide6.QtHttpServer.QHttpServerWebSocketUpgradeResponse.ResponseType",
        ResponseType_Initializer, ResponseType_InitializerValues);
    SbkPySide6_QtHttpServerTypeStructs[SBK_QHttpServerWebSocketUpgradeResponse_ResponseType_IDX].type = EType;
    // Register converter for enum 'QHttpServerWebSocketUpgradeResponse::ResponseType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QHttpServerWebSocketUpgradeResponse_ResponseType_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QHttpServerWebSocketUpgradeResponse_ResponseType,
            is_Enum_PythonToCpp_QHttpServerWebSocketUpgradeResponse_ResponseType_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QHttpServerWebSocketUpgradeResponse::ResponseType");
        Shiboken::Conversions::registerConverterAlias(converter, "ResponseType");
        Shiboken::Enum::setTypeConverter(EType, converter, nullptr);
    }
    // End of 'ResponseType' enum.

    qRegisterMetaType< ::QHttpServerWebSocketUpgradeResponse *>();
    qRegisterMetaType< ::QHttpServerWebSocketUpgradeResponse::ResponseType >("QHttpServerWebSocketUpgradeResponse::ResponseType");

    return pyType;
}
