// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGeoServiceProviderFactoryWrapper_H
#define SBK_QGeoServiceProviderFactoryWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtLocation/qgeoserviceproviderfactory.h>

class QGeoServiceProviderFactoryWrapper : public QGeoServiceProviderFactory
{
public:
    QGeoServiceProviderFactoryWrapper(const QGeoServiceProviderFactoryWrapper &) = delete;
    QGeoServiceProviderFactoryWrapper& operator=(const QGeoServiceProviderFactoryWrapper &) = delete;
    QGeoServiceProviderFactoryWrapper(QGeoServiceProviderFactoryWrapper &&) = delete;
    QGeoServiceProviderFactoryWrapper& operator=(QGeoServiceProviderFactoryWrapper &&) = delete;

    QGeoServiceProviderFactoryWrapper();
    ::QGeoCodingManagerEngine * createGeocodingManagerEngine(const ::QMap<QString,QVariant> & parameters, ::QGeoServiceProvider::Error * error, ::QString * errorString) const override;
    ::QPlaceManagerEngine * createPlaceManagerEngine(const ::QMap<QString,QVariant> & parameters, ::QGeoServiceProvider::Error * error, ::QString * errorString) const override;
    ::QGeoRoutingManagerEngine * createRoutingManagerEngine(const ::QMap<QString,QVariant> & parameters, ::QGeoServiceProvider::Error * error, ::QString * errorString) const override;
    ~QGeoServiceProviderFactoryWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QGeoServiceProviderFactoryWrapper_H

