// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtlocation_python.h"

// main header
#include "qlocation_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {

static const char *Sbk_QLocation_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QLocation_EnumFlagInfo[] = {
    "Visibility:Flag:VisibilityScope",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QLocation_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QLocation_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QLocation_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QLocation_Type = nullptr;
static PyTypeObject *Sbk_QLocation_TypeF(void)
{
    return _Sbk_QLocation_Type;
}

static PyType_Slot Sbk_QLocation_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QLocation_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QLocation_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QLocation_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QLocation_spec = {
    "2:PySide6.QtLocation.QLocation",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QLocation_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QLocation_Visibility(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QLocation::Visibility>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QLocation::Visibility *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QLocation_Visibility_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QLocation_Visibility_IDX])))
        return Enum_PythonToCpp_QLocation_Visibility;
    return {};
}

static PyObject *QLocation_Visibility_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QLocation::Visibility>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QLocation::Visibility *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QLocation_Visibility_IDX]), castCppIn);

}

static void Flag_PythonToCpp_QLocation_Visibility(PyObject *pyIn, void *cppOut)
{
    const auto value = QFlags<::QLocation::Visibility>::fromInt(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<QFlags<::QLocation::Visibility> *>(cppOut) = value;

}

static PyObject *QLocation_Visibility_CppToPython_Flag(const void *cppIn)
{
    const auto flags = *reinterpret_cast<const QFlags<::QLocation::Visibility> *>(cppIn);
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QLocation_Visibility_IDX]), flags.toInt());

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QtLocationQLocation_SignatureStrings[] = {
    nullptr}; // Sentinel
#else
static constexpr size_t QtLocationQLocation_SignatureByteSize = 0;
static constexpr uint8_t QtLocationQLocation_SignatureBytes[1] = {
    0x00
};
#endif

PyTypeObject *init_QtLocationQLocation(PyObject *module)
{
    if (SbkPySide6_QtLocationTypeStructs[SBK_QtLocationQLocation_IDX].type != nullptr)
        return SbkPySide6_QtLocationTypeStructs[SBK_QtLocationQLocation_IDX].type;

    Shiboken::AutoDecRef Sbk_QLocation_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QLocation_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QLocation",
        "QLocation",
        &Sbk_QLocation_spec,
        nullptr,
        Sbk_QLocation_Type_bases.object(),
        0);
    auto *pyType = Sbk_QLocation_TypeF(); // references _Sbk_QLocation_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QtLocationQLocation_SignatureStrings);
#else
    InitSignatureBytes(pyType, QtLocationQLocation_SignatureBytes, QtLocationQLocation_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QLocation_PropertyStrings);
    SbkPySide6_QtLocationTypeStructs[SBK_QtLocationQLocation_IDX].type = pyType;


    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QLocation_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Visibility'.
    const char *Visibility_Initializer[] = {
        "UnspecifiedVisibility",
        "DeviceVisibility",
        "PrivateVisibility",
        "PublicVisibility",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t Visibility_InitializerValues[] = {
        uint8_t(QLocation::Visibility::UnspecifiedVisibility), //  0x00  0
        uint8_t(QLocation::Visibility::DeviceVisibility),      //  0x01  1
        uint8_t(QLocation::Visibility::PrivateVisibility),     //  0x02  2
        uint8_t(QLocation::Visibility::PublicVisibility)       //  0x04  4
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QLocation_TypeF(),
        "2:PySide6.QtLocation.QLocation.Visibility",
        Visibility_Initializer, Visibility_InitializerValues);
    SbkPySide6_QtLocationTypeStructs[SBK_QLocation_Visibility_IDX].type = EType;
    // PYSIDE-1735: Mapping the flags class to the same enum class.
    SbkPySide6_QtLocationTypeStructs[SBK_QFlags_QLocation_Visibility_IDX].type =
        EType;
    // Register converter for enum 'QLocation::Visibility'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QLocation_Visibility_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QLocation_Visibility,
            is_Enum_PythonToCpp_QLocation_Visibility_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QLocation::Visibility");
        Shiboken::Conversions::registerConverterAlias(converter, "Visibility");
        SbkConverter *flagsConverter = Shiboken::Conversions::createConverter(EType,
            QLocation_Visibility_CppToPython_Flag);
        Shiboken::Conversions::addPythonToCppValueConversion(flagsConverter,
            Flag_PythonToCpp_QLocation_Visibility,
            is_Enum_PythonToCpp_QLocation_Visibility_Convertible);
        // Register converter for flag 'QFlags<QLocation::Visibility>'.
        Shiboken::Conversions::registerConverterName(flagsConverter, "QFlags<QLocation::Visibility>");
        Shiboken::Conversions::registerConverterName(flagsConverter, "QLocation::VisibilityScope");
        Shiboken::Enum::setTypeConverter(EType, converter, flagsConverter);
    }
    // End of 'Visibility' enum/flags.

    qRegisterMetaType< ::QLocation::Visibility >("QLocation::Visibility");

    return pyType;
}
