// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtlocation_python.h"

// main header
#include "qplacecontactdetail_wrapper.h"

// Argument includes
#include <QString>
#include <QtLocation/qplacecontactdetail.h>
#include <qobject.h>
#include <qobjectdefs.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QPlaceContactDetail_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QPlaceContactDetail >()))
        return -1;

    ::QPlaceContactDetail *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QPlaceContactDetail", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QPlaceContactDetail::QPlaceContactDetail()
    // 1: QPlaceContactDetail::QPlaceContactDetail(QPlaceContactDetail)
    if (numArgs == 0) {
        overloadId = 0; // QPlaceContactDetail()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QPlaceContactDetail(QPlaceContactDetail)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QPlaceContactDetail()
        {

            // QPlaceContactDetail()
            cptr = new ::QPlaceContactDetail();
            break;
        }
        case 1: // QPlaceContactDetail(const QPlaceContactDetail &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QPlaceContactDetail cppArg0_local;
            ::QPlaceContactDetail *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QPlaceContactDetail(QPlaceContactDetail)
                cptr = new ::QPlaceContactDetail(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QPlaceContactDetail >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QPlaceContactDetailFunc_clear(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPlaceContactDetail *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // clear()
        cppSelf->clear();
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QPlaceContactDetailFunc_label(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPlaceContactDetail *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // label()const
        QString cppResult = const_cast<const ::QPlaceContactDetail *>(cppSelf)->label();
        pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPlaceContactDetailFunc_setLabel(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPlaceContactDetail *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QPlaceContactDetail::setLabel(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setLabel(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setLabel", errInfo, SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setLabel(QString)
            cppSelf->setLabel(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QPlaceContactDetailFunc_setValue(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPlaceContactDetail *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QPlaceContactDetail::setValue(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setValue(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setValue", errInfo, SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setValue(QString)
            cppSelf->setValue(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QPlaceContactDetailFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPlaceContactDetail *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QPlaceContactDetail::swap(QPlaceContactDetail&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QPlaceContactDetail&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "swap", errInfo, SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QPlaceContactDetail cppArg0_local;
        ::QPlaceContactDetail *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QPlaceContactDetail&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QPlaceContactDetailFunc_value(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPlaceContactDetail *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // value()const
        QString cppResult = const_cast<const ::QPlaceContactDetail *>(cppSelf)->value();
        pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPlaceContactDetail__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QPlaceContactDetail *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QPlaceContactDetail_PropertyStrings[] = {
    "label::",
    "value::",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QPlaceContactDetail_methods[] = {
    {"clear", reinterpret_cast<PyCFunction>(Sbk_QPlaceContactDetailFunc_clear), METH_NOARGS, nullptr},
    {"label", reinterpret_cast<PyCFunction>(Sbk_QPlaceContactDetailFunc_label), METH_NOARGS, nullptr},
    {"setLabel", reinterpret_cast<PyCFunction>(Sbk_QPlaceContactDetailFunc_setLabel), METH_O, nullptr},
    {"setValue", reinterpret_cast<PyCFunction>(Sbk_QPlaceContactDetailFunc_setValue), METH_O, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QPlaceContactDetailFunc_swap), METH_O, nullptr},
    {"value", reinterpret_cast<PyCFunction>(Sbk_QPlaceContactDetailFunc_value), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QPlaceContactDetail__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QPlaceContactDetail_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QPlaceContactDetail *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]), (pyArg)))) {
                // operator!=(const QPlaceContactDetail &rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QPlaceContactDetail cppArg0_local;
                ::QPlaceContactDetail *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]), (pyArg)))) {
                // operator==(const QPlaceContactDetail &rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QPlaceContactDetail cppArg0_local;
                ::QPlaceContactDetail *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QPlaceContactDetail_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QPlaceContactDetail_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QPlaceContactDetail_Type = nullptr;
static PyTypeObject *Sbk_QPlaceContactDetail_TypeF(void)
{
    return _Sbk_QPlaceContactDetail_Type;
}

static PyType_Slot Sbk_QPlaceContactDetail_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QPlaceContactDetail_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QPlaceContactDetail_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QPlaceContactDetail_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QPlaceContactDetail_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QPlaceContactDetail_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QPlaceContactDetail_spec = {
    "2:PySide6.QtLocation.QPlaceContactDetail",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QPlaceContactDetail_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QPlaceContactDetail_PythonToCpp_QPlaceContactDetail_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QPlaceContactDetail_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QPlaceContactDetail_PythonToCpp_QPlaceContactDetail_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QPlaceContactDetail_TypeF()))
        return QPlaceContactDetail_PythonToCpp_QPlaceContactDetail_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QPlaceContactDetail_PTR_CppToPython_QPlaceContactDetail(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QPlaceContactDetail_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QPlaceContactDetail_COPY_CppToPython_QPlaceContactDetail(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QPlaceContactDetail *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QPlaceContactDetail_TypeF(), new ::QPlaceContactDetail(*source), true, true);
}

// Python to C++ copy conversion.
static void QPlaceContactDetail_PythonToCpp_QPlaceContactDetail_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QPlaceContactDetail *>(cppOut) = *reinterpret_cast< ::QPlaceContactDetail *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QPlaceContactDetail_PythonToCpp_QPlaceContactDetail_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QPlaceContactDetail_TypeF()))
        return QPlaceContactDetail_PythonToCpp_QPlaceContactDetail_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QPlaceContactDetail_SignatureStrings[] = {
    "1:PySide6.QtLocation.QPlaceContactDetail(self,*:KeywordOnly=None,label:QString=None,value:QString=None)",
    "0:PySide6.QtLocation.QPlaceContactDetail(self,other:PySide6.QtLocation.QPlaceContactDetail,*:KeywordOnly=None,label:QString=None,value:QString=None)",
    "PySide6.QtLocation.QPlaceContactDetail.clear(self)",
    "PySide6.QtLocation.QPlaceContactDetail.label(self)->QString",
    "PySide6.QtLocation.QPlaceContactDetail.setLabel(self,label:QString)",
    "PySide6.QtLocation.QPlaceContactDetail.setValue(self,value:QString)",
    "PySide6.QtLocation.QPlaceContactDetail.swap(self,other:PySide6.QtLocation.QPlaceContactDetail)",
    "PySide6.QtLocation.QPlaceContactDetail.value(self)->QString",
    "PySide6.QtLocation.QPlaceContactDetail.__copy__(self)->typing.Self",
    "PySide6.QtLocation.QPlaceContactDetail.__ne__(self,rhs:PySide6.QtLocation.QPlaceContactDetail)->bool",
    "PySide6.QtLocation.QPlaceContactDetail.__eq__(self,rhs:PySide6.QtLocation.QPlaceContactDetail)->bool",
    nullptr}; // Sentinel
#else
static constexpr size_t QPlaceContactDetail_SignatureByteSize = 202;
static constexpr uint8_t QPlaceContactDetail_SignatureBytes[202] = {
    0x78, 0xda, 0xa5, 0x91, 0x31, 0x0f, 0x82, 0x30, 0x10, 0x85, 0x77, 0x7f, 0x89, 0x18, 0x20, 0xba,
    0x38, 0x90, 0xc8, 0xa2, 0x9b, 0x46, 0x25, 0x24, 0xae, 0xa4, 0x94, 0x53, 0x9b, 0x5c, 0x7a, 0x58,
    0x4e, 0x4d, 0xff, 0xbd, 0x0a, 0x6a, 0xc2, 0x76, 0xe8, 0xd8, 0x26, 0xdf, 0xf7, 0xde, 0x6b, 0x67,
    0xc9, 0xde, 0xe7, 0xa6, 0x82, 0x79, 0x9c, 0xf1, 0x86, 0xb4, 0x62, 0x43, 0x36, 0xce, 0xf6, 0xa8,
    0x34, 0x2c, 0xc9, 0xb2, 0xd2, 0xbc, 0x02, 0x56, 0x06, 0xc7, 0x0d, 0xe0, 0x31, 0x9c, 0x24, 0x6b,
    0xf0, 0x77, 0x72, 0xd5, 0xce, 0xa2, 0x5f, 0x6c, 0xc9, 0x42, 0x88, 0xaa, 0x04, 0x4c, 0xb2, 0x9c,
    0x9d, 0xb1, 0xa7, 0xee, 0xea, 0xa6, 0xf0, 0x0a, 0xbd, 0xab, 0x60, 0x34, 0x1d, 0x94, 0x43, 0x7c,
    0x06, 0x27, 0x24, 0xfe, 0x28, 0x25, 0x0b, 0x88, 0x35, 0x82, 0x72, 0x6d, 0x31, 0x31, 0xd2, 0x16,
    0xe8, 0x90, 0x28, 0x7d, 0x87, 0x4a, 0xd9, 0x06, 0x78, 0xf3, 0xc5, 0xfb, 0x53, 0x82, 0x01, 0x8e,
    0xc3, 0x6b, 0x70, 0xe7, 0xe8, 0x6d, 0x97, 0x3b, 0xee, 0xaa, 0x1e, 0xfe, 0x1d, 0x62, 0xfd, 0xed,
    0xdb, 0x6f, 0xf8, 0x13, 0x15, 0x85, 0xa6, 0xda, 0x17, 0xc5, 0x07, 0x67, 0x5f, 0x3f, 0xe9, 0x38,
    0x7f, 0x9e, 0xe4, 0x0a, 0x0b, 0x6f, 0x41, 0xe8, 0xce, 0x8d, 0x74, 0x5d, 0x94, 0x96, 0x44, 0x28,
    0x0f, 0x81, 0xcb, 0xef, 0x21, 0x0f, 0x3d, 0x9c, 0x50, 0x12
};
#endif

PyTypeObject *init_QPlaceContactDetail(PyObject *module)
{
    if (SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX].type != nullptr)
        return SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX].type;

    Shiboken::AutoDecRef Sbk_QPlaceContactDetail_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QPlaceContactDetail_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QPlaceContactDetail",
        "QPlaceContactDetail",
        &Sbk_QPlaceContactDetail_spec,
        &Shiboken::callCppDestructor< ::QPlaceContactDetail >,
        Sbk_QPlaceContactDetail_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QPlaceContactDetail_TypeF(); // references _Sbk_QPlaceContactDetail_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QPlaceContactDetail_SignatureStrings);
#else
    InitSignatureBytes(pyType, QPlaceContactDetail_SignatureBytes, QPlaceContactDetail_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QPlaceContactDetail_PropertyStrings);
    SbkPySide6_QtLocationTypeStructs[SBK_QPlaceContactDetail_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QPlaceContactDetail_PythonToCpp_QPlaceContactDetail_PTR,
        is_QPlaceContactDetail_PythonToCpp_QPlaceContactDetail_PTR_Convertible,
        QPlaceContactDetail_PTR_CppToPython_QPlaceContactDetail,
        QPlaceContactDetail_COPY_CppToPython_QPlaceContactDetail);

    Shiboken::Conversions::registerConverterName(converter, "QPlaceContactDetail");
    Shiboken::Conversions::registerConverterName(converter, "QPlaceContactDetail*");
    Shiboken::Conversions::registerConverterName(converter, "QPlaceContactDetail&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QPlaceContactDetail).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QPlaceContactDetail_PythonToCpp_QPlaceContactDetail_COPY,
        is_QPlaceContactDetail_PythonToCpp_QPlaceContactDetail_COPY_Convertible);

    qRegisterMetaType< ::QPlaceContactDetail >("QPlaceContactDetail");

    return pyType;
}

PyTypeObject *init_QPlaceContactDetailStaticFields(PyObject *module)
{
    auto *obType = PyObject_GetAttrString(module, "QPlaceContactDetail");
    auto *type = reinterpret_cast<PyTypeObject *>(obType);
    Shiboken::AutoDecRef dict(PepType_GetDict(type));
    PyDict_SetItemString(dict, "Phone",
                         Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &QPlaceContactDetail::Phone));
    PyDict_SetItemString(dict, "Email",
                         Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &QPlaceContactDetail::Email));
    PyDict_SetItemString(dict, "Website",
                         Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &QPlaceContactDetail::Website));
    PyDict_SetItemString(dict, "Fax",
                         Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &QPlaceContactDetail::Fax));
    return type;
}
