// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPlaceIdReplyWrapper_H
#define SBK_QPlaceIdReplyWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtLocation/qplaceidreply.h>

namespace PySide { class DynamicQMetaObject; }

class QPlaceIdReplyWrapper : public QPlaceIdReply
{
public:
    QPlaceIdReplyWrapper(const QPlaceIdReplyWrapper &) = delete;
    QPlaceIdReplyWrapper& operator=(const QPlaceIdReplyWrapper &) = delete;
    QPlaceIdReplyWrapper(QPlaceIdReplyWrapper &&) = delete;
    QPlaceIdReplyWrapper& operator=(QPlaceIdReplyWrapper &&) = delete;

    QPlaceIdReplyWrapper(::QPlaceIdReply::OperationType operationType, ::QObject * parent = nullptr);
    void abort() override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ::QPlaceReply::Type type() const override;
    ~QPlaceIdReplyWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9] = {false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QPlaceIdReplyWrapper_H

