// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAbstractVideoBufferWrapper_H
#define SBK_QAbstractVideoBufferWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtMultimedia/qabstractvideobuffer.h>

class QAbstractVideoBufferWrapper : public QAbstractVideoBuffer
{
public:
    QAbstractVideoBufferWrapper(const QAbstractVideoBufferWrapper &) = delete;
    QAbstractVideoBufferWrapper& operator=(const QAbstractVideoBufferWrapper &) = delete;
    QAbstractVideoBufferWrapper(QAbstractVideoBufferWrapper &&) = delete;
    QAbstractVideoBufferWrapper& operator=(QAbstractVideoBufferWrapper &&) = delete;

    QAbstractVideoBufferWrapper();
    ::QVideoFrameFormat format() const override;
    ::QAbstractVideoBuffer::MapData map(::QVideoFrame::MapMode mode) override;
    void unmap() override;
    ~QAbstractVideoBufferWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QAbstractVideoBufferWrapper_H

