// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtmultimedia_python.h"

// main header
#include "qtvideo_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {

static const char *Sbk_QtVideo_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QtVideo_EnumFlagInfo[] = {
    "Rotation:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QtVideo_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QtVideo_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QtVideo_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QtVideo_Type = nullptr;
static PyTypeObject *Sbk_QtVideo_TypeF(void)
{
    return _Sbk_QtVideo_Type;
}

static PyType_Slot Sbk_QtVideo_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QtVideo_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QtVideo_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QtVideo_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QtVideo_spec = {
    "2:PySide6.QtMultimedia.QtVideo",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QtVideo_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QtVideo_Rotation(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QtVideo::Rotation>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QtVideo::Rotation *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QtVideo_Rotation_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QtVideo_Rotation_IDX])))
        return Enum_PythonToCpp_QtVideo_Rotation;
    return {};
}

static PyObject *QtVideo_Rotation_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QtVideo::Rotation>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QtVideo::Rotation *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QtVideo_Rotation_IDX]), castCppIn);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QtMultimediaQtVideo_SignatureStrings[] = {
    nullptr}; // Sentinel
#else
static constexpr size_t QtMultimediaQtVideo_SignatureByteSize = 0;
static constexpr uint8_t QtMultimediaQtVideo_SignatureBytes[1] = {
    0x00
};
#endif

PyTypeObject *init_QtMultimediaQtVideo(PyObject *module)
{
    if (SbkPySide6_QtMultimediaTypeStructs[SBK_QtMultimediaQtVideo_IDX].type != nullptr)
        return SbkPySide6_QtMultimediaTypeStructs[SBK_QtMultimediaQtVideo_IDX].type;

    Shiboken::AutoDecRef Sbk_QtVideo_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QtVideo_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QtVideo",
        "QtVideo",
        &Sbk_QtVideo_spec,
        nullptr,
        Sbk_QtVideo_Type_bases.object(),
        0);
    auto *pyType = Sbk_QtVideo_TypeF(); // references _Sbk_QtVideo_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QtMultimediaQtVideo_SignatureStrings);
#else
    InitSignatureBytes(pyType, QtMultimediaQtVideo_SignatureBytes, QtMultimediaQtVideo_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QtVideo_PropertyStrings);
    SbkPySide6_QtMultimediaTypeStructs[SBK_QtMultimediaQtVideo_IDX].type = pyType;


    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QtVideo_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Rotation'.
    const char *Rotation_Initializer[] = {
        "None_",
        "Clockwise90",
        "Clockwise180",
        "Clockwise270",
        nullptr};
    // "int16_t" used instead of "int"
    constexpr int16_t Rotation_InitializerValues[] = {
        int16_t(QtVideo::Rotation::None),         //  0x0000  0
        int16_t(QtVideo::Rotation::Clockwise90),  //  0x005a  90
        int16_t(QtVideo::Rotation::Clockwise180), //  0x00b4  180
        int16_t(QtVideo::Rotation::Clockwise270)  //  0x010e  270
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QtVideo_TypeF(),
        "2:PySide6.QtMultimedia.QtVideo.Rotation",
        Rotation_Initializer, Rotation_InitializerValues);
    SbkPySide6_QtMultimediaTypeStructs[SBK_QtVideo_Rotation_IDX].type = EType;
    // Register converter for enum 'QtVideo::Rotation'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QtVideo_Rotation_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QtVideo_Rotation,
            is_Enum_PythonToCpp_QtVideo_Rotation_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QtVideo::Rotation");
        Shiboken::Conversions::registerConverterAlias(converter, "Rotation");
        Shiboken::Enum::setTypeConverter(EType, converter, nullptr);
    }
    // End of 'Rotation' enum.

    qRegisterMetaType< ::QtVideo::Rotation >("QtVideo::Rotation");

    return pyType;
}
