// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QWaveDecoderWrapper_H
#define SBK_QWaveDecoderWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtMultimedia/qwavedecoder.h>

namespace PySide { class DynamicQMetaObject; }

class QWaveDecoderWrapper : public QWaveDecoder
{
public:
    QWaveDecoderWrapper(const QWaveDecoderWrapper &) = delete;
    QWaveDecoderWrapper& operator=(const QWaveDecoderWrapper &) = delete;
    QWaveDecoderWrapper(QWaveDecoderWrapper &&) = delete;
    QWaveDecoderWrapper& operator=(QWaveDecoderWrapper &&) = delete;

    QWaveDecoderWrapper(::QIODevice * device, ::QObject * parent = nullptr);
    QWaveDecoderWrapper(::QIODevice * device, const ::QAudioFormat & format, ::QObject * parent = nullptr);
    bool atEnd() const override;
    qint64 bytesAvailable() const override;
    qint64 bytesToWrite() const override;
    bool canReadLine() const override;
    void childEvent(::QChildEvent * event) override;
    void close() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool isSequential() const override;
    bool open(::QFlags<QIODeviceBase::OpenModeFlag> mode) override;
    qint64 pos() const override;
    qint64 readLineData(char * data, qint64 maxlen) override;
    bool reset() override;
    bool seek(qint64 pos) override;
    qint64 size() const override;
    qint64 skipData(qint64 maxSize) override;
    void timerEvent(::QTimerEvent * event) override;
    bool waitForBytesWritten(int msecs) override;
    bool waitForReadyRead(int msecs) override;
    ~QWaveDecoderWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[22] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QWaveDecoderWrapper_H

