// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QLocalSocketWrapper_H
#define SBK_QLocalSocketWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtNetwork/qlocalsocket.h>

namespace PySide { class DynamicQMetaObject; }

class QLocalSocketWrapper : public QLocalSocket
{
public:
    QLocalSocketWrapper(const QLocalSocketWrapper &) = delete;
    QLocalSocketWrapper& operator=(const QLocalSocketWrapper &) = delete;
    QLocalSocketWrapper(QLocalSocketWrapper &&) = delete;
    QLocalSocketWrapper& operator=(QLocalSocketWrapper &&) = delete;

    QLocalSocketWrapper(::QObject * parent = nullptr);
    bool atEnd() const override;
    qint64 bytesAvailable() const override;
    qint64 bytesToWrite() const override;
    bool canReadLine() const override;
    void childEvent(::QChildEvent * event) override;
    void close() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool isSequential() const override;
    bool open(::QFlags<QIODeviceBase::OpenModeFlag> openMode = QIODeviceBase::OpenModeFlag::ReadWrite) override;
    qint64 pos() const override;
    qint64 readData(char * arg__1, qint64 arg__2) override;
    qint64 readLineData(char * data, qint64 maxSize) override;
    bool reset() override;
    bool seek(qint64 pos) override;
    qint64 size() const override;
    qint64 skipData(qint64 maxSize) override;
    void timerEvent(::QTimerEvent * event) override;
    bool waitForBytesWritten(int msecs = 30000) override;
    bool waitForReadyRead(int msecs = 30000) override;
    qint64 writeData(const char * arg__1, qint64 arg__2) override;
    ~QLocalSocketWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[24] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QLocalSocketWrapper_H

