// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QNetworkAccessManagerWrapper_H
#define SBK_QNetworkAccessManagerWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtNetwork/qnetworkaccessmanager.h>

namespace PySide { class DynamicQMetaObject; }

class QNetworkAccessManagerWrapper : public QNetworkAccessManager
{
public:
    QNetworkAccessManagerWrapper(const QNetworkAccessManagerWrapper &) = delete;
    QNetworkAccessManagerWrapper& operator=(const QNetworkAccessManagerWrapper &) = delete;
    QNetworkAccessManagerWrapper(QNetworkAccessManagerWrapper &&) = delete;
    QNetworkAccessManagerWrapper& operator=(QNetworkAccessManagerWrapper &&) = delete;

    QNetworkAccessManagerWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QNetworkReply * createRequest(::QNetworkAccessManager::Operation op, const ::QNetworkRequest & request, ::QIODevice * outgoingData = nullptr) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QStringList supportedSchemes() const override;
    void timerEvent(::QTimerEvent * event) override;
    ~QNetworkAccessManagerWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9] = {false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QNetworkAccessManagerWrapper_H

