// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QNetworkDiskCacheWrapper_H
#define SBK_QNetworkDiskCacheWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtNetwork/qnetworkdiskcache.h>

namespace PySide { class DynamicQMetaObject; }

class QNetworkDiskCacheWrapper : public QNetworkDiskCache
{
public:
    QNetworkDiskCacheWrapper(const QNetworkDiskCacheWrapper &) = delete;
    QNetworkDiskCacheWrapper& operator=(const QNetworkDiskCacheWrapper &) = delete;
    QNetworkDiskCacheWrapper(QNetworkDiskCacheWrapper &&) = delete;
    QNetworkDiskCacheWrapper& operator=(QNetworkDiskCacheWrapper &&) = delete;

    QNetworkDiskCacheWrapper(::QObject * parent = nullptr);
    qint64 cacheSize() const override;
    void childEvent(::QChildEvent * event) override;
    void clear() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    ::QIODevice * data(const ::QUrl & url) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    qint64 expire() override;
    void insert(::QIODevice * device) override;
    ::QNetworkCacheMetaData metaData(const ::QUrl & url) override;
    ::QIODevice * prepare(const ::QNetworkCacheMetaData & metaData) override;
    bool remove(const ::QUrl & url) override;
    void timerEvent(::QTimerEvent * event) override;
    void updateMetaData(const ::QNetworkCacheMetaData & metaData) override;
    ~QNetworkDiskCacheWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[16] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QNetworkDiskCacheWrapper_H

