// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QNetworkReplyWrapper_H
#define SBK_QNetworkReplyWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtNetwork/qnetworkreply.h>

namespace PySide { class DynamicQMetaObject; }

class QNetworkReplyWrapper : public QNetworkReply
{
public:
    QNetworkReplyWrapper(const QNetworkReplyWrapper &) = delete;
    QNetworkReplyWrapper& operator=(const QNetworkReplyWrapper &) = delete;
    QNetworkReplyWrapper(QNetworkReplyWrapper &&) = delete;
    QNetworkReplyWrapper& operator=(QNetworkReplyWrapper &&) = delete;

    QNetworkReplyWrapper(::QObject * parent = nullptr);
    void abort() override;
    bool atEnd() const override;
    qint64 bytesAvailable() const override;
    qint64 bytesToWrite() const override;
    bool canReadLine() const override;
    void childEvent(::QChildEvent * event) override;
    void close() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void ignoreSslErrors() override;
    void ignoreSslErrorsImplementation(const ::QList<QSslError> & arg__1) override;
    bool isSequential() const override;
    bool open(::QFlags<QIODeviceBase::OpenModeFlag> mode) override;
    qint64 pos() const override;
    qint64 readData(char * data, qint64 maxlen) override;
    qint64 readLineData(char * data, qint64 maxlen) override;
    bool reset() override;
    bool seek(qint64 pos) override;
    void setReadBufferSize(qint64 size) override;
    void setSslConfigurationImplementation(const ::QSslConfiguration & arg__1) override;
    qint64 size() const override;
    qint64 skipData(qint64 maxSize) override;
    void sslConfigurationImplementation(::QSslConfiguration & arg__1) const override;
    void timerEvent(::QTimerEvent * event) override;
    bool waitForBytesWritten(int msecs) override;
    bool waitForReadyRead(int msecs) override;
    qint64 writeData(const char * data, qint64 len) override;
    ~QNetworkReplyWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    // Inherited overloads, because the using keyword sux
    void ignoreSslErrors(const ::QList<QSslError> & errors) { QNetworkReply::ignoreSslErrors(errors); }
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[30] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QNetworkReplyWrapper_H

