// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSslServerWrapper_H
#define SBK_QSslServerWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtNetwork/qsslserver.h>

namespace PySide { class DynamicQMetaObject; }

class QSslServerWrapper : public QSslServer
{
public:
    QSslServerWrapper(const QSslServerWrapper &) = delete;
    QSslServerWrapper& operator=(const QSslServerWrapper &) = delete;
    QSslServerWrapper(QSslServerWrapper &&) = delete;
    QSslServerWrapper& operator=(QSslServerWrapper &&) = delete;

    QSslServerWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool hasPendingConnections() const override;
    void incomingConnection(::qintptr socket) override;
    ::QTcpSocket * nextPendingConnection() override;
    void timerEvent(::QTimerEvent * event) override;
    ~QSslServerWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[10] = {false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QSslServerWrapper_H

