// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTcpServerWrapper_H
#define SBK_QTcpServerWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtNetwork/qtcpserver.h>

namespace PySide { class DynamicQMetaObject; }

class QTcpServerWrapper : public QTcpServer
{
public:
    QTcpServerWrapper(const QTcpServerWrapper &) = delete;
    QTcpServerWrapper& operator=(const QTcpServerWrapper &) = delete;
    QTcpServerWrapper(QTcpServerWrapper &&) = delete;
    QTcpServerWrapper& operator=(QTcpServerWrapper &&) = delete;

    QTcpServerWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool hasPendingConnections() const override;
    void incomingConnection(::qintptr handle) override;
    ::QTcpSocket * nextPendingConnection() override;
    void timerEvent(::QTimerEvent * event) override;
    ~QTcpServerWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[10] = {false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QTcpServerWrapper_H

