// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QOAuthHttpServerReplyHandlerWrapper_H
#define SBK_QOAuthHttpServerReplyHandlerWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtNetworkAuth/qoauthhttpserverreplyhandler.h>

namespace PySide { class DynamicQMetaObject; }

class QOAuthHttpServerReplyHandlerWrapper : public QOAuthHttpServerReplyHandler
{
public:
    QOAuthHttpServerReplyHandlerWrapper(const QOAuthHttpServerReplyHandlerWrapper &) = delete;
    QOAuthHttpServerReplyHandlerWrapper& operator=(const QOAuthHttpServerReplyHandlerWrapper &) = delete;
    QOAuthHttpServerReplyHandlerWrapper(QOAuthHttpServerReplyHandlerWrapper &&) = delete;
    QOAuthHttpServerReplyHandlerWrapper& operator=(QOAuthHttpServerReplyHandlerWrapper &&) = delete;

    QOAuthHttpServerReplyHandlerWrapper(::QObject * parent = nullptr);
    QOAuthHttpServerReplyHandlerWrapper(const ::QHostAddress & address, quint16 port, ::QObject * parent = nullptr);
    QOAuthHttpServerReplyHandlerWrapper(quint16 port, ::QObject * parent = nullptr);
    ::QString callback() const override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void networkReplyFinished(::QNetworkReply * reply) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QOAuthHttpServerReplyHandlerWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9] = {false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QOAuthHttpServerReplyHandlerWrapper_H

