// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QOAuthOobReplyHandlerWrapper_H
#define SBK_QOAuthOobReplyHandlerWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtNetworkAuth/qoauthoobreplyhandler.h>

namespace PySide { class DynamicQMetaObject; }

class QOAuthOobReplyHandlerWrapper : public QOAuthOobReplyHandler
{
public:
    QOAuthOobReplyHandlerWrapper(const QOAuthOobReplyHandlerWrapper &) = delete;
    QOAuthOobReplyHandlerWrapper& operator=(const QOAuthOobReplyHandlerWrapper &) = delete;
    QOAuthOobReplyHandlerWrapper(QOAuthOobReplyHandlerWrapper &&) = delete;
    QOAuthOobReplyHandlerWrapper& operator=(QOAuthOobReplyHandlerWrapper &&) = delete;

    QOAuthOobReplyHandlerWrapper(::QObject * parent = nullptr);
    ::QString callback() const override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void networkReplyFinished(::QNetworkReply * reply) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QOAuthOobReplyHandlerWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9] = {false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QOAuthOobReplyHandlerWrapper_H

