// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtnfc_python.h"

// main header
#include "qndefnfcurirecord_wrapper.h"

// Argument includes
#include <QtNfc/qndefrecord.h>
#include <qbytearray.h>
#include <qurl.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QNdefNfcUriRecord_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QNdefNfcUriRecord >()))
        return -1;

    ::QNdefNfcUriRecord *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QNdefNfcUriRecord", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QNdefNfcUriRecord::QNdefNfcUriRecord()
    // 1: QNdefNfcUriRecord::QNdefNfcUriRecord(QNdefNfcUriRecord)
    // 2: QNdefNfcUriRecord::QNdefNfcUriRecord(QNdefRecord)
    if (numArgs == 0) {
        overloadId = 0; // QNdefNfcUriRecord()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcUriRecord_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QNdefNfcUriRecord(QNdefNfcUriRecord)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefRecord_IDX]), (pyArgs[0])))) {
        overloadId = 2; // QNdefNfcUriRecord(QNdefRecord)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcUriRecord_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcUriRecord_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QNdefNfcUriRecord()
        {

            // QNdefNfcUriRecord()
            cptr = new ::QNdefNfcUriRecord();
            break;
        }
        case 1: // QNdefNfcUriRecord(const QNdefNfcUriRecord &QNdefNfcUriRecord)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QNdefNfcUriRecord cppArg0_local;
            ::QNdefNfcUriRecord *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QNdefNfcUriRecord(QNdefNfcUriRecord)
                cptr = new ::QNdefNfcUriRecord(*cppArg0);
            }
            break;
        }
        case 2: // QNdefNfcUriRecord(const QNdefRecord &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QNdefRecord cppArg0_local;
            ::QNdefRecord *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QNdefNfcUriRecord(QNdefRecord)
                cptr = new ::QNdefNfcUriRecord(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QNdefNfcUriRecord >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcUriRecord_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QNdefNfcUriRecordFunc_setUri(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcUriRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcUriRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QNdefNfcUriRecord::setUri(QUrl)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), (pyArg)))) {
        overloadId = 0; // setUri(QUrl)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setUri", errInfo, SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcUriRecord_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QUrl cppArg0_local;
        ::QUrl *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setUri(QUrl)
            cppSelf->setUri(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QNdefNfcUriRecordFunc_uri(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefNfcUriRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcUriRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // uri()const
        QUrl cppResult = const_cast<const ::QNdefNfcUriRecord *>(cppSelf)->uri();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNdefNfcUriRecord__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QNdefNfcUriRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcUriRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcUriRecord_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QNdefNfcUriRecord_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QNdefNfcUriRecord_methods[] = {
    {"setUri", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcUriRecordFunc_setUri), METH_O, nullptr},
    {"uri", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcUriRecordFunc_uri), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QNdefNfcUriRecord__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QNdefNfcUriRecord_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QNdefNfcUriRecord_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QNdefNfcUriRecord_Type = nullptr;
static PyTypeObject *Sbk_QNdefNfcUriRecord_TypeF(void)
{
    return _Sbk_QNdefNfcUriRecord_Type;
}

static PyType_Slot Sbk_QNdefNfcUriRecord_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QNdefNfcUriRecord_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QNdefNfcUriRecord_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QNdefNfcUriRecord_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QNdefNfcUriRecord_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QNdefNfcUriRecord_spec = {
    "2:PySide6.QtNfc.QNdefNfcUriRecord",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QNdefNfcUriRecord_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QNdefNfcUriRecord_PythonToCpp_QNdefNfcUriRecord_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QNdefNfcUriRecord_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QNdefNfcUriRecord_PythonToCpp_QNdefNfcUriRecord_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QNdefNfcUriRecord_TypeF()))
        return QNdefNfcUriRecord_PythonToCpp_QNdefNfcUriRecord_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QNdefNfcUriRecord_PTR_CppToPython_QNdefNfcUriRecord(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QNdefNfcUriRecord_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QNdefNfcUriRecord_COPY_CppToPython_QNdefNfcUriRecord(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QNdefNfcUriRecord *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QNdefNfcUriRecord_TypeF(), new ::QNdefNfcUriRecord(*source), true, true);
}

// Python to C++ copy conversion.
static void QNdefNfcUriRecord_PythonToCpp_QNdefNfcUriRecord_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QNdefNfcUriRecord *>(cppOut) = *reinterpret_cast< ::QNdefNfcUriRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcUriRecord_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QNdefNfcUriRecord_PythonToCpp_QNdefNfcUriRecord_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QNdefNfcUriRecord_TypeF()))
        return QNdefNfcUriRecord_PythonToCpp_QNdefNfcUriRecord_COPY;
    return {};
}

// Implicit conversions.
static void constQNdefRecordREF_PythonToCpp_QNdefNfcUriRecord(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QNdefNfcUriRecord *>(cppOut) = ::QNdefNfcUriRecord( *reinterpret_cast< ::QNdefRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefRecord_IDX]), reinterpret_cast<SbkObject *>(pyIn))));
}
static PythonToCppFunc is_constQNdefRecordREF_PythonToCpp_QNdefNfcUriRecord_Convertible(PyObject *pyIn)
{
    if (SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefRecord_IDX]), pyIn))
        return constQNdefRecordREF_PythonToCpp_QNdefNfcUriRecord;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QNdefNfcUriRecord_SignatureStrings[] = {
    "2:PySide6.QtNfc.QNdefNfcUriRecord(self)",
    "1:PySide6.QtNfc.QNdefNfcUriRecord(self,QNdefNfcUriRecord:PySide6.QtNfc.QNdefNfcUriRecord)",
    "0:PySide6.QtNfc.QNdefNfcUriRecord(self,other:PySide6.QtNfc.QNdefRecord)",
    "PySide6.QtNfc.QNdefNfcUriRecord.setUri(self,uri:typing.Union[PySide6.QtCore.QUrl, QString])",
    "PySide6.QtNfc.QNdefNfcUriRecord.uri(self)->PySide6.QtCore.QUrl",
    "PySide6.QtNfc.QNdefNfcUriRecord.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QNdefNfcUriRecord_SignatureByteSize = 146;
static constexpr uint8_t QNdefNfcUriRecord_SignatureBytes[146] = {
    0x78, 0xda, 0x33, 0xb2, 0x0a, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0xf1, 0x4b,
    0x4b, 0xd6, 0x0b, 0xf4, 0x4b, 0x49, 0x4d, 0x03, 0x32, 0x42, 0x8b, 0x32, 0x83, 0x52, 0x93, 0xf3,
    0x8b, 0x52, 0x34, 0x8a, 0x53, 0x73, 0xd2, 0x34, 0xb9, 0x0c, 0x89, 0x52, 0xa7, 0x83, 0x21, 0x4c,
    0x48, 0x9b, 0x26, 0x97, 0x01, 0x71, 0x26, 0xe7, 0x97, 0x64, 0xa4, 0x16, 0x61, 0x53, 0x0a, 0x33,
    0x87, 0x80, 0x29, 0x7a, 0xc5, 0xa9, 0x25, 0x40, 0x0e, 0xc4, 0xb0, 0xd2, 0xa2, 0x4c, 0xab, 0x92,
    0xca, 0x82, 0xcc, 0xbc, 0x74, 0xbd, 0xd0, 0xbc, 0xcc, 0xfc, 0xbc, 0x68, 0x84, 0x66, 0xe7, 0xfc,
    0xa2, 0x54, 0xbd, 0xc0, 0xd0, 0xa2, 0x1c, 0x1d, 0x85, 0xc0, 0xe0, 0x92, 0x22, 0xa0, 0x92, 0x58,
    0xc2, 0x66, 0x97, 0x42, 0x0d, 0xd6, 0xd4, 0xb5, 0xc3, 0x62, 0x12, 0x41, 0xed, 0xf1, 0xf1, 0xc9,
    0xf9, 0x05, 0x95, 0xf1, 0xf1, 0x30, 0x33, 0xa0, 0x4e, 0x0b, 0x06, 0xf2, 0xb8, 0x00, 0x3b, 0x3a,
    0x92, 0x69
};
#endif

PyTypeObject *init_QNdefNfcUriRecord(PyObject *module)
{
    if (SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcUriRecord_IDX].type != nullptr)
        return SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcUriRecord_IDX].type;

    Shiboken::AutoDecRef Sbk_QNdefNfcUriRecord_Type_bases(PyTuple_Pack(1,
        reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefRecord_IDX]))));

    _Sbk_QNdefNfcUriRecord_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QNdefNfcUriRecord",
        "QNdefNfcUriRecord",
        &Sbk_QNdefNfcUriRecord_spec,
        &Shiboken::callCppDestructor< ::QNdefNfcUriRecord >,
        Sbk_QNdefNfcUriRecord_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QNdefNfcUriRecord_TypeF(); // references _Sbk_QNdefNfcUriRecord_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QNdefNfcUriRecord_SignatureStrings);
#else
    InitSignatureBytes(pyType, QNdefNfcUriRecord_SignatureBytes, QNdefNfcUriRecord_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QNdefNfcUriRecord_PropertyStrings);
    SbkPySide6_QtNfcTypeStructs[SBK_QNdefNfcUriRecord_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QNdefNfcUriRecord_PythonToCpp_QNdefNfcUriRecord_PTR,
        is_QNdefNfcUriRecord_PythonToCpp_QNdefNfcUriRecord_PTR_Convertible,
        QNdefNfcUriRecord_PTR_CppToPython_QNdefNfcUriRecord,
        QNdefNfcUriRecord_COPY_CppToPython_QNdefNfcUriRecord);

    Shiboken::Conversions::registerConverterName(converter, "QNdefNfcUriRecord");
    Shiboken::Conversions::registerConverterName(converter, "QNdefNfcUriRecord*");
    Shiboken::Conversions::registerConverterName(converter, "QNdefNfcUriRecord&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QNdefNfcUriRecord).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QNdefNfcUriRecord_PythonToCpp_QNdefNfcUriRecord_COPY,
        is_QNdefNfcUriRecord_PythonToCpp_QNdefNfcUriRecord_COPY_Convertible);
    // Add implicit conversions to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        constQNdefRecordREF_PythonToCpp_QNdefNfcUriRecord,
        is_constQNdefRecordREF_PythonToCpp_QNdefNfcUriRecord_Convertible);

    qRegisterMetaType< ::QNdefNfcUriRecord >("QNdefNfcUriRecord");

    return pyType;
}
