// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QOpenGLFunctions_4_0_CoreWrapper_H
#define SBK_QOpenGLFunctions_4_0_CoreWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtOpenGL/qopenglfunctions_4_0_core.h>

class QOpenGLFunctions_4_0_CoreWrapper : public QOpenGLFunctions_4_0_Core
{
public:
    QOpenGLFunctions_4_0_CoreWrapper(const QOpenGLFunctions_4_0_CoreWrapper &) = delete;
    QOpenGLFunctions_4_0_CoreWrapper& operator=(const QOpenGLFunctions_4_0_CoreWrapper &) = delete;
    QOpenGLFunctions_4_0_CoreWrapper(QOpenGLFunctions_4_0_CoreWrapper &&) = delete;
    QOpenGLFunctions_4_0_CoreWrapper& operator=(QOpenGLFunctions_4_0_CoreWrapper &&) = delete;

    QOpenGLFunctions_4_0_CoreWrapper();
    bool initializeOpenGLFunctions() override;
    ~QOpenGLFunctions_4_0_CoreWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QOpenGLFunctions_4_0_CoreWrapper_H

