// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QOpenGLFunctions_4_5_CompatibilityWrapper_H
#define SBK_QOpenGLFunctions_4_5_CompatibilityWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtOpenGL/qopenglfunctions_4_5_compatibility.h>

class QOpenGLFunctions_4_5_CompatibilityWrapper : public QOpenGLFunctions_4_5_Compatibility
{
public:
    QOpenGLFunctions_4_5_CompatibilityWrapper(const QOpenGLFunctions_4_5_CompatibilityWrapper &) = delete;
    QOpenGLFunctions_4_5_CompatibilityWrapper& operator=(const QOpenGLFunctions_4_5_CompatibilityWrapper &) = delete;
    QOpenGLFunctions_4_5_CompatibilityWrapper(QOpenGLFunctions_4_5_CompatibilityWrapper &&) = delete;
    QOpenGLFunctions_4_5_CompatibilityWrapper& operator=(QOpenGLFunctions_4_5_CompatibilityWrapper &&) = delete;

    QOpenGLFunctions_4_5_CompatibilityWrapper();
    bool initializeOpenGLFunctions() override;
    ~QOpenGLFunctions_4_5_CompatibilityWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QOpenGLFunctions_4_5_CompatibilityWrapper_H

