// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGeoPositionInfoSourceFactoryWrapper_H
#define SBK_QGeoPositionInfoSourceFactoryWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtPositioning/qgeopositioninfosourcefactory.h>

class QGeoPositionInfoSourceFactoryWrapper : public QGeoPositionInfoSourceFactory
{
public:
    QGeoPositionInfoSourceFactoryWrapper(const QGeoPositionInfoSourceFactoryWrapper &) = delete;
    QGeoPositionInfoSourceFactoryWrapper& operator=(const QGeoPositionInfoSourceFactoryWrapper &) = delete;
    QGeoPositionInfoSourceFactoryWrapper(QGeoPositionInfoSourceFactoryWrapper &&) = delete;
    QGeoPositionInfoSourceFactoryWrapper& operator=(QGeoPositionInfoSourceFactoryWrapper &&) = delete;

    QGeoPositionInfoSourceFactoryWrapper();
    ::QGeoAreaMonitorSource * areaMonitor(::QObject * parent, const ::QMap<QString,QVariant> & parameters) override;
    ::QGeoPositionInfoSource * positionInfoSource(::QObject * parent, const ::QMap<QString,QVariant> & parameters) override;
    ::QGeoSatelliteInfoSource * satelliteInfoSource(::QObject * parent, const ::QMap<QString,QVariant> & parameters) override;
    ~QGeoPositionInfoSourceFactoryWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QGeoPositionInfoSourceFactoryWrapper_H

