// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPrintEngineWrapper_H
#define SBK_QPrintEngineWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtPrintSupport/qprintengine.h>

class QPrintEngineWrapper : public QPrintEngine
{
public:
    QPrintEngineWrapper(const QPrintEngineWrapper &) = delete;
    QPrintEngineWrapper& operator=(const QPrintEngineWrapper &) = delete;
    QPrintEngineWrapper(QPrintEngineWrapper &&) = delete;
    QPrintEngineWrapper& operator=(QPrintEngineWrapper &&) = delete;

    QPrintEngineWrapper();
    bool abort() override;
    int metric(::QPaintDevice::PaintDeviceMetric arg__1) const override;
    bool newPage() override;
    ::QPrinter::PrinterState printerState() const override;
    ::QVariant property(::QPrintEngine::PrintEnginePropertyKey key) const override;
    void setProperty(::QPrintEngine::PrintEnginePropertyKey key, const ::QVariant & value) override;
    ~QPrintEngineWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[6] = {false, false, false, false, false, false};
};

#endif // SBK_QPrintEngineWrapper_H

