// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQmlAbstractUrlInterceptorWrapper_H
#define SBK_QQmlAbstractUrlInterceptorWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlabstracturlinterceptor.h>

class QQmlAbstractUrlInterceptorWrapper : public QQmlAbstractUrlInterceptor
{
public:
    QQmlAbstractUrlInterceptorWrapper(const QQmlAbstractUrlInterceptorWrapper &) = delete;
    QQmlAbstractUrlInterceptorWrapper& operator=(const QQmlAbstractUrlInterceptorWrapper &) = delete;
    QQmlAbstractUrlInterceptorWrapper(QQmlAbstractUrlInterceptorWrapper &&) = delete;
    QQmlAbstractUrlInterceptorWrapper& operator=(QQmlAbstractUrlInterceptorWrapper &&) = delete;

    QQmlAbstractUrlInterceptorWrapper();
    ::QUrl intercept(const ::QUrl & path, ::QQmlAbstractUrlInterceptor::DataType type) override;
    ~QQmlAbstractUrlInterceptorWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QQmlAbstractUrlInterceptorWrapper_H

