// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQmlApplicationEngineWrapper_H
#define SBK_QQmlApplicationEngineWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlapplicationengine.h>

namespace PySide { class DynamicQMetaObject; }

class QQmlApplicationEngineWrapper : public QQmlApplicationEngine
{
public:
    QQmlApplicationEngineWrapper(const QQmlApplicationEngineWrapper &) = delete;
    QQmlApplicationEngineWrapper& operator=(const QQmlApplicationEngineWrapper &) = delete;
    QQmlApplicationEngineWrapper(QQmlApplicationEngineWrapper &&) = delete;
    QQmlApplicationEngineWrapper& operator=(QQmlApplicationEngineWrapper &&) = delete;

    QQmlApplicationEngineWrapper(::QAnyStringView uri, ::QAnyStringView typeName, ::QObject * parent = nullptr);
    QQmlApplicationEngineWrapper(::QObject * parent = nullptr);
    QQmlApplicationEngineWrapper(const ::QString & filePath, ::QObject * parent = nullptr);
    QQmlApplicationEngineWrapper(const ::QUrl & url, ::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * arg__1) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QQmlApplicationEngineWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QQmlApplicationEngineWrapper_H

