// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQmlComponentWrapper_H
#define SBK_QQmlComponentWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlcomponent.h>

namespace PySide { class DynamicQMetaObject; }

class QQmlComponentWrapper : public QQmlComponent
{
public:
    QQmlComponentWrapper(const QQmlComponentWrapper &) = delete;
    QQmlComponentWrapper& operator=(const QQmlComponentWrapper &) = delete;
    QQmlComponentWrapper(QQmlComponentWrapper &&) = delete;
    QQmlComponentWrapper& operator=(QQmlComponentWrapper &&) = delete;

    QQmlComponentWrapper(::QObject * parent = nullptr);
    QQmlComponentWrapper(::QQmlEngine * arg__1, ::QObject * parent = nullptr);
    QQmlComponentWrapper(::QQmlEngine * arg__1, const ::QString & fileName, ::QObject * parent = nullptr);
    QQmlComponentWrapper(::QQmlEngine * arg__1, const ::QString & fileName, ::QQmlComponent::CompilationMode mode, ::QObject * parent = nullptr);
    QQmlComponentWrapper(::QQmlEngine * arg__1, const ::QUrl & url, ::QObject * parent = nullptr);
    QQmlComponentWrapper(::QQmlEngine * arg__1, const ::QUrl & url, ::QQmlComponent::CompilationMode mode, ::QObject * parent = nullptr);
    QQmlComponentWrapper(::QQmlEngine * engine, ::QAnyStringView uri, ::QAnyStringView typeName, ::QObject * parent = nullptr);
    QQmlComponentWrapper(::QQmlEngine * engine, ::QAnyStringView uri, ::QAnyStringView typeName, ::QQmlComponent::CompilationMode mode, ::QObject * parent = nullptr);
    ::QObject * beginCreate(::QQmlContext * arg__1) override;
    void childEvent(::QChildEvent * event) override;
    void completeCreate() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QObject * create(::QQmlContext * context = nullptr) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QQmlComponentWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    // Inherited overloads, because the using keyword sux
    void create(::QQmlIncubator & arg__1, ::QQmlContext * context = nullptr, ::QQmlContext * forContext = nullptr) { QQmlComponent::create(arg__1, context, forContext); }
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[10] = {false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QQmlComponentWrapper_H

