// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtqml_python.h"

// main header
#include "qqmldebuggingenabler_wrapper.h"

// Argument includes
#include <QHash>
#include <QString>
#include <QStringList>
#include <QtQml/qqmldebug.h>
#include <qvariant.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QQmlDebuggingEnabler_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QQmlDebuggingEnabler >()))
        return -1;

    ::QQmlDebuggingEnabler *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);

    if (PyArg_ParseTuple(args, "|O:QQmlDebuggingEnabler", &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QQmlDebuggingEnabler::QQmlDebuggingEnabler(bool=)
    if (numArgs == 0) {
        overloadId = 0; // QQmlDebuggingEnabler(bool)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[0])))) {
        overloadId = 0; // QQmlDebuggingEnabler(bool)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {
        Shiboken::Warnings::warnDeprecated("QQmlDebuggingEnabler", "QQmlDebuggingEnabler(bool printWarning)");
        if (Shiboken::Errors::occurred() != nullptr)
            return -1;
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_printWarning = Shiboken::String::createStaticString("printWarning");
            if (PyDict_Contains(kwds, key_printWarning) != 0) {
                value = PyDict_GetItem(kwds, key_printWarning);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_printWarning);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[0]))))
                        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_printWarning);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);
            }
        }
        bool cppArg0 = true;
        if (pythonToCpp[0])
            pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // QQmlDebuggingEnabler(bool)
            cptr = new ::QQmlDebuggingEnabler(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QQmlDebuggingEnabler >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QQmlDebuggingEnablerFunc_connectToLocalDebugger(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "connectToLocalDebugger", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);

    if (PyArg_ParseTuple(args, "|OO:connectToLocalDebugger", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QQmlDebuggingEnabler::connectToLocalDebugger(QString,QQmlDebuggingEnabler::StartMode=)->bool
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // connectToLocalDebugger(QString,QQmlDebuggingEnabler::StartMode)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_StartMode_IDX])))->converter, (pyArgs[1])))) {
            overloadId = 0; // connectToLocalDebugger(QString,QQmlDebuggingEnabler::StartMode)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "connectToLocalDebugger", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_mode = Shiboken::String::createStaticString("mode");
            if (PyDict_Contains(kwds, key_mode) != 0) {
                value = PyDict_GetItem(kwds, key_mode);
                if (value != nullptr && pyArgs[1] != nullptr ) {
                    errInfo.reset(key_mode);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, "connectToLocalDebugger", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_StartMode_IDX])))->converter, (pyArgs[1]))))
                        return Shiboken::returnWrongArguments(args, "connectToLocalDebugger", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_mode);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, "connectToLocalDebugger", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);
            }
        }
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QQmlDebuggingEnabler::StartMode cppArg1(QQmlDebuggingEnabler::StartMode::DoNotWaitForClient);
        if (pythonToCpp[1])
            pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // connectToLocalDebugger(QString,QQmlDebuggingEnabler::StartMode)
            bool cppResult = ::QQmlDebuggingEnabler::connectToLocalDebugger(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlDebuggingEnablerFunc_debuggerServices(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // debuggerServices()
        QStringList cppResult = ::QQmlDebuggingEnabler::debuggerServices();
        pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlDebuggingEnablerFunc_enableDebugging(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QQmlDebuggingEnabler::enableDebugging(bool)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // enableDebugging(bool)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "enableDebugging", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // enableDebugging(bool)
            ::QQmlDebuggingEnabler::enableDebugging(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QQmlDebuggingEnablerFunc_inspectorServices(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // inspectorServices()
        QStringList cppResult = ::QQmlDebuggingEnabler::inspectorServices();
        pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlDebuggingEnablerFunc_nativeDebuggerServices(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // nativeDebuggerServices()
        QStringList cppResult = ::QQmlDebuggingEnabler::nativeDebuggerServices();
        pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlDebuggingEnablerFunc_profilerServices(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // profilerServices()
        QStringList cppResult = ::QQmlDebuggingEnabler::profilerServices();
        pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlDebuggingEnablerFunc_setServices(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QQmlDebuggingEnabler::setServices(QStringList)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], (pyArg)))) {
        overloadId = 0; // setServices(QStringList)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setServices", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);

    // Call function/method
    {
        ::QStringList cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setServices(QStringList)
            ::QQmlDebuggingEnabler::setServices(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QQmlDebuggingEnablerFunc_startDebugConnector(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "startDebugConnector", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);

    if (PyArg_ParseTuple(args, "|OO:startDebugConnector", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QQmlDebuggingEnabler::startDebugConnector(QString,const QHash<QString,QVariant>&=)->bool
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // startDebugConnector(QString,QHash<QString,QVariant>)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtQmlTypeConverters[SBK_QtQml_QHash_QString_QVariant_IDX], (pyArgs[1])))) {
            overloadId = 0; // startDebugConnector(QString,QHash<QString,QVariant>)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "startDebugConnector", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_configuration = Shiboken::String::createStaticString("configuration");
            if (PyDict_Contains(kwds, key_configuration) != 0) {
                value = PyDict_GetItem(kwds, key_configuration);
                if (value != nullptr && pyArgs[1] != nullptr ) {
                    errInfo.reset(key_configuration);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, "startDebugConnector", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtQmlTypeConverters[SBK_QtQml_QHash_QString_QVariant_IDX], (pyArgs[1]))))
                        return Shiboken::returnWrongArguments(args, "startDebugConnector", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_configuration);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, "startDebugConnector", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);
            }
        }
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QHash<QString,QVariant> cppArg1 = QVariantHash();
        if (pythonToCpp[1])
            pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // startDebugConnector(QString,QHash<QString,QVariant>)
            bool cppResult = ::QQmlDebuggingEnabler::startDebugConnector(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlDebuggingEnablerFunc_startTcpDebugServer(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 3));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "startTcpDebugServer", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);

    if (PyArg_ParseTuple(args, "|OOO:startTcpDebugServer", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QQmlDebuggingEnabler::startTcpDebugServer(int,QQmlDebuggingEnabler::StartMode=,const QString&=)->bool
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // startTcpDebugServer(int,QQmlDebuggingEnabler::StartMode,QString)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_StartMode_IDX])))->converter, (pyArgs[1])))) {
            if (numArgs == 2) {
                overloadId = 0; // startTcpDebugServer(int,QQmlDebuggingEnabler::StartMode,QString)
            } else if (numArgs >= 3
                && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[2])))) {
                overloadId = 0; // startTcpDebugServer(int,QQmlDebuggingEnabler::StartMode,QString)
            }
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "startTcpDebugServer", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_mode = Shiboken::String::createStaticString("mode");
            if (PyDict_Contains(kwds, key_mode) != 0) {
                value = PyDict_GetItem(kwds, key_mode);
                if (value != nullptr && pyArgs[1] != nullptr ) {
                    errInfo.reset(key_mode);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, "startTcpDebugServer", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_StartMode_IDX])))->converter, (pyArgs[1]))))
                        return Shiboken::returnWrongArguments(args, "startTcpDebugServer", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_mode);
            }
            static PyObject *const key_hostName = Shiboken::String::createStaticString("hostName");
            if (PyDict_Contains(kwds, key_hostName) != 0) {
                value = PyDict_GetItem(kwds, key_hostName);
                if (value != nullptr && pyArgs[2] != nullptr ) {
                    errInfo.reset(key_hostName);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, "startTcpDebugServer", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[2] = value;
                    if (!(pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[2]))))
                        return Shiboken::returnWrongArguments(args, "startTcpDebugServer", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_hostName);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, "startTcpDebugServer", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX]);
            }
        }
        int cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QQmlDebuggingEnabler::StartMode cppArg1(QQmlDebuggingEnabler::StartMode::DoNotWaitForClient);
        if (pythonToCpp[1])
            pythonToCpp[1](pyArgs[1], &cppArg1);
        ::QString cppArg2 = QString();
        if (pythonToCpp[2])
            pythonToCpp[2](pyArgs[2], &cppArg2);

        if (Shiboken::Errors::occurred() == nullptr) {
            // startTcpDebugServer(int,QQmlDebuggingEnabler::StartMode,QString)
            bool cppResult = ::QQmlDebuggingEnabler::startTcpDebugServer(cppArg0, cppArg1, cppArg2);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QQmlDebuggingEnabler_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QQmlDebuggingEnabler_EnumFlagInfo[] = {
    "StartMode:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QQmlDebuggingEnabler_methods[] = {
    {"connectToLocalDebugger", reinterpret_cast<PyCFunction>(Sbk_QQmlDebuggingEnablerFunc_connectToLocalDebugger), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {"debuggerServices", reinterpret_cast<PyCFunction>(Sbk_QQmlDebuggingEnablerFunc_debuggerServices), METH_NOARGS|METH_STATIC, nullptr},
    {"enableDebugging", reinterpret_cast<PyCFunction>(Sbk_QQmlDebuggingEnablerFunc_enableDebugging), METH_O|METH_STATIC, nullptr},
    {"inspectorServices", reinterpret_cast<PyCFunction>(Sbk_QQmlDebuggingEnablerFunc_inspectorServices), METH_NOARGS|METH_STATIC, nullptr},
    {"nativeDebuggerServices", reinterpret_cast<PyCFunction>(Sbk_QQmlDebuggingEnablerFunc_nativeDebuggerServices), METH_NOARGS|METH_STATIC, nullptr},
    {"profilerServices", reinterpret_cast<PyCFunction>(Sbk_QQmlDebuggingEnablerFunc_profilerServices), METH_NOARGS|METH_STATIC, nullptr},
    {"setServices", reinterpret_cast<PyCFunction>(Sbk_QQmlDebuggingEnablerFunc_setServices), METH_O|METH_STATIC, nullptr},
    {"startDebugConnector", reinterpret_cast<PyCFunction>(Sbk_QQmlDebuggingEnablerFunc_startDebugConnector), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {"startTcpDebugServer", reinterpret_cast<PyCFunction>(Sbk_QQmlDebuggingEnablerFunc_startTcpDebugServer), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QQmlDebuggingEnabler_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QQmlDebuggingEnabler_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QQmlDebuggingEnabler_Type = nullptr;
static PyTypeObject *Sbk_QQmlDebuggingEnabler_TypeF(void)
{
    return _Sbk_QQmlDebuggingEnabler_Type;
}

static PyType_Slot Sbk_QQmlDebuggingEnabler_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QQmlDebuggingEnabler_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QQmlDebuggingEnabler_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QQmlDebuggingEnabler_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QQmlDebuggingEnabler_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QQmlDebuggingEnabler_spec = {
    "2:PySide6.QtQml.QQmlDebuggingEnabler",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QQmlDebuggingEnabler_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QQmlDebuggingEnabler_StartMode(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QQmlDebuggingEnabler::StartMode>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QQmlDebuggingEnabler::StartMode *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QQmlDebuggingEnabler_StartMode_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_StartMode_IDX])))
        return Enum_PythonToCpp_QQmlDebuggingEnabler_StartMode;
    return {};
}

static PyObject *QQmlDebuggingEnabler_StartMode_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QQmlDebuggingEnabler::StartMode>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QQmlDebuggingEnabler::StartMode *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_StartMode_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QQmlDebuggingEnabler_PythonToCpp_QQmlDebuggingEnabler_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QQmlDebuggingEnabler_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QQmlDebuggingEnabler_PythonToCpp_QQmlDebuggingEnabler_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QQmlDebuggingEnabler_TypeF()))
        return QQmlDebuggingEnabler_PythonToCpp_QQmlDebuggingEnabler_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QQmlDebuggingEnabler_PTR_CppToPython_QQmlDebuggingEnabler(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QQmlDebuggingEnabler_TypeF(), const_cast<void *>(cppIn), false);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QQmlDebuggingEnabler_SignatureStrings[] = {
    "PySide6.QtQml.QQmlDebuggingEnabler(self,printWarning:bool=true)",
    "PySide6.QtQml.QQmlDebuggingEnabler.connectToLocalDebugger(socketFileName:QString,mode:PySide6.QtQml.QQmlDebuggingEnabler.StartMode=QQmlDebuggingEnabler.StartMode.DoNotWaitForClient)->bool",
    "PySide6.QtQml.QQmlDebuggingEnabler.debuggerServices()->QStringList",
    "PySide6.QtQml.QQmlDebuggingEnabler.enableDebugging(printWarning:bool)",
    "PySide6.QtQml.QQmlDebuggingEnabler.inspectorServices()->QStringList",
    "PySide6.QtQml.QQmlDebuggingEnabler.nativeDebuggerServices()->QStringList",
    "PySide6.QtQml.QQmlDebuggingEnabler.profilerServices()->QStringList",
    "PySide6.QtQml.QQmlDebuggingEnabler.setServices(services:QStringList)",
    "PySide6.QtQml.QQmlDebuggingEnabler.startDebugConnector(pluginName:QString,configuration:QHash[QString, QVariant]=QVariantHash())->bool",
    "PySide6.QtQml.QQmlDebuggingEnabler.startTcpDebugServer(port:int,mode:PySide6.QtQml.QQmlDebuggingEnabler.StartMode=QQmlDebuggingEnabler.StartMode.DoNotWaitForClient,hostName:QString=QString())->bool",
    nullptr}; // Sentinel
#else
static constexpr size_t QQmlDebuggingEnabler_SignatureByteSize = 297;
static constexpr uint8_t QQmlDebuggingEnabler_SignatureBytes[297] = {
    0x78, 0xda, 0xbd, 0x52, 0xb1, 0x4e, 0xc3, 0x30, 0x10, 0xdd, 0xf9, 0x0a, 0xc6, 0x44, 0x0a, 0x19,
    0x19, 0x2c, 0x85, 0xa5, 0xa1, 0x62, 0x28, 0x55, 0xad, 0x54, 0x30, 0x20, 0x06, 0x27, 0xb9, 0xa6,
    0x16, 0x8e, 0xcf, 0xb2, 0x2f, 0x95, 0xf8, 0x7b, 0x2e, 0x21, 0x2d, 0x45, 0x48, 0x90, 0x2a, 0x12,
    0x8b, 0x6d, 0xf9, 0xf9, 0x9e, 0xdf, 0xbb, 0x7b, 0x9b, 0xf7, 0x42, 0xd7, 0x70, 0x9b, 0x4a, 0x92,
    0xad, 0x49, 0x25, 0x2f, 0x39, 0x94, 0x5d, 0xd3, 0x68, 0xdb, 0xdc, 0x5b, 0x55, 0x1a, 0xf0, 0x51,
    0x00, 0xb3, 0x4b, 0x9c, 0xd7, 0x96, 0x9e, 0x95, 0xb7, 0x0c, 0x88, 0x12, 0xd1, 0x64, 0xe4, 0x3b,
    0x88, 0xaf, 0x36, 0x7f, 0xd6, 0xa7, 0x15, 0x5a, 0x0b, 0x15, 0x6d, 0x71, 0x85, 0x95, 0x1a, 0xe1,
    0x9e, 0x16, 0xab, 0x37, 0xa0, 0xa5, 0x36, 0xb0, 0x56, 0x2d, 0x08, 0x59, 0x10, 0x7f, 0xd1, 0x24,
    0x2d, 0xd6, 0x20, 0x26, 0xb0, 0x16, 0xa4, 0x3c, 0x3d, 0xf2, 0xe3, 0xec, 0x77, 0x38, 0xcd, 0x71,
    0x8d, 0xac, 0x5c, 0xd3, 0x12, 0xfd, 0xc2, 0x68, 0xb0, 0x14, 0xdf, 0xdc, 0xf5, 0x0e, 0xa6, 0x68,
    0xaf, 0x47, 0xb5, 0x05, 0xf8, 0x83, 0xae, 0x20, 0x44, 0x5c, 0x3b, 0x2a, 0x5d, 0xe9, 0x40, 0x53,
    0x28, 0x60, 0xd8, 0x4f, 0xd7, 0xd1, 0x8f, 0x4e, 0x4e, 0x6a, 0xa2, 0xb6, 0xc1, 0x71, 0x13, 0x71,
    0x8e, 0x12, 0xab, 0x48, 0x1f, 0x20, 0x9f, 0x6f, 0xc9, 0x79, 0xdc, 0xf1, 0xdc, 0xe6, 0x50, 0x04,
    0xa0, 0x53, 0x75, 0x18, 0x0f, 0xe2, 0x8c, 0x63, 0x52, 0x53, 0x42, 0x3f, 0xe4, 0xe1, 0x76, 0xf1,
    0x99, 0x31, 0xf4, 0x91, 0x33, 0x1d, 0x3f, 0xf9, 0x16, 0x29, 0x0e, 0xe0, 0x4e, 0x37, 0x9d, 0x67,
    0xfb, 0x68, 0x85, 0x7c, 0x50, 0x61, 0xff, 0x72, 0xc4, 0xae, 0xe5, 0x93, 0xf2, 0x5a, 0x59, 0x7a,
    0xcd, 0x8e, 0xa7, 0x1e, 0x8f, 0xe2, 0x0b, 0x42, 0x32, 0xc8, 0xd8, 0x56, 0x6e, 0x00, 0x7a, 0x57,
    0x9c, 0x6e, 0x87, 0x9e, 0x04, 0x0f, 0xfa, 0x3f, 0xf2, 0x9c, 0xec, 0x31, 0xd0, 0xb9, 0xe3, 0x6c,
    0xdc, 0xbf, 0x5c, 0x7c, 0x00, 0x55, 0xfc, 0x70, 0xfc
};
#endif

PyTypeObject *init_QQmlDebuggingEnabler(PyObject *module)
{
    if (SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX].type != nullptr)
        return SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX].type;

    Shiboken::AutoDecRef Sbk_QQmlDebuggingEnabler_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QQmlDebuggingEnabler_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QQmlDebuggingEnabler",
        "QQmlDebuggingEnabler*",
        &Sbk_QQmlDebuggingEnabler_spec,
        &Shiboken::callCppDestructor< ::QQmlDebuggingEnabler >,
        Sbk_QQmlDebuggingEnabler_Type_bases.object(),
        0);
    auto *pyType = Sbk_QQmlDebuggingEnabler_TypeF(); // references _Sbk_QQmlDebuggingEnabler_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QQmlDebuggingEnabler_SignatureStrings);
#else
    InitSignatureBytes(pyType, QQmlDebuggingEnabler_SignatureBytes, QQmlDebuggingEnabler_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QQmlDebuggingEnabler_PropertyStrings);
    SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QQmlDebuggingEnabler_PythonToCpp_QQmlDebuggingEnabler_PTR,
        is_QQmlDebuggingEnabler_PythonToCpp_QQmlDebuggingEnabler_PTR_Convertible,
        QQmlDebuggingEnabler_PTR_CppToPython_QQmlDebuggingEnabler);

    Shiboken::Conversions::registerConverterName(converter, "QQmlDebuggingEnabler");
    Shiboken::Conversions::registerConverterName(converter, "QQmlDebuggingEnabler*");
    Shiboken::Conversions::registerConverterName(converter, "QQmlDebuggingEnabler&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QQmlDebuggingEnabler).name());

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QQmlDebuggingEnabler_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'StartMode'.
    const char *StartMode_Initializer[] = {
        "DoNotWaitForClient",
        "WaitForClient",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t StartMode_InitializerValues[] = {
        uint8_t(QQmlDebuggingEnabler::StartMode::DoNotWaitForClient), //  0x00  0
        uint8_t(QQmlDebuggingEnabler::StartMode::WaitForClient)       //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QQmlDebuggingEnabler_TypeF(),
        "2:PySide6.QtQml.QQmlDebuggingEnabler.StartMode",
        StartMode_Initializer, StartMode_InitializerValues);
    SbkPySide6_QtQmlTypeStructs[SBK_QQmlDebuggingEnabler_StartMode_IDX].type = EType;
    // Register converter for enum 'QQmlDebuggingEnabler::StartMode'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QQmlDebuggingEnabler_StartMode_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QQmlDebuggingEnabler_StartMode,
            is_Enum_PythonToCpp_QQmlDebuggingEnabler_StartMode_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QQmlDebuggingEnabler::StartMode");
        Shiboken::Conversions::registerConverterAlias(converter, "StartMode");
        Shiboken::Enum::setTypeConverter(EType, converter, nullptr);
    }
    // End of 'StartMode' enum.

    qRegisterMetaType< ::QQmlDebuggingEnabler *>();
    qRegisterMetaType< ::QQmlDebuggingEnabler::StartMode >("QQmlDebuggingEnabler::StartMode");

    return pyType;
}
