// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQmlExtensionInterfaceWrapper_H
#define SBK_QQmlExtensionInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlextensioninterface.h>

class QQmlExtensionInterfaceWrapper : public QQmlExtensionInterface
{
public:
    QQmlExtensionInterfaceWrapper(const QQmlExtensionInterfaceWrapper &) = delete;
    QQmlExtensionInterfaceWrapper& operator=(const QQmlExtensionInterfaceWrapper &) = delete;
    QQmlExtensionInterfaceWrapper(QQmlExtensionInterfaceWrapper &&) = delete;
    QQmlExtensionInterfaceWrapper& operator=(QQmlExtensionInterfaceWrapper &&) = delete;

    QQmlExtensionInterfaceWrapper();
    void initializeEngine(::QQmlEngine * engine, const char * uri) override;
    void registerTypes(const char * uri) override;
    ~QQmlExtensionInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QQmlExtensionInterfaceWrapper_H

