// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQmlExtensionPluginWrapper_H
#define SBK_QQmlExtensionPluginWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlextensionplugin.h>

namespace PySide { class DynamicQMetaObject; }

class QQmlExtensionPluginWrapper : public QQmlExtensionPlugin
{
public:
    QQmlExtensionPluginWrapper(const QQmlExtensionPluginWrapper &) = delete;
    QQmlExtensionPluginWrapper& operator=(const QQmlExtensionPluginWrapper &) = delete;
    QQmlExtensionPluginWrapper(QQmlExtensionPluginWrapper &&) = delete;
    QQmlExtensionPluginWrapper& operator=(QQmlExtensionPluginWrapper &&) = delete;

    QQmlExtensionPluginWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void initializeEngine(::QQmlEngine * engine, const char * uri) override;
    void registerTypes(const char * uri) override;
    void timerEvent(::QTimerEvent * event) override;
    void unregisterTypes() override;
    ~QQmlExtensionPluginWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[10] = {false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QQmlExtensionPluginWrapper_H

