// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtqml_python.h"

// main header
#include "qqmllistreference_wrapper.h"

// Argument includes
#include <QtQml/qqmlengine.h>
#include <QtQml/qqmllist.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qvariant.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QQmlListReference_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QQmlListReference >()))
        return -1;

    ::QQmlListReference *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QQmlListReference", 0, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QQmlListReference::QQmlListReference()
    // 1: QQmlListReference::QQmlListReference(QObject*,const char*)
    // 2: QQmlListReference::QQmlListReference(QObject*,const char*,QQmlEngine*)
    // 3: QQmlListReference::QQmlListReference(QQmlListReference)
    // 4: QQmlListReference::QQmlListReference(QVariant)
    // 5: QQmlListReference::QQmlListReference(QVariant,QQmlEngine*)
    if (numArgs == 0) {
        overloadId = 0; // QQmlListReference()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), (pyArgs[0])))) {
        overloadId = 3; // QQmlListReference(QQmlListReference)
    } else if (numArgs >= 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArgs[0])))
        && Shiboken::String::check(pyArgs[1]) && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArgs[1])))) {
        if (numArgs == 2) {
            overloadId = 1; // QQmlListReference(QObject*,const char*)
        } else if (numArgs == 3
            && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlEngine_IDX]), (pyArgs[2])))) {
            overloadId = 2; // QQmlListReference(QObject*,const char*,QQmlEngine*)
        }
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 4; // QQmlListReference(QVariant)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlEngine_IDX]), (pyArgs[1])))) {
            overloadId = 5; // QQmlListReference(QVariant,QQmlEngine*)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QQmlListReference()
        {

            // QQmlListReference()
            cptr = new ::QQmlListReference();
            break;
        }
        case 1: // QQmlListReference(QObject *o, const char *property)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QObject *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            const char* cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QQmlListReference(QObject*,const char*)
                cptr = new ::QQmlListReference(cppArg0, cppArg1);
            }
            break;
        }
        case 2: // QQmlListReference(QObject *o, const char *property, QQmlEngine *engine)
        {
            Shiboken::Warnings::warnDeprecated("QQmlListReference", "QQmlListReference(QObject *o, const char *property, QQmlEngine *engine)");
            if (Shiboken::Errors::occurred() != nullptr)
                return -1;
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QObject *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            const char* cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            if (!Shiboken::Object::isValid(pyArgs[2]))
                return -1;
            ::QQmlEngine *cppArg2;
            pythonToCpp[2](pyArgs[2], &cppArg2);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QQmlListReference(QObject*,const char*,QQmlEngine*)
                cptr = new ::QQmlListReference(cppArg0, cppArg1, cppArg2);
            }
            break;
        }
        case 3: // QQmlListReference(const QQmlListReference &arg__1)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QQmlListReference cppArg0_local;
            ::QQmlListReference *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QQmlListReference(QQmlListReference)
                cptr = new ::QQmlListReference(*cppArg0);
            }
            break;
        }
        case 4: // QQmlListReference(const QVariant &variant)
        {
            ::QVariant cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QQmlListReference(QVariant)
                cptr = new ::QQmlListReference(cppArg0);
            }
            break;
        }
        case 5: // QQmlListReference(const QVariant &variant, QQmlEngine *engine)
        {
            Shiboken::Warnings::warnDeprecated("QQmlListReference", "QQmlListReference(const QVariant &variant, QQmlEngine *engine)");
            if (Shiboken::Errors::occurred() != nullptr)
                return -1;
            ::QVariant cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return -1;
            ::QQmlEngine *cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QQmlListReference(QVariant,QQmlEngine*)
                cptr = new ::QQmlListReference(cppArg0, cppArg1);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QQmlListReference >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QQmlListReferenceFunc_append(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QQmlListReference::append(QObject*)const->bool
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArg)))) {
        overloadId = 0; // append(QObject*)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "append", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QObject *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // append(QObject*)const
            bool cppResult = const_cast<const ::QQmlListReference *>(cppSelf)->append(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlListReferenceFunc_at(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QQmlListReference::at(qsizetype)const->QObject*
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), (pyArg)))) {
        overloadId = 0; // at(qsizetype)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "at", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]);

    // Call function/method
    {
        qsizetype cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // at(qsizetype)const
            QObject * cppResult = const_cast<const ::QQmlListReference *>(cppSelf)->at(cppArg0);
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlListReferenceFunc_canAppend(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // canAppend()const
        bool cppResult = const_cast<const ::QQmlListReference *>(cppSelf)->canAppend();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlListReferenceFunc_canAt(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // canAt()const
        bool cppResult = const_cast<const ::QQmlListReference *>(cppSelf)->canAt();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlListReferenceFunc_canClear(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // canClear()const
        bool cppResult = const_cast<const ::QQmlListReference *>(cppSelf)->canClear();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlListReferenceFunc_canCount(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // canCount()const
        bool cppResult = const_cast<const ::QQmlListReference *>(cppSelf)->canCount();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlListReferenceFunc_canRemoveLast(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // canRemoveLast()const
        bool cppResult = const_cast<const ::QQmlListReference *>(cppSelf)->canRemoveLast();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlListReferenceFunc_canReplace(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // canReplace()const
        bool cppResult = const_cast<const ::QQmlListReference *>(cppSelf)->canReplace();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlListReferenceFunc_clear(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // clear()const
        bool cppResult = const_cast<const ::QQmlListReference *>(cppSelf)->clear();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlListReferenceFunc_count(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // count()const
        qsizetype cppResult = const_cast<const ::QQmlListReference *>(cppSelf)->count();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlListReferenceFunc_isManipulable(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // isManipulable()const
        bool cppResult = const_cast<const ::QQmlListReference *>(cppSelf)->isManipulable();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlListReferenceFunc_isReadable(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // isReadable()const
        bool cppResult = const_cast<const ::QQmlListReference *>(cppSelf)->isReadable();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlListReferenceFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // isValid()const
        bool cppResult = const_cast<const ::QQmlListReference *>(cppSelf)->isValid();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlListReferenceFunc_listElementType(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // listElementType()const
        const QMetaObject * cppResult = const_cast<const ::QQmlListReference *>(cppSelf)->listElementType();
        pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaObject_IDX]), cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlListReferenceFunc_object(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // object()const
        QObject * cppResult = const_cast<const ::QQmlListReference *>(cppSelf)->object();
        pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlListReferenceFunc_removeLast(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // removeLast()const
        bool cppResult = const_cast<const ::QQmlListReference *>(cppSelf)->removeLast();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlListReferenceFunc_replace(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "replace", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QQmlListReference::replace(qsizetype,QObject*)const->bool
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArgs[1])))) {
        overloadId = 0; // replace(qsizetype,QObject*)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "replace", errInfo, SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]);

    // Call function/method
    {
        qsizetype cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        if (!Shiboken::Object::isValid(pyArgs[1]))
            return {};
        ::QObject *cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // replace(qsizetype,QObject*)const
            bool cppResult = const_cast<const ::QQmlListReference *>(cppSelf)->replace(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlListReferenceFunc_size(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // size()const
        qsizetype cppResult = const_cast<const ::QQmlListReference *>(cppSelf)->size();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQmlListReference__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QQmlListReference_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QQmlListReference_methods[] = {
    {"append", reinterpret_cast<PyCFunction>(Sbk_QQmlListReferenceFunc_append), METH_O, nullptr},
    {"at", reinterpret_cast<PyCFunction>(Sbk_QQmlListReferenceFunc_at), METH_O, nullptr},
    {"canAppend", reinterpret_cast<PyCFunction>(Sbk_QQmlListReferenceFunc_canAppend), METH_NOARGS, nullptr},
    {"canAt", reinterpret_cast<PyCFunction>(Sbk_QQmlListReferenceFunc_canAt), METH_NOARGS, nullptr},
    {"canClear", reinterpret_cast<PyCFunction>(Sbk_QQmlListReferenceFunc_canClear), METH_NOARGS, nullptr},
    {"canCount", reinterpret_cast<PyCFunction>(Sbk_QQmlListReferenceFunc_canCount), METH_NOARGS, nullptr},
    {"canRemoveLast", reinterpret_cast<PyCFunction>(Sbk_QQmlListReferenceFunc_canRemoveLast), METH_NOARGS, nullptr},
    {"canReplace", reinterpret_cast<PyCFunction>(Sbk_QQmlListReferenceFunc_canReplace), METH_NOARGS, nullptr},
    {"clear", reinterpret_cast<PyCFunction>(Sbk_QQmlListReferenceFunc_clear), METH_NOARGS, nullptr},
    {"count", reinterpret_cast<PyCFunction>(Sbk_QQmlListReferenceFunc_count), METH_NOARGS, nullptr},
    {"isManipulable", reinterpret_cast<PyCFunction>(Sbk_QQmlListReferenceFunc_isManipulable), METH_NOARGS, nullptr},
    {"isReadable", reinterpret_cast<PyCFunction>(Sbk_QQmlListReferenceFunc_isReadable), METH_NOARGS, nullptr},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_QQmlListReferenceFunc_isValid), METH_NOARGS, nullptr},
    {"listElementType", reinterpret_cast<PyCFunction>(Sbk_QQmlListReferenceFunc_listElementType), METH_NOARGS, nullptr},
    {"object", reinterpret_cast<PyCFunction>(Sbk_QQmlListReferenceFunc_object), METH_NOARGS, nullptr},
    {"removeLast", reinterpret_cast<PyCFunction>(Sbk_QQmlListReferenceFunc_removeLast), METH_NOARGS, nullptr},
    {"replace", reinterpret_cast<PyCFunction>(Sbk_QQmlListReferenceFunc_replace), METH_VARARGS, nullptr},
    {"size", reinterpret_cast<PyCFunction>(Sbk_QQmlListReferenceFunc_size), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QQmlListReference__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QQmlListReference_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), (pyArg)))) {
                // operator==(const QQmlListReference &other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QQmlListReference cppArg0_local;
                ::QQmlListReference *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QQmlListReference_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QQmlListReference_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QQmlListReference_Type = nullptr;
static PyTypeObject *Sbk_QQmlListReference_TypeF(void)
{
    return _Sbk_QQmlListReference_Type;
}

static PyType_Slot Sbk_QQmlListReference_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QQmlListReference_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QQmlListReference_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QQmlListReference_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QQmlListReference_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QQmlListReference_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QQmlListReference_spec = {
    "2:PySide6.QtQml.QQmlListReference",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QQmlListReference_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QQmlListReference_PythonToCpp_QQmlListReference_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QQmlListReference_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QQmlListReference_PythonToCpp_QQmlListReference_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QQmlListReference_TypeF()))
        return QQmlListReference_PythonToCpp_QQmlListReference_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QQmlListReference_PTR_CppToPython_QQmlListReference(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QQmlListReference_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QQmlListReference_COPY_CppToPython_QQmlListReference(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QQmlListReference *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QQmlListReference_TypeF(), new ::QQmlListReference(*source), true, true);
}

// Python to C++ copy conversion.
static void QQmlListReference_PythonToCpp_QQmlListReference_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QQmlListReference *>(cppOut) = *reinterpret_cast< ::QQmlListReference *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QQmlListReference_PythonToCpp_QQmlListReference_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QQmlListReference_TypeF()))
        return QQmlListReference_PythonToCpp_QQmlListReference_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QQmlListReference_SignatureStrings[] = {
    "5:PySide6.QtQml.QQmlListReference(self)",
    "4:PySide6.QtQml.QQmlListReference(self,o:PySide6.QtCore.QObject,property:char*)",
    "3:PySide6.QtQml.QQmlListReference(self,o:PySide6.QtCore.QObject,property:char*,engine:PySide6.QtQml.QQmlEngine)",
    "2:PySide6.QtQml.QQmlListReference(self,arg__1:PySide6.QtQml.QQmlListReference)",
    "1:PySide6.QtQml.QQmlListReference(self,variant:QVariant)",
    "0:PySide6.QtQml.QQmlListReference(self,variant:QVariant,engine:PySide6.QtQml.QQmlEngine)",
    "PySide6.QtQml.QQmlListReference.append(self,arg__1:PySide6.QtCore.QObject)->bool",
    "PySide6.QtQml.QQmlListReference.at(self,arg__1:qsizetype)->PySide6.QtCore.QObject",
    "PySide6.QtQml.QQmlListReference.canAppend(self)->bool",
    "PySide6.QtQml.QQmlListReference.canAt(self)->bool",
    "PySide6.QtQml.QQmlListReference.canClear(self)->bool",
    "PySide6.QtQml.QQmlListReference.canCount(self)->bool",
    "PySide6.QtQml.QQmlListReference.canRemoveLast(self)->bool",
    "PySide6.QtQml.QQmlListReference.canReplace(self)->bool",
    "PySide6.QtQml.QQmlListReference.clear(self)->bool",
    "PySide6.QtQml.QQmlListReference.count(self)->qsizetype",
    "PySide6.QtQml.QQmlListReference.isManipulable(self)->bool",
    "PySide6.QtQml.QQmlListReference.isReadable(self)->bool",
    "PySide6.QtQml.QQmlListReference.isValid(self)->bool",
    "PySide6.QtQml.QQmlListReference.listElementType(self)->PySide6.QtCore.QMetaObject",
    "PySide6.QtQml.QQmlListReference.object(self)->PySide6.QtCore.QObject",
    "PySide6.QtQml.QQmlListReference.removeLast(self)->bool",
    "PySide6.QtQml.QQmlListReference.replace(self,arg__1:qsizetype,arg__2:PySide6.QtCore.QObject)->bool",
    "PySide6.QtQml.QQmlListReference.size(self)->qsizetype",
    "PySide6.QtQml.QQmlListReference.__copy__(self)->typing.Self",
    "PySide6.QtQml.QQmlListReference.__eq__(self,other:PySide6.QtQml.QQmlListReference)->bool",
    nullptr}; // Sentinel
#else
static constexpr size_t QQmlListReference_SignatureByteSize = 325;
static constexpr uint8_t QQmlListReference_SignatureBytes[325] = {
    0x78, 0xda, 0xad, 0x94, 0xcb, 0x6e, 0x83, 0x30, 0x10, 0x45, 0xf7, 0x7c, 0x49, 0xa9, 0x28, 0x6a,
    0xd2, 0xc7, 0x22, 0x8b, 0x4a, 0x55, 0x94, 0x5d, 0xa2, 0x16, 0x52, 0x65, 0x6b, 0x0d, 0x30, 0x21,
    0xae, 0x8c, 0xed, 0xd8, 0x4e, 0x24, 0xfa, 0xf5, 0x25, 0x0f, 0x5a, 0x9a, 0x26, 0xb2, 0x4d, 0xbb,
    0x41, 0x18, 0xe6, 0x5c, 0xcf, 0x85, 0x3b, 0x7e, 0x18, 0xbd, 0xd6, 0x73, 0x5a, 0xe0, 0x63, 0x9c,
    0x98, 0xa4, 0x62, 0x71, 0xd2, 0x5c, 0xa6, 0x54, 0x9b, 0x14, 0x97, 0xa8, 0x90, 0xe7, 0x78, 0xa5,
    0x91, 0x2d, 0xc3, 0xe0, 0xde, 0xa9, 0x2e, 0x12, 0x9d, 0xb2, 0xb1, 0x50, 0x18, 0x27, 0x2f, 0xd9,
    0x3b, 0xe6, 0x26, 0x92, 0x4a, 0x48, 0x54, 0xa6, 0x1e, 0xe5, 0x2b, 0x50, 0xd7, 0x61, 0x70, 0xf7,
    0xaf, 0x7a, 0x11, 0xf2, 0x92, 0x72, 0x3c, 0xa3, 0x39, 0xd9, 0xbf, 0x08, 0x83, 0xa1, 0xdb, 0x7e,
    0xa0, 0x4a, 0x42, 0x06, 0xb6, 0xda, 0x30, 0x18, 0xb8, 0xc9, 0x6d, 0x41, 0x51, 0xe0, 0x66, 0x94,
    0x2c, 0x0e, 0x37, 0x61, 0x70, 0xdb, 0x0f, 0xb4, 0x1b, 0xb4, 0xc8, 0xc6, 0x20, 0x25, 0xf2, 0xe2,
    0x82, 0xcb, 0xee, 0xa7, 0x0d, 0x6f, 0x9e, 0x32, 0x21, 0x98, 0x5d, 0xd0, 0xfc, 0x10, 0x5b, 0x6b,
    0xfa, 0x81, 0xa6, 0x96, 0xd8, 0xf0, 0xe7, 0x85, 0xad, 0x8a, 0x39, 0xf0, 0xe7, 0xef, 0x2e, 0x5d,
    0xfb, 0xd8, 0x51, 0xc6, 0x97, 0x18, 0x33, 0x04, 0xe5, 0x0d, 0x89, 0x0d, 0xf7, 0xde, 0x29, 0xc5,
    0x4a, 0x6c, 0x71, 0x0a, 0xba, 0x07, 0x29, 0x19, 0xb4, 0x03, 0xe8, 0x8a, 0xf9, 0xfb, 0xea, 0x9a,
    0xfa, 0xfa, 0x89, 0x56, 0x8c, 0xea, 0x19, 0x70, 0x2a, 0x37, 0x0c, 0x32, 0xe6, 0xd7, 0x22, 0xd5,
    0x29, 0x42, 0xd1, 0x03, 0x5b, 0x00, 0xa3, 0x7e, 0xd1, 0x60, 0xcd, 0x6a, 0xc2, 0xb0, 0x42, 0x6e,
    0xde, 0x1a, 0x53, 0x2d, 0x7b, 0x1a, 0xcf, 0x19, 0x1a, 0x70, 0x8c, 0xa8, 0xd8, 0x97, 0x5d, 0x12,
    0x72, 0x14, 0x51, 0xfd, 0x22, 0xa1, 0x3a, 0x79, 0xf8, 0x35, 0x75, 0x87, 0x07, 0xc3, 0x3f, 0xce,
    0xf4, 0x4e, 0xcd, 0x3f, 0x0b, 0x84, 0xe4, 0x42, 0xd6, 0x84, 0xb4, 0x64, 0x03, 0x51, 0x5e, 0xc6,
    0xf3, 0x66, 0xe5, 0xc0, 0xe2, 0xfa, 0x48, 0x46, 0xc2, 0xac, 0x50, 0x59, 0xcf, 0xde, 0xa3, 0x95,
    0x4f, 0xb6, 0x4d, 0x67, 0x61
};
#endif

PyTypeObject *init_QQmlListReference(PyObject *module)
{
    if (SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX].type != nullptr)
        return SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX].type;

    Shiboken::AutoDecRef Sbk_QQmlListReference_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QQmlListReference_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QQmlListReference",
        "QQmlListReference",
        &Sbk_QQmlListReference_spec,
        &Shiboken::callCppDestructor< ::QQmlListReference >,
        Sbk_QQmlListReference_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QQmlListReference_TypeF(); // references _Sbk_QQmlListReference_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QQmlListReference_SignatureStrings);
#else
    InitSignatureBytes(pyType, QQmlListReference_SignatureBytes, QQmlListReference_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QQmlListReference_PropertyStrings);
    SbkPySide6_QtQmlTypeStructs[SBK_QQmlListReference_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QQmlListReference_PythonToCpp_QQmlListReference_PTR,
        is_QQmlListReference_PythonToCpp_QQmlListReference_PTR_Convertible,
        QQmlListReference_PTR_CppToPython_QQmlListReference,
        QQmlListReference_COPY_CppToPython_QQmlListReference);

    Shiboken::Conversions::registerConverterName(converter, "QQmlListReference");
    Shiboken::Conversions::registerConverterName(converter, "QQmlListReference*");
    Shiboken::Conversions::registerConverterName(converter, "QQmlListReference&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QQmlListReference).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QQmlListReference_PythonToCpp_QQmlListReference_COPY,
        is_QQmlListReference_PythonToCpp_QQmlListReference_COPY_Convertible);

    qRegisterMetaType< ::QQmlListReference >("QQmlListReference");

    return pyType;
}
