// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQmlNetworkAccessManagerFactoryWrapper_H
#define SBK_QQmlNetworkAccessManagerFactoryWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlnetworkaccessmanagerfactory.h>

class QQmlNetworkAccessManagerFactoryWrapper : public QQmlNetworkAccessManagerFactory
{
public:
    QQmlNetworkAccessManagerFactoryWrapper(const QQmlNetworkAccessManagerFactoryWrapper &) = delete;
    QQmlNetworkAccessManagerFactoryWrapper& operator=(const QQmlNetworkAccessManagerFactoryWrapper &) = delete;
    QQmlNetworkAccessManagerFactoryWrapper(QQmlNetworkAccessManagerFactoryWrapper &&) = delete;
    QQmlNetworkAccessManagerFactoryWrapper& operator=(QQmlNetworkAccessManagerFactoryWrapper &&) = delete;

    QQmlNetworkAccessManagerFactoryWrapper();
    ::QNetworkAccessManager * create(::QObject * parent) override;
    ~QQmlNetworkAccessManagerFactoryWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QQmlNetworkAccessManagerFactoryWrapper_H

