// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQmlPropertyValueSourceWrapper_H
#define SBK_QQmlPropertyValueSourceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlpropertyvaluesource.h>

class QQmlPropertyValueSourceWrapper : public QQmlPropertyValueSource
{
public:
    QQmlPropertyValueSourceWrapper(const QQmlPropertyValueSourceWrapper &) = delete;
    QQmlPropertyValueSourceWrapper& operator=(const QQmlPropertyValueSourceWrapper &) = delete;
    QQmlPropertyValueSourceWrapper(QQmlPropertyValueSourceWrapper &&) = delete;
    QQmlPropertyValueSourceWrapper& operator=(QQmlPropertyValueSourceWrapper &&) = delete;

    QQmlPropertyValueSourceWrapper();
    void setTarget(const ::QQmlProperty & arg__1) override;
    ~QQmlPropertyValueSourceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QQmlPropertyValueSourceWrapper_H

