// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQmlTypesExtensionInterfaceWrapper_H
#define SBK_QQmlTypesExtensionInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlextensioninterface.h>

class QQmlTypesExtensionInterfaceWrapper : public QQmlTypesExtensionInterface
{
public:
    QQmlTypesExtensionInterfaceWrapper(const QQmlTypesExtensionInterfaceWrapper &) = delete;
    QQmlTypesExtensionInterfaceWrapper& operator=(const QQmlTypesExtensionInterfaceWrapper &) = delete;
    QQmlTypesExtensionInterfaceWrapper(QQmlTypesExtensionInterfaceWrapper &&) = delete;
    QQmlTypesExtensionInterfaceWrapper& operator=(QQmlTypesExtensionInterfaceWrapper &&) = delete;

    QQmlTypesExtensionInterfaceWrapper();
    void registerTypes(const char * uri) override;
    ~QQmlTypesExtensionInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QQmlTypesExtensionInterfaceWrapper_H

