// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQuickAsyncImageProviderWrapper_H
#define SBK_QQuickAsyncImageProviderWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qquickimageprovider.h>

namespace PySide { class DynamicQMetaObject; }

class QQuickAsyncImageProviderWrapper : public QQuickAsyncImageProvider
{
public:
    QQuickAsyncImageProviderWrapper(const QQuickAsyncImageProviderWrapper &) = delete;
    QQuickAsyncImageProviderWrapper& operator=(const QQuickAsyncImageProviderWrapper &) = delete;
    QQuickAsyncImageProviderWrapper(QQuickAsyncImageProviderWrapper &&) = delete;
    QQuickAsyncImageProviderWrapper& operator=(QQuickAsyncImageProviderWrapper &&) = delete;

    QQuickAsyncImageProviderWrapper();
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QFlags<QQmlImageProviderBase::Flag> flags() const override;
    ::QQmlImageProviderBase::ImageType imageType() const override;
    ::QImage requestImage(const ::QString & id, ::QSize * size, const ::QSize & requestedSize) override;
    ::QQuickImageResponse * requestImageResponse(const ::QString & id, const ::QSize & requestedSize) override;
    ::QPixmap requestPixmap(const ::QString & id, ::QSize * size, const ::QSize & requestedSize) override;
    ::QQuickTextureFactory * requestTexture(const ::QString & id, ::QSize * size, const ::QSize & requestedSize) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QQuickAsyncImageProviderWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[13] = {false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QQuickAsyncImageProviderWrapper_H

