// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQuickImageResponseWrapper_H
#define SBK_QQuickImageResponseWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qquickimageprovider.h>

namespace PySide { class DynamicQMetaObject; }

class QQuickImageResponseWrapper : public QQuickImageResponse
{
public:
    QQuickImageResponseWrapper(const QQuickImageResponseWrapper &) = delete;
    QQuickImageResponseWrapper& operator=(const QQuickImageResponseWrapper &) = delete;
    QQuickImageResponseWrapper(QQuickImageResponseWrapper &&) = delete;
    QQuickImageResponseWrapper& operator=(QQuickImageResponseWrapper &&) = delete;

    QQuickImageResponseWrapper();
    void cancel() override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    ::QString errorString() const override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QQuickTextureFactory * textureFactory() const override;
    void timerEvent(::QTimerEvent * event) override;
    ~QQuickImageResponseWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[10] = {false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QQuickImageResponseWrapper_H

