// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtquick_python.h"

// main header
#include "qquickitem_updatepaintnodedata_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QQuickItem_UpdatePaintNodeData_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QQuickItem::UpdatePaintNodeData >()))
        return -1;

    ::QQuickItem::UpdatePaintNodeData *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "UpdatePaintNodeData", 1, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: UpdatePaintNodeData::UpdatePaintNodeData(QQuickItem::UpdatePaintNodeData)
    if (numArgs == 1
        && (pyArgs[0] != Py_None && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QQuickItem_UpdatePaintNodeData_IDX]), (pyArgs[0]))))) {
        overloadId = 0; // UpdatePaintNodeData(QQuickItem::UpdatePaintNodeData)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtQuickTypeStructs[SBK_QQuickItem_UpdatePaintNodeData_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtQuickTypeStructs[SBK_QQuickItem_UpdatePaintNodeData_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return -1;
        ::QQuickItem::UpdatePaintNodeData *cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // UpdatePaintNodeData(QQuickItem::UpdatePaintNodeData)
            cptr = new ::QQuickItem::UpdatePaintNodeData(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QQuickItem::UpdatePaintNodeData >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtQuickTypeStructs[SBK_QQuickItem_UpdatePaintNodeData_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QQuickItem_UpdatePaintNodeData__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QQuickItem::UpdatePaintNodeData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QQuickItem_UpdatePaintNodeData_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QQuickItem_UpdatePaintNodeData_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QQuickItem_UpdatePaintNodeData_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QQuickItem_UpdatePaintNodeData_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QQuickItem_UpdatePaintNodeData__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QQuickItem_UpdatePaintNodeData_get_transformNode(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQuickItem::UpdatePaintNodeData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QQuickItem_UpdatePaintNodeData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGTransformNode_IDX]), cppSelf->transformNode);
    return pyOut;
}
static int Sbk_QQuickItem_UpdatePaintNodeData_set_transformNode(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QQuickItem::UpdatePaintNodeData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QQuickItem_UpdatePaintNodeData_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("transformNode");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGTransformNode_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("transformNode", "QSGTransformNode");
        return -1;
    }

    auto *&cppOut_ptr = cppSelf->transformNode;
    pythonToCpp(pyIn, &cppOut_ptr);

    Shiboken::Object::keepReference(reinterpret_cast<SbkObject *>(self), "transformNode", pyIn);
    return 0;
}

// Getters and Setters for UpdatePaintNodeData
static PyGetSetDef Sbk_QQuickItem_UpdatePaintNodeData_getsetlist[] = {
    {const_cast<char *>("transformNode"), Sbk_QQuickItem_UpdatePaintNodeData_get_transformNode, Sbk_QQuickItem_UpdatePaintNodeData_set_transformNode, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QQuickItem_UpdatePaintNodeData_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QQuickItem_UpdatePaintNodeData_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QQuickItem_UpdatePaintNodeData_Type = nullptr;
static PyTypeObject *Sbk_QQuickItem_UpdatePaintNodeData_TypeF(void)
{
    return _Sbk_QQuickItem_UpdatePaintNodeData_Type;
}

static PyType_Slot Sbk_QQuickItem_UpdatePaintNodeData_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QQuickItem_UpdatePaintNodeData_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QQuickItem_UpdatePaintNodeData_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QQuickItem_UpdatePaintNodeData_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QQuickItem_UpdatePaintNodeData_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QQuickItem_UpdatePaintNodeData_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QQuickItem_UpdatePaintNodeData_spec = {
    "2:PySide6.QtQuick.QQuickItem.UpdatePaintNodeData",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QQuickItem_UpdatePaintNodeData_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void UpdatePaintNodeData_PythonToCpp_UpdatePaintNodeData_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QQuickItem_UpdatePaintNodeData_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_UpdatePaintNodeData_PythonToCpp_UpdatePaintNodeData_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QQuickItem_UpdatePaintNodeData_TypeF()))
        return UpdatePaintNodeData_PythonToCpp_UpdatePaintNodeData_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *UpdatePaintNodeData_PTR_CppToPython_UpdatePaintNodeData(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QQuickItem_UpdatePaintNodeData_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *UpdatePaintNodeData_COPY_CppToPython_UpdatePaintNodeData(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QQuickItem::UpdatePaintNodeData *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QQuickItem_UpdatePaintNodeData_TypeF(), new ::QQuickItem::UpdatePaintNodeData(*source), true, true);
}

// Python to C++ copy conversion.
static void UpdatePaintNodeData_PythonToCpp_UpdatePaintNodeData_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QQuickItem::UpdatePaintNodeData *>(cppOut) = *reinterpret_cast< ::QQuickItem::UpdatePaintNodeData *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QQuickItem_UpdatePaintNodeData_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_UpdatePaintNodeData_PythonToCpp_UpdatePaintNodeData_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QQuickItem_UpdatePaintNodeData_TypeF()))
        return UpdatePaintNodeData_PythonToCpp_UpdatePaintNodeData_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QQuickItem_UpdatePaintNodeData_SignatureStrings[] = {
    "PySide6.QtQuick.QQuickItem.UpdatePaintNodeData(self,UpdatePaintNodeData:PySide6.QtQuick.QQuickItem.UpdatePaintNodeData)",
    "PySide6.QtQuick.QQuickItem.UpdatePaintNodeData.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QQuickItem_UpdatePaintNodeData_SignatureByteSize = 92;
static constexpr uint8_t QQuickItem_UpdatePaintNodeData_SignatureBytes[92] = {
    0x78, 0xda, 0x0b, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x09, 0x2c, 0xcd, 0x4c,
    0xce, 0xd6, 0x0b, 0x04, 0x53, 0x9e, 0x25, 0xa9, 0xb9, 0x7a, 0xa1, 0x05, 0x29, 0x89, 0x25, 0xa9,
    0x01, 0x89, 0x99, 0x79, 0x25, 0x7e, 0xf9, 0x29, 0xa9, 0x2e, 0x89, 0x25, 0x89, 0x1a, 0xc5, 0xa9,
    0x39, 0x69, 0x3a, 0x58, 0x24, 0xac, 0x02, 0x48, 0x32, 0x47, 0x93, 0x8b, 0x34, 0xf5, 0x7a, 0xf1,
    0xf1, 0xc9, 0xf9, 0x05, 0x95, 0xf1, 0xf1, 0x60, 0x07, 0x68, 0xea, 0xda, 0x95, 0x54, 0x16, 0x64,
    0xe6, 0xa5, 0xeb, 0x05, 0x03, 0x79, 0x5c, 0x00, 0x5e, 0xc5, 0x47, 0x17
};
#endif

PyTypeObject *init_QQuickItem_UpdatePaintNodeData(PyObject *enclosingClass)
{
    if (SbkPySide6_QtQuickTypeStructs[SBK_QQuickItem_UpdatePaintNodeData_IDX].type != nullptr)
        return SbkPySide6_QtQuickTypeStructs[SBK_QQuickItem_UpdatePaintNodeData_IDX].type;

    Shiboken::AutoDecRef Sbk_QQuickItem_UpdatePaintNodeData_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QQuickItem_UpdatePaintNodeData_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "UpdatePaintNodeData",
        "QQuickItem::UpdatePaintNodeData",
        &Sbk_QQuickItem_UpdatePaintNodeData_spec,
        &Shiboken::callCppDestructor< ::QQuickItem::UpdatePaintNodeData >,
        Sbk_QQuickItem_UpdatePaintNodeData_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QQuickItem_UpdatePaintNodeData_TypeF(); // references _Sbk_QQuickItem_UpdatePaintNodeData_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QQuickItem_UpdatePaintNodeData_SignatureStrings);
#else
    InitSignatureBytes(pyType, QQuickItem_UpdatePaintNodeData_SignatureBytes, QQuickItem_UpdatePaintNodeData_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QQuickItem_UpdatePaintNodeData_PropertyStrings);
    SbkPySide6_QtQuickTypeStructs[SBK_QQuickItem_UpdatePaintNodeData_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        UpdatePaintNodeData_PythonToCpp_UpdatePaintNodeData_PTR,
        is_UpdatePaintNodeData_PythonToCpp_UpdatePaintNodeData_PTR_Convertible,
        UpdatePaintNodeData_PTR_CppToPython_UpdatePaintNodeData,
        UpdatePaintNodeData_COPY_CppToPython_UpdatePaintNodeData);

    Shiboken::Conversions::registerConverterName(converter, "QQuickItem::UpdatePaintNodeData");
    Shiboken::Conversions::registerConverterName(converter, "QQuickItem::UpdatePaintNodeData*");
    Shiboken::Conversions::registerConverterName(converter, "QQuickItem::UpdatePaintNodeData&");
    Shiboken::Conversions::registerConverterAlias(converter, "UpdatePaintNodeData");
    Shiboken::Conversions::registerConverterAlias(converter, "UpdatePaintNodeData*");
    Shiboken::Conversions::registerConverterAlias(converter, "UpdatePaintNodeData&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QQuickItem::UpdatePaintNodeData).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        UpdatePaintNodeData_PythonToCpp_UpdatePaintNodeData_COPY,
        is_UpdatePaintNodeData_PythonToCpp_UpdatePaintNodeData_COPY_Convertible);


    return pyType;
}
