// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQuickItemWrapper_H
#define SBK_QQuickItemWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qquickitem.h>

namespace PySide { class DynamicQMetaObject; }

class QQuickItemWrapper : public QQuickItem
{
public:
    QQuickItemWrapper(const QQuickItemWrapper &) = delete;
    QQuickItemWrapper& operator=(const QQuickItemWrapper &) = delete;
    QQuickItemWrapper(QQuickItemWrapper &&) = delete;
    QQuickItemWrapper& operator=(QQuickItemWrapper &&) = delete;

    QQuickItemWrapper(::QQuickItem * parent = nullptr);
    ::QRectF boundingRect() const override;
    void childEvent(::QChildEvent * event) override;
    bool childMouseEventFilter(::QQuickItem * arg__1, ::QEvent * arg__2) override;
    void classBegin() override;
    ::QRectF clipRect() const override;
    void componentComplete() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    bool contains(const ::QPointF & point) const override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    void dragEnterEvent(::QDragEnterEvent * arg__1) override;
    void dragLeaveEvent(::QDragLeaveEvent * arg__1) override;
    void dragMoveEvent(::QDragMoveEvent * arg__1) override;
    void dropEvent(::QDropEvent * arg__1) override;
    bool event(::QEvent * arg__1) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void focusInEvent(::QFocusEvent * arg__1) override;
    void focusOutEvent(::QFocusEvent * arg__1) override;
    void geometryChange(const ::QRectF & newGeometry, const ::QRectF & oldGeometry) override;
    void hoverEnterEvent(::QHoverEvent * event) override;
    void hoverLeaveEvent(::QHoverEvent * event) override;
    void hoverMoveEvent(::QHoverEvent * event) override;
    void inputMethodEvent(::QInputMethodEvent * arg__1) override;
    ::QVariant inputMethodQuery(::Qt::InputMethodQuery query) const override;
    bool isTextureProvider() const override;
    void keyPressEvent(::QKeyEvent * event) override;
    void keyReleaseEvent(::QKeyEvent * event) override;
    void mouseDoubleClickEvent(::QMouseEvent * event) override;
    void mouseMoveEvent(::QMouseEvent * event) override;
    void mousePressEvent(::QMouseEvent * event) override;
    void mouseReleaseEvent(::QMouseEvent * event) override;
    void mouseUngrabEvent() override;
    void releaseResources() override;
    ::QSGTextureProvider * textureProvider() const override;
    void timerEvent(::QTimerEvent * event) override;
    void touchEvent(::QTouchEvent * event) override;
    void touchUngrabEvent() override;
    ::QSGNode * updatePaintNode(::QSGNode * arg__1, ::QQuickItem::UpdatePaintNodeData * arg__2) override;
    void updatePolish() override;
    void wheelEvent(::QWheelEvent * event) override;
    ~QQuickItemWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[40] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QQuickItemWrapper_H

