// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtquick_python.h"

// main header
#include "qquickopenglutils_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static PyObject *Sbk_QQuickOpenGLUtilsFunc_resetOpenGLState(PyObject *self)
{
    SBK_UNUSED(self)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // resetOpenGLState()
        ::QQuickOpenGLUtils::resetOpenGLState();
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}


static const char *Sbk_QQuickOpenGLUtils_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QQuickOpenGLUtils_methods[] = {
    {"resetOpenGLState", reinterpret_cast<PyCFunction>(Sbk_QQuickOpenGLUtilsFunc_resetOpenGLState), METH_NOARGS|METH_STATIC, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QQuickOpenGLUtils_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QQuickOpenGLUtils_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QQuickOpenGLUtils_Type = nullptr;
static PyTypeObject *Sbk_QQuickOpenGLUtils_TypeF(void)
{
    return _Sbk_QQuickOpenGLUtils_Type;
}

static PyType_Slot Sbk_QQuickOpenGLUtils_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QQuickOpenGLUtils_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QQuickOpenGLUtils_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QQuickOpenGLUtils_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QQuickOpenGLUtils_spec = {
    "2:PySide6.QtQuick.QQuickOpenGLUtils",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QQuickOpenGLUtils_slots
};

} //extern "C"

// Type conversion functions.

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QtQuickQQuickOpenGLUtils_SignatureStrings[] = {
    "PySide6.QtQuick.QQuickOpenGLUtils.resetOpenGLState()",
    nullptr}; // Sentinel
#else
static constexpr size_t QtQuickQQuickOpenGLUtils_SignatureByteSize = 53;
static constexpr uint8_t QtQuickQQuickOpenGLUtils_SignatureBytes[53] = {
    0x78, 0xda, 0x0b, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x09, 0x2c, 0xcd, 0x4c,
    0xce, 0xd6, 0x0b, 0x04, 0x53, 0xfe, 0x05, 0xa9, 0x79, 0xee, 0x3e, 0xa1, 0x25, 0x99, 0x39, 0xc5,
    0x7a, 0x45, 0xa9, 0xc5, 0xa9, 0x25, 0x10, 0x81, 0xe0, 0x92, 0xc4, 0x92, 0x54, 0x0d, 0x4d, 0x2e,
    0x00, 0x0a, 0x8e, 0x12, 0xf9
};
#endif

PyTypeObject *init_QtQuickQQuickOpenGLUtils(PyObject *module)
{
    if (SbkPySide6_QtQuickTypeStructs[SBK_QtQuickQQuickOpenGLUtils_IDX].type != nullptr)
        return SbkPySide6_QtQuickTypeStructs[SBK_QtQuickQQuickOpenGLUtils_IDX].type;

    Shiboken::AutoDecRef Sbk_QQuickOpenGLUtils_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QQuickOpenGLUtils_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QQuickOpenGLUtils",
        "QQuickOpenGLUtils",
        &Sbk_QQuickOpenGLUtils_spec,
        nullptr,
        Sbk_QQuickOpenGLUtils_Type_bases.object(),
        0);
    auto *pyType = Sbk_QQuickOpenGLUtils_TypeF(); // references _Sbk_QQuickOpenGLUtils_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QtQuickQQuickOpenGLUtils_SignatureStrings);
#else
    InitSignatureBytes(pyType, QtQuickQQuickOpenGLUtils_SignatureBytes, QtQuickQQuickOpenGLUtils_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QQuickOpenGLUtils_PropertyStrings);
    SbkPySide6_QtQuickTypeStructs[SBK_QtQuickQQuickOpenGLUtils_IDX].type = pyType;



    return pyType;
}
