// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQuickRenderControlWrapper_H
#define SBK_QQuickRenderControlWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qquickrendercontrol.h>

namespace PySide { class DynamicQMetaObject; }

class QQuickRenderControlWrapper : public QQuickRenderControl
{
public:
    QQuickRenderControlWrapper(const QQuickRenderControlWrapper &) = delete;
    QQuickRenderControlWrapper& operator=(const QQuickRenderControlWrapper &) = delete;
    QQuickRenderControlWrapper(QQuickRenderControlWrapper &&) = delete;
    QQuickRenderControlWrapper& operator=(QQuickRenderControlWrapper &&) = delete;

    QQuickRenderControlWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QWindow * renderWindow(::QPoint * offset) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QQuickRenderControlWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_QQuickRenderControlWrapper_H

