// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQuickTextureFactoryWrapper_H
#define SBK_QQuickTextureFactoryWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qquickimageprovider.h>

namespace PySide { class DynamicQMetaObject; }

class QQuickTextureFactoryWrapper : public QQuickTextureFactory
{
public:
    QQuickTextureFactoryWrapper(const QQuickTextureFactoryWrapper &) = delete;
    QQuickTextureFactoryWrapper& operator=(const QQuickTextureFactoryWrapper &) = delete;
    QQuickTextureFactoryWrapper(QQuickTextureFactoryWrapper &&) = delete;
    QQuickTextureFactoryWrapper& operator=(QQuickTextureFactoryWrapper &&) = delete;

    QQuickTextureFactoryWrapper();
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QSGTexture * createTexture(::QQuickWindow * window) const override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QImage image() const override;
    int textureByteCount() const override;
    ::QSize textureSize() const override;
    void timerEvent(::QTimerEvent * event) override;
    ~QQuickTextureFactoryWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[11] = {false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QQuickTextureFactoryWrapper_H

