// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGBasicGeometryNodeWrapper_H
#define SBK_QSGBasicGeometryNodeWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgnode.h>

class QSGBasicGeometryNodeWrapper : public QSGBasicGeometryNode
{
public:
    QSGBasicGeometryNodeWrapper(const QSGBasicGeometryNodeWrapper &) = delete;
    QSGBasicGeometryNodeWrapper& operator=(const QSGBasicGeometryNodeWrapper &) = delete;
    QSGBasicGeometryNodeWrapper(QSGBasicGeometryNodeWrapper &&) = delete;
    QSGBasicGeometryNodeWrapper& operator=(QSGBasicGeometryNodeWrapper &&) = delete;

    QSGBasicGeometryNodeWrapper(::QSGNode::NodeType type);
    bool isSubtreeBlocked() const override;
    void preprocess() override;
    ~QSGBasicGeometryNodeWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QSGBasicGeometryNodeWrapper_H

