// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGMaterialWrapper_H
#define SBK_QSGMaterialWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgmaterial.h>

class QSGMaterialWrapper : public QSGMaterial
{
public:
    QSGMaterialWrapper(const QSGMaterialWrapper &) = delete;
    QSGMaterialWrapper& operator=(const QSGMaterialWrapper &) = delete;
    QSGMaterialWrapper(QSGMaterialWrapper &&) = delete;
    QSGMaterialWrapper& operator=(QSGMaterialWrapper &&) = delete;

    QSGMaterialWrapper();
    int compare(const ::QSGMaterial * other) const override;
    ::QSGMaterialShader * createShader(::QSGRendererInterface::RenderMode renderMode) const override;
    ::QSGMaterialType * type() const override;
    ~QSGMaterialWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QSGMaterialWrapper_H

