// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtquick_python.h"

// main header
#include "qsgmaterialshader_renderstate_wrapper.h"

// Argument includes
#include <QtGui/qmatrix4x4.h>
#include <qbytearray.h>
#include <qrect.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QSGMaterialShader_RenderState_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QSGMaterialShader::RenderState >()))
        return -1;

    ::QSGMaterialShader::RenderState *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "RenderState", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: RenderState::RenderState()
    // 1: RenderState::RenderState(QSGMaterialShader::RenderState)
    if (numArgs == 0) {
        overloadId = 0; // RenderState()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), (pyArgs[0])))) {
        overloadId = 1; // RenderState(QSGMaterialShader::RenderState)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // RenderState()
        {

            // RenderState()
            cptr = new ::QSGMaterialShader::RenderState();
            break;
        }
        case 1: // RenderState(const QSGMaterialShader::RenderState &RenderState)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QSGMaterialShader::RenderState cppArg0_local;
            ::QSGMaterialShader::RenderState *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // RenderState(QSGMaterialShader::RenderState)
                cptr = new ::QSGMaterialShader::RenderState(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QSGMaterialShader::RenderState >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_combinedMatrix(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "combinedMatrix", 0, 1, &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: RenderState::combinedMatrix()const->QMatrix4x4
    // 1: RenderState::combinedMatrix(qsizetype)const->QMatrix4x4
    if (numArgs == 0) {
        overloadId = 0; // combinedMatrix()const
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), (pyArgs[0])))) {
        overloadId = 1; // combinedMatrix(qsizetype)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "combinedMatrix", errInfo, SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]);

    // Call function/method
    switch (overloadId) {
        case 0: // combinedMatrix() const
        {

            // combinedMatrix()const
            QMatrix4x4 cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->combinedMatrix();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QMatrix4x4_IDX]), &cppResult);
            break;
        }
        case 1: // combinedMatrix(qsizetype index) const
        {
            qsizetype cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // combinedMatrix(qsizetype)const
                QMatrix4x4 cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->combinedMatrix(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QMatrix4x4_IDX]), &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_determinant(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // determinant()const
        float cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->determinant();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_devicePixelRatio(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // devicePixelRatio()const
        float cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->devicePixelRatio();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_deviceRect(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // deviceRect()const
        QRect cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->deviceRect();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRect_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_dirtyStates(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // dirtyStates()const
        QFlags<QSGMaterialShader::RenderState::DirtyState> cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->dirtyStates();
        pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QFlags_QSGMaterialShader_RenderState_DirtyState_IDX])))->flagsConverter, &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_isMatrixDirty(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // isMatrixDirty()const
        bool cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->isMatrixDirty();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_isOpacityDirty(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // isOpacityDirty()const
        bool cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->isOpacityDirty();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_modelViewMatrix(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // modelViewMatrix()const
        QMatrix4x4 cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->modelViewMatrix();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QMatrix4x4_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_opacity(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // opacity()const
        float cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->opacity();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<float>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_projectionMatrix(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "projectionMatrix", 0, 1, &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: RenderState::projectionMatrix()const->QMatrix4x4
    // 1: RenderState::projectionMatrix(qsizetype)const->QMatrix4x4
    if (numArgs == 0) {
        overloadId = 0; // projectionMatrix()const
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), (pyArgs[0])))) {
        overloadId = 1; // projectionMatrix(qsizetype)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "projectionMatrix", errInfo, SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]);

    // Call function/method
    switch (overloadId) {
        case 0: // projectionMatrix() const
        {

            // projectionMatrix()const
            QMatrix4x4 cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->projectionMatrix();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QMatrix4x4_IDX]), &cppResult);
            break;
        }
        case 1: // projectionMatrix(qsizetype index) const
        {
            qsizetype cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // projectionMatrix(qsizetype)const
                QMatrix4x4 cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->projectionMatrix(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QMatrix4x4_IDX]), &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_projectionMatrixCount(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // projectionMatrixCount()const
        qsizetype cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->projectionMatrixCount();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_resourceUpdateBatch(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // resourceUpdateBatch()
        QRhiResourceUpdateBatch * cppResult = cppSelf->resourceUpdateBatch();
        pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiResourceUpdateBatch_IDX]), cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_rhi(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // rhi()
        QRhi * cppResult = cppSelf->rhi();
        pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhi_IDX]), cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_uniformData(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // uniformData()
        QByteArray * cppResult = cppSelf->uniformData();
        pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderStateFunc_viewportRect(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // viewportRect()const
        QRect cppResult = const_cast<const ::QSGMaterialShader::RenderState *>(cppSelf)->viewportRect();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRect_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSGMaterialShader_RenderState__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QSGMaterialShader_RenderState_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QSGMaterialShader_RenderState_EnumFlagInfo[] = {
    "DirtyState:Flag:DirtyStates",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QSGMaterialShader_RenderState_methods[] = {
    {"combinedMatrix", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_combinedMatrix), METH_VARARGS, nullptr},
    {"determinant", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_determinant), METH_NOARGS, nullptr},
    {"devicePixelRatio", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_devicePixelRatio), METH_NOARGS, nullptr},
    {"deviceRect", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_deviceRect), METH_NOARGS, nullptr},
    {"dirtyStates", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_dirtyStates), METH_NOARGS, nullptr},
    {"isMatrixDirty", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_isMatrixDirty), METH_NOARGS, nullptr},
    {"isOpacityDirty", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_isOpacityDirty), METH_NOARGS, nullptr},
    {"modelViewMatrix", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_modelViewMatrix), METH_NOARGS, nullptr},
    {"opacity", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_opacity), METH_NOARGS, nullptr},
    {"projectionMatrix", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_projectionMatrix), METH_VARARGS, nullptr},
    {"projectionMatrixCount", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_projectionMatrixCount), METH_NOARGS, nullptr},
    {"resourceUpdateBatch", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_resourceUpdateBatch), METH_NOARGS, nullptr},
    {"rhi", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_rhi), METH_NOARGS, nullptr},
    {"uniformData", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_uniformData), METH_NOARGS, nullptr},
    {"viewportRect", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderStateFunc_viewportRect), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QSGMaterialShader_RenderState__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QSGMaterialShader_RenderState_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QSGMaterialShader_RenderState_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QSGMaterialShader_RenderState_Type = nullptr;
static PyTypeObject *Sbk_QSGMaterialShader_RenderState_TypeF(void)
{
    return _Sbk_QSGMaterialShader_RenderState_Type;
}

static PyType_Slot Sbk_QSGMaterialShader_RenderState_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QSGMaterialShader_RenderState_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QSGMaterialShader_RenderState_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QSGMaterialShader_RenderState_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QSGMaterialShader_RenderState_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QSGMaterialShader_RenderState_spec = {
    "2:PySide6.QtQuick.QSGMaterialShader.RenderState",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QSGMaterialShader_RenderState_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QSGMaterialShader_RenderState_DirtyState(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSGMaterialShader::RenderState::DirtyState>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSGMaterialShader::RenderState::DirtyState *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QSGMaterialShader_RenderState_DirtyState_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_DirtyState_IDX])))
        return Enum_PythonToCpp_QSGMaterialShader_RenderState_DirtyState;
    return {};
}

static PyObject *QSGMaterialShader_RenderState_DirtyState_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QSGMaterialShader::RenderState::DirtyState>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QSGMaterialShader::RenderState::DirtyState *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_DirtyState_IDX]), castCppIn);

}

static void Flag_PythonToCpp_QSGMaterialShader_RenderState_DirtyState(PyObject *pyIn, void *cppOut)
{
    const auto value = QFlags<::QSGMaterialShader::RenderState::DirtyState>::fromInt(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<QFlags<::QSGMaterialShader::RenderState::DirtyState> *>(cppOut) = value;

}

static PyObject *QSGMaterialShader_RenderState_DirtyState_CppToPython_Flag(const void *cppIn)
{
    const auto flags = *reinterpret_cast<const QFlags<::QSGMaterialShader::RenderState::DirtyState> *>(cppIn);
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_DirtyState_IDX]), flags.toInt());

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void RenderState_PythonToCpp_RenderState_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QSGMaterialShader_RenderState_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_RenderState_PythonToCpp_RenderState_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QSGMaterialShader_RenderState_TypeF()))
        return RenderState_PythonToCpp_RenderState_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *RenderState_PTR_CppToPython_RenderState(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QSGMaterialShader_RenderState_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *RenderState_COPY_CppToPython_RenderState(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QSGMaterialShader::RenderState *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QSGMaterialShader_RenderState_TypeF(), new ::QSGMaterialShader::RenderState(*source), true, true);
}

// Python to C++ copy conversion.
static void RenderState_PythonToCpp_RenderState_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QSGMaterialShader::RenderState *>(cppOut) = *reinterpret_cast< ::QSGMaterialShader::RenderState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_RenderState_PythonToCpp_RenderState_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QSGMaterialShader_RenderState_TypeF()))
        return RenderState_PythonToCpp_RenderState_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QSGMaterialShader_RenderState_SignatureStrings[] = {
    "1:PySide6.QtQuick.QSGMaterialShader.RenderState(self)",
    "0:PySide6.QtQuick.QSGMaterialShader.RenderState(self,RenderState:PySide6.QtQuick.QSGMaterialShader.RenderState)",
    "1:PySide6.QtQuick.QSGMaterialShader.RenderState.combinedMatrix(self)->PySide6.QtGui.QMatrix4x4",
    "0:PySide6.QtQuick.QSGMaterialShader.RenderState.combinedMatrix(self,index:qsizetype)->PySide6.QtGui.QMatrix4x4",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.determinant(self)->float",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.devicePixelRatio(self)->float",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.deviceRect(self)->PySide6.QtCore.QRect",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.dirtyStates(self)->PySide6.QtQuick.QSGMaterialShader.RenderState.DirtyState",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.isMatrixDirty(self)->bool",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.isOpacityDirty(self)->bool",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.modelViewMatrix(self)->PySide6.QtGui.QMatrix4x4",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.opacity(self)->float",
    "1:PySide6.QtQuick.QSGMaterialShader.RenderState.projectionMatrix(self)->PySide6.QtGui.QMatrix4x4",
    "0:PySide6.QtQuick.QSGMaterialShader.RenderState.projectionMatrix(self,index:qsizetype)->PySide6.QtGui.QMatrix4x4",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.projectionMatrixCount(self)->qsizetype",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.resourceUpdateBatch(self)->PySide6.QtGui.QRhiResourceUpdateBatch",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.rhi(self)->PySide6.QtGui.QRhi",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.uniformData(self)->PySide6.QtCore.QByteArray",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.viewportRect(self)->PySide6.QtCore.QRect",
    "PySide6.QtQuick.QSGMaterialShader.RenderState.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QSGMaterialShader_RenderState_SignatureByteSize = 332;
static constexpr uint8_t QSGMaterialShader_RenderState_SignatureBytes[332] = {
    0x78, 0xda, 0xb5, 0x94, 0x51, 0x4f, 0xc2, 0x30, 0x10, 0xc7, 0xdf, 0xf9, 0x24, 0x92, 0xe0, 0x22,
    0x09, 0xf1, 0x81, 0x07, 0x13, 0x81, 0x84, 0x27, 0x23, 0xdb, 0xa2, 0xaf, 0x4b, 0xe9, 0x0e, 0x77,
    0xba, 0xf5, 0x66, 0x77, 0xc3, 0xd5, 0x4f, 0x6f, 0x65, 0x01, 0x54, 0xc0, 0x70, 0x22, 0x4f, 0x5b,
    0x7b, 0xbd, 0xdf, 0xbf, 0xed, 0xdd, 0xbf, 0xfd, 0xe1, 0xcc, 0xc5, 0x98, 0xc2, 0x75, 0x10, 0x72,
    0x58, 0xa3, 0x7e, 0x09, 0xc2, 0x78, 0x7a, 0xa7, 0x18, 0x2c, 0xaa, 0x3c, 0xce, 0x54, 0x0a, 0x36,
    0x88, 0xc0, 0xf8, 0x4f, 0xcc, 0x7e, 0xf6, 0xa2, 0x82, 0x7c, 0xd1, 0xed, 0x5c, 0xfd, 0x21, 0xab,
    0xf7, 0x65, 0x42, 0x96, 0xde, 0xed, 0xf4, 0x65, 0x09, 0x81, 0xa6, 0x62, 0x8e, 0x06, 0x52, 0xbf,
    0xc4, 0x62, 0xd3, 0x6e, 0xfa, 0xf2, 0x66, 0xcb, 0x98, 0xd6, 0x18, 0x84, 0x6d, 0x70, 0xd0, 0x0c,
    0xa4, 0xc7, 0xd9, 0x87, 0xef, 0xa1, 0x0f, 0x37, 0xc3, 0xd7, 0x0a, 0xdf, 0x81, 0x5d, 0x09, 0xbf,
    0xc9, 0xc9, 0xc4, 0x52, 0xf0, 0xa1, 0x02, 0x8d, 0x32, 0xbc, 0x3e, 0xc8, 0x22, 0x27, 0xc5, 0x62,
    0xcc, 0x12, 0x35, 0xcc, 0xb0, 0x81, 0x3c, 0x52, 0x8c, 0x74, 0x3a, 0x2b, 0x02, 0xcd, 0xbb, 0x57,
    0x3b, 0x26, 0x0b, 0x41, 0xf8, 0x19, 0x93, 0x42, 0xd1, 0xb2, 0x5b, 0xfd, 0x56, 0xbb, 0xd4, 0x63,
    0x00, 0x93, 0x0d, 0x40, 0xa8, 0x8c, 0x55, 0x5b, 0x9b, 0x15, 0x60, 0xad, 0x3d, 0x27, 0xca, 0xc5,
    0x9c, 0xfb, 0x52, 0x69, 0x64, 0x77, 0x2a, 0xa8, 0xa0, 0x14, 0xf2, 0x47, 0x84, 0xb7, 0x23, 0xfb,
    0x57, 0x46, 0xa7, 0x76, 0x93, 0xdf, 0x1b, 0x40, 0xea, 0xb0, 0xd2, 0xd2, 0xb3, 0xaf, 0x31, 0x92,
    0x39, 0x93, 0xc7, 0xf6, 0x0a, 0x9c, 0xcf, 0x65, 0x3f, 0xe5, 0xc6, 0x54, 0x6f, 0xfd, 0xb6, 0xd1,
    0x13, 0x42, 0x2d, 0x54, 0x54, 0x5b, 0x0d, 0x0f, 0x65, 0xea, 0x87, 0x23, 0xc5, 0x3a, 0x3b, 0x70,
    0x4f, 0x51, 0x86, 0xd1, 0xee, 0x62, 0xa9, 0x5c, 0x86, 0x87, 0xf1, 0x42, 0x56, 0x6d, 0x70, 0x41,
    0xb6, 0x98, 0x28, 0x56, 0x87, 0x3c, 0x3e, 0x72, 0x0c, 0xb7, 0xd6, 0x2a, 0x27, 0x44, 0x2f, 0x7d,
    0x63, 0x97, 0x64, 0xf9, 0x9f, 0xdf, 0x8f, 0x24, 0xd1, 0x54, 0xba, 0x24, 0x59, 0x23, 0x7d, 0xbd,
    0xd0, 0x3c, 0x05, 0xb1, 0x1f, 0x75, 0x3e, 0x00, 0x60, 0xf1, 0x7f, 0xe6
};
#endif

PyTypeObject *init_QSGMaterialShader_RenderState(PyObject *enclosingClass)
{
    if (SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX].type != nullptr)
        return SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX].type;

    Shiboken::AutoDecRef Sbk_QSGMaterialShader_RenderState_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QSGMaterialShader_RenderState_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "RenderState",
        "QSGMaterialShader::RenderState",
        &Sbk_QSGMaterialShader_RenderState_spec,
        &Shiboken::callCppDestructor< ::QSGMaterialShader::RenderState >,
        Sbk_QSGMaterialShader_RenderState_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QSGMaterialShader_RenderState_TypeF(); // references _Sbk_QSGMaterialShader_RenderState_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QSGMaterialShader_RenderState_SignatureStrings);
#else
    InitSignatureBytes(pyType, QSGMaterialShader_RenderState_SignatureBytes, QSGMaterialShader_RenderState_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QSGMaterialShader_RenderState_PropertyStrings);
    SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        RenderState_PythonToCpp_RenderState_PTR,
        is_RenderState_PythonToCpp_RenderState_PTR_Convertible,
        RenderState_PTR_CppToPython_RenderState,
        RenderState_COPY_CppToPython_RenderState);

    Shiboken::Conversions::registerConverterName(converter, "QSGMaterialShader::RenderState");
    Shiboken::Conversions::registerConverterName(converter, "QSGMaterialShader::RenderState*");
    Shiboken::Conversions::registerConverterName(converter, "QSGMaterialShader::RenderState&");
    Shiboken::Conversions::registerConverterAlias(converter, "RenderState");
    Shiboken::Conversions::registerConverterAlias(converter, "RenderState*");
    Shiboken::Conversions::registerConverterAlias(converter, "RenderState&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QSGMaterialShader::RenderState).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        RenderState_PythonToCpp_RenderState_COPY,
        is_RenderState_PythonToCpp_RenderState_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QSGMaterialShader_RenderState_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'DirtyState'.
    const char *DirtyState_Initializer[] = {
        "DirtyMatrix",
        "DirtyOpacity",
        "DirtyCachedMaterialData",
        "DirtyAll",
        nullptr};
    // "uint16_t" used instead of "unsigned int"
    constexpr uint16_t DirtyState_InitializerValues[] = {
        uint16_t(QSGMaterialShader::RenderState::DirtyState::DirtyMatrix),             //  0x0001  1
        uint16_t(QSGMaterialShader::RenderState::DirtyState::DirtyOpacity),            //  0x0002  2
        uint16_t(QSGMaterialShader::RenderState::DirtyState::DirtyCachedMaterialData), //  0x0004  4
        uint16_t(QSGMaterialShader::RenderState::DirtyState::DirtyAll)                 //  0xffff  65535
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSGMaterialShader_RenderState_TypeF(),
        "2:PySide6.QtQuick.QSGMaterialShader.RenderState.DirtyState",
        DirtyState_Initializer, DirtyState_InitializerValues);
    SbkPySide6_QtQuickTypeStructs[SBK_QSGMaterialShader_RenderState_DirtyState_IDX].type = EType;
    // PYSIDE-1735: Mapping the flags class to the same enum class.
    SbkPySide6_QtQuickTypeStructs[SBK_QFlags_QSGMaterialShader_RenderState_DirtyState_IDX].type =
        EType;
    // Register converter for enum 'QSGMaterialShader::RenderState::DirtyState'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSGMaterialShader_RenderState_DirtyState_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QSGMaterialShader_RenderState_DirtyState,
            is_Enum_PythonToCpp_QSGMaterialShader_RenderState_DirtyState_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QSGMaterialShader::RenderState::DirtyState");
        Shiboken::Conversions::registerConverterAlias(converter, "RenderState::DirtyState");
        Shiboken::Conversions::registerConverterAlias(converter, "DirtyState");
        SbkConverter *flagsConverter = Shiboken::Conversions::createConverter(EType,
            QSGMaterialShader_RenderState_DirtyState_CppToPython_Flag);
        Shiboken::Conversions::addPythonToCppValueConversion(flagsConverter,
            Flag_PythonToCpp_QSGMaterialShader_RenderState_DirtyState,
            is_Enum_PythonToCpp_QSGMaterialShader_RenderState_DirtyState_Convertible);
        // Register converter for flag 'QFlags<QSGMaterialShader::RenderState::DirtyState>'.
        Shiboken::Conversions::registerConverterName(flagsConverter, "QFlags<QSGMaterialShader::RenderState::DirtyState>");
        Shiboken::Conversions::registerConverterName(flagsConverter, "QSGMaterialShader::RenderState::DirtyStates");
        Shiboken::Enum::setTypeConverter(EType, converter, flagsConverter);
    }
    // End of 'DirtyState' enum/flags.

    qRegisterMetaType< ::QSGMaterialShader::RenderState >("RenderState");
    qRegisterMetaType< ::QSGMaterialShader::RenderState >("QSGMaterialShader::RenderState");
    qRegisterMetaType< ::QSGMaterialShader::RenderState::DirtyState >("RenderState::DirtyState");
    qRegisterMetaType< ::QSGMaterialShader::RenderState::DirtyState >("QSGMaterialShader::RenderState::DirtyState");

    return pyType;
}
