// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGNinePatchNodeWrapper_H
#define SBK_QSGNinePatchNodeWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgninepatchnode.h>

class QSGNinePatchNodeWrapper : public QSGNinePatchNode
{
public:
    QSGNinePatchNodeWrapper(const QSGNinePatchNodeWrapper &) = delete;
    QSGNinePatchNodeWrapper& operator=(const QSGNinePatchNodeWrapper &) = delete;
    QSGNinePatchNodeWrapper(QSGNinePatchNodeWrapper &&) = delete;
    QSGNinePatchNodeWrapper& operator=(QSGNinePatchNodeWrapper &&) = delete;

    QSGNinePatchNodeWrapper();
    bool isSubtreeBlocked() const override;
    void preprocess() override;
    void setBounds(const ::QRectF & bounds) override;
    void setDevicePixelRatio(qreal ratio) override;
    void setPadding(qreal left, qreal top, qreal right, qreal bottom) override;
    void setTexture(::QSGTexture * texture) override;
    void update() override;
    ~QSGNinePatchNodeWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QSGNinePatchNodeWrapper_H

