// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGOpaqueTextureMaterialWrapper_H
#define SBK_QSGOpaqueTextureMaterialWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgtexturematerial.h>

class QSGOpaqueTextureMaterialWrapper : public QSGOpaqueTextureMaterial
{
public:
    QSGOpaqueTextureMaterialWrapper(const QSGOpaqueTextureMaterialWrapper &) = delete;
    QSGOpaqueTextureMaterialWrapper& operator=(const QSGOpaqueTextureMaterialWrapper &) = delete;
    QSGOpaqueTextureMaterialWrapper(QSGOpaqueTextureMaterialWrapper &&) = delete;
    QSGOpaqueTextureMaterialWrapper& operator=(QSGOpaqueTextureMaterialWrapper &&) = delete;

    QSGOpaqueTextureMaterialWrapper();
    int compare(const ::QSGMaterial * other) const override;
    ::QSGMaterialShader * createShader(::QSGRendererInterface::RenderMode renderMode) const override;
    ::QSGMaterialType * type() const override;
    ~QSGOpaqueTextureMaterialWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QSGOpaqueTextureMaterialWrapper_H

