// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGRendererInterfaceWrapper_H
#define SBK_QSGRendererInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgrendererinterface.h>

class QSGRendererInterfaceWrapper : public QSGRendererInterface
{
public:
    QSGRendererInterfaceWrapper(const QSGRendererInterfaceWrapper &) = delete;
    QSGRendererInterfaceWrapper& operator=(const QSGRendererInterfaceWrapper &) = delete;
    QSGRendererInterfaceWrapper(QSGRendererInterfaceWrapper &&) = delete;
    QSGRendererInterfaceWrapper& operator=(QSGRendererInterfaceWrapper &&) = delete;

    QSGRendererInterfaceWrapper();
    void * getResource(::QQuickWindow * window, ::QSGRendererInterface::Resource resource) const override;
    void * getResource(::QQuickWindow * window, const char * resource) const override;
    ::QSGRendererInterface::GraphicsApi graphicsApi() const override;
    ::QFlags<QSGRendererInterface::ShaderCompilationType> shaderCompilationType() const override;
    ::QFlags<QSGRendererInterface::ShaderSourceType> shaderSourceType() const override;
    ::QSGRendererInterface::ShaderType shaderType() const override;
    ~QSGRendererInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[6] = {false, false, false, false, false, false};
};

#endif // SBK_QSGRendererInterfaceWrapper_H

