// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_RenderStateWrapper_H
#define SBK_RenderStateWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgrendernode.h>

class RenderStateWrapper : public QSGRenderNode::RenderState
{
public:
    RenderStateWrapper(const RenderStateWrapper &) = delete;
    RenderStateWrapper& operator=(const RenderStateWrapper &) = delete;
    RenderStateWrapper(RenderStateWrapper &&) = delete;
    RenderStateWrapper& operator=(RenderStateWrapper &&) = delete;

    RenderStateWrapper();
    const ::QRegion * clipRegion() const override;
    void * get(const char * state) const override;
    const ::QMatrix4x4 * projectionMatrix() const override;
    bool scissorEnabled() const override;
    ::QRect scissorRect() const override;
    bool stencilEnabled() const override;
    int stencilValue() const override;
    ~RenderStateWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_RenderStateWrapper_H

