// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGSimpleRectNodeWrapper_H
#define SBK_QSGSimpleRectNodeWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgsimplerectnode.h>

class QSGSimpleRectNodeWrapper : public QSGSimpleRectNode
{
public:
    QSGSimpleRectNodeWrapper(const QSGSimpleRectNodeWrapper &) = delete;
    QSGSimpleRectNodeWrapper& operator=(const QSGSimpleRectNodeWrapper &) = delete;
    QSGSimpleRectNodeWrapper(QSGSimpleRectNodeWrapper &&) = delete;
    QSGSimpleRectNodeWrapper& operator=(QSGSimpleRectNodeWrapper &&) = delete;

    QSGSimpleRectNodeWrapper();
    QSGSimpleRectNodeWrapper(const ::QRectF & rect, const ::QColor & color);
    bool isSubtreeBlocked() const override;
    void preprocess() override;
    ~QSGSimpleRectNodeWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QSGSimpleRectNodeWrapper_H

