// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGSimpleTextureNodeWrapper_H
#define SBK_QSGSimpleTextureNodeWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgsimpletexturenode.h>

class QSGSimpleTextureNodeWrapper : public QSGSimpleTextureNode
{
public:
    QSGSimpleTextureNodeWrapper(const QSGSimpleTextureNodeWrapper &) = delete;
    QSGSimpleTextureNodeWrapper& operator=(const QSGSimpleTextureNodeWrapper &) = delete;
    QSGSimpleTextureNodeWrapper(QSGSimpleTextureNodeWrapper &&) = delete;
    QSGSimpleTextureNodeWrapper& operator=(QSGSimpleTextureNodeWrapper &&) = delete;

    QSGSimpleTextureNodeWrapper();
    bool isSubtreeBlocked() const override;
    void preprocess() override;
    ~QSGSimpleTextureNodeWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QSGSimpleTextureNodeWrapper_H

