// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGTextNodeWrapper_H
#define SBK_QSGTextNodeWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgtextnode.h>

class QSGTextNodeWrapper : public QSGTextNode
{
public:
    QSGTextNodeWrapper(const QSGTextNodeWrapper &) = delete;
    QSGTextNodeWrapper& operator=(const QSGTextNodeWrapper &) = delete;
    QSGTextNodeWrapper(QSGTextNodeWrapper &&) = delete;
    QSGTextNodeWrapper& operator=(QSGTextNodeWrapper &&) = delete;

    QSGTextNodeWrapper();
    void clear() override;
    ::QColor color() const override;
    void doAddTextDocument(::QPointF position, ::QTextDocument * document, int selectionStart, int selectionCount) override;
    void doAddTextLayout(::QPointF position, ::QTextLayout * layout, int selectionStart, int selectionCount, int lineStart, int lineCount) override;
    ::QSGTexture::Filtering filtering() const override;
    bool isSubtreeBlocked() const override;
    ::QColor linkColor() const override;
    void preprocess() override;
    ::QSGTextNode::RenderType renderType() const override;
    int renderTypeQuality() const override;
    ::QColor selectionColor() const override;
    ::QColor selectionTextColor() const override;
    void setColor(::QColor color) override;
    void setFiltering(::QSGTexture::Filtering arg__1) override;
    void setLinkColor(::QColor linkColor) override;
    void setRenderType(::QSGTextNode::RenderType renderType) override;
    void setRenderTypeQuality(int renderTypeQuality) override;
    void setSelectionColor(::QColor selectionColor) override;
    void setSelectionTextColor(::QColor selectionTextColor) override;
    void setStyleColor(::QColor styleColor) override;
    void setTextStyle(::QSGTextNode::TextStyle textStyle) override;
    void setViewport(const ::QRectF & viewport) override;
    ::QColor styleColor() const override;
    ::QSGTextNode::TextStyle textStyle() override;
    ::QRectF viewport() const override;
    ~QSGTextNodeWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[25] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QSGTextNodeWrapper_H

