// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGTransformNodeWrapper_H
#define SBK_QSGTransformNodeWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgnode.h>

class QSGTransformNodeWrapper : public QSGTransformNode
{
public:
    QSGTransformNodeWrapper(const QSGTransformNodeWrapper &) = delete;
    QSGTransformNodeWrapper& operator=(const QSGTransformNodeWrapper &) = delete;
    QSGTransformNodeWrapper(QSGTransformNodeWrapper &&) = delete;
    QSGTransformNodeWrapper& operator=(QSGTransformNodeWrapper &&) = delete;

    QSGTransformNodeWrapper();
    bool isSubtreeBlocked() const override;
    void preprocess() override;
    ~QSGTransformNodeWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QSGTransformNodeWrapper_H

