// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQuick3DGeometryWrapper_H
#define SBK_QQuick3DGeometryWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick3D/qquick3dgeometry.h>

namespace PySide { class DynamicQMetaObject; }

class QQuick3DGeometryWrapper : public QQuick3DGeometry
{
public:
    QQuick3DGeometryWrapper(const QQuick3DGeometryWrapper &) = delete;
    QQuick3DGeometryWrapper& operator=(const QQuick3DGeometryWrapper &) = delete;
    QQuick3DGeometryWrapper(QQuick3DGeometryWrapper &&) = delete;
    QQuick3DGeometryWrapper& operator=(QQuick3DGeometryWrapper &&) = delete;

    QQuick3DGeometryWrapper(::QQuick3DObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void classBegin() override;
    void componentComplete() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void markAllDirty() override;
    void preSync() override;
    void timerEvent(::QTimerEvent * event) override;
    ~QQuick3DGeometryWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[11] = {false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QQuick3DGeometryWrapper_H

