// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQuick3DInstancingWrapper_H
#define SBK_QQuick3DInstancingWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick3D/qquick3dinstancing.h>

namespace PySide { class DynamicQMetaObject; }

class QQuick3DInstancingWrapper : public QQuick3DInstancing
{
public:
    QQuick3DInstancingWrapper(const QQuick3DInstancingWrapper &) = delete;
    QQuick3DInstancingWrapper& operator=(const QQuick3DInstancingWrapper &) = delete;
    QQuick3DInstancingWrapper(QQuick3DInstancingWrapper &&) = delete;
    QQuick3DInstancingWrapper& operator=(QQuick3DInstancingWrapper &&) = delete;

    QQuick3DInstancingWrapper(::QQuick3DObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void classBegin() override;
    void componentComplete() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QByteArray getInstanceBuffer(int * instanceCount) override;
    void markAllDirty() override;
    void preSync() override;
    void timerEvent(::QTimerEvent * event) override;
    ~QQuick3DInstancingWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    static ::std::pair<QByteArray,int> getInstanceBufferOverride(Shiboken::GilState &gil, PyObject *pyOverride);

    mutable bool m_PyMethodCache[12] = {false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QQuick3DInstancingWrapper_H

