// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRemoteObjectRegistryHostWrapper_H
#define SBK_QRemoteObjectRegistryHostWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtRemoteObjects/qremoteobjectnode.h>

namespace PySide { class DynamicQMetaObject; }

class QRemoteObjectRegistryHostWrapper : public QRemoteObjectRegistryHost
{
public:
    QRemoteObjectRegistryHostWrapper(const QRemoteObjectRegistryHostWrapper &) = delete;
    QRemoteObjectRegistryHostWrapper& operator=(const QRemoteObjectRegistryHostWrapper &) = delete;
    QRemoteObjectRegistryHostWrapper(QRemoteObjectRegistryHostWrapper &&) = delete;
    QRemoteObjectRegistryHostWrapper& operator=(QRemoteObjectRegistryHostWrapper &&) = delete;

    QRemoteObjectRegistryHostWrapper(const ::QUrl & registryAddress = QUrl(), ::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QUrl hostUrl() const override;
    bool setHostUrl(const ::QUrl & hostAddress, ::QRemoteObjectHostBase::AllowedSchemas allowedSchemas = QRemoteObjectHostBase::AllowedSchemas::BuiltInSchemasOnly) override;
    void setName(const ::QString & name) override;
    bool setRegistryUrl(const ::QUrl & registryUrl) override;
    void timerEvent(::QTimerEvent * arg__1) override;
    ~QRemoteObjectRegistryHostWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[11] = {false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QRemoteObjectRegistryHostWrapper_H

