// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <QtCore/QBuffer>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtremoteobjects_python.h"

// main header
#include "qremoteobjectsourcelocationinfo_wrapper.h"

// Argument includes
#include <QString>
#include <QtRemoteObjects/qtremoteobjectglobal.h>
#include <qdatastream.h>
#include <qurl.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRemoteObjectSourceLocationInfo_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRemoteObjectSourceLocationInfo >()))
        return -1;

    ::QRemoteObjectSourceLocationInfo *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QRemoteObjectSourceLocationInfo", 0, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRemoteObjectSourceLocationInfo::QRemoteObjectSourceLocationInfo()
    // 1: QRemoteObjectSourceLocationInfo::QRemoteObjectSourceLocationInfo(QRemoteObjectSourceLocationInfo)
    // 2: QRemoteObjectSourceLocationInfo::QRemoteObjectSourceLocationInfo(QString,QUrl)
    if (numArgs == 0) {
        overloadId = 0; // QRemoteObjectSourceLocationInfo()
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), (pyArgs[1])))) {
        overloadId = 2; // QRemoteObjectSourceLocationInfo(QString,QUrl)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QRemoteObjectSourceLocationInfo(QRemoteObjectSourceLocationInfo)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRemoteObjectSourceLocationInfo()
        {

            // QRemoteObjectSourceLocationInfo()
            cptr = new ::QRemoteObjectSourceLocationInfo();
            break;
        }
        case 1: // QRemoteObjectSourceLocationInfo(const QRemoteObjectSourceLocationInfo &QRemoteObjectSourceLocationInfo)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRemoteObjectSourceLocationInfo cppArg0_local;
            ::QRemoteObjectSourceLocationInfo *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRemoteObjectSourceLocationInfo(QRemoteObjectSourceLocationInfo)
                cptr = new ::QRemoteObjectSourceLocationInfo(*cppArg0);
            }
            break;
        }
        case 2: // QRemoteObjectSourceLocationInfo(const QString &typeName_, const QUrl &hostUrl_)
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return -1;
            ::QUrl cppArg1_local;
            ::QUrl *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRemoteObjectSourceLocationInfo(QString,QUrl)
                cptr = new ::QRemoteObjectSourceLocationInfo(cppArg0, *cppArg1);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRemoteObjectSourceLocationInfo >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRemoteObjectSourceLocationInfo__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRemoteObjectSourceLocationInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRemoteObjectSourceLocationInfo_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRemoteObjectSourceLocationInfo_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRemoteObjectSourceLocationInfo__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QRemoteObjectSourceLocationInfoFunc___lshift__(PyObject *self, PyObject *pyArg)
{
    bool isReverse = SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]), pyArg)
                    && !SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]), self);
    if (isReverse)
        std::swap(self, pyArg);
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRemoteObjectSourceLocationInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    static PyObject *attrName = Shiboken::PyMagicName::rlshift();
    if (!isReverse
        && Shiboken::Object::checkType(pyArg)
        && !PyObject_TypeCheck(pyArg, self->ob_type)
        && PyObject_HasAttr(pyArg, attrName)) {
        PyObject *revOpMethod = PyObject_GetAttr(pyArg, attrName);
        if (revOpMethod && PyCallable_Check(revOpMethod)) {
            pyResult = PyObject_CallFunction(revOpMethod, "O", self);
            if (Shiboken::Errors::occurred() != nullptr && (PyErr_ExceptionMatches(PyExc_NotImplementedError) || PyErr_ExceptionMatches(PyExc_AttributeError))) {
                PyErr_Clear();
                Py_XDECREF(pyResult);
                pyResult = nullptr;
            }
        }
        Py_XDECREF(revOpMethod);

    }

    // Do not enter here if other object has implemented a reverse operator.
    if (pyResult == nullptr) {
        // Overloaded function decisor
        // 0: QRemoteObjectSourceLocationInfo::operator<<(QDataStream&)->QDataStream&
        if (isReverse
            && (pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDataStream_IDX]), (pyArg)))) {
            overloadId = 0; // operator<<(QDataStream&,QRemoteObjectSourceLocationInfo)
        }

        if (isReverse && overloadId == -1) {
            Shiboken::Errors::setReverseOperatorNotImplemented();
            return {};
        }

        // Function signature not found.
        if (overloadId == -1)
            return Shiboken::returnWrongArguments(pyArg, "operator<<", errInfo, SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]);

        // Call function/method
        {
            if (!Shiboken::Object::isValid(pyArg))
                return {};
            ::QDataStream *cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // operator<<(QDataStream&,QRemoteObjectSourceLocationInfo) [reverse operator]
                QDataStream & cppResult = (*cppArg0) << (*cppSelf);
                pyResult = Shiboken::Conversions::referenceToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDataStream_IDX]), &cppResult);
            }
        }

    } // End of "if (!pyResult)"

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRemoteObjectSourceLocationInfoFunc___rshift__(PyObject *self, PyObject *pyArg)
{
    bool isReverse = SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]), pyArg)
                    && !SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]), self);
    if (isReverse)
        std::swap(self, pyArg);
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRemoteObjectSourceLocationInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    static PyObject *attrName = Shiboken::PyMagicName::rrshift();
    if (!isReverse
        && Shiboken::Object::checkType(pyArg)
        && !PyObject_TypeCheck(pyArg, self->ob_type)
        && PyObject_HasAttr(pyArg, attrName)) {
        PyObject *revOpMethod = PyObject_GetAttr(pyArg, attrName);
        if (revOpMethod && PyCallable_Check(revOpMethod)) {
            pyResult = PyObject_CallFunction(revOpMethod, "O", self);
            if (Shiboken::Errors::occurred() != nullptr && (PyErr_ExceptionMatches(PyExc_NotImplementedError) || PyErr_ExceptionMatches(PyExc_AttributeError))) {
                PyErr_Clear();
                Py_XDECREF(pyResult);
                pyResult = nullptr;
            }
        }
        Py_XDECREF(revOpMethod);

    }

    // Do not enter here if other object has implemented a reverse operator.
    if (pyResult == nullptr) {
        // Overloaded function decisor
        // 0: QRemoteObjectSourceLocationInfo::operator>>(QDataStream&)->QDataStream&
        if (isReverse
            && (pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDataStream_IDX]), (pyArg)))) {
            overloadId = 0; // operator>>(QDataStream&,QRemoteObjectSourceLocationInfo&)
        }

        if (isReverse && overloadId == -1) {
            Shiboken::Errors::setReverseOperatorNotImplemented();
            return {};
        }

        // Function signature not found.
        if (overloadId == -1)
            return Shiboken::returnWrongArguments(pyArg, "operator>>", errInfo, SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]);

        // Call function/method
        {
            if (!Shiboken::Object::isValid(pyArg))
                return {};
            ::QDataStream *cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // operator>>(QDataStream&,QRemoteObjectSourceLocationInfo&) [reverse operator]
                QDataStream & cppResult = (*cppArg0) >> (*cppSelf);
                pyResult = Shiboken::Conversions::referenceToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDataStream_IDX]), &cppResult);
            }
        }

    } // End of "if (!pyResult)"

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

// Rich comparison
static PyObject * Sbk_QRemoteObjectSourceLocationInfo_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRemoteObjectSourceLocationInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]), (pyArg)))) {
                // operator!=(const QRemoteObjectSourceLocationInfo &other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QRemoteObjectSourceLocationInfo cppArg0_local;
                ::QRemoteObjectSourceLocationInfo *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]), (pyArg)))) {
                // operator==(const QRemoteObjectSourceLocationInfo &other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QRemoteObjectSourceLocationInfo cppArg0_local;
                ::QRemoteObjectSourceLocationInfo *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

static PyObject *Sbk_QRemoteObjectSourceLocationInfo_get_typeName(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRemoteObjectSourceLocationInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppSelf->typeName);
    return pyOut;
}
static int Sbk_QRemoteObjectSourceLocationInfo_set_typeName(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRemoteObjectSourceLocationInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("typeName");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("typeName", "QString");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->typeName;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QRemoteObjectSourceLocationInfo_get_hostUrl(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRemoteObjectSourceLocationInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->hostUrl)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->hostUrl))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->hostUrl)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), &(cppSelf->hostUrl), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QRemoteObjectSourceLocationInfo_set_hostUrl(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRemoteObjectSourceLocationInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("hostUrl");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("hostUrl", "QUrl");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->hostUrl;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for QRemoteObjectSourceLocationInfo
static PyGetSetDef Sbk_QRemoteObjectSourceLocationInfo_getsetlist[] = {
    {const_cast<char *>("typeName"), Sbk_QRemoteObjectSourceLocationInfo_get_typeName, Sbk_QRemoteObjectSourceLocationInfo_set_typeName, nullptr, nullptr},
    {const_cast<char *>("hostUrl"), Sbk_QRemoteObjectSourceLocationInfo_get_hostUrl, Sbk_QRemoteObjectSourceLocationInfo_set_hostUrl, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRemoteObjectSourceLocationInfo_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRemoteObjectSourceLocationInfo_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
extern "C"
{
static PyObject *Sbk_QRemoteObjectSourceLocationInfo__repr__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRemoteObjectSourceLocationInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    QBuffer buffer;
    buffer.open(QBuffer::ReadWrite);
    QDebug dbg(&buffer);
    dbg << *cppSelf;
    buffer.close();
    QByteArray str = buffer.data();
    const auto idx = str.indexOf('(');
    auto *typeName = Py_TYPE(self)->tp_name;
    if (idx >= 0)
        str.replace(0, idx, typeName);
    str = str.trimmed();
    Shiboken::AutoDecRef tpDict(PepType_GetDict(Py_TYPE(self)));
    PyObject *mod = PyDict_GetItem(tpDict.object(), Shiboken::PyMagicName::module());
    if (mod != nullptr && std::strchr(typeName, '.') == nullptr)
        return Shiboken::String::fromFormat("<%s.%s at %p>", Shiboken::String::toCString(mod), str.constData(), self);
    return Shiboken::String::fromFormat("<%s at %p>", str.constData(), self);
}
} // extern C

// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRemoteObjectSourceLocationInfo_Type = nullptr;
static PyTypeObject *Sbk_QRemoteObjectSourceLocationInfo_TypeF(void)
{
    return _Sbk_QRemoteObjectSourceLocationInfo_Type;
}

static PyType_Slot Sbk_QRemoteObjectSourceLocationInfo_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        reinterpret_cast<void *>(Sbk_QRemoteObjectSourceLocationInfo__repr__)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRemoteObjectSourceLocationInfo_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRemoteObjectSourceLocationInfo_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QRemoteObjectSourceLocationInfo_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRemoteObjectSourceLocationInfo_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QRemoteObjectSourceLocationInfo_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRemoteObjectSourceLocationInfo_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    // type supports number protocol
    {Py_nb_lshift,      reinterpret_cast<void *>(Sbk_QRemoteObjectSourceLocationInfoFunc___lshift__)},
    {Py_nb_rshift,      reinterpret_cast<void *>(Sbk_QRemoteObjectSourceLocationInfoFunc___rshift__)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRemoteObjectSourceLocationInfo_spec = {
    "2:PySide6.QtRemoteObjects.QRemoteObjectSourceLocationInfo",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRemoteObjectSourceLocationInfo_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRemoteObjectSourceLocationInfo_PythonToCpp_QRemoteObjectSourceLocationInfo_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRemoteObjectSourceLocationInfo_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRemoteObjectSourceLocationInfo_PythonToCpp_QRemoteObjectSourceLocationInfo_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRemoteObjectSourceLocationInfo_TypeF()))
        return QRemoteObjectSourceLocationInfo_PythonToCpp_QRemoteObjectSourceLocationInfo_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRemoteObjectSourceLocationInfo_PTR_CppToPython_QRemoteObjectSourceLocationInfo(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QRemoteObjectSourceLocationInfo_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QRemoteObjectSourceLocationInfo_COPY_CppToPython_QRemoteObjectSourceLocationInfo(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRemoteObjectSourceLocationInfo *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRemoteObjectSourceLocationInfo_TypeF(), new ::QRemoteObjectSourceLocationInfo(*source), true, true);
}

// Python to C++ copy conversion.
static void QRemoteObjectSourceLocationInfo_PythonToCpp_QRemoteObjectSourceLocationInfo_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRemoteObjectSourceLocationInfo *>(cppOut) = *reinterpret_cast< ::QRemoteObjectSourceLocationInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRemoteObjectSourceLocationInfo_PythonToCpp_QRemoteObjectSourceLocationInfo_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRemoteObjectSourceLocationInfo_TypeF()))
        return QRemoteObjectSourceLocationInfo_PythonToCpp_QRemoteObjectSourceLocationInfo_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QRemoteObjectSourceLocationInfo_SignatureStrings[] = {
    "2:PySide6.QtRemoteObjects.QRemoteObjectSourceLocationInfo(self)",
    "1:PySide6.QtRemoteObjects.QRemoteObjectSourceLocationInfo(self,QRemoteObjectSourceLocationInfo:PySide6.QtRemoteObjects.QRemoteObjectSourceLocationInfo)",
    "0:PySide6.QtRemoteObjects.QRemoteObjectSourceLocationInfo(self,typeName_:QString,hostUrl_:typing.Union[PySide6.QtCore.QUrl, QString])",
    "PySide6.QtRemoteObjects.QRemoteObjectSourceLocationInfo.__copy__(self)->typing.Self",
    "PySide6.QtRemoteObjects.QRemoteObjectSourceLocationInfo.__lshift__(self,stream:PySide6.QtCore.QDataStream)->PySide6.QtCore.QDataStream",
    "PySide6.QtRemoteObjects.QRemoteObjectSourceLocationInfo.__rshift__(self,stream:PySide6.QtCore.QDataStream)->PySide6.QtCore.QDataStream",
    "PySide6.QtRemoteObjects.QRemoteObjectSourceLocationInfo.__ne__(self,other:PySide6.QtRemoteObjects.QRemoteObjectSourceLocationInfo)->bool",
    "PySide6.QtRemoteObjects.QRemoteObjectSourceLocationInfo.__eq__(self,other:PySide6.QtRemoteObjects.QRemoteObjectSourceLocationInfo)->bool",
    nullptr}; // Sentinel
#else
static constexpr size_t QRemoteObjectSourceLocationInfo_SignatureByteSize = 208;
static constexpr uint8_t QRemoteObjectSourceLocationInfo_SignatureBytes[208] = {
    0x78, 0xda, 0xcd, 0x92, 0x31, 0x0b, 0xc2, 0x30, 0x10, 0x85, 0xf7, 0xfe, 0x0a, 0x47, 0x0b, 0x35,
    0xa8, 0x83, 0x43, 0x87, 0x2e, 0xba, 0x08, 0xa2, 0xd6, 0xd0, 0x49, 0x24, 0xc4, 0x7a, 0xb5, 0x95,
    0x36, 0x57, 0x93, 0x73, 0xe8, 0xbf, 0x37, 0x68, 0x45, 0x11, 0x44, 0x68, 0x1c, 0x1c, 0x8f, 0x77,
    0xef, 0xbd, 0xef, 0x42, 0xc6, 0xe1, 0xba, 0xe1, 0xc5, 0x01, 0x26, 0x2c, 0xa6, 0x0d, 0x54, 0x48,
    0xb0, 0xda, 0x9f, 0x20, 0x25, 0xc3, 0xe2, 0xd7, 0x91, 0xe3, 0x45, 0xa7, 0xb0, 0xc0, 0x54, 0x52,
    0x81, 0x6a, 0xae, 0x32, 0xec, 0x1b, 0x28, 0x33, 0xdf, 0x1b, 0x39, 0xf9, 0x83, 0x2f, 0x4b, 0x5d,
    0xc3, 0x7d, 0x6f, 0xe8, 0xc6, 0x45, 0x4d, 0x0d, 0x4b, 0x59, 0x81, 0x08, 0x63, 0x4e, 0xba, 0x50,
    0xc7, 0x20, 0x47, 0x43, 0x89, 0x2e, 0x45, 0x68, 0x25, 0x3b, 0xb3, 0x44, 0x59, 0xc3, 0xf6, 0x59,
    0x32, 0x45, 0x0d, 0x2c, 0xb6, 0x1b, 0x41, 0xaf, 0xb5, 0xec, 0x7c, 0xaf, 0x23, 0x03, 0x13, 0x22,
    0xc5, 0xba, 0x11, 0xe2, 0xfe, 0xc8, 0x83, 0xa8, 0xed, 0xe4, 0x76, 0x72, 0xc8, 0x2c, 0x4d, 0x5e,
    0x64, 0xd4, 0xa6, 0x06, 0x86, 0x34, 0xc8, 0x2a, 0x7c, 0xbf, 0x60, 0x26, 0x49, 0xf2, 0x9b, 0x64,
    0x7b, 0x3f, 0x8b, 0x0e, 0x18, 0xfa, 0x3f, 0x30, 0x14, 0x3c, 0x10, 0x90, 0x72, 0xd0, 0x9d, 0xbf,
    0xda, 0x20, 0xda, 0x23, 0x96, 0x0e, 0x20, 0x70, 0xfe, 0x29, 0xc8, 0x15, 0xf2, 0xa7, 0x6b, 0xb0
};
#endif

PyTypeObject *init_QRemoteObjectSourceLocationInfo(PyObject *module)
{
    if (SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX].type != nullptr)
        return SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX].type;

    Shiboken::AutoDecRef Sbk_QRemoteObjectSourceLocationInfo_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QRemoteObjectSourceLocationInfo_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRemoteObjectSourceLocationInfo",
        "QRemoteObjectSourceLocationInfo",
        &Sbk_QRemoteObjectSourceLocationInfo_spec,
        &Shiboken::callCppDestructor< ::QRemoteObjectSourceLocationInfo >,
        Sbk_QRemoteObjectSourceLocationInfo_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRemoteObjectSourceLocationInfo_TypeF(); // references _Sbk_QRemoteObjectSourceLocationInfo_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QRemoteObjectSourceLocationInfo_SignatureStrings);
#else
    InitSignatureBytes(pyType, QRemoteObjectSourceLocationInfo_SignatureBytes, QRemoteObjectSourceLocationInfo_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRemoteObjectSourceLocationInfo_PropertyStrings);
    SbkPySide6_QtRemoteObjectsTypeStructs[SBK_QRemoteObjectSourceLocationInfo_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRemoteObjectSourceLocationInfo_PythonToCpp_QRemoteObjectSourceLocationInfo_PTR,
        is_QRemoteObjectSourceLocationInfo_PythonToCpp_QRemoteObjectSourceLocationInfo_PTR_Convertible,
        QRemoteObjectSourceLocationInfo_PTR_CppToPython_QRemoteObjectSourceLocationInfo,
        QRemoteObjectSourceLocationInfo_COPY_CppToPython_QRemoteObjectSourceLocationInfo);

    Shiboken::Conversions::registerConverterName(converter, "QRemoteObjectSourceLocationInfo");
    Shiboken::Conversions::registerConverterName(converter, "QRemoteObjectSourceLocationInfo*");
    Shiboken::Conversions::registerConverterName(converter, "QRemoteObjectSourceLocationInfo&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRemoteObjectSourceLocationInfo).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRemoteObjectSourceLocationInfo_PythonToCpp_QRemoteObjectSourceLocationInfo_COPY,
        is_QRemoteObjectSourceLocationInfo_PythonToCpp_QRemoteObjectSourceLocationInfo_COPY_Convertible);

    qRegisterMetaType< ::QRemoteObjectSourceLocationInfo >("QRemoteObjectSourceLocationInfo");

    return pyType;
}
