// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QtROClientIoDeviceWrapper_H
#define SBK_QtROClientIoDeviceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtRemoteObjects/qconnectionfactories.h>

namespace PySide { class DynamicQMetaObject; }

class QtROClientIoDeviceWrapper : public QtROClientIoDevice
{
public:
    QtROClientIoDeviceWrapper(const QtROClientIoDeviceWrapper &) = delete;
    QtROClientIoDeviceWrapper& operator=(const QtROClientIoDeviceWrapper &) = delete;
    QtROClientIoDeviceWrapper(QtROClientIoDeviceWrapper &&) = delete;
    QtROClientIoDeviceWrapper& operator=(QtROClientIoDeviceWrapper &&) = delete;

    QtROClientIoDeviceWrapper(::QObject * parent = nullptr);
    qint64 bytesAvailable() const override;
    void childEvent(::QChildEvent * event) override;
    void close() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void connectToServer() override;
    ::QIODevice * connection() const override;
    void customEvent(::QEvent * event) override;
    ::QString deviceType() const override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    void doClose() override;
    void doDisconnectFromServer() override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool isOpen() const override;
    void timerEvent(::QTimerEvent * event) override;
    void write(const ::QByteArray & data) override;
    void write(const ::QByteArray & data, qint64 arg__2) override;
    ~QtROClientIoDeviceWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[17] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QtROClientIoDeviceWrapper_H

