// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_LoaderWrapper_H
#define SBK_LoaderWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtScxml/qscxmlcompiler.h>

class LoaderWrapper : public QScxmlCompiler::Loader
{
public:
    LoaderWrapper(const LoaderWrapper &) = delete;
    LoaderWrapper& operator=(const LoaderWrapper &) = delete;
    LoaderWrapper(LoaderWrapper &&) = delete;
    LoaderWrapper& operator=(LoaderWrapper &&) = delete;

    LoaderWrapper();
    ::QByteArray load(const ::QString & name, const ::QString & baseDir, ::QStringList * errors) override;
    ~LoaderWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_LoaderWrapper_H

