// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QScxmlDataModelWrapper_H
#define SBK_QScxmlDataModelWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtScxml/qscxmldatamodel.h>

namespace PySide { class DynamicQMetaObject; }

class QScxmlDataModelWrapper : public QScxmlDataModel
{
public:
    QScxmlDataModelWrapper(const QScxmlDataModelWrapper &) = delete;
    QScxmlDataModelWrapper& operator=(const QScxmlDataModelWrapper &) = delete;
    QScxmlDataModelWrapper(QScxmlDataModelWrapper &&) = delete;
    QScxmlDataModelWrapper& operator=(QScxmlDataModelWrapper &&) = delete;

    QScxmlDataModelWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    void evaluateAssignment(int id, bool * ok) override;
    void evaluateForeach(int id, bool * ok, ::QScxmlDataModel::ForeachLoopBody * body) override;
    void evaluateInitialization(int id, bool * ok) override;
    bool evaluateToBool(int id, bool * ok) override;
    ::QString evaluateToString(int id, bool * ok) override;
    ::QVariant evaluateToVariant(int id, bool * ok) override;
    void evaluateToVoid(int id, bool * ok) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool hasScxmlProperty(const ::QString & name) const override;
    ::QVariant scxmlProperty(const ::QString & name) const override;
    void setScxmlEvent(const ::QScxmlEvent & event) override;
    bool setScxmlProperty(const ::QString & name, const ::QVariant & value, const ::QString & context) override;
    bool setup(const ::QMap<QString,QVariant> & initialDataValues) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QScxmlDataModelWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[19] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QScxmlDataModelWrapper_H

