// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtscxml_python.h"

// main header
#include "qscxmlexecutablecontent_parameterinfo_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>

using namespace QScxmlExecutableContent;


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QScxmlExecutableContent_ParameterInfo_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QScxmlExecutableContent::ParameterInfo >()))
        return -1;

    ::QScxmlExecutableContent::ParameterInfo *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "ParameterInfo", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: ParameterInfo::ParameterInfo()
    // 1: ParameterInfo::ParameterInfo(QScxmlExecutableContent::ParameterInfo)
    if (numArgs == 0) {
        overloadId = 0; // ParameterInfo()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ParameterInfo_IDX]), (pyArgs[0])))) {
        overloadId = 1; // ParameterInfo(QScxmlExecutableContent::ParameterInfo)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ParameterInfo_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ParameterInfo_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // ParameterInfo()
        {

            // ParameterInfo()
            cptr = new ::QScxmlExecutableContent::ParameterInfo();
            break;
        }
        case 1: // ParameterInfo(const QScxmlExecutableContent::ParameterInfo &ParameterInfo)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QScxmlExecutableContent::ParameterInfo cppArg0_local;
            ::QScxmlExecutableContent::ParameterInfo *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // ParameterInfo(QScxmlExecutableContent::ParameterInfo)
                cptr = new ::QScxmlExecutableContent::ParameterInfo(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QScxmlExecutableContent::ParameterInfo >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ParameterInfo_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QScxmlExecutableContent_ParameterInfo__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QScxmlExecutableContent::ParameterInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ParameterInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ParameterInfo_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QScxmlExecutableContent_ParameterInfo_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QScxmlExecutableContent_ParameterInfo_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QScxmlExecutableContent_ParameterInfo__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QScxmlExecutableContent_ParameterInfo_get_name(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::ParameterInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ParameterInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->name;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_ParameterInfo_set_name(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::ParameterInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ParameterInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("name");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("name", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->name;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->name = cppOut_local;

    return 0;
}

static PyObject *Sbk_QScxmlExecutableContent_ParameterInfo_get_expr(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::ParameterInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ParameterInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->expr;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_ParameterInfo_set_expr(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::ParameterInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ParameterInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("expr");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("expr", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->expr;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->expr = cppOut_local;

    return 0;
}

static PyObject *Sbk_QScxmlExecutableContent_ParameterInfo_get_location(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::ParameterInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ParameterInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->location;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_ParameterInfo_set_location(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::ParameterInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ParameterInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("location");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("location", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->location;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->location = cppOut_local;

    return 0;
}

// Getters and Setters for ParameterInfo
static PyGetSetDef Sbk_QScxmlExecutableContent_ParameterInfo_getsetlist[] = {
    {const_cast<char *>("name"), Sbk_QScxmlExecutableContent_ParameterInfo_get_name, Sbk_QScxmlExecutableContent_ParameterInfo_set_name, nullptr, nullptr},
    {const_cast<char *>("expr"), Sbk_QScxmlExecutableContent_ParameterInfo_get_expr, Sbk_QScxmlExecutableContent_ParameterInfo_set_expr, nullptr, nullptr},
    {const_cast<char *>("location"), Sbk_QScxmlExecutableContent_ParameterInfo_get_location, Sbk_QScxmlExecutableContent_ParameterInfo_set_location, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QScxmlExecutableContent_ParameterInfo_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QScxmlExecutableContent_ParameterInfo_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QScxmlExecutableContent_ParameterInfo_Type = nullptr;
static PyTypeObject *Sbk_QScxmlExecutableContent_ParameterInfo_TypeF(void)
{
    return _Sbk_QScxmlExecutableContent_ParameterInfo_Type;
}

static PyType_Slot Sbk_QScxmlExecutableContent_ParameterInfo_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_ParameterInfo_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_ParameterInfo_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_ParameterInfo_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_ParameterInfo_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_ParameterInfo_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QScxmlExecutableContent_ParameterInfo_spec = {
    "2:PySide6.QtScxml.QScxmlExecutableContent.ParameterInfo",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QScxmlExecutableContent_ParameterInfo_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void ParameterInfo_PythonToCpp_ParameterInfo_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QScxmlExecutableContent_ParameterInfo_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_ParameterInfo_PythonToCpp_ParameterInfo_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QScxmlExecutableContent_ParameterInfo_TypeF()))
        return ParameterInfo_PythonToCpp_ParameterInfo_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *ParameterInfo_PTR_CppToPython_ParameterInfo(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QScxmlExecutableContent_ParameterInfo_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *ParameterInfo_COPY_CppToPython_ParameterInfo(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QScxmlExecutableContent::ParameterInfo *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QScxmlExecutableContent_ParameterInfo_TypeF(), new ::QScxmlExecutableContent::ParameterInfo(*source), true, true);
}

// Python to C++ copy conversion.
static void ParameterInfo_PythonToCpp_ParameterInfo_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QScxmlExecutableContent::ParameterInfo *>(cppOut) = *reinterpret_cast< ::QScxmlExecutableContent::ParameterInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ParameterInfo_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_ParameterInfo_PythonToCpp_ParameterInfo_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QScxmlExecutableContent_ParameterInfo_TypeF()))
        return ParameterInfo_PythonToCpp_ParameterInfo_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QScxmlExecutableContent_ParameterInfo_SignatureStrings[] = {
    "1:PySide6.QtScxml.QScxmlExecutableContent.ParameterInfo(self)",
    "0:PySide6.QtScxml.QScxmlExecutableContent.ParameterInfo(self,ParameterInfo:PySide6.QtScxml.QScxmlExecutableContent.ParameterInfo)",
    "PySide6.QtScxml.QScxmlExecutableContent.ParameterInfo.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QScxmlExecutableContent_ParameterInfo_SignatureByteSize = 104;
static constexpr uint8_t QScxmlExecutableContent_ParameterInfo_SignatureBytes[104] = {
    0x78, 0xda, 0x33, 0xb4, 0x0a, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x09, 0x4e,
    0xae, 0xc8, 0xcd, 0xd1, 0x0b, 0x04, 0x53, 0xae, 0x15, 0xa9, 0xc9, 0xa5, 0x25, 0x89, 0x49, 0x39,
    0xa9, 0xce, 0xf9, 0x79, 0x25, 0xa9, 0x79, 0x25, 0x7a, 0x01, 0x89, 0x45, 0x89, 0xb9, 0xa9, 0x25,
    0xa9, 0x45, 0x9e, 0x79, 0x69, 0xf9, 0x1a, 0xc5, 0xa9, 0x39, 0x69, 0x9a, 0x5c, 0x06, 0x14, 0xe8,
    0xd6, 0x41, 0x11, 0x22, 0xcf, 0x20, 0x4d, 0x2e, 0xb2, 0xb4, 0xe9, 0xc5, 0xc7, 0x27, 0xe7, 0x17,
    0x54, 0xc6, 0xc7, 0x43, 0xbc, 0xa1, 0x6b, 0x57, 0x52, 0x59, 0x90, 0x99, 0x97, 0xae, 0x17, 0x0c,
    0xe4, 0x71, 0x01, 0x00, 0x6d, 0xce, 0x65, 0x8b
};
#endif

PyTypeObject *init_QScxmlExecutableContent_ParameterInfo(PyObject *enclosingClass)
{
    if (SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ParameterInfo_IDX].type != nullptr)
        return SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ParameterInfo_IDX].type;

    Shiboken::AutoDecRef Sbk_QScxmlExecutableContent_ParameterInfo_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QScxmlExecutableContent_ParameterInfo_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "ParameterInfo",
        "QScxmlExecutableContent::ParameterInfo",
        &Sbk_QScxmlExecutableContent_ParameterInfo_spec,
        &Shiboken::callCppDestructor< ::QScxmlExecutableContent::ParameterInfo >,
        Sbk_QScxmlExecutableContent_ParameterInfo_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QScxmlExecutableContent_ParameterInfo_TypeF(); // references _Sbk_QScxmlExecutableContent_ParameterInfo_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QScxmlExecutableContent_ParameterInfo_SignatureStrings);
#else
    InitSignatureBytes(pyType, QScxmlExecutableContent_ParameterInfo_SignatureBytes, QScxmlExecutableContent_ParameterInfo_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QScxmlExecutableContent_ParameterInfo_PropertyStrings);
    SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ParameterInfo_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        ParameterInfo_PythonToCpp_ParameterInfo_PTR,
        is_ParameterInfo_PythonToCpp_ParameterInfo_PTR_Convertible,
        ParameterInfo_PTR_CppToPython_ParameterInfo,
        ParameterInfo_COPY_CppToPython_ParameterInfo);

    Shiboken::Conversions::registerConverterName(converter, "QScxmlExecutableContent::ParameterInfo");
    Shiboken::Conversions::registerConverterName(converter, "QScxmlExecutableContent::ParameterInfo*");
    Shiboken::Conversions::registerConverterName(converter, "QScxmlExecutableContent::ParameterInfo&");
    Shiboken::Conversions::registerConverterAlias(converter, "ParameterInfo");
    Shiboken::Conversions::registerConverterAlias(converter, "ParameterInfo*");
    Shiboken::Conversions::registerConverterAlias(converter, "ParameterInfo&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QScxmlExecutableContent::ParameterInfo).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        ParameterInfo_PythonToCpp_ParameterInfo_COPY,
        is_ParameterInfo_PythonToCpp_ParameterInfo_COPY_Convertible);

    qRegisterMetaType< ::QScxmlExecutableContent::ParameterInfo >("ParameterInfo");
    qRegisterMetaType< ::QScxmlExecutableContent::ParameterInfo >("QScxmlExecutableContent::ParameterInfo");

    return pyType;
}
