// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QScxmlTableDataWrapper_H
#define SBK_QScxmlTableDataWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtScxml/qscxmltabledata.h>

class QScxmlTableDataWrapper : public QScxmlTableData
{
public:
    QScxmlTableDataWrapper(const QScxmlTableDataWrapper &) = delete;
    QScxmlTableDataWrapper& operator=(const QScxmlTableDataWrapper &) = delete;
    QScxmlTableDataWrapper(QScxmlTableDataWrapper &&) = delete;
    QScxmlTableDataWrapper& operator=(QScxmlTableDataWrapper &&) = delete;

    QScxmlTableDataWrapper();
    ::QScxmlExecutableContent::AssignmentInfo assignmentInfo(int assignmentId) const override;
    int * dataNames(int * count) const override;
    ::QScxmlExecutableContent::EvaluatorInfo evaluatorInfo(int evaluatorId) const override;
    ::QScxmlExecutableContent::ForeachInfo foreachInfo(int foreachId) const override;
    int initialSetup() const override;
    int * instructions() const override;
    ::QString name() const override;
    ::QScxmlInvokableServiceFactory * serviceFactory(int id) const override;
    const qint32 * stateMachineTable() const override;
    ::QString string(int id) const override;
    ~QScxmlTableDataWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[10] = {false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QScxmlTableDataWrapper_H

