// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAccelerometerFilterWrapper_H
#define SBK_QAccelerometerFilterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qaccelerometer.h>

class QAccelerometerFilterWrapper : public QAccelerometerFilter
{
public:
    QAccelerometerFilterWrapper(const QAccelerometerFilterWrapper &) = delete;
    QAccelerometerFilterWrapper& operator=(const QAccelerometerFilterWrapper &) = delete;
    QAccelerometerFilterWrapper(QAccelerometerFilterWrapper &&) = delete;
    QAccelerometerFilterWrapper& operator=(QAccelerometerFilterWrapper &&) = delete;

    bool filter(::QAccelerometerReading * reading) override;
    void setSensor(::QSensor * sensor) override;
    ~QAccelerometerFilterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QAccelerometerFilterWrapper_H

