// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAmbientLightFilterWrapper_H
#define SBK_QAmbientLightFilterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qambientlightsensor.h>

class QAmbientLightFilterWrapper : public QAmbientLightFilter
{
public:
    QAmbientLightFilterWrapper(const QAmbientLightFilterWrapper &) = delete;
    QAmbientLightFilterWrapper& operator=(const QAmbientLightFilterWrapper &) = delete;
    QAmbientLightFilterWrapper(QAmbientLightFilterWrapper &&) = delete;
    QAmbientLightFilterWrapper& operator=(QAmbientLightFilterWrapper &&) = delete;

    bool filter(::QAmbientLightReading * reading) override;
    void setSensor(::QSensor * sensor) override;
    ~QAmbientLightFilterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QAmbientLightFilterWrapper_H

