// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QHumidityFilterWrapper_H
#define SBK_QHumidityFilterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qhumiditysensor.h>

class QHumidityFilterWrapper : public QHumidityFilter
{
public:
    QHumidityFilterWrapper(const QHumidityFilterWrapper &) = delete;
    QHumidityFilterWrapper& operator=(const QHumidityFilterWrapper &) = delete;
    QHumidityFilterWrapper(QHumidityFilterWrapper &&) = delete;
    QHumidityFilterWrapper& operator=(QHumidityFilterWrapper &&) = delete;

    bool filter(::QHumidityReading * reading) override;
    void setSensor(::QSensor * sensor) override;
    ~QHumidityFilterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QHumidityFilterWrapper_H

