// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QHumidityReadingWrapper_H
#define SBK_QHumidityReadingWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qhumiditysensor.h>

namespace PySide { class DynamicQMetaObject; }

class QHumidityReadingWrapper : public QHumidityReading
{
public:
    QHumidityReadingWrapper(const QHumidityReadingWrapper &) = delete;
    QHumidityReadingWrapper& operator=(const QHumidityReadingWrapper &) = delete;
    QHumidityReadingWrapper(QHumidityReadingWrapper &&) = delete;
    QHumidityReadingWrapper& operator=(QHumidityReadingWrapper &&) = delete;

    QHumidityReadingWrapper(::QObject * parent);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void copyValuesFrom(::QSensorReading * other) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QHumidityReadingWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_QHumidityReadingWrapper_H

