// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QLidFilterWrapper_H
#define SBK_QLidFilterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qlidsensor.h>

class QLidFilterWrapper : public QLidFilter
{
public:
    QLidFilterWrapper(const QLidFilterWrapper &) = delete;
    QLidFilterWrapper& operator=(const QLidFilterWrapper &) = delete;
    QLidFilterWrapper(QLidFilterWrapper &&) = delete;
    QLidFilterWrapper& operator=(QLidFilterWrapper &&) = delete;

    bool filter(::QLidReading * reading) override;
    void setSensor(::QSensor * sensor) override;
    ~QLidFilterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QLidFilterWrapper_H

