// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QMagnetometerFilterWrapper_H
#define SBK_QMagnetometerFilterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qmagnetometer.h>

class QMagnetometerFilterWrapper : public QMagnetometerFilter
{
public:
    QMagnetometerFilterWrapper(const QMagnetometerFilterWrapper &) = delete;
    QMagnetometerFilterWrapper& operator=(const QMagnetometerFilterWrapper &) = delete;
    QMagnetometerFilterWrapper(QMagnetometerFilterWrapper &&) = delete;
    QMagnetometerFilterWrapper& operator=(QMagnetometerFilterWrapper &&) = delete;

    bool filter(::QMagnetometerReading * reading) override;
    void setSensor(::QSensor * sensor) override;
    ~QMagnetometerFilterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QMagnetometerFilterWrapper_H

