// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QMagnetometerReadingWrapper_H
#define SBK_QMagnetometerReadingWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qmagnetometer.h>

namespace PySide { class DynamicQMetaObject; }

class QMagnetometerReadingWrapper : public QMagnetometerReading
{
public:
    QMagnetometerReadingWrapper(const QMagnetometerReadingWrapper &) = delete;
    QMagnetometerReadingWrapper& operator=(const QMagnetometerReadingWrapper &) = delete;
    QMagnetometerReadingWrapper(QMagnetometerReadingWrapper &&) = delete;
    QMagnetometerReadingWrapper& operator=(QMagnetometerReadingWrapper &&) = delete;

    QMagnetometerReadingWrapper(::QObject * parent);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void copyValuesFrom(::QSensorReading * other) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QMagnetometerReadingWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_QMagnetometerReadingWrapper_H

