// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QProximitySensorWrapper_H
#define SBK_QProximitySensorWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qproximitysensor.h>

namespace PySide { class DynamicQMetaObject; }

class QProximitySensorWrapper : public QProximitySensor
{
public:
    QProximitySensorWrapper(const QProximitySensorWrapper &) = delete;
    QProximitySensorWrapper& operator=(const QProximitySensorWrapper &) = delete;
    QProximitySensorWrapper(QProximitySensorWrapper &&) = delete;
    QProximitySensorWrapper& operator=(QProximitySensorWrapper &&) = delete;

    QProximitySensorWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QProximitySensorWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QProximitySensorWrapper_H

