// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRotationFilterWrapper_H
#define SBK_QRotationFilterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qrotationsensor.h>

class QRotationFilterWrapper : public QRotationFilter
{
public:
    QRotationFilterWrapper(const QRotationFilterWrapper &) = delete;
    QRotationFilterWrapper& operator=(const QRotationFilterWrapper &) = delete;
    QRotationFilterWrapper(QRotationFilterWrapper &&) = delete;
    QRotationFilterWrapper& operator=(QRotationFilterWrapper &&) = delete;

    bool filter(::QRotationReading * reading) override;
    void setSensor(::QSensor * sensor) override;
    ~QRotationFilterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QRotationFilterWrapper_H

