// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSensorBackendFactoryWrapper_H
#define SBK_QSensorBackendFactoryWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qsensormanager.h>

class QSensorBackendFactoryWrapper : public QSensorBackendFactory
{
public:
    QSensorBackendFactoryWrapper(const QSensorBackendFactoryWrapper &) = delete;
    QSensorBackendFactoryWrapper& operator=(const QSensorBackendFactoryWrapper &) = delete;
    QSensorBackendFactoryWrapper(QSensorBackendFactoryWrapper &&) = delete;
    QSensorBackendFactoryWrapper& operator=(QSensorBackendFactoryWrapper &&) = delete;

    QSensorBackendFactoryWrapper();
    ::QSensorBackend * createBackend(::QSensor * sensor) override;
    ~QSensorBackendFactoryWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QSensorBackendFactoryWrapper_H

