// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSensorFilterWrapper_H
#define SBK_QSensorFilterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qsensor.h>

class QSensorFilterWrapper : public QSensorFilter
{
public:
    QSensorFilterWrapper(const QSensorFilterWrapper &) = delete;
    QSensorFilterWrapper& operator=(const QSensorFilterWrapper &) = delete;
    QSensorFilterWrapper(QSensorFilterWrapper &&) = delete;
    QSensorFilterWrapper& operator=(QSensorFilterWrapper &&) = delete;

    QSensorFilterWrapper();
    bool filter(::QSensorReading * reading) override;
    void setSensor(::QSensor * sensor) override;
    ~QSensorFilterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QSensorFilterWrapper_H

