// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTiltFilterWrapper_H
#define SBK_QTiltFilterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qtiltsensor.h>

class QTiltFilterWrapper : public QTiltFilter
{
public:
    QTiltFilterWrapper(const QTiltFilterWrapper &) = delete;
    QTiltFilterWrapper& operator=(const QTiltFilterWrapper &) = delete;
    QTiltFilterWrapper(QTiltFilterWrapper &&) = delete;
    QTiltFilterWrapper& operator=(QTiltFilterWrapper &&) = delete;

    bool filter(::QTiltReading * reading) override;
    void setSensor(::QSensor * sensor) override;
    ~QTiltFilterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QTiltFilterWrapper_H

