// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QCanBusFactoryWrapper_H
#define SBK_QCanBusFactoryWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSerialBus/qcanbusfactory.h>

class QCanBusFactoryWrapper : public QCanBusFactory
{
public:
    QCanBusFactoryWrapper(const QCanBusFactoryWrapper &) = delete;
    QCanBusFactoryWrapper& operator=(const QCanBusFactoryWrapper &) = delete;
    QCanBusFactoryWrapper(QCanBusFactoryWrapper &&) = delete;
    QCanBusFactoryWrapper& operator=(QCanBusFactoryWrapper &&) = delete;

    QCanBusFactoryWrapper();
    ::QList<QCanBusDeviceInfo> availableDevices(::QString * errorMessage) const override;
    ::QCanBusDevice * createDevice(const ::QString & interfaceName, ::QString * errorMessage) const override;
    ~QCanBusFactoryWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QCanBusFactoryWrapper_H

