// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtserialbus_python.h"

// main header
#include "qcanuniqueiddescription_wrapper.h"

// Argument includes
#include <QtSerialBus/qcancommondefinitions.h>
#include <QtSerialBus/qcanuniqueiddescription.h>
#include <qsysinfo.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QCanUniqueIdDescription_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QCanUniqueIdDescription >()))
        return -1;

    ::QCanUniqueIdDescription *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QCanUniqueIdDescription", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QCanUniqueIdDescription::QCanUniqueIdDescription()
    // 1: QCanUniqueIdDescription::QCanUniqueIdDescription(QCanUniqueIdDescription)
    if (numArgs == 0) {
        overloadId = 0; // QCanUniqueIdDescription()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QCanUniqueIdDescription(QCanUniqueIdDescription)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QCanUniqueIdDescription()
        {

            // QCanUniqueIdDescription()
            cptr = new ::QCanUniqueIdDescription();
            break;
        }
        case 1: // QCanUniqueIdDescription(const QCanUniqueIdDescription &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QCanUniqueIdDescription cppArg0_local;
            ::QCanUniqueIdDescription *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QCanUniqueIdDescription(QCanUniqueIdDescription)
                cptr = new ::QCanUniqueIdDescription(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QCanUniqueIdDescription >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_bitLength(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // bitLength()const
        quint8 cppResult = const_cast<const ::QCanUniqueIdDescription *>(cppSelf)->bitLength();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint8>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_endian(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // endian()const
        QSysInfo::Endian cppResult = const_cast<const ::QCanUniqueIdDescription *>(cppSelf)->endian();
        pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSysInfo_Endian_IDX])))->converter, &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // isValid()const
        bool cppResult = const_cast<const ::QCanUniqueIdDescription *>(cppSelf)->isValid();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_setBitLength(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanUniqueIdDescription::setBitLength(quint8)
    if (SbkChar_Check(pyArg) && (pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint8>(), (pyArg)))) {
        overloadId = 0; // setBitLength(quint8)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setBitLength", errInfo, SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]);

    // Call function/method
    {
        quint8 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setBitLength(quint8)
            cppSelf->setBitLength(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_setEndian(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanUniqueIdDescription::setEndian(QSysInfo::Endian)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSysInfo_Endian_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setEndian(QSysInfo::Endian)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setEndian", errInfo, SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]);

    // Call function/method
    {
        ::QSysInfo::Endian cppArg0{QSysInfo::BigEndian};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setEndian(QSysInfo::Endian)
            cppSelf->setEndian(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_setSource(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanUniqueIdDescription::setSource(QtCanBus::DataSource)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QtCanBus_DataSource_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setSource(QtCanBus::DataSource)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setSource", errInfo, SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]);

    // Call function/method
    {
        ::QtCanBus::DataSource cppArg0{QtCanBus::DataSource::Payload};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setSource(QtCanBus::DataSource)
            cppSelf->setSource(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_setStartBit(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanUniqueIdDescription::setStartBit(quint16)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), (pyArg)))) {
        overloadId = 0; // setStartBit(quint16)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setStartBit", errInfo, SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]);

    // Call function/method
    {
        quint16 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setStartBit(quint16)
            cppSelf->setStartBit(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_source(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // source()const
        QtCanBus::DataSource cppResult = const_cast<const ::QCanUniqueIdDescription *>(cppSelf)->source();
        pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QtCanBus_DataSource_IDX])))->converter, &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_startBit(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // startBit()const
        quint16 cppResult = const_cast<const ::QCanUniqueIdDescription *>(cppSelf)->startBit();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanUniqueIdDescription::swap(QCanUniqueIdDescription&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QCanUniqueIdDescription&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "swap", errInfo, SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QCanUniqueIdDescription cppArg0_local;
        ::QCanUniqueIdDescription *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QCanUniqueIdDescription&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanUniqueIdDescription__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QCanUniqueIdDescription_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QCanUniqueIdDescription_methods[] = {
    {"bitLength", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_bitLength), METH_NOARGS, nullptr},
    {"endian", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_endian), METH_NOARGS, nullptr},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_isValid), METH_NOARGS, nullptr},
    {"setBitLength", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_setBitLength), METH_O, nullptr},
    {"setEndian", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_setEndian), METH_O, nullptr},
    {"setSource", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_setSource), METH_O, nullptr},
    {"setStartBit", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_setStartBit), METH_O, nullptr},
    {"source", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_source), METH_NOARGS, nullptr},
    {"startBit", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_startBit), METH_NOARGS, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_swap), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescription__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QCanUniqueIdDescription_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QCanUniqueIdDescription_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QCanUniqueIdDescription_Type = nullptr;
static PyTypeObject *Sbk_QCanUniqueIdDescription_TypeF(void)
{
    return _Sbk_QCanUniqueIdDescription_Type;
}

static PyType_Slot Sbk_QCanUniqueIdDescription_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QCanUniqueIdDescription_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QCanUniqueIdDescription_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QCanUniqueIdDescription_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QCanUniqueIdDescription_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QCanUniqueIdDescription_spec = {
    "2:PySide6.QtSerialBus.QCanUniqueIdDescription",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QCanUniqueIdDescription_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QCanUniqueIdDescription_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QCanUniqueIdDescription_TypeF()))
        return QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QCanUniqueIdDescription_PTR_CppToPython_QCanUniqueIdDescription(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QCanUniqueIdDescription_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QCanUniqueIdDescription_COPY_CppToPython_QCanUniqueIdDescription(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QCanUniqueIdDescription *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QCanUniqueIdDescription_TypeF(), new ::QCanUniqueIdDescription(*source), true, true);
}

// Python to C++ copy conversion.
static void QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QCanUniqueIdDescription *>(cppOut) = *reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QCanUniqueIdDescription_TypeF()))
        return QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QCanUniqueIdDescription_SignatureStrings[] = {
    "1:PySide6.QtSerialBus.QCanUniqueIdDescription(self)",
    "0:PySide6.QtSerialBus.QCanUniqueIdDescription(self,other:PySide6.QtSerialBus.QCanUniqueIdDescription)",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.bitLength(self)->quint8",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.endian(self)->PySide6.QtCore.QSysInfo.Endian",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.isValid(self)->bool",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.setBitLength(self,length:quint8)",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.setEndian(self,endian:PySide6.QtCore.QSysInfo.Endian)",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.setSource(self,source:PySide6.QtSerialBus.QtCanBus.DataSource)",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.setStartBit(self,bit:quint16)",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.source(self)->PySide6.QtSerialBus.QtCanBus.DataSource",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.startBit(self)->quint16",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.swap(self,other:PySide6.QtSerialBus.QCanUniqueIdDescription)",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QCanUniqueIdDescription_SignatureByteSize = 245;
static constexpr uint8_t QCanUniqueIdDescription_SignatureBytes[245] = {
    0x78, 0xda, 0xbd, 0x53, 0x4b, 0x6b, 0xc3, 0x30, 0x0c, 0xbe, 0xe7, 0x97, 0x34, 0x90, 0x99, 0xe5,
    0x12, 0x46, 0x0e, 0x3d, 0xf4, 0x71, 0x28, 0xec, 0xb0, 0x60, 0xba, 0x6b, 0x70, 0x13, 0xb5, 0x15,
    0x18, 0x39, 0xb5, 0x15, 0x46, 0xfe, 0x7d, 0xd3, 0x98, 0x90, 0x15, 0x46, 0x41, 0x97, 0xdd, 0x64,
    0xd0, 0xf7, 0x92, 0xe4, 0xbc, 0xfc, 0x1a, 0x34, 0xb6, 0x50, 0xa8, 0x8a, 0x35, 0x78, 0x34, 0x76,
    0xd3, 0x07, 0x55, 0x6d, 0x0d, 0x1d, 0x09, 0x6f, 0x3d, 0x1c, 0xda, 0x1d, 0x84, 0xc6, 0x63, 0xc7,
    0xe8, 0x68, 0x15, 0xc0, 0x9e, 0xd3, 0xe4, 0x5d, 0x8c, 0xc9, 0x1c, 0x5f, 0xc1, 0x4b, 0x60, 0x69,
    0x22, 0x68, 0x56, 0x27, 0xe4, 0x4f, 0xa0, 0x0b, 0x5f, 0xa3, 0xc3, 0xb7, 0xf5, 0xad, 0x47, 0xe2,
    0x0f, 0x11, 0x07, 0x50, 0x8b, 0x86, 0x66, 0x82, 0x05, 0xb9, 0x75, 0x1e, 0x54, 0xa5, 0x87, 0x70,
    0xa0, 0xb3, 0x53, 0xfb, 0xa9, 0x4b, 0x44, 0x8c, 0xe1, 0xdb, 0x58, 0x6c, 0x67, 0xe6, 0x93, 0x73,
    0x56, 0x84, 0x0f, 0xc0, 0x9b, 0xa7, 0x7c, 0x99, 0x9d, 0xea, 0x32, 0x86, 0x4c, 0xa5, 0x64, 0xfb,
    0x25, 0x68, 0x16, 0x43, 0x97, 0xaf, 0xd3, 0x8a, 0x15, 0xb4, 0xeb, 0x7d, 0x03, 0x51, 0x21, 0x4c,
    0xf5, 0xdf, 0xab, 0xe7, 0x91, 0xe2, 0x51, 0xec, 0x0c, 0x9b, 0x88, 0x91, 0x4b, 0xb1, 0xf1, 0x8f,
    0xf1, 0x44, 0xb1, 0xf1, 0x0e, 0xe2, 0x54, 0xf2, 0x42, 0xc8, 0xb4, 0x38, 0x7e, 0x5a, 0xfe, 0x4b,
    0xb3, 0x32, 0x85, 0xdf, 0x46, 0xe7, 0x0b, 0xcd, 0x0b, 0x19, 0xc7, 0x8f, 0xe9, 0xfe, 0xe5, 0x3f,
    0xd5, 0x75, 0xe3, 0xba, 0xa1, 0xae, 0x67, 0xb3, 0x3c, 0x74, 0x48, 0x17, 0xa5, 0xc7, 0x57, 0x72,
    0x07, 0xcf, 0x1d, 0x88, 0xdc
};
#endif

PyTypeObject *init_QCanUniqueIdDescription(PyObject *module)
{
    if (SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX].type != nullptr)
        return SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX].type;

    Shiboken::AutoDecRef Sbk_QCanUniqueIdDescription_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QCanUniqueIdDescription_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QCanUniqueIdDescription",
        "QCanUniqueIdDescription",
        &Sbk_QCanUniqueIdDescription_spec,
        &Shiboken::callCppDestructor< ::QCanUniqueIdDescription >,
        Sbk_QCanUniqueIdDescription_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QCanUniqueIdDescription_TypeF(); // references _Sbk_QCanUniqueIdDescription_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QCanUniqueIdDescription_SignatureStrings);
#else
    InitSignatureBytes(pyType, QCanUniqueIdDescription_SignatureBytes, QCanUniqueIdDescription_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QCanUniqueIdDescription_PropertyStrings);
    SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_PTR,
        is_QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_PTR_Convertible,
        QCanUniqueIdDescription_PTR_CppToPython_QCanUniqueIdDescription,
        QCanUniqueIdDescription_COPY_CppToPython_QCanUniqueIdDescription);

    Shiboken::Conversions::registerConverterName(converter, "QCanUniqueIdDescription");
    Shiboken::Conversions::registerConverterName(converter, "QCanUniqueIdDescription*");
    Shiboken::Conversions::registerConverterName(converter, "QCanUniqueIdDescription&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QCanUniqueIdDescription).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_COPY,
        is_QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_COPY_Convertible);

    qRegisterMetaType< ::QCanUniqueIdDescription >("QCanUniqueIdDescription");

    return pyType;
}
