// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QModbusDeviceWrapper_H
#define SBK_QModbusDeviceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSerialBus/qmodbusdevice.h>

namespace PySide { class DynamicQMetaObject; }

class QModbusDeviceWrapper : public QModbusDevice
{
public:
    QModbusDeviceWrapper(const QModbusDeviceWrapper &) = delete;
    QModbusDeviceWrapper& operator=(const QModbusDeviceWrapper &) = delete;
    QModbusDeviceWrapper(QModbusDeviceWrapper &&) = delete;
    QModbusDeviceWrapper& operator=(QModbusDeviceWrapper &&) = delete;

    QModbusDeviceWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void close() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool open() override;
    void timerEvent(::QTimerEvent * event) override;
    ~QModbusDeviceWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9] = {false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QModbusDeviceWrapper_H

