// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QModbusPduWrapper_H
#define SBK_QModbusPduWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSerialBus/qmodbuspdu.h>

class QModbusPduWrapper : public QModbusPdu
{
public:
    QModbusPduWrapper(const QModbusPduWrapper &) = delete;
    QModbusPduWrapper& operator=(const QModbusPduWrapper &) = delete;
    QModbusPduWrapper(QModbusPduWrapper &&) = delete;
    QModbusPduWrapper& operator=(QModbusPduWrapper &&) = delete;

    QModbusPduWrapper();
    QModbusPduWrapper(::QModbusPdu::FunctionCode code, const ::QByteArray & newData);
    QModbusPduWrapper(const QModbusPdu& self) : QModbusPdu(self)
    {
    }

    void setFunctionCode(::QModbusPdu::FunctionCode code) override;
    ~QModbusPduWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QModbusPduWrapper_H

