// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QModbusRequestWrapper_H
#define SBK_QModbusRequestWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSerialBus/qmodbuspdu.h>

class QModbusRequestWrapper : public QModbusRequest
{
public:
    QModbusRequestWrapper(const QModbusRequestWrapper &) = delete;
    QModbusRequestWrapper& operator=(const QModbusRequestWrapper &) = delete;
    QModbusRequestWrapper(QModbusRequestWrapper &&) = delete;
    QModbusRequestWrapper& operator=(QModbusRequestWrapper &&) = delete;

    QModbusRequestWrapper();
    QModbusRequestWrapper(::QModbusPdu::FunctionCode code, const ::QByteArray & newData = QByteArray());
    QModbusRequestWrapper(const ::QModbusPdu & pdu);
    void setFunctionCode(::QModbusPdu::FunctionCode code) override;
    ~QModbusRequestWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QModbusRequestWrapper_H

