// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QModbusResponseWrapper_H
#define SBK_QModbusResponseWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSerialBus/qmodbuspdu.h>

class QModbusResponseWrapper : public QModbusResponse
{
public:
    QModbusResponseWrapper(const QModbusResponseWrapper &) = delete;
    QModbusResponseWrapper& operator=(const QModbusResponseWrapper &) = delete;
    QModbusResponseWrapper(QModbusResponseWrapper &&) = delete;
    QModbusResponseWrapper& operator=(QModbusResponseWrapper &&) = delete;

    QModbusResponseWrapper();
    QModbusResponseWrapper(::QModbusPdu::FunctionCode code, const ::QByteArray & newData = QByteArray());
    QModbusResponseWrapper(const ::QModbusPdu & pdu);
    void setFunctionCode(::QModbusPdu::FunctionCode code) override;
    ~QModbusResponseWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QModbusResponseWrapper_H

