// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QModbusTcpConnectionObserverWrapper_H
#define SBK_QModbusTcpConnectionObserverWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSerialBus/qmodbustcpserver.h>

class QModbusTcpConnectionObserverWrapper : public QModbusTcpConnectionObserver
{
public:
    QModbusTcpConnectionObserverWrapper(const QModbusTcpConnectionObserverWrapper &) = delete;
    QModbusTcpConnectionObserverWrapper& operator=(const QModbusTcpConnectionObserverWrapper &) = delete;
    QModbusTcpConnectionObserverWrapper(QModbusTcpConnectionObserverWrapper &&) = delete;
    QModbusTcpConnectionObserverWrapper& operator=(QModbusTcpConnectionObserverWrapper &&) = delete;

    QModbusTcpConnectionObserverWrapper();
    bool acceptNewConnection(::QTcpSocket * newClient) override;
    ~QModbusTcpConnectionObserverWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QModbusTcpConnectionObserverWrapper_H

