// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QModbusTcpServerWrapper_H
#define SBK_QModbusTcpServerWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSerialBus/qmodbustcpserver.h>

namespace PySide { class DynamicQMetaObject; }

class QModbusTcpServerWrapper : public QModbusTcpServer
{
public:
    QModbusTcpServerWrapper(const QModbusTcpServerWrapper &) = delete;
    QModbusTcpServerWrapper& operator=(const QModbusTcpServerWrapper &) = delete;
    QModbusTcpServerWrapper(QModbusTcpServerWrapper &&) = delete;
    QModbusTcpServerWrapper& operator=(QModbusTcpServerWrapper &&) = delete;

    QModbusTcpServerWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void close() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool open() override;
    ::QModbusResponse processPrivateRequest(const ::QModbusPdu & request) override;
    ::QModbusResponse processRequest(const ::QModbusPdu & request) override;
    bool processesBroadcast() const override;
    bool readData(::QModbusDataUnit * newData) const override;
    bool setMap(const ::QMap<QModbusDataUnit::RegisterType,QModbusDataUnit> & map) override;
    bool setValue(int option, const ::QVariant & value) override;
    void timerEvent(::QTimerEvent * event) override;
    ::QVariant value(int option) const override;
    bool writeData(const ::QModbusDataUnit & unit) override;
    ~QModbusTcpServerWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[17] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QModbusTcpServerWrapper_H

