// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtsql_python.h"

// main header
#include "qsql_wrapper.h"

// Extra includes
#include <QtSql/qtsqlglobal.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {

static const char *Sbk_QSql_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QSql_EnumFlagInfo[] = {
    "Location:Enum",
    "NumericalPrecisionPolicy:Enum",
    "ParamTypeFlag:Flag:ParamType",
    "TableType:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QSql_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QSql_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QSql_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QSql_Type = nullptr;
static PyTypeObject *Sbk_QSql_TypeF(void)
{
    return _Sbk_QSql_Type;
}

static PyType_Slot Sbk_QSql_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QSql_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QSql_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QSql_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QSql_spec = {
    "2:PySide6.QtSql.QSql",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QSql_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QSql_Location(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSql::Location>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSql::Location *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QSql_Location_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtSqlTypeStructs[SBK_QSql_Location_IDX])))
        return Enum_PythonToCpp_QSql_Location;
    return {};
}

static PyObject *QSql_Location_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QSql::Location>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QSql::Location *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtSqlTypeStructs[SBK_QSql_Location_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QSql_ParamTypeFlag(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSql::ParamTypeFlag>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSql::ParamTypeFlag *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QSql_ParamTypeFlag_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtSqlTypeStructs[SBK_QSql_ParamTypeFlag_IDX])))
        return Enum_PythonToCpp_QSql_ParamTypeFlag;
    return {};
}

static PyObject *QSql_ParamTypeFlag_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QSql::ParamTypeFlag>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QSql::ParamTypeFlag *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtSqlTypeStructs[SBK_QSql_ParamTypeFlag_IDX]), castCppIn);

}

static void Flag_PythonToCpp_QSql_ParamTypeFlag(PyObject *pyIn, void *cppOut)
{
    const auto value = QFlags<::QSql::ParamTypeFlag>::fromInt(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<QFlags<::QSql::ParamTypeFlag> *>(cppOut) = value;

}

static PyObject *QSql_ParamTypeFlag_CppToPython_Flag(const void *cppIn)
{
    const auto flags = *reinterpret_cast<const QFlags<::QSql::ParamTypeFlag> *>(cppIn);
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtSqlTypeStructs[SBK_QSql_ParamTypeFlag_IDX]), flags.toInt());

}

static void Enum_PythonToCpp_QSql_TableType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSql::TableType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSql::TableType *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QSql_TableType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtSqlTypeStructs[SBK_QSql_TableType_IDX])))
        return Enum_PythonToCpp_QSql_TableType;
    return {};
}

static PyObject *QSql_TableType_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QSql::TableType>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QSql::TableType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtSqlTypeStructs[SBK_QSql_TableType_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QSql_NumericalPrecisionPolicy(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSql::NumericalPrecisionPolicy>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSql::NumericalPrecisionPolicy *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QSql_NumericalPrecisionPolicy_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtSqlTypeStructs[SBK_QSql_NumericalPrecisionPolicy_IDX])))
        return Enum_PythonToCpp_QSql_NumericalPrecisionPolicy;
    return {};
}

static PyObject *QSql_NumericalPrecisionPolicy_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QSql::NumericalPrecisionPolicy>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QSql::NumericalPrecisionPolicy *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtSqlTypeStructs[SBK_QSql_NumericalPrecisionPolicy_IDX]), castCppIn);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QtSqlQSql_SignatureStrings[] = {
    nullptr}; // Sentinel
#else
static constexpr size_t QtSqlQSql_SignatureByteSize = 0;
static constexpr uint8_t QtSqlQSql_SignatureBytes[1] = {
    0x00
};
#endif

PyTypeObject *init_QtSqlQSql(PyObject *module)
{
    if (SbkPySide6_QtSqlTypeStructs[SBK_QtSqlQSql_IDX].type != nullptr)
        return SbkPySide6_QtSqlTypeStructs[SBK_QtSqlQSql_IDX].type;

    Shiboken::AutoDecRef Sbk_QSql_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QSql_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QSql",
        "QSql",
        &Sbk_QSql_spec,
        nullptr,
        Sbk_QSql_Type_bases.object(),
        0);
    auto *pyType = Sbk_QSql_TypeF(); // references _Sbk_QSql_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QtSqlQSql_SignatureStrings);
#else
    InitSignatureBytes(pyType, QtSqlQSql_SignatureBytes, QtSqlQSql_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QSql_PropertyStrings);
    SbkPySide6_QtSqlTypeStructs[SBK_QtSqlQSql_IDX].type = pyType;


    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QSql_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Location'.
    const char *Location_Initializer[] = {
        "BeforeFirstRow",
        "AfterLastRow",
        nullptr};
    // "int8_t" used instead of "int"
    constexpr int8_t Location_InitializerValues[] = {
        int8_t(QSql::Location::BeforeFirstRow), // -0x01 -1
        int8_t(QSql::Location::AfterLastRow)    // -0x02 -2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSql_TypeF(),
        "2:PySide6.QtSql.QSql.Location",
        Location_Initializer, Location_InitializerValues);
    SbkPySide6_QtSqlTypeStructs[SBK_QSql_Location_IDX].type = EType;
    // Register converter for enum 'QSql::Location'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSql_Location_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QSql_Location,
            is_Enum_PythonToCpp_QSql_Location_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QSql::Location");
        Shiboken::Conversions::registerConverterAlias(converter, "Location");
        Shiboken::Enum::setTypeConverter(EType, converter, nullptr);
    }
    // End of 'Location' enum.

    // Initialization of enum 'ParamTypeFlag'.
    const char *ParamTypeFlag_Initializer[] = {
        "In",
        "Out",
        "InOut",
        "Binary",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t ParamTypeFlag_InitializerValues[] = {
        uint8_t(QSql::ParamTypeFlag::In),    //  0x01  1
        uint8_t(QSql::ParamTypeFlag::Out),   //  0x02  2
        uint8_t(QSql::ParamTypeFlag::InOut), //  0x03  3
        uint8_t(QSql::ParamTypeFlag::Binary) //  0x04  4
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSql_TypeF(),
        "2:PySide6.QtSql.QSql.ParamTypeFlag",
        ParamTypeFlag_Initializer, ParamTypeFlag_InitializerValues);
    SbkPySide6_QtSqlTypeStructs[SBK_QSql_ParamTypeFlag_IDX].type = EType;
    // PYSIDE-1735: Mapping the flags class to the same enum class.
    SbkPySide6_QtSqlTypeStructs[SBK_QFlags_QSql_ParamTypeFlag_IDX].type =
        EType;
    // Register converter for enum 'QSql::ParamTypeFlag'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSql_ParamTypeFlag_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QSql_ParamTypeFlag,
            is_Enum_PythonToCpp_QSql_ParamTypeFlag_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QSql::ParamTypeFlag");
        Shiboken::Conversions::registerConverterAlias(converter, "ParamTypeFlag");
        SbkConverter *flagsConverter = Shiboken::Conversions::createConverter(EType,
            QSql_ParamTypeFlag_CppToPython_Flag);
        Shiboken::Conversions::addPythonToCppValueConversion(flagsConverter,
            Flag_PythonToCpp_QSql_ParamTypeFlag,
            is_Enum_PythonToCpp_QSql_ParamTypeFlag_Convertible);
        // Register converter for flag 'QFlags<QSql::ParamTypeFlag>'.
        Shiboken::Conversions::registerConverterName(flagsConverter, "QFlags<QSql::ParamTypeFlag>");
        Shiboken::Conversions::registerConverterName(flagsConverter, "QSql::ParamType");
        Shiboken::Enum::setTypeConverter(EType, converter, flagsConverter);
    }
    // End of 'ParamTypeFlag' enum/flags.

    // Initialization of enum 'TableType'.
    const char *TableType_Initializer[] = {
        "Tables",
        "SystemTables",
        "Views",
        "AllTables",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t TableType_InitializerValues[] = {
        uint8_t(QSql::TableType::Tables),       //  0x01  1
        uint8_t(QSql::TableType::SystemTables), //  0x02  2
        uint8_t(QSql::TableType::Views),        //  0x04  4
        uint8_t(QSql::TableType::AllTables)     //  0xff  255
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSql_TypeF(),
        "2:PySide6.QtSql.QSql.TableType",
        TableType_Initializer, TableType_InitializerValues);
    SbkPySide6_QtSqlTypeStructs[SBK_QSql_TableType_IDX].type = EType;
    // Register converter for enum 'QSql::TableType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSql_TableType_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QSql_TableType,
            is_Enum_PythonToCpp_QSql_TableType_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QSql::TableType");
        Shiboken::Conversions::registerConverterAlias(converter, "TableType");
        Shiboken::Enum::setTypeConverter(EType, converter, nullptr);
    }
    // End of 'TableType' enum.

    // Initialization of enum 'NumericalPrecisionPolicy'.
    const char *NumericalPrecisionPolicy_Initializer[] = {
        "LowPrecisionInt32",
        "LowPrecisionInt64",
        "LowPrecisionDouble",
        "HighPrecision",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t NumericalPrecisionPolicy_InitializerValues[] = {
        uint8_t(QSql::NumericalPrecisionPolicy::LowPrecisionInt32),  //  0x01  1
        uint8_t(QSql::NumericalPrecisionPolicy::LowPrecisionInt64),  //  0x02  2
        uint8_t(QSql::NumericalPrecisionPolicy::LowPrecisionDouble), //  0x04  4
        uint8_t(QSql::NumericalPrecisionPolicy::HighPrecision)       //  0x00  0
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSql_TypeF(),
        "2:PySide6.QtSql.QSql.NumericalPrecisionPolicy",
        NumericalPrecisionPolicy_Initializer, NumericalPrecisionPolicy_InitializerValues);
    SbkPySide6_QtSqlTypeStructs[SBK_QSql_NumericalPrecisionPolicy_IDX].type = EType;
    // Register converter for enum 'QSql::NumericalPrecisionPolicy'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSql_NumericalPrecisionPolicy_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QSql_NumericalPrecisionPolicy,
            is_Enum_PythonToCpp_QSql_NumericalPrecisionPolicy_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QSql::NumericalPrecisionPolicy");
        Shiboken::Conversions::registerConverterAlias(converter, "NumericalPrecisionPolicy");
        Shiboken::Enum::setTypeConverter(EType, converter, nullptr);
    }
    // End of 'NumericalPrecisionPolicy' enum.

    qRegisterMetaType< ::QSql::Location >("QSql::Location");
    qRegisterMetaType< ::QSql::ParamTypeFlag >("QSql::ParamTypeFlag");
    qRegisterMetaType< ::QSql::TableType >("QSql::TableType");
    qRegisterMetaType< ::QSql::NumericalPrecisionPolicy >("QSql::NumericalPrecisionPolicy");

    return pyType;
}
