// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSqlDriverCreatorBaseWrapper_H
#define SBK_QSqlDriverCreatorBaseWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSql/qsqldatabase.h>

class QSqlDriverCreatorBaseWrapper : public QSqlDriverCreatorBase
{
public:
    QSqlDriverCreatorBaseWrapper(const QSqlDriverCreatorBaseWrapper &) = delete;
    QSqlDriverCreatorBaseWrapper& operator=(const QSqlDriverCreatorBaseWrapper &) = delete;
    QSqlDriverCreatorBaseWrapper(QSqlDriverCreatorBaseWrapper &&) = delete;
    QSqlDriverCreatorBaseWrapper& operator=(QSqlDriverCreatorBaseWrapper &&) = delete;

    QSqlDriverCreatorBaseWrapper();
    ::QSqlDriver * createObject() const override;
    ~QSqlDriverCreatorBaseWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QSqlDriverCreatorBaseWrapper_H

