// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSqlRelationalDelegateWrapper_H
#define SBK_QSqlRelationalDelegateWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSql/qsqlrelationaldelegate.h>

namespace PySide { class DynamicQMetaObject; }

class QSqlRelationalDelegateWrapper : public QSqlRelationalDelegate
{
public:
    QSqlRelationalDelegateWrapper(const QSqlRelationalDelegateWrapper &) = delete;
    QSqlRelationalDelegateWrapper& operator=(const QSqlRelationalDelegateWrapper &) = delete;
    QSqlRelationalDelegateWrapper(QSqlRelationalDelegateWrapper &&) = delete;
    QSqlRelationalDelegateWrapper& operator=(QSqlRelationalDelegateWrapper &&) = delete;

    QSqlRelationalDelegateWrapper(::QObject * aParent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QWidget * createEditor(::QWidget * aParent, const ::QStyleOptionViewItem & option, const ::QModelIndex & index) const override;
    void customEvent(::QEvent * event) override;
    void destroyEditor(::QWidget * editor, const ::QModelIndex & index) const override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    ::QString displayText(const ::QVariant & value, const ::QLocale & locale) const override;
    bool editorEvent(::QEvent * event, ::QAbstractItemModel * model, const ::QStyleOptionViewItem & option, const ::QModelIndex & index) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * object, ::QEvent * event) override;
    bool helpEvent(::QHelpEvent * event, ::QAbstractItemView * view, const ::QStyleOptionViewItem & option, const ::QModelIndex & index) override;
    void initStyleOption(::QStyleOptionViewItem * option, const ::QModelIndex & index) const override;
    void paint(::QPainter * painter, const ::QStyleOptionViewItem & option, const ::QModelIndex & index) const override;
    ::QList<int> paintingRoles() const override;
    void setEditorData(::QWidget * editor, const ::QModelIndex & index) const override;
    void setModelData(::QWidget * editor, ::QAbstractItemModel * model, const ::QModelIndex & index) const override;
    ::QSize sizeHint(const ::QStyleOptionViewItem & option, const ::QModelIndex & index) const override;
    void timerEvent(::QTimerEvent * event) override;
    void updateEditorGeometry(::QWidget * editor, const ::QStyleOptionViewItem & option, const ::QModelIndex & index) const override;
    ~QSqlRelationalDelegateWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[19] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QSqlRelationalDelegateWrapper_H

