// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSqlRelationalTableModelWrapper_H
#define SBK_QSqlRelationalTableModelWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSql/qsqlrelationaltablemodel.h>

namespace PySide { class DynamicQMetaObject; }

class QSqlRelationalTableModelWrapper : public QSqlRelationalTableModel
{
public:
    QSqlRelationalTableModelWrapper(const QSqlRelationalTableModelWrapper &) = delete;
    QSqlRelationalTableModelWrapper& operator=(const QSqlRelationalTableModelWrapper &) = delete;
    QSqlRelationalTableModelWrapper(QSqlRelationalTableModelWrapper &&) = delete;
    QSqlRelationalTableModelWrapper& operator=(QSqlRelationalTableModelWrapper &&) = delete;

    QSqlRelationalTableModelWrapper(::QObject * parent = nullptr, const ::QSqlDatabase & db = QSqlDatabase());
    ::QModelIndex buddy(const ::QModelIndex & index) const override;
    bool canDropMimeData(const ::QMimeData * data, ::Qt::DropAction action, int row, int column, const ::QModelIndex & parent) const override;
    bool canFetchMore(const ::QModelIndex & parent = QModelIndex()) const override;
    void childEvent(::QChildEvent * event) override;
    void clear() override;
    bool clearItemData(const ::QModelIndex & index) override;
    int columnCount(const ::QModelIndex & parent = QModelIndex()) const override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    ::QVariant data(const ::QModelIndex & item, int role = Qt::DisplayRole) const override;
    bool deleteRowFromTable(int row) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool dropMimeData(const ::QMimeData * data, ::Qt::DropAction action, int row, int column, const ::QModelIndex & parent) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void fetchMore(const ::QModelIndex & parent = QModelIndex()) override;
    ::QFlags<Qt::ItemFlag> flags(const ::QModelIndex & index) const override;
    ::QVariant headerData(int section, ::Qt::Orientation orientation, int role = Qt::DisplayRole) const override;
    ::QModelIndex index(int row, int column, const ::QModelIndex & parent = QModelIndex()) const override;
    ::QModelIndex indexInQuery(const ::QModelIndex & item) const override;
    bool insertColumns(int column, int count, const ::QModelIndex & parent = QModelIndex()) override;
    bool insertRowIntoTable(const ::QSqlRecord & values) override;
    bool insertRows(int row, int count, const ::QModelIndex & parent = QModelIndex()) override;
    ::QMap<int,QVariant> itemData(const ::QModelIndex & index) const override;
    ::QList<QModelIndex> match(const ::QModelIndex & start, int role, const ::QVariant & value, int hits = 1, ::QFlags<Qt::MatchFlag> flags = Qt::MatchFlags(Qt::MatchStartsWith|Qt::MatchWrap)) const override;
    ::QMimeData * mimeData(const ::QList<QModelIndex> & indexes) const override;
    ::QStringList mimeTypes() const override;
    bool moveColumns(const ::QModelIndex & sourceParent, int sourceColumn, int count, const ::QModelIndex & destinationParent, int destinationChild) override;
    bool moveRows(const ::QModelIndex & sourceParent, int sourceRow, int count, const ::QModelIndex & destinationParent, int destinationChild) override;
    void multiData(const ::QModelIndex & index, ::QModelRoleDataSpan roleDataSpan) const override;
    ::QString orderByClause() const override;
    void queryChange() override;
    ::QSqlTableModel * relationModel(int column) const override;
    bool removeColumns(int column, int count, const ::QModelIndex & parent = QModelIndex()) override;
    bool removeRows(int row, int count, const ::QModelIndex & parent = QModelIndex()) override;
    void resetInternalData() override;
    void revert() override;
    void revertRow(int row) override;
    ::QHash<int,QByteArray> roleNames() const override;
    int rowCount(const ::QModelIndex & parent = QModelIndex()) const override;
    bool select() override;
    bool selectRow(int row) override;
    ::QString selectStatement() const override;
    bool setData(const ::QModelIndex & item, const ::QVariant & value, int role = Qt::EditRole) override;
    void setEditStrategy(::QSqlTableModel::EditStrategy strategy) override;
    void setFilter(const ::QString & filter) override;
    bool setHeaderData(int section, ::Qt::Orientation orientation, const ::QVariant & value, int role = Qt::EditRole) override;
    bool setItemData(const ::QModelIndex & index, const ::QMap<int,QVariant> & roles) override;
    void setRelation(int column, const ::QSqlRelation & relation) override;
    void setSort(int column, ::Qt::SortOrder order) override;
    void setTable(const ::QString & tableName) override;
    ::QModelIndex sibling(int row, int column, const ::QModelIndex & idx) const override;
    void sort(int column, ::Qt::SortOrder order) override;
    ::QSize span(const ::QModelIndex & index) const override;
    bool submit() override;
    ::QFlags<Qt::DropAction> supportedDragActions() const override;
    ::QFlags<Qt::DropAction> supportedDropActions() const override;
    void timerEvent(::QTimerEvent * event) override;
    bool updateRowInTable(int row, const ::QSqlRecord & values) override;
    ~QSqlRelationalTableModelWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[59] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QSqlRelationalTableModelWrapper_H

