// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QMouseEventTransitionWrapper_H
#define SBK_QMouseEventTransitionWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtStateMachine/qmouseeventtransition.h>

namespace PySide { class DynamicQMetaObject; }

class QMouseEventTransitionWrapper : public QMouseEventTransition
{
public:
    QMouseEventTransitionWrapper(const QMouseEventTransitionWrapper &) = delete;
    QMouseEventTransitionWrapper& operator=(const QMouseEventTransitionWrapper &) = delete;
    QMouseEventTransitionWrapper(QMouseEventTransitionWrapper &&) = delete;
    QMouseEventTransitionWrapper& operator=(QMouseEventTransitionWrapper &&) = delete;

    QMouseEventTransitionWrapper(::QObject * object, ::QEvent::Type type, ::Qt::MouseButton button, ::QState * sourceState = nullptr);
    QMouseEventTransitionWrapper(::QState * sourceState = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * e) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool eventTest(::QEvent * event) override;
    void onTransition(::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QMouseEventTransitionWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9] = {false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QMouseEventTransitionWrapper_H

