// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QStateMachineWrapper_H
#define SBK_QStateMachineWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtStateMachine/qstatemachine.h>

namespace PySide { class DynamicQMetaObject; }

class QStateMachineWrapper : public QStateMachine
{
public:
    QStateMachineWrapper(const QStateMachineWrapper &) = delete;
    QStateMachineWrapper& operator=(const QStateMachineWrapper &) = delete;
    QStateMachineWrapper(QStateMachineWrapper &&) = delete;
    QStateMachineWrapper& operator=(QStateMachineWrapper &&) = delete;

    QStateMachineWrapper(::QObject * parent = nullptr);
    QStateMachineWrapper(::QState::ChildMode childMode, ::QObject * parent = nullptr);
    void beginMicrostep(::QEvent * event) override;
    void beginSelectTransitions(::QEvent * event) override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    void endMicrostep(::QEvent * event) override;
    void endSelectTransitions(::QEvent * event) override;
    bool event(::QEvent * e) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void onEntry(::QEvent * event) override;
    void onExit(::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QStateMachineWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[13] = {false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QStateMachineWrapper_H

