// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTextToSpeechEngineWrapper_H
#define SBK_QTextToSpeechEngineWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtTextToSpeech/qtexttospeechengine.h>

namespace PySide { class DynamicQMetaObject; }

class QTextToSpeechEngineWrapper : public QTextToSpeechEngine
{
public:
    QTextToSpeechEngineWrapper(const QTextToSpeechEngineWrapper &) = delete;
    QTextToSpeechEngineWrapper& operator=(const QTextToSpeechEngineWrapper &) = delete;
    QTextToSpeechEngineWrapper(QTextToSpeechEngineWrapper &&) = delete;
    QTextToSpeechEngineWrapper& operator=(QTextToSpeechEngineWrapper &&) = delete;

    QTextToSpeechEngineWrapper(::QObject * parent = nullptr);
    ::QList<QLocale> availableLocales() const override;
    ::QList<QVoice> availableVoices() const override;
    ::QFlags<QTextToSpeech::Capability> capabilities() const override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    ::QTextToSpeech::ErrorReason errorReason() const override;
    ::QString errorString() const override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QLocale locale() const override;
    void pause(::QTextToSpeech::BoundaryHint boundaryHint) override;
    double pitch() const override;
    double rate() const override;
    void resume() override;
    void say(const ::QString & text) override;
    bool setLocale(const ::QLocale & locale) override;
    bool setPitch(double pitch) override;
    bool setRate(double rate) override;
    bool setVoice(const ::QVoice & voice) override;
    bool setVolume(double volume) override;
    ::QTextToSpeech::State state() const override;
    void stop(::QTextToSpeech::BoundaryHint boundaryHint) override;
    void synthesize(const ::QString & text) override;
    void timerEvent(::QTimerEvent * event) override;
    ::QVoice voice() const override;
    double volume() const override;
    ~QTextToSpeechEngineWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[28] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QTextToSpeechEngineWrapper_H

