// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqobject.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <signalmanager.h>
#include <pysidemetafunction.h>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebenginecore_python.h"

// main header
#include "qwebenginehistory_wrapper.h"

// Argument includes
#include <QAnyStringView>
#include <QList>
#include <QString>
#include <QtWebEngineCore/qwebenginehistory.h>
#include <qbytearray.h>
#include <qcoreevent.h>
#include <qdatastream.h>
#include <qmetaobject.h>
#include <qnamespace.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qthread.h>
#include <qvariant.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static PyObject *Sbk_QWebEngineHistoryFunc_back(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // back()
        cppSelf->back();
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineHistoryFunc_backItem(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // backItem()const
        QWebEngineHistoryItem cppResult = const_cast<const ::QWebEngineHistory *>(cppSelf)->backItem();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryItem_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineHistoryFunc_backItems(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebEngineHistory::backItems(int)const->QList<QWebEngineHistoryItem>
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // backItems(int)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "backItems", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // backItems(int)const
            QList<QWebEngineHistoryItem> cppResult = const_cast<const ::QWebEngineHistory *>(cppSelf)->backItems(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtWebEngineCoreTypeConverters[SBK_QtWebEngineCore_QList_QWebEngineHistoryItem_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineHistoryFunc_backItemsModel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // backItemsModel()const
        QWebEngineHistoryModel * cppResult = const_cast<const ::QWebEngineHistory *>(cppSelf)->backItemsModel();
        pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX]), cppResult);
        // Ownership transferences (return value heuristics).
        Shiboken::Object::setParent(self, pyResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineHistoryFunc_canGoBack(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // canGoBack()const
        bool cppResult = const_cast<const ::QWebEngineHistory *>(cppSelf)->canGoBack();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineHistoryFunc_canGoForward(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // canGoForward()const
        bool cppResult = const_cast<const ::QWebEngineHistory *>(cppSelf)->canGoForward();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineHistoryFunc_clear(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // clear()
        cppSelf->clear();
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineHistoryFunc_count(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // count()const
        int cppResult = const_cast<const ::QWebEngineHistory *>(cppSelf)->count();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineHistoryFunc_currentItem(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // currentItem()const
        QWebEngineHistoryItem cppResult = const_cast<const ::QWebEngineHistory *>(cppSelf)->currentItem();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryItem_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineHistoryFunc_currentItemIndex(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // currentItemIndex()const
        int cppResult = const_cast<const ::QWebEngineHistory *>(cppSelf)->currentItemIndex();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineHistoryFunc_forward(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // forward()
        cppSelf->forward();
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineHistoryFunc_forwardItem(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // forwardItem()const
        QWebEngineHistoryItem cppResult = const_cast<const ::QWebEngineHistory *>(cppSelf)->forwardItem();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryItem_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineHistoryFunc_forwardItems(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebEngineHistory::forwardItems(int)const->QList<QWebEngineHistoryItem>
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // forwardItems(int)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "forwardItems", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // forwardItems(int)const
            QList<QWebEngineHistoryItem> cppResult = const_cast<const ::QWebEngineHistory *>(cppSelf)->forwardItems(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtWebEngineCoreTypeConverters[SBK_QtWebEngineCore_QList_QWebEngineHistoryItem_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineHistoryFunc_forwardItemsModel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // forwardItemsModel()const
        QWebEngineHistoryModel * cppResult = const_cast<const ::QWebEngineHistory *>(cppSelf)->forwardItemsModel();
        pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX]), cppResult);
        // Ownership transferences (return value heuristics).
        Shiboken::Object::setParent(self, pyResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineHistoryFunc_goToItem(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebEngineHistory::goToItem(QWebEngineHistoryItem)
    if ((pyArg != Py_None && (pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryItem_IDX]), (pyArg))))) {
        overloadId = 0; // goToItem(QWebEngineHistoryItem)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "goToItem", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QWebEngineHistoryItem *cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // goToItem(QWebEngineHistoryItem)
            cppSelf->goToItem(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineHistoryFunc_itemAt(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebEngineHistory::itemAt(int)const->QWebEngineHistoryItem
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // itemAt(int)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "itemAt", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // itemAt(int)const
            QWebEngineHistoryItem cppResult = const_cast<const ::QWebEngineHistory *>(cppSelf)->itemAt(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryItem_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineHistoryFunc_items(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // items()const
        QList<QWebEngineHistoryItem> cppResult = const_cast<const ::QWebEngineHistory *>(cppSelf)->items();
        pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtWebEngineCoreTypeConverters[SBK_QtWebEngineCore_QList_QWebEngineHistoryItem_IDX], &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineHistoryFunc_itemsModel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // itemsModel()const
        QWebEngineHistoryModel * cppResult = const_cast<const ::QWebEngineHistory *>(cppSelf)->itemsModel();
        pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX]), cppResult);
        // Ownership transferences (return value heuristics).
        Shiboken::Object::setParent(self, pyResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QWebEngineHistory_PropertyStrings[] = {
    "backItems:backItemsModel",
    "forwardItems:forwardItemsModel",
    "items:itemsModel",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QWebEngineHistory_methods[] = {
    {"back", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryFunc_back), METH_NOARGS, nullptr},
    {"backItem", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryFunc_backItem), METH_NOARGS, nullptr},
    {"backItems", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryFunc_backItems), METH_O, nullptr},
    {"backItemsModel", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryFunc_backItemsModel), METH_NOARGS, nullptr},
    {"canGoBack", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryFunc_canGoBack), METH_NOARGS, nullptr},
    {"canGoForward", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryFunc_canGoForward), METH_NOARGS, nullptr},
    {"clear", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryFunc_clear), METH_NOARGS, nullptr},
    {"count", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryFunc_count), METH_NOARGS, nullptr},
    {"currentItem", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryFunc_currentItem), METH_NOARGS, nullptr},
    {"currentItemIndex", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryFunc_currentItemIndex), METH_NOARGS, nullptr},
    {"forward", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryFunc_forward), METH_NOARGS, nullptr},
    {"forwardItem", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryFunc_forwardItem), METH_NOARGS, nullptr},
    {"forwardItems", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryFunc_forwardItems), METH_O, nullptr},
    {"forwardItemsModel", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryFunc_forwardItemsModel), METH_NOARGS, nullptr},
    {"goToItem", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryFunc_goToItem), METH_O, nullptr},
    {"itemAt", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryFunc_itemAt), METH_O, nullptr},
    {"items", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryFunc_items), METH_NOARGS, nullptr},
    {"itemsModel", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryFunc_itemsModel), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static int Sbk_QWebEngineHistory_setattro(PyObject *self, PyObject *name, PyObject *value)
{
    PySide::Feature::Select(self);
    Shiboken::AutoDecRef pp(reinterpret_cast<PyObject *>(PySide::Property::getObject(self, name)));
    if (!pp.isNull())
        return PySide::Property::setValue(reinterpret_cast<PySideProperty *>(pp.object()), self, value);
    return PyObject_GenericSetAttr(self, name, value);
}

static PyObject *Sbk_QWebEngineHistoryFunc___lshift__(PyObject *self, PyObject *pyArg)
{
    bool isReverse = SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), pyArg)
                    && !SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), self);
    if (isReverse)
        std::swap(self, pyArg);
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    static PyObject *attrName = Shiboken::PyMagicName::rlshift();
    if (!isReverse
        && Shiboken::Object::checkType(pyArg)
        && !PyObject_TypeCheck(pyArg, self->ob_type)
        && PyObject_HasAttr(pyArg, attrName)) {
        PyObject *revOpMethod = PyObject_GetAttr(pyArg, attrName);
        if (revOpMethod && PyCallable_Check(revOpMethod)) {
            pyResult = PyObject_CallFunction(revOpMethod, "O", self);
            if (Shiboken::Errors::occurred() != nullptr && (PyErr_ExceptionMatches(PyExc_NotImplementedError) || PyErr_ExceptionMatches(PyExc_AttributeError))) {
                PyErr_Clear();
                Py_XDECREF(pyResult);
                pyResult = nullptr;
            }
        }
        Py_XDECREF(revOpMethod);

    }

    // Do not enter here if other object has implemented a reverse operator.
    if (pyResult == nullptr) {
        // Overloaded function decisor
        // 0: QWebEngineHistory::operator<<(QDataStream&)->QDataStream&
        if (isReverse
            && (pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDataStream_IDX]), (pyArg)))) {
            overloadId = 0; // operator<<(QDataStream&,QWebEngineHistory)
        }

        if (isReverse && overloadId == -1) {
            Shiboken::Errors::setReverseOperatorNotImplemented();
            return {};
        }

        // Function signature not found.
        if (overloadId == -1)
            return Shiboken::returnWrongArguments(pyArg, "operator<<", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]);

        // Call function/method
        {
            if (!Shiboken::Object::isValid(pyArg))
                return {};
            ::QDataStream *cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // operator<<(QDataStream&,QWebEngineHistory) [reverse operator]
                QDataStream & cppResult = (*cppArg0) << (*cppSelf);
                pyResult = Shiboken::Conversions::referenceToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDataStream_IDX]), &cppResult);
            }
        }

    } // End of "if (!pyResult)"

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineHistoryFunc___rshift__(PyObject *self, PyObject *pyArg)
{
    bool isReverse = SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), pyArg)
                    && !SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), self);
    if (isReverse)
        std::swap(self, pyArg);
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistory *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    static PyObject *attrName = Shiboken::PyMagicName::rrshift();
    if (!isReverse
        && Shiboken::Object::checkType(pyArg)
        && !PyObject_TypeCheck(pyArg, self->ob_type)
        && PyObject_HasAttr(pyArg, attrName)) {
        PyObject *revOpMethod = PyObject_GetAttr(pyArg, attrName);
        if (revOpMethod && PyCallable_Check(revOpMethod)) {
            pyResult = PyObject_CallFunction(revOpMethod, "O", self);
            if (Shiboken::Errors::occurred() != nullptr && (PyErr_ExceptionMatches(PyExc_NotImplementedError) || PyErr_ExceptionMatches(PyExc_AttributeError))) {
                PyErr_Clear();
                Py_XDECREF(pyResult);
                pyResult = nullptr;
            }
        }
        Py_XDECREF(revOpMethod);

    }

    // Do not enter here if other object has implemented a reverse operator.
    if (pyResult == nullptr) {
        // Overloaded function decisor
        // 0: QWebEngineHistory::operator>>(QDataStream&)->QDataStream&
        if (isReverse
            && (pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDataStream_IDX]), (pyArg)))) {
            overloadId = 0; // operator>>(QDataStream&,QWebEngineHistory&)
        }

        if (isReverse && overloadId == -1) {
            Shiboken::Errors::setReverseOperatorNotImplemented();
            return {};
        }

        // Function signature not found.
        if (overloadId == -1)
            return Shiboken::returnWrongArguments(pyArg, "operator>>", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX]);

        // Call function/method
        {
            if (!Shiboken::Object::isValid(pyArg))
                return {};
            ::QDataStream *cppArg0;
            pythonToCpp(pyArg, &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // operator>>(QDataStream&,QWebEngineHistory&) [reverse operator]
                QDataStream & cppResult = (*cppArg0) >> (*cppSelf);
                pyResult = Shiboken::Conversions::referenceToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QDataStream_IDX]), &cppResult);
            }
        }

    } // End of "if (!pyResult)"

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

} // extern "C"

static int Sbk_QWebEngineHistory_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QWebEngineHistory_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QWebEngineHistory_Type = nullptr;
static PyTypeObject *Sbk_QWebEngineHistory_TypeF(void)
{
    return _Sbk_QWebEngineHistory_Type;
}

static PyType_Slot Sbk_QWebEngineHistory_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(SbkDeallocWrapperWithPrivateDtor)},
    {Py_tp_setattro,    reinterpret_cast<void *>(Sbk_QWebEngineHistory_setattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QWebEngineHistory_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QWebEngineHistory_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QWebEngineHistory_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    // type supports number protocol
    {Py_nb_lshift,      reinterpret_cast<void *>(Sbk_QWebEngineHistoryFunc___lshift__)},
    {Py_nb_rshift,      reinterpret_cast<void *>(Sbk_QWebEngineHistoryFunc___rshift__)},
    {0, nullptr}
};
static PyType_Spec Sbk_QWebEngineHistory_spec = {
    "2:PySide6.QtWebEngineCore.QWebEngineHistory",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QWebEngineHistory_slots
};

} //extern "C"

static void *Sbk_QWebEngineHistory_typeDiscovery(void *cptr, PyTypeObject *instanceType)
{
    SBK_UNUSED(cptr)
    SBK_UNUSED(instanceType)
    if (instanceType == Shiboken::SbkType< ::QObject >())
        return dynamic_cast< ::QWebEngineHistory *>(reinterpret_cast< ::QObject *>(cptr));
    return {};
}


// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QWebEngineHistory_PythonToCpp_QWebEngineHistory_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QWebEngineHistory_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QWebEngineHistory_PythonToCpp_QWebEngineHistory_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineHistory_TypeF()))
        return QWebEngineHistory_PythonToCpp_QWebEngineHistory_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QWebEngineHistory_PTR_CppToPython_QWebEngineHistory(const void *cppIn)
{
    return PySide::getWrapperForQObject(reinterpret_cast<::QWebEngineHistory *>(const_cast<void *>(cppIn)), Sbk_QWebEngineHistory_TypeF());

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QWebEngineHistory_SignatureStrings[] = {
    "PySide6.QtWebEngineCore.QWebEngineHistory.back(self)",
    "PySide6.QtWebEngineCore.QWebEngineHistory.backItem(self)->PySide6.QtWebEngineCore.QWebEngineHistoryItem",
    "PySide6.QtWebEngineCore.QWebEngineHistory.backItems(self,maxItems:int)->QList[PySide6.QtWebEngineCore.QWebEngineHistoryItem]",
    "PySide6.QtWebEngineCore.QWebEngineHistory.backItemsModel(self)->PySide6.QtWebEngineCore.QWebEngineHistoryModel",
    "PySide6.QtWebEngineCore.QWebEngineHistory.canGoBack(self)->bool",
    "PySide6.QtWebEngineCore.QWebEngineHistory.canGoForward(self)->bool",
    "PySide6.QtWebEngineCore.QWebEngineHistory.clear(self)",
    "PySide6.QtWebEngineCore.QWebEngineHistory.count(self)->int",
    "PySide6.QtWebEngineCore.QWebEngineHistory.currentItem(self)->PySide6.QtWebEngineCore.QWebEngineHistoryItem",
    "PySide6.QtWebEngineCore.QWebEngineHistory.currentItemIndex(self)->int",
    "PySide6.QtWebEngineCore.QWebEngineHistory.forward(self)",
    "PySide6.QtWebEngineCore.QWebEngineHistory.forwardItem(self)->PySide6.QtWebEngineCore.QWebEngineHistoryItem",
    "PySide6.QtWebEngineCore.QWebEngineHistory.forwardItems(self,maxItems:int)->QList[PySide6.QtWebEngineCore.QWebEngineHistoryItem]",
    "PySide6.QtWebEngineCore.QWebEngineHistory.forwardItemsModel(self)->PySide6.QtWebEngineCore.QWebEngineHistoryModel",
    "PySide6.QtWebEngineCore.QWebEngineHistory.goToItem(self,item:PySide6.QtWebEngineCore.QWebEngineHistoryItem)",
    "PySide6.QtWebEngineCore.QWebEngineHistory.itemAt(self,i:int)->PySide6.QtWebEngineCore.QWebEngineHistoryItem",
    "PySide6.QtWebEngineCore.QWebEngineHistory.items(self)->QList[PySide6.QtWebEngineCore.QWebEngineHistoryItem]",
    "PySide6.QtWebEngineCore.QWebEngineHistory.itemsModel(self)->PySide6.QtWebEngineCore.QWebEngineHistoryModel",
    "PySide6.QtWebEngineCore.QWebEngineHistory.__lshift__(self,stream:PySide6.QtCore.QDataStream)->PySide6.QtCore.QDataStream",
    "PySide6.QtWebEngineCore.QWebEngineHistory.__rshift__(self,stream:PySide6.QtCore.QDataStream)->PySide6.QtCore.QDataStream",
    nullptr}; // Sentinel
#else
static constexpr size_t QWebEngineHistory_SignatureByteSize = 260;
static constexpr uint8_t QWebEngineHistory_SignatureBytes[260] = {
    0x78, 0xda, 0xc5, 0x93, 0x51, 0x6b, 0xc2, 0x30, 0x10, 0xc7, 0xdf, 0xfd, 0x24, 0x0a, 0xda, 0xc7,
    0x3d, 0xf8, 0x20, 0x4c, 0xdd, 0x54, 0x50, 0x68, 0x71, 0xe0, 0xc3, 0x18, 0x21, 0x6d, 0xaf, 0x5d,
    0x58, 0x9b, 0x83, 0xcb, 0xc9, 0xf4, 0xdb, 0xaf, 0xb6, 0x5a, 0xb2, 0x3d, 0xed, 0xca, 0xec, 0xde,
    0x12, 0x92, 0x5f, 0x7e, 0xb9, 0xfb, 0x27, 0xe1, 0x79, 0x6f, 0x52, 0x78, 0x08, 0x22, 0x3e, 0x40,
    0xfc, 0x64, 0x73, 0x63, 0x61, 0x81, 0x04, 0x41, 0xd4, 0x4e, 0xd7, 0xc6, 0x31, 0xd2, 0x39, 0x88,
    0x75, 0xf2, 0x31, 0x74, 0x50, 0x64, 0xa3, 0x41, 0x28, 0x82, 0x36, 0x0c, 0x65, 0x03, 0x4e, 0x66,
    0xbf, 0x26, 0x2f, 0x50, 0x07, 0x8f, 0xab, 0x45, 0xe3, 0x52, 0x9f, 0xea, 0xd9, 0xd4, 0x58, 0xae,
    0xac, 0xd1, 0xb6, 0xda, 0xf6, 0x2a, 0x72, 0xbf, 0x75, 0x91, 0xef, 0x30, 0x85, 0x42, 0x5c, 0x6a,
    0x4d, 0x09, 0x74, 0x89, 0xb6, 0x2b, 0x9c, 0xb7, 0x69, 0x4c, 0x66, 0x31, 0xa2, 0x98, 0x7f, 0x46,
    0xfa, 0xd4, 0x94, 0x76, 0x3d, 0xa2, 0x00, 0x4d, 0xe2, 0xc7, 0x90, 0xe0, 0xd1, 0xf2, 0xcd, 0x58,
    0x25, 0x23, 0x41, 0x8f, 0x44, 0x60, 0xb9, 0x8f, 0xa7, 0xe4, 0xa9, 0x36, 0x36, 0x85, 0x53, 0xb7,
    0x0b, 0x67, 0x7e, 0x7f, 0xe5, 0x5c, 0x1f, 0x85, 0x7a, 0xaa, 0x7f, 0xf9, 0x36, 0xbe, 0xbf, 0x9f,
    0x9f, 0x93, 0xe3, 0x0b, 0xb6, 0x9d, 0x1d, 0x9b, 0x6a, 0x34, 0x15, 0x55, 0x27, 0x09, 0xf2, 0x72,
    0xfa, 0x23, 0x5f, 0x4d, 0xd7, 0x86, 0xde, 0x2b, 0x49, 0xd3, 0x46, 0x78, 0xff, 0xd4, 0x4c, 0x7f,
    0x71, 0x29, 0x55, 0xb8, 0x77, 0x93, 0xb1, 0x52, 0x4d, 0x1b, 0x1d, 0x13, 0x68, 0x3f, 0xb2, 0x86,
    0x5b, 0x6a, 0xd6, 0xfb, 0x7a, 0xe9, 0xdb, 0x65, 0x7e, 0x2e, 0x8a, 0xc4, 0xf4, 0x97, 0xe2, 0x2f,
    0x87, 0x9d, 0xb4, 0xa8
};
#endif

PyTypeObject *init_QWebEngineHistory(PyObject *module)
{
    if (SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX].type != nullptr)
        return SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX].type;

    Shiboken::AutoDecRef Sbk_QWebEngineHistory_Type_bases(PyTuple_Pack(1,
        reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]))));

    _Sbk_QWebEngineHistory_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QWebEngineHistory",
        "QWebEngineHistory*",
        &Sbk_QWebEngineHistory_spec,
        nullptr,
        Sbk_QWebEngineHistory_Type_bases.object(),
        0);
    auto *pyType = Sbk_QWebEngineHistory_TypeF(); // references _Sbk_QWebEngineHistory_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QWebEngineHistory_SignatureStrings);
#else
    InitSignatureBytes(pyType, QWebEngineHistory_SignatureBytes, QWebEngineHistory_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QWebEngineHistory_PropertyStrings);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistory_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QWebEngineHistory_PythonToCpp_QWebEngineHistory_PTR,
        is_QWebEngineHistory_PythonToCpp_QWebEngineHistory_PTR_Convertible,
        QWebEngineHistory_PTR_CppToPython_QWebEngineHistory);

    Shiboken::Conversions::registerConverterName(converter, "QWebEngineHistory");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineHistory*");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineHistory&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QWebEngineHistory).name());

    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(
        Sbk_QWebEngineHistory_TypeF(), &Sbk_QWebEngineHistory_typeDiscovery);

    Shiboken::ObjectType::setSubTypeInitHook(pyType, &PySide::initQObjectSubType);
    PySide::initDynamicMetaObject(pyType, &::QWebEngineHistory::staticMetaObject, sizeof(::QWebEngineHistory));

    return pyType;
}
