// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqobject.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <signalmanager.h>
#include <pysidemetafunction.h>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebenginecore_python.h"

// main header
#include "qwebenginehistorymodel_wrapper.h"

// Argument includes
#include <QHash>
#include <QList>
#include <QMap>
#include <QStringList>
#include <qabstractitemmodel.h>
#include <qbytearray.h>
#include <qcoreevent.h>
#include <qmetaobject.h>
#include <qmimedata.h>
#include <qnamespace.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qsize.h>
#include <qvariant.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static PyObject *Sbk_QWebEngineHistoryModelFunc_data(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistoryModel *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "data", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX]);

    if (PyArg_ParseTuple(args, "|OO:data", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QAbstractItemModel::data(QModelIndex,int=)const->QVariant
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QModelIndex_IDX]), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // data(QModelIndex,int)const
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
            overloadId = 0; // data(QModelIndex,int)const
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "data", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX]);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_role = Shiboken::String::createStaticString("role");
            if (PyDict_Contains(kwds, key_role) != 0) {
                value = PyDict_GetItem(kwds, key_role);
                if (value != nullptr && pyArgs[1] != nullptr ) {
                    errInfo.reset(key_role);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, "data", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1]))))
                        return Shiboken::returnWrongArguments(args, "data", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_role);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, "data", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX]);
            }
        }
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return {};
        ::QModelIndex cppArg0_local;
        ::QModelIndex *cppArg0 = &cppArg0_local;
        if (pythonToCpp[0].isValue())
            pythonToCpp[0](pyArgs[0], &cppArg0_local);
        else
            pythonToCpp[0](pyArgs[0], &cppArg0);

        int cppArg1 = Qt::DisplayRole;
        if (pythonToCpp[1])
            pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // data(QModelIndex,int)const
            QVariant cppResult = Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))
                ? const_cast<const ::QWebEngineHistoryModel *>(cppSelf)->::QWebEngineHistoryModel::data(*cppArg0, cppArg1)
                : const_cast<const ::QWebEngineHistoryModel *>(cppSelf)->data(*cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineHistoryModelFunc_reset(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistoryModel *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // reset()
        cppSelf->reset();
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineHistoryModelFunc_roleNames(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistoryModel *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // roleNames()const
        QHash<int,QByteArray> cppResult = Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))
            ? const_cast<const ::QWebEngineHistoryModel *>(cppSelf)->::QWebEngineHistoryModel::roleNames()
            : const_cast<const ::QWebEngineHistoryModel *>(cppSelf)->roleNames();
        pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtWebEngineCoreTypeConverters[SBK_QtWebEngineCore_QHash_int_QByteArray_IDX], &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineHistoryModelFunc_rowCount(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineHistoryModel *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "rowCount", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX]);

    if (PyArg_ParseTuple(args, "|O:rowCount", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QAbstractItemModel::rowCount(const QModelIndex&=)const->int
    if (numArgs == 0) {
        overloadId = 0; // rowCount(QModelIndex)const
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QModelIndex_IDX]), (pyArgs[0])))) {
        overloadId = 0; // rowCount(QModelIndex)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "rowCount", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX]);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_parent = Shiboken::String::createStaticString("parent");
            if (PyDict_Contains(kwds, key_parent) != 0) {
                value = PyDict_GetItem(kwds, key_parent);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_parent);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, "rowCount", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QModelIndex_IDX]), (pyArgs[0]))))
                        return Shiboken::returnWrongArguments(args, "rowCount", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_parent);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, "rowCount", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX]);
            }
        }
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return {};
        ::QModelIndex cppArg0_local = QModelIndex();
        ::QModelIndex *cppArg0 = &cppArg0_local;
        if (pythonToCpp[0]) {
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);
            }

        if (Shiboken::Errors::occurred() == nullptr) {
            // rowCount(QModelIndex)const
            int cppResult = Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))
                ? const_cast<const ::QWebEngineHistoryModel *>(cppSelf)->::QWebEngineHistoryModel::rowCount(*cppArg0)
                : const_cast<const ::QWebEngineHistoryModel *>(cppSelf)->rowCount(*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QWebEngineHistoryModel_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QWebEngineHistoryModel_EnumFlagInfo[] = {
    "Roles:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QWebEngineHistoryModel_methods[] = {
    {"data", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryModelFunc_data), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"reset", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryModelFunc_reset), METH_NOARGS, nullptr},
    {"roleNames", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryModelFunc_roleNames), METH_NOARGS, nullptr},
    {"rowCount", reinterpret_cast<PyCFunction>(Sbk_QWebEngineHistoryModelFunc_rowCount), METH_VARARGS|METH_KEYWORDS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static int Sbk_QWebEngineHistoryModel_setattro(PyObject *self, PyObject *name, PyObject *value)
{
    PySide::Feature::Select(self);
    Shiboken::AutoDecRef pp(reinterpret_cast<PyObject *>(PySide::Property::getObject(self, name)));
    if (!pp.isNull())
        return PySide::Property::setValue(reinterpret_cast<PySideProperty *>(pp.object()), self, value);
    return PyObject_GenericSetAttr(self, name, value);
}

} // extern "C"

static int Sbk_QWebEngineHistoryModel_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QWebEngineHistoryModel_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QWebEngineHistoryModel_Type = nullptr;
static PyTypeObject *Sbk_QWebEngineHistoryModel_TypeF(void)
{
    return _Sbk_QWebEngineHistoryModel_Type;
}

static PyType_Slot Sbk_QWebEngineHistoryModel_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(SbkDeallocWrapperWithPrivateDtor)},
    {Py_tp_setattro,    reinterpret_cast<void *>(Sbk_QWebEngineHistoryModel_setattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QWebEngineHistoryModel_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QWebEngineHistoryModel_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QWebEngineHistoryModel_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QWebEngineHistoryModel_spec = {
    "2:PySide6.QtWebEngineCore.QWebEngineHistoryModel",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QWebEngineHistoryModel_slots
};

} //extern "C"

static void *Sbk_QWebEngineHistoryModel_typeDiscovery(void *cptr, PyTypeObject *instanceType)
{
    SBK_UNUSED(cptr)
    SBK_UNUSED(instanceType)
    if (instanceType == Shiboken::SbkType< ::QObject >())
        return dynamic_cast< ::QWebEngineHistoryModel *>(reinterpret_cast< ::QObject *>(cptr));
    return {};
}


// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QWebEngineHistoryModel_Roles(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QWebEngineHistoryModel::Roles>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QWebEngineHistoryModel::Roles *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QWebEngineHistoryModel_Roles_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_Roles_IDX])))
        return Enum_PythonToCpp_QWebEngineHistoryModel_Roles;
    return {};
}

static PyObject *QWebEngineHistoryModel_Roles_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QWebEngineHistoryModel::Roles>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QWebEngineHistoryModel::Roles *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_Roles_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QWebEngineHistoryModel_PythonToCpp_QWebEngineHistoryModel_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QWebEngineHistoryModel_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QWebEngineHistoryModel_PythonToCpp_QWebEngineHistoryModel_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineHistoryModel_TypeF()))
        return QWebEngineHistoryModel_PythonToCpp_QWebEngineHistoryModel_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QWebEngineHistoryModel_PTR_CppToPython_QWebEngineHistoryModel(const void *cppIn)
{
    return PySide::getWrapperForQObject(reinterpret_cast<::QWebEngineHistoryModel *>(const_cast<void *>(cppIn)), Sbk_QWebEngineHistoryModel_TypeF());

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QWebEngineHistoryModel_SignatureStrings[] = {
    "PySide6.QtWebEngineCore.QWebEngineHistoryModel.data(self,index:typing.Union[PySide6.QtCore.QModelIndex, PySide6.QtCore.QPersistentModelIndex],role:int=Qt.DisplayRole)->QVariant",
    "PySide6.QtWebEngineCore.QWebEngineHistoryModel.reset(self)",
    "PySide6.QtWebEngineCore.QWebEngineHistoryModel.roleNames(self)->QHash[int, PySide6.QtCore.QByteArray]",
    "PySide6.QtWebEngineCore.QWebEngineHistoryModel.rowCount(self,parent:typing.Union[PySide6.QtCore.QModelIndex, PySide6.QtCore.QPersistentModelIndex]=QModelIndex())->int",
    nullptr}; // Sentinel
#else
static constexpr size_t QWebEngineHistoryModel_SignatureByteSize = 200;
static constexpr uint8_t QWebEngineHistoryModel_SignatureBytes[200] = {
    0x78, 0xda, 0xad, 0x90, 0x3b, 0x0b, 0xc2, 0x50, 0x0c, 0x85, 0x77, 0x7f, 0x85, 0xa3, 0x85, 0x7a,
    0x47, 0x07, 0x41, 0xc1, 0x17, 0xd4, 0x41, 0x69, 0x15, 0x75, 0x10, 0x87, 0x48, 0xa3, 0x06, 0x6a,
    0x6e, 0xc9, 0x8d, 0xe8, 0xfd, 0xf7, 0x5e, 0x2d, 0xa8, 0xe8, 0x54, 0x70, 0xcc, 0xe3, 0x9c, 0x7c,
    0x27, 0xa9, 0x5f, 0x52, 0x8e, 0x1d, 0x93, 0xe9, 0x06, 0xf7, 0x13, 0x3e, 0x12, 0xe3, 0xc8, 0x0a,
    0x9a, 0xec, 0x55, 0x26, 0xe4, 0xd4, 0x8a, 0x9f, 0xd9, 0x1c, 0x0b, 0x93, 0x83, 0x42, 0xcb, 0x61,
    0x71, 0x88, 0x89, 0x73, 0xbc, 0x75, 0xd5, 0x97, 0xc4, 0x47, 0xb3, 0x62, 0xb2, 0xbc, 0x4d, 0x5f,
    0x5e, 0x95, 0xc5, 0x53, 0x32, 0x7d, 0xec, 0xc5, 0xcd, 0xef, 0x59, 0x8a, 0xe2, 0x82, 0x31, 0xb2,
    0xbe, 0xb7, 0x76, 0xb1, 0xd8, 0x02, 0xbb, 0xc4, 0xda, 0xcb, 0xd4, 0x8c, 0xc9, 0x95, 0x05, 0xf8,
    0x45, 0x68, 0x45, 0xed, 0x7e, 0xb6, 0x06, 0x21, 0x60, 0x6d, 0xa4, 0xf5, 0x80, 0x05, 0x1d, 0xea,
    0x93, 0x38, 0xaa, 0x2d, 0x0d, 0x97, 0xe7, 0x70, 0x46, 0x57, 0xc9, 0x03, 0x43, 0x02, 0xee, 0xb4,
    0x0d, 0x78, 0xbf, 0x71, 0x86, 0x5e, 0x71, 0x20, 0x02, 0x7e, 0x57, 0xff, 0xca, 0x75, 0x64, 0x2f,
    0x5c, 0x31, 0xc6, 0x25, 0x48, 0x78, 0xc9, 0x9f, 0xdf, 0xda, 0xfb, 0x90, 0xb4, 0xa2, 0x10, 0x24,
    0x44, 0x68, 0xdc, 0x01, 0x29, 0x54, 0xb8, 0x80
};
#endif

PyTypeObject *init_QWebEngineHistoryModel(PyObject *module)
{
    if (SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX].type != nullptr)
        return SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX].type;

    Shiboken::AutoDecRef Sbk_QWebEngineHistoryModel_Type_bases(PyTuple_Pack(1,
        reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QAbstractListModel_IDX]))));

    _Sbk_QWebEngineHistoryModel_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QWebEngineHistoryModel",
        "QWebEngineHistoryModel*",
        &Sbk_QWebEngineHistoryModel_spec,
        nullptr,
        Sbk_QWebEngineHistoryModel_Type_bases.object(),
        0);
    auto *pyType = Sbk_QWebEngineHistoryModel_TypeF(); // references _Sbk_QWebEngineHistoryModel_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QWebEngineHistoryModel_SignatureStrings);
#else
    InitSignatureBytes(pyType, QWebEngineHistoryModel_SignatureBytes, QWebEngineHistoryModel_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QWebEngineHistoryModel_PropertyStrings);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QWebEngineHistoryModel_PythonToCpp_QWebEngineHistoryModel_PTR,
        is_QWebEngineHistoryModel_PythonToCpp_QWebEngineHistoryModel_PTR_Convertible,
        QWebEngineHistoryModel_PTR_CppToPython_QWebEngineHistoryModel);

    Shiboken::Conversions::registerConverterName(converter, "QWebEngineHistoryModel");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineHistoryModel*");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineHistoryModel&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QWebEngineHistoryModel).name());

    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(
        Sbk_QWebEngineHistoryModel_TypeF(), &Sbk_QWebEngineHistoryModel_typeDiscovery);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QWebEngineHistoryModel_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Roles'.
    const char *Roles_Initializer[] = {
        "UrlRole",
        "TitleRole",
        "OffsetRole",
        "IconUrlRole",
        nullptr};
    // "uint16_t" used instead of "unsigned int"
    constexpr uint16_t Roles_InitializerValues[] = {
        uint16_t(QWebEngineHistoryModel::Roles::UrlRole),    //  0x0100  256
        uint16_t(QWebEngineHistoryModel::Roles::TitleRole),  //  0x0101  257
        uint16_t(QWebEngineHistoryModel::Roles::OffsetRole), //  0x0102  258
        uint16_t(QWebEngineHistoryModel::Roles::IconUrlRole) //  0x0103  259
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QWebEngineHistoryModel_TypeF(),
        "2:PySide6.QtWebEngineCore.QWebEngineHistoryModel.Roles",
        Roles_Initializer, Roles_InitializerValues);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineHistoryModel_Roles_IDX].type = EType;
    // Register converter for enum 'QWebEngineHistoryModel::Roles'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QWebEngineHistoryModel_Roles_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QWebEngineHistoryModel_Roles,
            is_Enum_PythonToCpp_QWebEngineHistoryModel_Roles_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QWebEngineHistoryModel::Roles");
        Shiboken::Conversions::registerConverterAlias(converter, "Roles");
        Shiboken::Enum::setTypeConverter(EType, converter, nullptr);
    }
    // End of 'Roles' enum.

    qRegisterMetaType< ::QWebEngineHistoryModel::Roles >("QWebEngineHistoryModel::Roles");
    Shiboken::ObjectType::setSubTypeInitHook(pyType, &PySide::initQObjectSubType);
    PySide::initDynamicMetaObject(pyType, &::QWebEngineHistoryModel::staticMetaObject, sizeof(::QWebEngineHistoryModel));

    return pyType;
}
