// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QWebEnginePageWrapper_H
#define SBK_QWebEnginePageWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWebEngineCore/qwebenginepage.h>

namespace PySide { class DynamicQMetaObject; }

class QWebEnginePageWrapper : public QWebEnginePage
{
public:
    QWebEnginePageWrapper(const QWebEnginePageWrapper &) = delete;
    QWebEnginePageWrapper& operator=(const QWebEnginePageWrapper &) = delete;
    QWebEnginePageWrapper(QWebEnginePageWrapper &&) = delete;
    QWebEnginePageWrapper& operator=(QWebEnginePageWrapper &&) = delete;

    QWebEnginePageWrapper(::QObject * parent = nullptr);
    QWebEnginePageWrapper(::QWebEngineProfile * profile, ::QObject * parent = nullptr);
    bool acceptNavigationRequest(const ::QUrl & url, ::QWebEnginePage::NavigationType type, bool isMainFrame) override;
    void childEvent(::QChildEvent * event) override;
    ::QStringList chooseFiles(::QWebEnginePage::FileSelectionMode mode, const ::QStringList & oldFiles, const ::QStringList & acceptedMimeTypes) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QWebEnginePage * createWindow(::QWebEnginePage::WebWindowType type) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * arg__1) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void javaScriptAlert(const ::QUrl & securityOrigin, const ::QString & msg) override;
    bool javaScriptConfirm(const ::QUrl & securityOrigin, const ::QString & msg) override;
    void javaScriptConsoleMessage(::QWebEnginePage::JavaScriptConsoleMessageLevel level, const ::QString & message, int lineNumber, const ::QString & sourceID) override;
    bool javaScriptPrompt(const ::QUrl & securityOrigin, const ::QString & msg, const ::QString & defaultValue, ::QString * result) override;
    void timerEvent(::QTimerEvent * event) override;
    void triggerAction(::QWebEnginePage::WebAction action, bool checked = false) override;
    ~QWebEnginePageWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    static ::std::pair<bool,QString> javaScriptPromptPyOverride(Shiboken::GilState &gil, PyObject *pyOverride, ::QUrl securityOrigin, ::QString msg, ::QString defaultValue);

    mutable bool m_PyMethodCache[15] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QWebEnginePageWrapper_H

