// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebenginecore_python.h"

// main header
#include "qwebengineregisterprotocolhandlerrequest_wrapper.h"

// Argument includes
#include <QString>
#include <QtWebEngineCore/qwebengineregisterprotocolhandlerrequest.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qurl.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QWebEngineRegisterProtocolHandlerRequest_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(args)
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QWebEngineRegisterProtocolHandlerRequest >()))
        return -1;

    ::QWebEngineRegisterProtocolHandlerRequest *cptr{};
    Shiboken::PythonContextMarker pcm;


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {

        // QWebEngineRegisterProtocolHandlerRequest()
        cptr = new ::QWebEngineRegisterProtocolHandlerRequest();
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QWebEngineRegisterProtocolHandlerRequest >(), cptr)) {
        delete cptr;
        return -1;
    }
    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_accept(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // accept()
        cppSelf->accept();
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_origin(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // origin()const
        QUrl cppResult = const_cast<const ::QWebEngineRegisterProtocolHandlerRequest *>(cppSelf)->origin();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_reject(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // reject()
        cppSelf->reject();
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_scheme(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // scheme()const
        QString cppResult = const_cast<const ::QWebEngineRegisterProtocolHandlerRequest *>(cppSelf)->scheme();
        pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineRegisterProtocolHandlerRequest__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QWebEngineRegisterProtocolHandlerRequest_PropertyStrings[] = {
    "origin:",
    "scheme:",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QWebEngineRegisterProtocolHandlerRequest_methods[] = {
    {"accept", reinterpret_cast<PyCFunction>(Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_accept), METH_NOARGS, nullptr},
    {"origin", reinterpret_cast<PyCFunction>(Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_origin), METH_NOARGS, nullptr},
    {"reject", reinterpret_cast<PyCFunction>(Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_reject), METH_NOARGS, nullptr},
    {"scheme", reinterpret_cast<PyCFunction>(Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_scheme), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QWebEngineRegisterProtocolHandlerRequest__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QWebEngineRegisterProtocolHandlerRequest_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), (pyArg)))) {
                // operator!=(const QWebEngineRegisterProtocolHandlerRequest &that) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QWebEngineRegisterProtocolHandlerRequest cppArg0_local;
                ::QWebEngineRegisterProtocolHandlerRequest *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), (pyArg)))) {
                // operator==(const QWebEngineRegisterProtocolHandlerRequest &that) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QWebEngineRegisterProtocolHandlerRequest cppArg0_local;
                ::QWebEngineRegisterProtocolHandlerRequest *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QWebEngineRegisterProtocolHandlerRequest_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QWebEngineRegisterProtocolHandlerRequest_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QWebEngineRegisterProtocolHandlerRequest_Type = nullptr;
static PyTypeObject *Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF(void)
{
    return _Sbk_QWebEngineRegisterProtocolHandlerRequest_Type;
}

static PyType_Slot Sbk_QWebEngineRegisterProtocolHandlerRequest_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QWebEngineRegisterProtocolHandlerRequest_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QWebEngineRegisterProtocolHandlerRequest_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QWebEngineRegisterProtocolHandlerRequest_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QWebEngineRegisterProtocolHandlerRequest_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QWebEngineRegisterProtocolHandlerRequest_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QWebEngineRegisterProtocolHandlerRequest_spec = {
    "2:PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QWebEngineRegisterProtocolHandlerRequest_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF()))
        return QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QWebEngineRegisterProtocolHandlerRequest_PTR_CppToPython_QWebEngineRegisterProtocolHandlerRequest(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QWebEngineRegisterProtocolHandlerRequest_COPY_CppToPython_QWebEngineRegisterProtocolHandlerRequest(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QWebEngineRegisterProtocolHandlerRequest *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF(), new ::QWebEngineRegisterProtocolHandlerRequest(*source), true, true);
}

// Python to C++ copy conversion.
static void QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QWebEngineRegisterProtocolHandlerRequest *>(cppOut) = *reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF()))
        return QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QWebEngineRegisterProtocolHandlerRequest_SignatureStrings[] = {
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest(self,*:KeywordOnly=None,origin:QUrl=None,scheme:QString=None)",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.accept(self)",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.origin(self)->PySide6.QtCore.QUrl",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.reject(self)",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.scheme(self)->QString",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.__copy__(self)->typing.Self",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.__ne__(self,that:PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest)->bool",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.__eq__(self,that:PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest)->bool",
    nullptr}; // Sentinel
#else
static constexpr size_t QWebEngineRegisterProtocolHandlerRequest_SignatureByteSize = 197;
static constexpr uint8_t QWebEngineRegisterProtocolHandlerRequest_SignatureBytes[197] = {
    0x78, 0xda, 0xb5, 0x90, 0xcb, 0x0a, 0xc2, 0x30, 0x10, 0x45, 0xf7, 0x7e, 0x89, 0x4a, 0xed, 0xd2,
    0x45, 0x40, 0x37, 0x22, 0x08, 0x82, 0xb6, 0x16, 0x71, 0x59, 0x6a, 0x7a, 0x6d, 0x23, 0x31, 0xd3,
    0x4e, 0x23, 0x92, 0xbf, 0x37, 0x18, 0x1f, 0x1f, 0xd0, 0xba, 0xbc, 0x17, 0xe6, 0xcc, 0x99, 0x49,
    0x5c, 0xa6, 0x4a, 0xcc, 0xe3, 0xd4, 0x9e, 0x70, 0x5e, 0x9b, 0x4a, 0x19, 0xac, 0x88, 0x11, 0xa7,
    0xdf, 0x78, 0x40, 0xa5, 0x3a, 0x0b, 0x4e, 0x98, 0x2c, 0x49, 0xd2, 0x9b, 0xc2, 0x94, 0x1a, 0x7c,
    0x40, 0x7b, 0x47, 0x67, 0xc7, 0x1d, 0xf4, 0x25, 0x9a, 0x8a, 0x2d, 0xdc, 0x83, 0xb8, 0xdc, 0x1b,
    0xed, 0x16, 0x3b, 0x32, 0x88, 0x88, 0x95, 0x9f, 0x16, 0xe9, 0x91, 0x75, 0x28, 0x3a, 0x59, 0xe3,
    0x06, 0x91, 0x66, 0x96, 0x95, 0xa9, 0x5e, 0xdd, 0x64, 0x94, 0xf4, 0x5c, 0x1f, 0x17, 0x52, 0xa2,
    0x09, 0x16, 0x03, 0xd0, 0x82, 0x74, 0xa0, 0xcd, 0x96, 0x3f, 0x5c, 0xa0, 0xf8, 0x53, 0xfa, 0xaf,
    0x60, 0x5c, 0x21, 0x07, 0x13, 0x0e, 0x4f, 0xfd, 0x08, 0xbf, 0x7f, 0xdb, 0x1f, 0x9b, 0xe7, 0x92,
    0x1a, 0x97, 0xe7, 0x1f, 0xb0, 0x75, 0x8d, 0xe7, 0xc6, 0x99, 0x4f, 0x43, 0xc0, 0x0d, 0xde, 0xe8,
    0xc8, 0xd6, 0x85, 0x15, 0x7d, 0x89, 0x5e, 0xf0, 0x4c, 0xa4, 0x87, 0x30, 0x43, 0xfb, 0x17, 0xb3,
    0x27, 0xe7, 0x3a, 0x45, 0xab
};
#endif

PyTypeObject *init_QWebEngineRegisterProtocolHandlerRequest(PyObject *module)
{
    if (SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX].type != nullptr)
        return SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX].type;

    Shiboken::AutoDecRef Sbk_QWebEngineRegisterProtocolHandlerRequest_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QWebEngineRegisterProtocolHandlerRequest_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QWebEngineRegisterProtocolHandlerRequest",
        "QWebEngineRegisterProtocolHandlerRequest",
        &Sbk_QWebEngineRegisterProtocolHandlerRequest_spec,
        &Shiboken::callCppDestructor< ::QWebEngineRegisterProtocolHandlerRequest >,
        Sbk_QWebEngineRegisterProtocolHandlerRequest_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF(); // references _Sbk_QWebEngineRegisterProtocolHandlerRequest_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QWebEngineRegisterProtocolHandlerRequest_SignatureStrings);
#else
    InitSignatureBytes(pyType, QWebEngineRegisterProtocolHandlerRequest_SignatureBytes, QWebEngineRegisterProtocolHandlerRequest_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QWebEngineRegisterProtocolHandlerRequest_PropertyStrings);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_PTR,
        is_QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_PTR_Convertible,
        QWebEngineRegisterProtocolHandlerRequest_PTR_CppToPython_QWebEngineRegisterProtocolHandlerRequest,
        QWebEngineRegisterProtocolHandlerRequest_COPY_CppToPython_QWebEngineRegisterProtocolHandlerRequest);

    Shiboken::Conversions::registerConverterName(converter, "QWebEngineRegisterProtocolHandlerRequest");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineRegisterProtocolHandlerRequest*");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineRegisterProtocolHandlerRequest&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QWebEngineRegisterProtocolHandlerRequest).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_COPY,
        is_QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_COPY_Convertible);

    qRegisterMetaType< ::QWebEngineRegisterProtocolHandlerRequest >("QWebEngineRegisterProtocolHandlerRequest");

    return pyType;
}
