// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebenginecore_python.h"

// main header
#include "qwebenginewebauthpinrequest_wrapper.h"

// Argument includes
#include <qobject.h>
#include <qobjectdefs.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QWebEngineWebAuthPinRequest_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QWebEngineWebAuthPinRequest >()))
        return -1;

    ::QWebEngineWebAuthPinRequest *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QWebEngineWebAuthPinRequest", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QWebEngineWebAuthPinRequest::QWebEngineWebAuthPinRequest()
    // 1: QWebEngineWebAuthPinRequest::QWebEngineWebAuthPinRequest(QWebEngineWebAuthPinRequest)
    if (numArgs == 0) {
        overloadId = 0; // QWebEngineWebAuthPinRequest()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthPinRequest_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QWebEngineWebAuthPinRequest(QWebEngineWebAuthPinRequest)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthPinRequest_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthPinRequest_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QWebEngineWebAuthPinRequest()
        {

            // QWebEngineWebAuthPinRequest()
            cptr = new ::QWebEngineWebAuthPinRequest();
            break;
        }
        case 1: // QWebEngineWebAuthPinRequest(const QWebEngineWebAuthPinRequest &QWebEngineWebAuthPinRequest)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QWebEngineWebAuthPinRequest cppArg0_local;
            ::QWebEngineWebAuthPinRequest *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QWebEngineWebAuthPinRequest(QWebEngineWebAuthPinRequest)
                cptr = new ::QWebEngineWebAuthPinRequest(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QWebEngineWebAuthPinRequest >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthPinRequest_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QWebEngineWebAuthPinRequest__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QWebEngineWebAuthPinRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthPinRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthPinRequest_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QWebEngineWebAuthPinRequest_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QWebEngineWebAuthPinRequest_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QWebEngineWebAuthPinRequest__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QWebEngineWebAuthPinRequest_get_reason(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineWebAuthPinRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthPinRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QWebEngineWebAuthUxRequest::PinEntryReason cppOut_local = cppSelf->reason;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthUxRequest_PinEntryReason_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QWebEngineWebAuthPinRequest_set_reason(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QWebEngineWebAuthPinRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthPinRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("reason");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthUxRequest_PinEntryReason_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("reason", "PinEntryReason");
        return -1;
    }

    auto cppOut_local = cppSelf->reason;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->reason = cppOut_local;

    return 0;
}

static PyObject *Sbk_QWebEngineWebAuthPinRequest_get_error(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineWebAuthPinRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthPinRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QWebEngineWebAuthUxRequest::PinEntryError cppOut_local = cppSelf->error;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthUxRequest_PinEntryError_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QWebEngineWebAuthPinRequest_set_error(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QWebEngineWebAuthPinRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthPinRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("error");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthUxRequest_PinEntryError_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("error", "PinEntryError");
        return -1;
    }

    auto cppOut_local = cppSelf->error;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->error = cppOut_local;

    return 0;
}

static PyObject *Sbk_QWebEngineWebAuthPinRequest_get_minPinLength(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineWebAuthPinRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthPinRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    qint32 cppOut_local = cppSelf->minPinLength;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qint32>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QWebEngineWebAuthPinRequest_set_minPinLength(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QWebEngineWebAuthPinRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthPinRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("minPinLength");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qint32>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("minPinLength", "qint32");
        return -1;
    }

    auto cppOut_local = cppSelf->minPinLength;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->minPinLength = cppOut_local;

    return 0;
}

static PyObject *Sbk_QWebEngineWebAuthPinRequest_get_remainingAttempts(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineWebAuthPinRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthPinRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->remainingAttempts;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QWebEngineWebAuthPinRequest_set_remainingAttempts(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QWebEngineWebAuthPinRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthPinRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("remainingAttempts");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("remainingAttempts", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->remainingAttempts;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->remainingAttempts = cppOut_local;

    return 0;
}

// Getters and Setters for QWebEngineWebAuthPinRequest
static PyGetSetDef Sbk_QWebEngineWebAuthPinRequest_getsetlist[] = {
    {const_cast<char *>("reason"), Sbk_QWebEngineWebAuthPinRequest_get_reason, Sbk_QWebEngineWebAuthPinRequest_set_reason, nullptr, nullptr},
    {const_cast<char *>("error"), Sbk_QWebEngineWebAuthPinRequest_get_error, Sbk_QWebEngineWebAuthPinRequest_set_error, nullptr, nullptr},
    {const_cast<char *>("minPinLength"), Sbk_QWebEngineWebAuthPinRequest_get_minPinLength, Sbk_QWebEngineWebAuthPinRequest_set_minPinLength, nullptr, nullptr},
    {const_cast<char *>("remainingAttempts"), Sbk_QWebEngineWebAuthPinRequest_get_remainingAttempts, Sbk_QWebEngineWebAuthPinRequest_set_remainingAttempts, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QWebEngineWebAuthPinRequest_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QWebEngineWebAuthPinRequest_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QWebEngineWebAuthPinRequest_Type = nullptr;
static PyTypeObject *Sbk_QWebEngineWebAuthPinRequest_TypeF(void)
{
    return _Sbk_QWebEngineWebAuthPinRequest_Type;
}

static PyType_Slot Sbk_QWebEngineWebAuthPinRequest_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QWebEngineWebAuthPinRequest_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QWebEngineWebAuthPinRequest_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QWebEngineWebAuthPinRequest_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QWebEngineWebAuthPinRequest_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QWebEngineWebAuthPinRequest_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QWebEngineWebAuthPinRequest_spec = {
    "2:PySide6.QtWebEngineCore.QWebEngineWebAuthPinRequest",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QWebEngineWebAuthPinRequest_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QWebEngineWebAuthPinRequest_PythonToCpp_QWebEngineWebAuthPinRequest_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QWebEngineWebAuthPinRequest_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QWebEngineWebAuthPinRequest_PythonToCpp_QWebEngineWebAuthPinRequest_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineWebAuthPinRequest_TypeF()))
        return QWebEngineWebAuthPinRequest_PythonToCpp_QWebEngineWebAuthPinRequest_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QWebEngineWebAuthPinRequest_PTR_CppToPython_QWebEngineWebAuthPinRequest(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QWebEngineWebAuthPinRequest_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QWebEngineWebAuthPinRequest_COPY_CppToPython_QWebEngineWebAuthPinRequest(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QWebEngineWebAuthPinRequest *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QWebEngineWebAuthPinRequest_TypeF(), new ::QWebEngineWebAuthPinRequest(*source), true, true);
}

// Python to C++ copy conversion.
static void QWebEngineWebAuthPinRequest_PythonToCpp_QWebEngineWebAuthPinRequest_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QWebEngineWebAuthPinRequest *>(cppOut) = *reinterpret_cast< ::QWebEngineWebAuthPinRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthPinRequest_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QWebEngineWebAuthPinRequest_PythonToCpp_QWebEngineWebAuthPinRequest_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineWebAuthPinRequest_TypeF()))
        return QWebEngineWebAuthPinRequest_PythonToCpp_QWebEngineWebAuthPinRequest_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QWebEngineWebAuthPinRequest_SignatureStrings[] = {
    "1:PySide6.QtWebEngineCore.QWebEngineWebAuthPinRequest(self)",
    "0:PySide6.QtWebEngineCore.QWebEngineWebAuthPinRequest(self,QWebEngineWebAuthPinRequest:PySide6.QtWebEngineCore.QWebEngineWebAuthPinRequest)",
    "PySide6.QtWebEngineCore.QWebEngineWebAuthPinRequest.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QWebEngineWebAuthPinRequest_SignatureByteSize = 97;
static constexpr uint8_t QWebEngineWebAuthPinRequest_SignatureBytes[97] = {
    0x78, 0xda, 0x33, 0xb4, 0x0a, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x09, 0x4f,
    0x4d, 0x72, 0xcd, 0x4b, 0xcf, 0xcc, 0x4b, 0x75, 0xce, 0x2f, 0x4a, 0xd5, 0x0b, 0x84, 0x73, 0x81,
    0x0c, 0xc7, 0xd2, 0x92, 0x8c, 0x80, 0xcc, 0xbc, 0xa0, 0xd4, 0xc2, 0xd2, 0xd4, 0xe2, 0x12, 0x8d,
    0xe2, 0xd4, 0x9c, 0x34, 0x4d, 0x2e, 0x03, 0xb2, 0xf5, 0xea, 0xe0, 0x51, 0x40, 0x8e, 0xa1, 0x9a,
    0x5c, 0x64, 0x68, 0xd2, 0x8b, 0x8f, 0x4f, 0xce, 0x2f, 0xa8, 0x8c, 0x8f, 0x87, 0x78, 0x47, 0xd7,
    0xae, 0xa4, 0xb2, 0x20, 0x33, 0x2f, 0x5d, 0x2f, 0x18, 0xc8, 0xe3, 0x02, 0x00, 0x10, 0x7e, 0x66,
    0x8f
};
#endif

PyTypeObject *init_QWebEngineWebAuthPinRequest(PyObject *module)
{
    if (SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthPinRequest_IDX].type != nullptr)
        return SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthPinRequest_IDX].type;

    Shiboken::AutoDecRef Sbk_QWebEngineWebAuthPinRequest_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QWebEngineWebAuthPinRequest_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QWebEngineWebAuthPinRequest",
        "QWebEngineWebAuthPinRequest",
        &Sbk_QWebEngineWebAuthPinRequest_spec,
        &Shiboken::callCppDestructor< ::QWebEngineWebAuthPinRequest >,
        Sbk_QWebEngineWebAuthPinRequest_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QWebEngineWebAuthPinRequest_TypeF(); // references _Sbk_QWebEngineWebAuthPinRequest_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QWebEngineWebAuthPinRequest_SignatureStrings);
#else
    InitSignatureBytes(pyType, QWebEngineWebAuthPinRequest_SignatureBytes, QWebEngineWebAuthPinRequest_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QWebEngineWebAuthPinRequest_PropertyStrings);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineWebAuthPinRequest_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QWebEngineWebAuthPinRequest_PythonToCpp_QWebEngineWebAuthPinRequest_PTR,
        is_QWebEngineWebAuthPinRequest_PythonToCpp_QWebEngineWebAuthPinRequest_PTR_Convertible,
        QWebEngineWebAuthPinRequest_PTR_CppToPython_QWebEngineWebAuthPinRequest,
        QWebEngineWebAuthPinRequest_COPY_CppToPython_QWebEngineWebAuthPinRequest);

    Shiboken::Conversions::registerConverterName(converter, "QWebEngineWebAuthPinRequest");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineWebAuthPinRequest*");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineWebAuthPinRequest&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QWebEngineWebAuthPinRequest).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QWebEngineWebAuthPinRequest_PythonToCpp_QWebEngineWebAuthPinRequest_COPY,
        is_QWebEngineWebAuthPinRequest_PythonToCpp_QWebEngineWebAuthPinRequest_COPY_Convertible);

    qRegisterMetaType< ::QWebEngineWebAuthPinRequest >("QWebEngineWebAuthPinRequest");

    return pyType;
}
