// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebenginequick_python.h"

// main header
#include "qtwebenginequick_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static PyObject *Sbk_QtWebEngineQuickFunc_initialize(PyObject *self)
{
    SBK_UNUSED(self)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // initialize()
        ::QtWebEngineQuick::initialize();
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}


static const char *Sbk_QtWebEngineQuick_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QtWebEngineQuick_methods[] = {
    {"initialize", reinterpret_cast<PyCFunction>(Sbk_QtWebEngineQuickFunc_initialize), METH_NOARGS|METH_STATIC, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QtWebEngineQuick_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QtWebEngineQuick_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QtWebEngineQuick_Type = nullptr;
static PyTypeObject *Sbk_QtWebEngineQuick_TypeF(void)
{
    return _Sbk_QtWebEngineQuick_Type;
}

static PyType_Slot Sbk_QtWebEngineQuick_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QtWebEngineQuick_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QtWebEngineQuick_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QtWebEngineQuick_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QtWebEngineQuick_spec = {
    "2:PySide6.QtWebEngineQuick.QtWebEngineQuick",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QtWebEngineQuick_slots
};

} //extern "C"

// Type conversion functions.

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QtWebEngineQuickQtWebEngineQuick_SignatureStrings[] = {
    "PySide6.QtWebEngineQuick.QtWebEngineQuick.initialize()",
    nullptr}; // Sentinel
#else
static constexpr size_t QtWebEngineQuickQtWebEngineQuick_SignatureByteSize = 47;
static constexpr uint8_t QtWebEngineQuickQtWebEngineQuick_SignatureBytes[47] = {
    0x78, 0xda, 0x0b, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x09, 0x4f, 0x4d, 0x72,
    0xcd, 0x4b, 0xcf, 0xcc, 0x4b, 0x0d, 0x2c, 0xcd, 0x4c, 0xce, 0xc6, 0x14, 0xc8, 0xcc, 0xcb, 0x2c,
    0xc9, 0x4c, 0xcc, 0xc9, 0xac, 0x4a, 0xd5, 0xd0, 0xe4, 0x02, 0x00, 0x37, 0x9f, 0x14, 0x08
};
#endif

PyTypeObject *init_QtWebEngineQuickQtWebEngineQuick(PyObject *module)
{
    if (SbkPySide6_QtWebEngineQuickTypeStructs[SBK_QtWebEngineQuickQtWebEngineQuick_IDX].type != nullptr)
        return SbkPySide6_QtWebEngineQuickTypeStructs[SBK_QtWebEngineQuickQtWebEngineQuick_IDX].type;

    Shiboken::AutoDecRef Sbk_QtWebEngineQuick_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QtWebEngineQuick_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QtWebEngineQuick",
        "QtWebEngineQuick",
        &Sbk_QtWebEngineQuick_spec,
        nullptr,
        Sbk_QtWebEngineQuick_Type_bases.object(),
        0);
    auto *pyType = Sbk_QtWebEngineQuick_TypeF(); // references _Sbk_QtWebEngineQuick_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QtWebEngineQuickQtWebEngineQuick_SignatureStrings);
#else
    InitSignatureBytes(pyType, QtWebEngineQuickQtWebEngineQuick_SignatureBytes, QtWebEngineQuickQtWebEngineQuick_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QtWebEngineQuick_PropertyStrings);
    SbkPySide6_QtWebEngineQuickTypeStructs[SBK_QtWebEngineQuickQtWebEngineQuick_IDX].type = pyType;



    return pyType;
}
