// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QApplicationWrapper_H
#define SBK_QApplicationWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qapplication.h>

namespace PySide { class DynamicQMetaObject; }

class QApplicationWrapper : public QApplication
{
public:
    QApplicationWrapper(const QApplicationWrapper &) = delete;
    QApplicationWrapper& operator=(const QApplicationWrapper &) = delete;
    QApplicationWrapper(QApplicationWrapper &&) = delete;
    QApplicationWrapper& operator=(QApplicationWrapper &&) = delete;

    QApplicationWrapper(int & argc, char ** argv, int arg__3 = QCoreApplication::ApplicationFlags);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * arg__1) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool notify(::QObject * arg__1, ::QEvent * arg__2) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QApplicationWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_QApplicationWrapper_H

