// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QCompleterWrapper_H
#define SBK_QCompleterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qcompleter.h>

namespace PySide { class DynamicQMetaObject; }

class QCompleterWrapper : public QCompleter
{
public:
    QCompleterWrapper(const QCompleterWrapper &) = delete;
    QCompleterWrapper& operator=(const QCompleterWrapper &) = delete;
    QCompleterWrapper(QCompleterWrapper &&) = delete;
    QCompleterWrapper& operator=(QCompleterWrapper &&) = delete;

    QCompleterWrapper(::QAbstractItemModel * model, ::QObject * parent = nullptr);
    QCompleterWrapper(::QObject * parent = nullptr);
    QCompleterWrapper(const ::QStringList & completions, ::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * arg__1) override;
    bool eventFilter(::QObject * o, ::QEvent * e) override;
    ::QString pathFromIndex(const ::QModelIndex & index) const override;
    ::QStringList splitPath(const ::QString & path) const override;
    void timerEvent(::QTimerEvent * event) override;
    ~QCompleterWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9] = {false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QCompleterWrapper_H

