// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGestureRecognizerWrapper_H
#define SBK_QGestureRecognizerWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgesturerecognizer.h>

class QGestureRecognizerWrapper : public QGestureRecognizer
{
public:
    QGestureRecognizerWrapper(const QGestureRecognizerWrapper &) = delete;
    QGestureRecognizerWrapper& operator=(const QGestureRecognizerWrapper &) = delete;
    QGestureRecognizerWrapper(QGestureRecognizerWrapper &&) = delete;
    QGestureRecognizerWrapper& operator=(QGestureRecognizerWrapper &&) = delete;

    QGestureRecognizerWrapper();
    ::QGesture * create(::QObject * target) override;
    ::QFlags<QGestureRecognizer::ResultFlag> recognize(::QGesture * state, ::QObject * watched, ::QEvent * event) override;
    void reset(::QGesture * state) override;
    ~QGestureRecognizerWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QGestureRecognizerWrapper_H

