// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGraphicsDropShadowEffectWrapper_H
#define SBK_QGraphicsDropShadowEffectWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicseffect.h>

namespace PySide { class DynamicQMetaObject; }

class QGraphicsDropShadowEffectWrapper : public QGraphicsDropShadowEffect
{
public:
    QGraphicsDropShadowEffectWrapper(const QGraphicsDropShadowEffectWrapper &) = delete;
    QGraphicsDropShadowEffectWrapper& operator=(const QGraphicsDropShadowEffectWrapper &) = delete;
    QGraphicsDropShadowEffectWrapper(QGraphicsDropShadowEffectWrapper &&) = delete;
    QGraphicsDropShadowEffectWrapper& operator=(QGraphicsDropShadowEffectWrapper &&) = delete;

    QGraphicsDropShadowEffectWrapper(::QObject * parent = nullptr);
    ::QRectF boundingRectFor(const ::QRectF & rect) const override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    void draw(::QPainter * painter) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void sourceChanged(::QFlags<QGraphicsEffect::ChangeFlag> flags) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QGraphicsDropShadowEffectWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[10] = {false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QGraphicsDropShadowEffectWrapper_H

