// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGraphicsLayoutWrapper_H
#define SBK_QGraphicsLayoutWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicslayout.h>

class QGraphicsLayoutWrapper : public QGraphicsLayout
{
public:
    QGraphicsLayoutWrapper(const QGraphicsLayoutWrapper &) = delete;
    QGraphicsLayoutWrapper& operator=(const QGraphicsLayoutWrapper &) = delete;
    QGraphicsLayoutWrapper(QGraphicsLayoutWrapper &&) = delete;
    QGraphicsLayoutWrapper& operator=(QGraphicsLayoutWrapper &&) = delete;

    QGraphicsLayoutWrapper(::QGraphicsLayoutItem * parent = nullptr);
    int count() const override;
    void getContentsMargins(qreal * left, qreal * top, qreal * right, qreal * bottom) const override;
    void invalidate() override;
    bool isEmpty() const override;
    ::QGraphicsLayoutItem * itemAt(int i) const override;
    void removeAt(int index) override;
    void setGeometry(const ::QRectF & rect) override;
    ::QSizeF sizeHint(::Qt::SizeHint which, const ::QSizeF & constraint = QSizeF()) const override;
    void updateGeometry() override;
    void widgetEvent(::QEvent * e) override;
    ~QGraphicsLayoutWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[10] = {false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QGraphicsLayoutWrapper_H

