// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGraphicsLayoutItemWrapper_H
#define SBK_QGraphicsLayoutItemWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicslayoutitem.h>

class QGraphicsLayoutItemWrapper : public QGraphicsLayoutItem
{
public:
    QGraphicsLayoutItemWrapper(const QGraphicsLayoutItemWrapper &) = delete;
    QGraphicsLayoutItemWrapper& operator=(const QGraphicsLayoutItemWrapper &) = delete;
    QGraphicsLayoutItemWrapper(QGraphicsLayoutItemWrapper &&) = delete;
    QGraphicsLayoutItemWrapper& operator=(QGraphicsLayoutItemWrapper &&) = delete;

    QGraphicsLayoutItemWrapper(::QGraphicsLayoutItem * parent = nullptr, bool isLayout = false);
    void getContentsMargins(qreal * left, qreal * top, qreal * right, qreal * bottom) const override;
    bool isEmpty() const override;
    void setGeometry(const ::QRectF & rect) override;
    ::QSizeF sizeHint(::Qt::SizeHint which, const ::QSizeF & constraint = QSizeF()) const override;
    void updateGeometry() override;
    ~QGraphicsLayoutItemWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[5] = {false, false, false, false, false};
};

#endif // SBK_QGraphicsLayoutItemWrapper_H

