// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGraphicsSceneWrapper_H
#define SBK_QGraphicsSceneWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicsscene.h>

namespace PySide { class DynamicQMetaObject; }

class QGraphicsSceneWrapper : public QGraphicsScene
{
public:
    QGraphicsSceneWrapper(const QGraphicsSceneWrapper &) = delete;
    QGraphicsSceneWrapper& operator=(const QGraphicsSceneWrapper &) = delete;
    QGraphicsSceneWrapper(QGraphicsSceneWrapper &&) = delete;
    QGraphicsSceneWrapper& operator=(QGraphicsSceneWrapper &&) = delete;

    QGraphicsSceneWrapper(::QObject * parent = nullptr);
    QGraphicsSceneWrapper(const ::QRectF & sceneRect, ::QObject * parent = nullptr);
    QGraphicsSceneWrapper(qreal x, qreal y, qreal width, qreal height, ::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void contextMenuEvent(::QGraphicsSceneContextMenuEvent * event) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    void dragEnterEvent(::QGraphicsSceneDragDropEvent * event) override;
    void dragLeaveEvent(::QGraphicsSceneDragDropEvent * event) override;
    void dragMoveEvent(::QGraphicsSceneDragDropEvent * event) override;
    void drawBackground(::QPainter * painter, const ::QRectF & rect) override;
    void drawForeground(::QPainter * painter, const ::QRectF & rect) override;
    void dropEvent(::QGraphicsSceneDragDropEvent * event) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void focusInEvent(::QFocusEvent * event) override;
    bool focusNextPrevChild(bool next) override;
    void focusOutEvent(::QFocusEvent * event) override;
    void helpEvent(::QGraphicsSceneHelpEvent * event) override;
    void inputMethodEvent(::QInputMethodEvent * event) override;
    ::QVariant inputMethodQuery(::Qt::InputMethodQuery query) const override;
    void keyPressEvent(::QKeyEvent * event) override;
    void keyReleaseEvent(::QKeyEvent * event) override;
    void mouseDoubleClickEvent(::QGraphicsSceneMouseEvent * event) override;
    void mouseMoveEvent(::QGraphicsSceneMouseEvent * event) override;
    void mousePressEvent(::QGraphicsSceneMouseEvent * event) override;
    void mouseReleaseEvent(::QGraphicsSceneMouseEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    void wheelEvent(::QGraphicsSceneWheelEvent * event) override;
    ~QGraphicsSceneWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[27] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QGraphicsSceneWrapper_H

