// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGraphicsSceneEventWrapper_H
#define SBK_QGraphicsSceneEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicssceneevent.h>

class QGraphicsSceneEventWrapper : public QGraphicsSceneEvent
{
public:
    QGraphicsSceneEventWrapper(const QGraphicsSceneEventWrapper &) = delete;
    QGraphicsSceneEventWrapper& operator=(const QGraphicsSceneEventWrapper &) = delete;
    QGraphicsSceneEventWrapper(QGraphicsSceneEventWrapper &&) = delete;
    QGraphicsSceneEventWrapper& operator=(QGraphicsSceneEventWrapper &&) = delete;

    QGraphicsSceneEventWrapper(::QEvent::Type type);
    ::QEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QGraphicsSceneEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QGraphicsSceneEventWrapper_H

