// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGraphicsSceneMouseEventWrapper_H
#define SBK_QGraphicsSceneMouseEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicssceneevent.h>

class QGraphicsSceneMouseEventWrapper : public QGraphicsSceneMouseEvent
{
public:
    QGraphicsSceneMouseEventWrapper(const QGraphicsSceneMouseEventWrapper &) = delete;
    QGraphicsSceneMouseEventWrapper& operator=(const QGraphicsSceneMouseEventWrapper &) = delete;
    QGraphicsSceneMouseEventWrapper(QGraphicsSceneMouseEventWrapper &&) = delete;
    QGraphicsSceneMouseEventWrapper& operator=(QGraphicsSceneMouseEventWrapper &&) = delete;

    QGraphicsSceneMouseEventWrapper(::QEvent::Type type = QEvent::Type::None);
    ::QEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QGraphicsSceneMouseEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QGraphicsSceneMouseEventWrapper_H

