// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGraphicsSceneMoveEventWrapper_H
#define SBK_QGraphicsSceneMoveEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicssceneevent.h>

class QGraphicsSceneMoveEventWrapper : public QGraphicsSceneMoveEvent
{
public:
    QGraphicsSceneMoveEventWrapper(const QGraphicsSceneMoveEventWrapper &) = delete;
    QGraphicsSceneMoveEventWrapper& operator=(const QGraphicsSceneMoveEventWrapper &) = delete;
    QGraphicsSceneMoveEventWrapper(QGraphicsSceneMoveEventWrapper &&) = delete;
    QGraphicsSceneMoveEventWrapper& operator=(QGraphicsSceneMoveEventWrapper &&) = delete;

    QGraphicsSceneMoveEventWrapper();
    ::QEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QGraphicsSceneMoveEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QGraphicsSceneMoveEventWrapper_H

