// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGridLayoutWrapper_H
#define SBK_QGridLayoutWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgridlayout.h>

namespace PySide { class DynamicQMetaObject; }

class QGridLayoutWrapper : public QGridLayout
{
public:
    QGridLayoutWrapper(const QGridLayoutWrapper &) = delete;
    QGridLayoutWrapper& operator=(const QGridLayoutWrapper &) = delete;
    QGridLayoutWrapper(QGridLayoutWrapper &&) = delete;
    QGridLayoutWrapper& operator=(QGridLayoutWrapper &&) = delete;

    QGridLayoutWrapper(::QWidget * parent = nullptr);
    void addItem(::QLayoutItem * arg__1) override;
    void childEvent(::QChildEvent * e) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QFlags<QSizePolicy::ControlType> controlTypes() const override;
    int count() const override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QFlags<Qt::Orientation> expandingDirections() const override;
    ::QRect geometry() const override;
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    int indexOf(const ::QLayoutItem * arg__1) const override;
    int indexOf(const ::QWidget * arg__1) const override;
    void invalidate() override;
    bool isEmpty() const override;
    ::QLayoutItem * itemAt(int index) const override;
    ::QLayout * layout() override;
    ::QSize maximumSize() const override;
    int minimumHeightForWidth(int arg__1) const override;
    ::QSize minimumSize() const override;
    ::QLayoutItem * replaceWidget(::QWidget * from, ::QWidget * to, ::QFlags<Qt::FindChildOption> options = Qt::FindChildrenRecursively) override;
    void setGeometry(const ::QRect & arg__1) override;
    void setSpacing(int spacing) override;
    ::QSize sizeHint() const override;
    ::QSpacerItem * spacerItem() override;
    int spacing() const override;
    ::QLayoutItem * takeAt(int index) override;
    void timerEvent(::QTimerEvent * event) override;
    ::QWidget * widget() const override;
    ~QGridLayoutWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    // Inherited overloads, because the using keyword sux
    void addItem(::QLayoutItem * item, int row, int column, int rowSpan = 1, int columnSpan = 1, ::QFlags<Qt::AlignmentFlag> alignment = Qt::Alignment()) { QGridLayout::addItem(item, row, column, rowSpan, columnSpan, QFlags<Qt::AlignmentFlag>(alignment)); }
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[31] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QGridLayoutWrapper_H

