// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QItemDelegateWrapper_H
#define SBK_QItemDelegateWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qitemdelegate.h>

namespace PySide { class DynamicQMetaObject; }

class QItemDelegateWrapper : public QItemDelegate
{
public:
    QItemDelegateWrapper(const QItemDelegateWrapper &) = delete;
    QItemDelegateWrapper& operator=(const QItemDelegateWrapper &) = delete;
    QItemDelegateWrapper(QItemDelegateWrapper &&) = delete;
    QItemDelegateWrapper& operator=(QItemDelegateWrapper &&) = delete;

    QItemDelegateWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QWidget * createEditor(::QWidget * parent, const ::QStyleOptionViewItem & option, const ::QModelIndex & index) const override;
    void customEvent(::QEvent * event) override;
    void destroyEditor(::QWidget * editor, const ::QModelIndex & index) const override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    void drawCheck(::QPainter * painter, const ::QStyleOptionViewItem & option, const ::QRect & rect, ::Qt::CheckState state) const override;
    void drawDecoration(::QPainter * painter, const ::QStyleOptionViewItem & option, const ::QRect & rect, const ::QPixmap & pixmap) const override;
    void drawDisplay(::QPainter * painter, const ::QStyleOptionViewItem & option, const ::QRect & rect, const ::QString & text) const override;
    void drawFocus(::QPainter * painter, const ::QStyleOptionViewItem & option, const ::QRect & rect) const override;
    bool editorEvent(::QEvent * event, ::QAbstractItemModel * model, const ::QStyleOptionViewItem & option, const ::QModelIndex & index) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * object, ::QEvent * event) override;
    bool helpEvent(::QHelpEvent * event, ::QAbstractItemView * view, const ::QStyleOptionViewItem & option, const ::QModelIndex & index) override;
    void paint(::QPainter * painter, const ::QStyleOptionViewItem & option, const ::QModelIndex & index) const override;
    ::QList<int> paintingRoles() const override;
    void setEditorData(::QWidget * editor, const ::QModelIndex & index) const override;
    void setModelData(::QWidget * editor, ::QAbstractItemModel * model, const ::QModelIndex & index) const override;
    ::QSize sizeHint(const ::QStyleOptionViewItem & option, const ::QModelIndex & index) const override;
    void timerEvent(::QTimerEvent * event) override;
    void updateEditorGeometry(::QWidget * editor, const ::QStyleOptionViewItem & option, const ::QModelIndex & index) const override;
    ~QItemDelegateWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[21] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QItemDelegateWrapper_H

