// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QItemEditorFactoryWrapper_H
#define SBK_QItemEditorFactoryWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qitemeditorfactory.h>

class QItemEditorFactoryWrapper : public QItemEditorFactory
{
public:
    QItemEditorFactoryWrapper(const QItemEditorFactoryWrapper &) = delete;
    QItemEditorFactoryWrapper& operator=(const QItemEditorFactoryWrapper &) = delete;
    QItemEditorFactoryWrapper(QItemEditorFactoryWrapper &&) = delete;
    QItemEditorFactoryWrapper& operator=(QItemEditorFactoryWrapper &&) = delete;

    QItemEditorFactoryWrapper();
    ::QWidget * createEditor(int userType, ::QWidget * parent) const override;
    ::QByteArray valuePropertyName(int userType) const override;
    ~QItemEditorFactoryWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QItemEditorFactoryWrapper_H

