// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPlainTextDocumentLayoutWrapper_H
#define SBK_QPlainTextDocumentLayoutWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qplaintextedit.h>

namespace PySide { class DynamicQMetaObject; }

class QPlainTextDocumentLayoutWrapper : public QPlainTextDocumentLayout
{
public:
    QPlainTextDocumentLayoutWrapper(const QPlainTextDocumentLayoutWrapper &) = delete;
    QPlainTextDocumentLayoutWrapper& operator=(const QPlainTextDocumentLayoutWrapper &) = delete;
    QPlainTextDocumentLayoutWrapper(QPlainTextDocumentLayoutWrapper &&) = delete;
    QPlainTextDocumentLayoutWrapper& operator=(QPlainTextDocumentLayoutWrapper &&) = delete;

    QPlainTextDocumentLayoutWrapper(::QTextDocument * document);
    ::QRectF blockBoundingRect(const ::QTextBlock & block) const override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    void documentChanged(int from, int arg__2, int charsAdded) override;
    ::QSizeF documentSize() const override;
    void draw(::QPainter * arg__1, const ::QAbstractTextDocumentLayout::PaintContext & arg__2) override;
    void drawInlineObject(::QPainter * painter, const ::QRectF & rect, ::QTextInlineObject object, int posInDocument, const ::QTextFormat & format) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QRectF frameBoundingRect(::QTextFrame * arg__1) const override;
    int hitTest(const ::QPointF & arg__1, ::Qt::HitTestAccuracy arg__2) const override;
    int pageCount() const override;
    void positionInlineObject(::QTextInlineObject item, int posInDocument, const ::QTextFormat & format) override;
    void resizeInlineObject(::QTextInlineObject item, int posInDocument, const ::QTextFormat & format) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QPlainTextDocumentLayoutWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[17] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QPlainTextDocumentLayoutWrapper_H

