// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwidgets_python.h"

// main header
#include "qstylehintreturnvariant_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleHintReturnVariant_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(args)
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QStyleHintReturnVariant >()))
        return -1;

    ::QStyleHintReturnVariant *cptr{};
    Shiboken::PythonContextMarker pcm;


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnVariant_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {

        // QStyleHintReturnVariant()
        cptr = new ::QStyleHintReturnVariant();
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QStyleHintReturnVariant >(), cptr)) {
        delete cptr;
        return -1;
    }
    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}


static const char *Sbk_QStyleHintReturnVariant_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QStyleHintReturnVariant_EnumFlagInfo[] = {
    "StyleOptionType:Enum",
    "StyleOptionVersion:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QStyleHintReturnVariant_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QStyleHintReturnVariant_get_variant(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleHintReturnVariant *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnVariant_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], &cppSelf->variant);
    return pyOut;
}
static int Sbk_QStyleHintReturnVariant_set_variant(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleHintReturnVariant *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnVariant_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("variant");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QVariant_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("variant", "QVariant");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->variant;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for QStyleHintReturnVariant
static PyGetSetDef Sbk_QStyleHintReturnVariant_getsetlist[] = {
    {const_cast<char *>("variant"), Sbk_QStyleHintReturnVariant_get_variant, Sbk_QStyleHintReturnVariant_set_variant, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QStyleHintReturnVariant_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QStyleHintReturnVariant_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QStyleHintReturnVariant_Type = nullptr;
static PyTypeObject *Sbk_QStyleHintReturnVariant_TypeF(void)
{
    return _Sbk_QStyleHintReturnVariant_Type;
}

static PyType_Slot Sbk_QStyleHintReturnVariant_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QStyleHintReturnVariant_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QStyleHintReturnVariant_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QStyleHintReturnVariant_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QStyleHintReturnVariant_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QStyleHintReturnVariant_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QStyleHintReturnVariant_spec = {
    "2:PySide6.QtWidgets.QStyleHintReturnVariant",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QStyleHintReturnVariant_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QStyleHintReturnVariant_StyleOptionType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleHintReturnVariant::StyleOptionType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleHintReturnVariant::StyleOptionType *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QStyleHintReturnVariant_StyleOptionType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnVariant_StyleOptionType_IDX])))
        return Enum_PythonToCpp_QStyleHintReturnVariant_StyleOptionType;
    return {};
}

static PyObject *QStyleHintReturnVariant_StyleOptionType_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QStyleHintReturnVariant::StyleOptionType>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QStyleHintReturnVariant::StyleOptionType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnVariant_StyleOptionType_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QStyleHintReturnVariant_StyleOptionVersion(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleHintReturnVariant::StyleOptionVersion>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleHintReturnVariant::StyleOptionVersion *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QStyleHintReturnVariant_StyleOptionVersion_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnVariant_StyleOptionVersion_IDX])))
        return Enum_PythonToCpp_QStyleHintReturnVariant_StyleOptionVersion;
    return {};
}

static PyObject *QStyleHintReturnVariant_StyleOptionVersion_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QStyleHintReturnVariant::StyleOptionVersion>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QStyleHintReturnVariant::StyleOptionVersion *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnVariant_StyleOptionVersion_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QStyleHintReturnVariant_PythonToCpp_QStyleHintReturnVariant_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QStyleHintReturnVariant_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QStyleHintReturnVariant_PythonToCpp_QStyleHintReturnVariant_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QStyleHintReturnVariant_TypeF()))
        return QStyleHintReturnVariant_PythonToCpp_QStyleHintReturnVariant_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QStyleHintReturnVariant_PTR_CppToPython_QStyleHintReturnVariant(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QStyleHintReturnVariant_TypeF(), const_cast<void *>(cppIn), false);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QStyleHintReturnVariant_SignatureStrings[] = {
    "PySide6.QtWidgets.QStyleHintReturnVariant(self)",
    nullptr}; // Sentinel
#else
static constexpr size_t QStyleHintReturnVariant_SignatureByteSize = 56;
static constexpr uint8_t QStyleHintReturnVariant_SignatureBytes[56] = {
    0x78, 0xda, 0x0b, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x09, 0xcf, 0x4c, 0x49,
    0x4f, 0x2d, 0x29, 0xd6, 0x0b, 0x0c, 0x2e, 0xa9, 0xcc, 0x49, 0xf5, 0xc8, 0xcc, 0x2b, 0x09, 0x4a,
    0x2d, 0x29, 0x2d, 0xca, 0x0b, 0x4b, 0x2c, 0xca, 0x4c, 0xcc, 0x2b, 0xd1, 0x28, 0x4e, 0xcd, 0x49,
    0xd3, 0xe4, 0x02, 0x00, 0xb7, 0x95, 0x11, 0xcc
};
#endif

PyTypeObject *init_QStyleHintReturnVariant(PyObject *module)
{
    if (SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnVariant_IDX].type != nullptr)
        return SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnVariant_IDX].type;

    Shiboken::AutoDecRef Sbk_QStyleHintReturnVariant_Type_bases(PyTuple_Pack(1,
        reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturn_IDX]))));

    _Sbk_QStyleHintReturnVariant_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QStyleHintReturnVariant",
        "QStyleHintReturnVariant*",
        &Sbk_QStyleHintReturnVariant_spec,
        &Shiboken::callCppDestructor< ::QStyleHintReturnVariant >,
        Sbk_QStyleHintReturnVariant_Type_bases.object(),
        0);
    auto *pyType = Sbk_QStyleHintReturnVariant_TypeF(); // references _Sbk_QStyleHintReturnVariant_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QStyleHintReturnVariant_SignatureStrings);
#else
    InitSignatureBytes(pyType, QStyleHintReturnVariant_SignatureBytes, QStyleHintReturnVariant_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QStyleHintReturnVariant_PropertyStrings);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnVariant_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QStyleHintReturnVariant_PythonToCpp_QStyleHintReturnVariant_PTR,
        is_QStyleHintReturnVariant_PythonToCpp_QStyleHintReturnVariant_PTR_Convertible,
        QStyleHintReturnVariant_PTR_CppToPython_QStyleHintReturnVariant);

    Shiboken::Conversions::registerConverterName(converter, "QStyleHintReturnVariant");
    Shiboken::Conversions::registerConverterName(converter, "QStyleHintReturnVariant*");
    Shiboken::Conversions::registerConverterName(converter, "QStyleHintReturnVariant&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QStyleHintReturnVariant).name());

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QStyleHintReturnVariant_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'StyleOptionType'.
    const char *StyleOptionType_Initializer[] = {
        "Type",
        nullptr};
    // "uint16_t" used instead of "unsigned int"
    constexpr uint16_t StyleOptionType_InitializerValues[] = {
        uint16_t(QStyleHintReturnVariant::StyleOptionType::Type) //  0xf002  61442
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleHintReturnVariant_TypeF(),
        "2:PySide6.QtWidgets.QStyleHintReturnVariant.StyleOptionType",
        StyleOptionType_Initializer, StyleOptionType_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnVariant_StyleOptionType_IDX].type = EType;
    // Register converter for enum 'QStyleHintReturnVariant::StyleOptionType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleHintReturnVariant_StyleOptionType_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QStyleHintReturnVariant_StyleOptionType,
            is_Enum_PythonToCpp_QStyleHintReturnVariant_StyleOptionType_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QStyleHintReturnVariant::StyleOptionType");
        Shiboken::Conversions::registerConverterAlias(converter, "StyleOptionType");
        Shiboken::Enum::setTypeConverter(EType, converter, nullptr);
    }
    // End of 'StyleOptionType' enum.

    // Initialization of enum 'StyleOptionVersion'.
    const char *StyleOptionVersion_Initializer[] = {
        "Version",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t StyleOptionVersion_InitializerValues[] = {
        uint8_t(QStyleHintReturnVariant::StyleOptionVersion::Version) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleHintReturnVariant_TypeF(),
        "2:PySide6.QtWidgets.QStyleHintReturnVariant.StyleOptionVersion",
        StyleOptionVersion_Initializer, StyleOptionVersion_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleHintReturnVariant_StyleOptionVersion_IDX].type = EType;
    // Register converter for enum 'QStyleHintReturnVariant::StyleOptionVersion'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleHintReturnVariant_StyleOptionVersion_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QStyleHintReturnVariant_StyleOptionVersion,
            is_Enum_PythonToCpp_QStyleHintReturnVariant_StyleOptionVersion_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QStyleHintReturnVariant::StyleOptionVersion");
        Shiboken::Conversions::registerConverterAlias(converter, "StyleOptionVersion");
        Shiboken::Enum::setTypeConverter(EType, converter, nullptr);
    }
    // End of 'StyleOptionVersion' enum.

    qRegisterMetaType< ::QStyleHintReturnVariant *>();
    qRegisterMetaType< ::QStyleHintReturnVariant::StyleOptionType >("QStyleHintReturnVariant::StyleOptionType");
    qRegisterMetaType< ::QStyleHintReturnVariant::StyleOptionVersion >("QStyleHintReturnVariant::StyleOptionVersion");

    return pyType;
}
