// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwidgets_python.h"

// main header
#include "qstyleoptionsizegrip_wrapper.h"

// Argument includes
#include <QtWidgets/qstyleoption.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleOptionSizeGrip_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QStyleOptionSizeGrip >()))
        return -1;

    ::QStyleOptionSizeGrip *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QStyleOptionSizeGrip", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QStyleOptionSizeGrip::QStyleOptionSizeGrip()
    // 1: QStyleOptionSizeGrip::QStyleOptionSizeGrip(QStyleOptionSizeGrip)
    // 2: QStyleOptionSizeGrip::QStyleOptionSizeGrip(int)
    if (numArgs == 0) {
        overloadId = 0; // QStyleOptionSizeGrip()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        overloadId = 2; // QStyleOptionSizeGrip(int)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionSizeGrip_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QStyleOptionSizeGrip(QStyleOptionSizeGrip)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionSizeGrip_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionSizeGrip_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QStyleOptionSizeGrip()
        {

            // QStyleOptionSizeGrip()
            cptr = new ::QStyleOptionSizeGrip();
            break;
        }
        case 1: // QStyleOptionSizeGrip(const QStyleOptionSizeGrip &other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QStyleOptionSizeGrip *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionSizeGrip(QStyleOptionSizeGrip)
                cptr = new ::QStyleOptionSizeGrip(*cppArg0);
            }
            break;
        }
        case 2: // QStyleOptionSizeGrip(int version)
        {
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionSizeGrip(int)
                cptr = new ::QStyleOptionSizeGrip(cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QStyleOptionSizeGrip >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionSizeGrip_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}


static const char *Sbk_QStyleOptionSizeGrip_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QStyleOptionSizeGrip_EnumFlagInfo[] = {
    "StyleOptionType:Enum",
    "StyleOptionVersion:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QStyleOptionSizeGrip_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QStyleOptionSizeGrip_get_corner(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionSizeGrip *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionSizeGrip_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::Qt::Corner cppOut_local = cppSelf->corner;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_Qt_Corner_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionSizeGrip_set_corner(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionSizeGrip *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionSizeGrip_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("corner");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_Qt_Corner_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("corner", "Corner");
        return -1;
    }

    auto cppOut_local = cppSelf->corner;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->corner = cppOut_local;

    return 0;
}

// Getters and Setters for QStyleOptionSizeGrip
static PyGetSetDef Sbk_QStyleOptionSizeGrip_getsetlist[] = {
    {const_cast<char *>("corner"), Sbk_QStyleOptionSizeGrip_get_corner, Sbk_QStyleOptionSizeGrip_set_corner, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QStyleOptionSizeGrip_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QStyleOptionSizeGrip_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QStyleOptionSizeGrip_Type = nullptr;
static PyTypeObject *Sbk_QStyleOptionSizeGrip_TypeF(void)
{
    return _Sbk_QStyleOptionSizeGrip_Type;
}

static PyType_Slot Sbk_QStyleOptionSizeGrip_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QStyleOptionSizeGrip_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QStyleOptionSizeGrip_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QStyleOptionSizeGrip_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QStyleOptionSizeGrip_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QStyleOptionSizeGrip_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QStyleOptionSizeGrip_spec = {
    "2:PySide6.QtWidgets.QStyleOptionSizeGrip",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QStyleOptionSizeGrip_slots
};

} //extern "C"

static void *Sbk_QStyleOptionSizeGrip_typeDiscovery(void *cptr, PyTypeObject *instanceType)
{
    SBK_UNUSED(cptr)
    SBK_UNUSED(instanceType)
    if (qstyleoption_cast<const QStyleOptionSizeGrip *>( reinterpret_cast< ::QStyleOption *>(cptr)) != nullptr)
        return cptr;
    return {};
}


// Type conversion functions.

// Python to C++ enum conversion.
static void Enum_PythonToCpp_QStyleOptionSizeGrip_StyleOptionType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionSizeGrip::StyleOptionType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionSizeGrip::StyleOptionType *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QStyleOptionSizeGrip_StyleOptionType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionSizeGrip_StyleOptionType_IDX])))
        return Enum_PythonToCpp_QStyleOptionSizeGrip_StyleOptionType;
    return {};
}

static PyObject *QStyleOptionSizeGrip_StyleOptionType_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QStyleOptionSizeGrip::StyleOptionType>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QStyleOptionSizeGrip::StyleOptionType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionSizeGrip_StyleOptionType_IDX]), castCppIn);

}

static void Enum_PythonToCpp_QStyleOptionSizeGrip_StyleOptionVersion(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionSizeGrip::StyleOptionVersion>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionSizeGrip::StyleOptionVersion *>(cppOut) = value;

}
static PythonToCppFunc is_Enum_PythonToCpp_QStyleOptionSizeGrip_StyleOptionVersion_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionSizeGrip_StyleOptionVersion_IDX])))
        return Enum_PythonToCpp_QStyleOptionSizeGrip_StyleOptionVersion;
    return {};
}

static PyObject *QStyleOptionSizeGrip_StyleOptionVersion_CppToPython_Enum(const void *cppIn)
{
    using IntType = std::underlying_type_t<::QStyleOptionSizeGrip::StyleOptionVersion>;
    const auto castCppIn = IntType(*reinterpret_cast<const ::QStyleOptionSizeGrip::StyleOptionVersion *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionSizeGrip_StyleOptionVersion_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QStyleOptionSizeGrip_PythonToCpp_QStyleOptionSizeGrip_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QStyleOptionSizeGrip_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QStyleOptionSizeGrip_PythonToCpp_QStyleOptionSizeGrip_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QStyleOptionSizeGrip_TypeF()))
        return QStyleOptionSizeGrip_PythonToCpp_QStyleOptionSizeGrip_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QStyleOptionSizeGrip_PTR_CppToPython_QStyleOptionSizeGrip(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QStyleOptionSizeGrip_TypeF(), const_cast<void *>(cppIn), false);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QStyleOptionSizeGrip_SignatureStrings[] = {
    "2:PySide6.QtWidgets.QStyleOptionSizeGrip(self)",
    "1:PySide6.QtWidgets.QStyleOptionSizeGrip(self,other:PySide6.QtWidgets.QStyleOptionSizeGrip)",
    "0:PySide6.QtWidgets.QStyleOptionSizeGrip(self,version:int)",
    nullptr}; // Sentinel
#else
static constexpr size_t QStyleOptionSizeGrip_SignatureByteSize = 84;
static constexpr uint8_t QStyleOptionSizeGrip_SignatureBytes[84] = {
    0x78, 0xda, 0x33, 0xb2, 0x0a, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x09, 0xcf,
    0x4c, 0x49, 0x4f, 0x2d, 0x29, 0xd6, 0x0b, 0x0c, 0x2e, 0xa9, 0xcc, 0x49, 0xf5, 0x2f, 0x28, 0xc9,
    0xcc, 0xcf, 0x0b, 0xce, 0xac, 0x4a, 0x75, 0x2f, 0xca, 0x2c, 0xd0, 0x28, 0x4e, 0xcd, 0x49, 0xd3,
    0xe4, 0x32, 0x24, 0x45, 0xb9, 0x4e, 0x7e, 0x49, 0x46, 0x6a, 0x11, 0x91, 0x3a, 0x34, 0xb9, 0x0c,
    0x48, 0x32, 0xbb, 0x2c, 0xb5, 0xa8, 0x18, 0x28, 0x68, 0x95, 0x99, 0x57, 0xa2, 0xc9, 0x05, 0x00,
    0x17, 0x6b, 0x48, 0xa0
};
#endif

PyTypeObject *init_QStyleOptionSizeGrip(PyObject *module)
{
    if (SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionSizeGrip_IDX].type != nullptr)
        return SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionSizeGrip_IDX].type;

    Shiboken::AutoDecRef Sbk_QStyleOptionSizeGrip_Type_bases(PyTuple_Pack(1,
        reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionComplex_IDX]))));

    _Sbk_QStyleOptionSizeGrip_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QStyleOptionSizeGrip",
        "QStyleOptionSizeGrip*",
        &Sbk_QStyleOptionSizeGrip_spec,
        &Shiboken::callCppDestructor< ::QStyleOptionSizeGrip >,
        Sbk_QStyleOptionSizeGrip_Type_bases.object(),
        0);
    auto *pyType = Sbk_QStyleOptionSizeGrip_TypeF(); // references _Sbk_QStyleOptionSizeGrip_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QStyleOptionSizeGrip_SignatureStrings);
#else
    InitSignatureBytes(pyType, QStyleOptionSizeGrip_SignatureBytes, QStyleOptionSizeGrip_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QStyleOptionSizeGrip_PropertyStrings);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionSizeGrip_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QStyleOptionSizeGrip_PythonToCpp_QStyleOptionSizeGrip_PTR,
        is_QStyleOptionSizeGrip_PythonToCpp_QStyleOptionSizeGrip_PTR_Convertible,
        QStyleOptionSizeGrip_PTR_CppToPython_QStyleOptionSizeGrip);

    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionSizeGrip");
    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionSizeGrip*");
    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionSizeGrip&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QStyleOptionSizeGrip).name());

    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(
        Sbk_QStyleOptionSizeGrip_TypeF(), &Sbk_QStyleOptionSizeGrip_typeDiscovery);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QStyleOptionSizeGrip_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'StyleOptionType'.
    const char *StyleOptionType_Initializer[] = {
        "Type",
        nullptr};
    // "uint32_t" used instead of "unsigned int"
    constexpr uint32_t StyleOptionType_InitializerValues[] = {
        uint32_t(QStyleOptionSizeGrip::StyleOptionType::Type) //  0x000f0007  983047
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionSizeGrip_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionSizeGrip.StyleOptionType",
        StyleOptionType_Initializer, StyleOptionType_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionSizeGrip_StyleOptionType_IDX].type = EType;
    // Register converter for enum 'QStyleOptionSizeGrip::StyleOptionType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionSizeGrip_StyleOptionType_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QStyleOptionSizeGrip_StyleOptionType,
            is_Enum_PythonToCpp_QStyleOptionSizeGrip_StyleOptionType_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionSizeGrip::StyleOptionType");
        Shiboken::Conversions::registerConverterAlias(converter, "StyleOptionType");
        Shiboken::Enum::setTypeConverter(EType, converter, nullptr);
    }
    // End of 'StyleOptionType' enum.

    // Initialization of enum 'StyleOptionVersion'.
    const char *StyleOptionVersion_Initializer[] = {
        "Version",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t StyleOptionVersion_InitializerValues[] = {
        uint8_t(QStyleOptionSizeGrip::StyleOptionVersion::Version) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionSizeGrip_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionSizeGrip.StyleOptionVersion",
        StyleOptionVersion_Initializer, StyleOptionVersion_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionSizeGrip_StyleOptionVersion_IDX].type = EType;
    // Register converter for enum 'QStyleOptionSizeGrip::StyleOptionVersion'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionSizeGrip_StyleOptionVersion_CppToPython_Enum);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            Enum_PythonToCpp_QStyleOptionSizeGrip_StyleOptionVersion,
            is_Enum_PythonToCpp_QStyleOptionSizeGrip_StyleOptionVersion_Convertible);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionSizeGrip::StyleOptionVersion");
        Shiboken::Conversions::registerConverterAlias(converter, "StyleOptionVersion");
        Shiboken::Enum::setTypeConverter(EType, converter, nullptr);
    }
    // End of 'StyleOptionVersion' enum.

    qRegisterMetaType< ::QStyleOptionSizeGrip *>();
    qRegisterMetaType< ::QStyleOptionSizeGrip::StyleOptionType >("QStyleOptionSizeGrip::StyleOptionType");
    qRegisterMetaType< ::QStyleOptionSizeGrip::StyleOptionVersion >("QStyleOptionSizeGrip::StyleOptionVersion");

    return pyType;
}
