// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTableWidgetItemWrapper_H
#define SBK_QTableWidgetItemWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qtablewidget.h>

class QTableWidgetItemWrapper : public QTableWidgetItem
{
public:
    QTableWidgetItemWrapper(const QTableWidgetItemWrapper &) = delete;
    QTableWidgetItemWrapper& operator=(const QTableWidgetItemWrapper &) = delete;
    QTableWidgetItemWrapper(QTableWidgetItemWrapper &&) = delete;
    QTableWidgetItemWrapper& operator=(QTableWidgetItemWrapper &&) = delete;

    QTableWidgetItemWrapper(const ::QIcon & icon, const ::QString & text, int type = QTableWidgetItem::ItemType::Type);
    QTableWidgetItemWrapper(const ::QString & text, int type = QTableWidgetItem::ItemType::Type);
    QTableWidgetItemWrapper(const QTableWidgetItem& self) : QTableWidgetItem(self)
    {
    }

    QTableWidgetItemWrapper(int type = QTableWidgetItem::ItemType::Type);
    ::QTableWidgetItem * clone() const override;
    ::QVariant data(int role) const override;
    bool operator<(const ::QTableWidgetItem & other) const override;
    void read(::QDataStream & in) override;
    void setData(int role, const ::QVariant & value) override;
    void write(::QDataStream & out) const override;
    ~QTableWidgetItemWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[6] = {false, false, false, false, false, false};
};

#endif // SBK_QTableWidgetItemWrapper_H

