// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTextEditWrapper_H
#define SBK_QTextEditWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qtextedit.h>

namespace PySide { class DynamicQMetaObject; }

class QTextEditWrapper : public QTextEdit
{
public:
    QTextEditWrapper(const QTextEditWrapper &) = delete;
    QTextEditWrapper& operator=(const QTextEditWrapper &) = delete;
    QTextEditWrapper(QTextEditWrapper &&) = delete;
    QTextEditWrapper& operator=(QTextEditWrapper &&) = delete;

    QTextEditWrapper(::QWidget * parent = nullptr);
    QTextEditWrapper(const ::QString & text, ::QWidget * parent = nullptr);
    void actionEvent(::QActionEvent * event) override;
    bool canInsertFromMimeData(const ::QMimeData * source) const override;
    void changeEvent(::QEvent * e) override;
    void childEvent(::QChildEvent * event) override;
    void closeEvent(::QCloseEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void contextMenuEvent(::QContextMenuEvent * e) override;
    ::QMimeData * createMimeDataFromSelection() const override;
    void customEvent(::QEvent * event) override;
    int devType() const override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    void doSetTextCursor(const ::QTextCursor & cursor) override;
    void dragEnterEvent(::QDragEnterEvent * e) override;
    void dragLeaveEvent(::QDragLeaveEvent * e) override;
    void dragMoveEvent(::QDragMoveEvent * e) override;
    void dropEvent(::QDropEvent * e) override;
    void enterEvent(::QEnterEvent * event) override;
    bool event(::QEvent * e) override;
    bool eventFilter(::QObject * arg__1, ::QEvent * arg__2) override;
    void focusInEvent(::QFocusEvent * e) override;
    bool focusNextPrevChild(bool next) override;
    void focusOutEvent(::QFocusEvent * e) override;
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    void hideEvent(::QHideEvent * event) override;
    void initPainter(::QPainter * painter) const override;
    void initStyleOption(::QStyleOptionFrame * option) const override;
    void inputMethodEvent(::QInputMethodEvent * arg__1) override;
    ::QVariant inputMethodQuery(::Qt::InputMethodQuery property) const override;
    void insertFromMimeData(const ::QMimeData * source) override;
    void keyPressEvent(::QKeyEvent * e) override;
    void keyReleaseEvent(::QKeyEvent * e) override;
    void leaveEvent(::QEvent * event) override;
    ::QVariant loadResource(int type, const ::QUrl & name) override;
    int metric(::QPaintDevice::PaintDeviceMetric arg__1) const override;
    ::QSize minimumSizeHint() const override;
    void mouseDoubleClickEvent(::QMouseEvent * e) override;
    void mouseMoveEvent(::QMouseEvent * e) override;
    void mousePressEvent(::QMouseEvent * e) override;
    void mouseReleaseEvent(::QMouseEvent * e) override;
    void moveEvent(::QMoveEvent * event) override;
    bool nativeEvent(const ::QByteArray & eventType, void * message, ::qintptr * result) override;
    ::QPaintEngine * paintEngine() const override;
    void paintEvent(::QPaintEvent * e) override;
    ::QPaintDevice * redirected(::QPoint * offset) const override;
    void resizeEvent(::QResizeEvent * e) override;
    void scrollContentsBy(int dx, int dy) override;
    void setVisible(bool visible) override;
    void setupViewport(::QWidget * viewport) override;
    ::QPainter * sharedPainter() const override;
    void showEvent(::QShowEvent * arg__1) override;
    ::QSize sizeHint() const override;
    void tabletEvent(::QTabletEvent * event) override;
    void timerEvent(::QTimerEvent * e) override;
    bool viewportEvent(::QEvent * arg__1) override;
    ::QSize viewportSizeHint() const override;
    void wheelEvent(::QWheelEvent * e) override;
    ~QTextEditWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    // Inherited overloads, because the using keyword sux
    ::QVariant inputMethodQuery(::Qt::InputMethodQuery query, ::QVariant argument) const { return QTextEdit::inputMethodQuery(Qt::InputMethodQuery(query), argument); }
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[57] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QTextEditWrapper_H

