// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QVBoxLayoutWrapper_H
#define SBK_QVBoxLayoutWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qboxlayout.h>

namespace PySide { class DynamicQMetaObject; }

class QVBoxLayoutWrapper : public QVBoxLayout
{
public:
    QVBoxLayoutWrapper(const QVBoxLayoutWrapper &) = delete;
    QVBoxLayoutWrapper& operator=(const QVBoxLayoutWrapper &) = delete;
    QVBoxLayoutWrapper(QVBoxLayoutWrapper &&) = delete;
    QVBoxLayoutWrapper& operator=(QVBoxLayoutWrapper &&) = delete;

    QVBoxLayoutWrapper();
    QVBoxLayoutWrapper(::QWidget * parent);
    void addItem(::QLayoutItem * arg__1) override;
    void childEvent(::QChildEvent * e) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QFlags<QSizePolicy::ControlType> controlTypes() const override;
    int count() const override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QFlags<Qt::Orientation> expandingDirections() const override;
    ::QRect geometry() const override;
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    int indexOf(const ::QLayoutItem * arg__1) const override;
    int indexOf(const ::QWidget * arg__1) const override;
    void invalidate() override;
    bool isEmpty() const override;
    ::QLayoutItem * itemAt(int arg__1) const override;
    ::QLayout * layout() override;
    ::QSize maximumSize() const override;
    int minimumHeightForWidth(int arg__1) const override;
    ::QSize minimumSize() const override;
    ::QLayoutItem * replaceWidget(::QWidget * from, ::QWidget * to, ::QFlags<Qt::FindChildOption> options = Qt::FindChildrenRecursively) override;
    void setGeometry(const ::QRect & arg__1) override;
    void setSpacing(int spacing) override;
    ::QSize sizeHint() const override;
    ::QSpacerItem * spacerItem() override;
    int spacing() const override;
    ::QLayoutItem * takeAt(int arg__1) override;
    void timerEvent(::QTimerEvent * event) override;
    ::QWidget * widget() const override;
    ~QVBoxLayoutWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[31] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QVBoxLayoutWrapper_H

