// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtxml_python.h"

// main header
#include "qdomcdatasection_wrapper.h"

// Argument includes
#include <QtXml/qdom.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QDomCDATASection_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QDomCDATASection >()))
        return -1;

    ::QDomCDATASection *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QDomCDATASection", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QDomCDATASection::QDomCDATASection()
    // 1: QDomCDATASection::QDomCDATASection(QDomCDATASection)
    if (numArgs == 0) {
        overloadId = 0; // QDomCDATASection()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomCDATASection_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QDomCDATASection(QDomCDATASection)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtXmlTypeStructs[SBK_QDomCDATASection_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtXmlTypeStructs[SBK_QDomCDATASection_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QDomCDATASection()
        {

            // QDomCDATASection()
            cptr = new ::QDomCDATASection();
            break;
        }
        case 1: // QDomCDATASection(const QDomCDATASection &cdataSection)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QDomCDATASection cppArg0_local;
            ::QDomCDATASection *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QDomCDATASection(QDomCDATASection)
                cptr = new ::QDomCDATASection(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QDomCDATASection >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtXmlTypeStructs[SBK_QDomCDATASection_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QDomCDATASectionFunc_nodeType(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDomCDATASection *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomCDATASection_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // nodeType()const
        QDomNode::NodeType cppResult = const_cast<const ::QDomCDATASection *>(cppSelf)->nodeType();
        pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomNode_NodeType_IDX])))->converter, &cppResult);
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDomCDATASection__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QDomCDATASection *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomCDATASection_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomCDATASection_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QDomCDATASection_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QDomCDATASection_methods[] = {
    {"nodeType", reinterpret_cast<PyCFunction>(Sbk_QDomCDATASectionFunc_nodeType), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QDomCDATASection__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QDomCDATASection_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QDomCDATASection_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QDomCDATASection_Type = nullptr;
static PyTypeObject *Sbk_QDomCDATASection_TypeF(void)
{
    return _Sbk_QDomCDATASection_Type;
}

static PyType_Slot Sbk_QDomCDATASection_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QDomCDATASection_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QDomCDATASection_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QDomCDATASection_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QDomCDATASection_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QDomCDATASection_spec = {
    "2:PySide6.QtXml.QDomCDATASection",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QDomCDATASection_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QDomCDATASection_PythonToCpp_QDomCDATASection_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QDomCDATASection_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QDomCDATASection_PythonToCpp_QDomCDATASection_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QDomCDATASection_TypeF()))
        return QDomCDATASection_PythonToCpp_QDomCDATASection_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QDomCDATASection_PTR_CppToPython_QDomCDATASection(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QDomCDATASection_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QDomCDATASection_COPY_CppToPython_QDomCDATASection(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QDomCDATASection *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QDomCDATASection_TypeF(), new ::QDomCDATASection(*source), true, true);
}

// Python to C++ copy conversion.
static void QDomCDATASection_PythonToCpp_QDomCDATASection_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QDomCDATASection *>(cppOut) = *reinterpret_cast< ::QDomCDATASection *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomCDATASection_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QDomCDATASection_PythonToCpp_QDomCDATASection_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QDomCDATASection_TypeF()))
        return QDomCDATASection_PythonToCpp_QDomCDATASection_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QDomCDATASection_SignatureStrings[] = {
    "1:PySide6.QtXml.QDomCDATASection(self)",
    "0:PySide6.QtXml.QDomCDATASection(self,cdataSection:PySide6.QtXml.QDomCDATASection)",
    "PySide6.QtXml.QDomCDATASection.nodeType(self)->PySide6.QtXml.QDomNode.NodeType",
    "PySide6.QtXml.QDomCDATASection.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QDomCDATASection_SignatureByteSize = 110;
static constexpr uint8_t QDomCDATASection_SignatureBytes[110] = {
    0x78, 0xda, 0x33, 0xb4, 0x0a, 0xa8, 0x0c, 0xce, 0x4c, 0x49, 0x35, 0xd3, 0x0b, 0x2c, 0x89, 0xc8,
    0xcd, 0xd1, 0x0b, 0x74, 0xc9, 0xcf, 0x75, 0x76, 0x71, 0x0c, 0x71, 0x0c, 0x4e, 0x4d, 0x2e, 0xc9,
    0xcc, 0xcf, 0xd3, 0x28, 0x4e, 0xcd, 0x49, 0xd3, 0xe4, 0x32, 0x20, 0x46, 0x99, 0x4e, 0x72, 0x4a,
    0x62, 0x49, 0x22, 0x54, 0x84, 0x80, 0x06, 0x4d, 0x2e, 0xfc, 0xf2, 0x7a, 0x79, 0xf9, 0x29, 0xa9,
    0x21, 0x95, 0x05, 0xa9, 0x10, 0x07, 0xe8, 0xda, 0x61, 0x2a, 0xf7, 0x03, 0xaa, 0xd0, 0xf3, 0x83,
    0x2a, 0x23, 0x64, 0x5c, 0x7c, 0x7c, 0x72, 0x7e, 0x41, 0x65, 0x7c, 0x3c, 0xcc, 0xb8, 0x92, 0xca,
    0x82, 0xcc, 0xbc, 0x74, 0xbd, 0x60, 0x20, 0x8f, 0x0b, 0x00, 0x57, 0x81, 0x59, 0xa6
};
#endif

PyTypeObject *init_QDomCDATASection(PyObject *module)
{
    if (SbkPySide6_QtXmlTypeStructs[SBK_QDomCDATASection_IDX].type != nullptr)
        return SbkPySide6_QtXmlTypeStructs[SBK_QDomCDATASection_IDX].type;

    Shiboken::AutoDecRef Sbk_QDomCDATASection_Type_bases(PyTuple_Pack(1,
        reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomText_IDX]))));

    _Sbk_QDomCDATASection_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QDomCDATASection",
        "QDomCDATASection",
        &Sbk_QDomCDATASection_spec,
        &Shiboken::callCppDestructor< ::QDomCDATASection >,
        Sbk_QDomCDATASection_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QDomCDATASection_TypeF(); // references _Sbk_QDomCDATASection_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QDomCDATASection_SignatureStrings);
#else
    InitSignatureBytes(pyType, QDomCDATASection_SignatureBytes, QDomCDATASection_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QDomCDATASection_PropertyStrings);
    SbkPySide6_QtXmlTypeStructs[SBK_QDomCDATASection_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QDomCDATASection_PythonToCpp_QDomCDATASection_PTR,
        is_QDomCDATASection_PythonToCpp_QDomCDATASection_PTR_Convertible,
        QDomCDATASection_PTR_CppToPython_QDomCDATASection,
        QDomCDATASection_COPY_CppToPython_QDomCDATASection);

    Shiboken::Conversions::registerConverterName(converter, "QDomCDATASection");
    Shiboken::Conversions::registerConverterName(converter, "QDomCDATASection*");
    Shiboken::Conversions::registerConverterName(converter, "QDomCDATASection&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QDomCDATASection).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QDomCDATASection_PythonToCpp_QDomCDATASection_COPY,
        is_QDomCDATASection_PythonToCpp_QDomCDATASection_COPY_Convertible);

    qRegisterMetaType< ::QDomCDATASection >("QDomCDATASection");

    return pyType;
}
